type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val negb : bool -> bool **)

let negb = function
| true -> false
| false -> true

type nat =
| O
| S of nat

(** val option_map : ('a1 -> 'a2) -> 'a1 option -> 'a2 option **)

let option_map f = function
| Some a -> Some (f a)
| None -> None

type ('a, 'b) sum =
| Inl of 'a
| Inr of 'b

(** val fst : ('a1 * 'a2) -> 'a1 **)

let fst = function
| (x, y) -> x

(** val snd : ('a1 * 'a2) -> 'a2 **)

let snd = function
| (x, y) -> y

(** val length : 'a1 list -> nat **)

let rec length = function
| [] -> O
| y :: l' -> S (length l')

(** val app : 'a1 list -> 'a1 list -> 'a1 list **)

let rec app l m =
  match l with
  | [] -> m
  | a :: l1 -> a :: (app l1 m)

type comparison =
| Eq
| Lt
| Gt

type compareSpecT =
| CompEqT
| CompLtT
| CompGtT

(** val compareSpec2Type : comparison -> compareSpecT **)

let compareSpec2Type = function
| Eq -> CompEqT
| Lt -> CompLtT
| Gt -> CompGtT

type 'a compSpecT = compareSpecT

(** val compSpec2Type : 'a1 -> 'a1 -> comparison -> 'a1 compSpecT **)

let compSpec2Type x y c =
  compareSpec2Type c

(** val id : 'a1 -> 'a1 **)

let id x =
  x

type 'a sig0 =
  'a
  (* singleton inductive, whose constructor was exist *)

(** val plus : nat -> nat -> nat **)

let rec plus n m =
  match n with
  | O -> m
  | S p -> S (plus p m)

(** val mult : nat -> nat -> nat **)

let rec mult n m =
  match n with
  | O -> O
  | S p -> plus m (mult p m)

(** val minus : nat -> nat -> nat **)

let rec minus n m =
  match n with
  | O -> n
  | S k ->
    (match m with
     | O -> n
     | S l -> minus k l)

(** val max : nat -> nat -> nat **)

let rec max n m =
  match n with
  | O -> m
  | S n' ->
    (match m with
     | O -> n
     | S m' -> S (max n' m'))

(** val nat_iter : nat -> ('a1 -> 'a1) -> 'a1 -> 'a1 **)

let rec nat_iter n f x =
  match n with
  | O -> x
  | S n' -> f (nat_iter n' f x)

(** val eqb : bool -> bool -> bool **)

let eqb b1 b2 =
  if b1 then b2 else if b2 then false else true

type reflect =
| ReflectT
| ReflectF

(** val iff_reflect : bool -> reflect **)

let iff_reflect = function
| true -> ReflectT
| false -> ReflectF

(** val compose : ('a2 -> 'a3) -> ('a1 -> 'a2) -> 'a1 -> 'a3 **)

let compose g0 f x =
  g0 (f x)

(** val flip : ('a1 -> 'a2 -> 'a3) -> 'a2 -> 'a1 -> 'a3 **)

let flip f x y =
  f y x

(** val tl : 'a1 list -> 'a1 list **)

let tl = function
| [] -> []
| a :: m -> m

(** val nth : nat -> 'a1 list -> 'a1 -> 'a1 **)

let rec nth n l default0 =
  match n with
  | O ->
    (match l with
     | [] -> default0
     | x :: l' -> x)
  | S m ->
    (match l with
     | [] -> default0
     | x :: t0 -> nth m t0 default0)

(** val last : 'a1 list -> 'a1 -> 'a1 **)

let rec last l d =
  match l with
  | [] -> d
  | a :: l0 ->
    (match l0 with
     | [] -> a
     | a0 :: l1 -> last l0 d)

(** val removelast : 'a1 list -> 'a1 list **)

let rec removelast = function
| [] -> []
| a :: l0 ->
  (match l0 with
   | [] -> []
   | a0 :: l1 -> a :: (removelast l0))

(** val rev : 'a1 list -> 'a1 list **)

let rec rev = function
| [] -> []
| x :: l' -> app (rev l') (x :: [])

module Coq__2 = struct 
 (** val map : ('a1 -> 'a2) -> 'a1 list -> 'a2 list **)
 
 let rec map f = function
 | [] -> []
 | a :: t0 -> (f a) :: (map f t0)
end
let map = Coq__2.map


(** val flat_map : ('a1 -> 'a2 list) -> 'a1 list -> 'a2 list **)

let rec flat_map f = function
| [] -> []
| x :: t0 -> app (f x) (flat_map f t0)

(** val fold_left : ('a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> 'a1 **)

let rec fold_left f l a0 =
  match l with
  | [] -> a0
  | b :: t0 -> fold_left f t0 (f a0 b)

(** val fold_right : ('a2 -> 'a1 -> 'a1) -> 'a1 -> 'a2 list -> 'a1 **)

let rec fold_right f a0 = function
| [] -> a0
| b :: t0 -> f b (fold_right f a0 t0)

(** val filter : ('a1 -> bool) -> 'a1 list -> 'a1 list **)

let rec filter f = function
| [] -> []
| x :: l0 -> if f x then x :: (filter f l0) else filter f l0

(** val firstn : nat -> 'a1 list -> 'a1 list **)

let rec firstn n l =
  match n with
  | O -> []
  | S n0 ->
    (match l with
     | [] -> []
     | a :: l0 -> a :: (firstn n0 l0))

(** val skipn : nat -> 'a1 list -> 'a1 list **)

let rec skipn n l =
  match n with
  | O -> l
  | S n0 ->
    (match l with
     | [] -> []
     | a :: l0 -> skipn n0 l0)

module type EqLtLe = 
 sig 
  type t 
 end

module MakeOrderTac = 
 functor (O:EqLtLe) ->
 functor (P:sig 
  
 end) ->
 struct 
  
 end

type 'x compare =
| LT
| EQ
| GT

module type OrderedType = 
 sig 
  type t 
  
  val compare : t -> t -> t compare
  
  val eq_dec : t -> t -> bool
 end

module OrderedTypeFacts = 
 functor (O:OrderedType) ->
 struct 
  module TO = 
   struct 
    type t = O.t
   end
  
  module IsTO = 
   struct 
    
   end
  
  module OrderTac = MakeOrderTac(TO)(IsTO)
  
  (** val eq_dec : O.t -> O.t -> bool **)
  
  let eq_dec =
    O.eq_dec
  
  (** val lt_dec : O.t -> O.t -> bool **)
  
  let lt_dec x y =
    match O.compare x y with
    | LT -> true
    | _ -> false
  
  (** val eqb : O.t -> O.t -> bool **)
  
  let eqb x y =
    if eq_dec x y then true else false
 end

module KeyOrderedType = 
 functor (O:OrderedType) ->
 struct 
  module MO = OrderedTypeFacts(O)
 end

module Raw = 
 functor (X:OrderedType) ->
 struct 
  module MX = OrderedTypeFacts(X)
  
  module PX = KeyOrderedType(X)
  
  type key = X.t
  
  type 'elt t = (X.t * 'elt) list
  
  (** val empty : 'a1 t **)
  
  let empty =
    []
  
  (** val is_empty : 'a1 t -> bool **)
  
  let is_empty = function
  | [] -> true
  | x :: x0 -> false
  
  (** val mem : key -> 'a1 t -> bool **)
  
  let rec mem k = function
  | [] -> false
  | p :: l ->
    let (k', e) = p in
    (match X.compare k k' with
     | LT -> false
     | EQ -> true
     | GT -> mem k l)
  
  type 'elt coq_R_mem =
  | R_mem_0 of 'elt t
  | R_mem_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_mem_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_mem_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * bool
     * 'elt coq_R_mem
  
  (** val coq_R_mem_rect :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 t ->
      bool -> 'a1 coq_R_mem -> 'a2 **)
  
  let rec coq_R_mem_rect k f f0 f1 f2 s b = function
  | R_mem_0 s0 -> f s0 __
  | R_mem_1 (s0, k', _x, l) -> f0 s0 k' _x l __ __ __
  | R_mem_2 (s0, k', _x, l) -> f1 s0 k' _x l __ __ __
  | R_mem_3 (s0, k', _x, l, res, r0) ->
    f2 s0 k' _x l __ __ __ res r0 (coq_R_mem_rect k f f0 f1 f2 l res r0)
  
  (** val coq_R_mem_rec :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 t ->
      bool -> 'a1 coq_R_mem -> 'a2 **)
  
  let rec coq_R_mem_rec k f f0 f1 f2 s b = function
  | R_mem_0 s0 -> f s0 __
  | R_mem_1 (s0, k', _x, l) -> f0 s0 k' _x l __ __ __
  | R_mem_2 (s0, k', _x, l) -> f1 s0 k' _x l __ __ __
  | R_mem_3 (s0, k', _x, l, res, r0) ->
    f2 s0 k' _x l __ __ __ res r0 (coq_R_mem_rec k f f0 f1 f2 l res r0)
  
  (** val mem_rect :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let rec mem_rect k f2 f1 f0 f s =
    let f3 = f2 s in
    let f4 = f1 s in
    let f5 = f0 s in
    let f6 = f s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (t0, e) = p in
       let f7 = f6 t0 e l __ in
       let f8 = fun _ _ ->
         let hrec = mem_rect k f2 f1 f0 f l in f7 __ __ hrec
       in
       let f9 = f5 t0 e l __ in
       let f10 = f4 t0 e l __ in
       (match X.compare k t0 with
        | LT -> f10 __ __
        | EQ -> f9 __ __
        | GT -> f8 __ __))
  
  (** val mem_rec :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let mem_rec k =
    mem_rect k
  
  (** val coq_R_mem_correct : key -> 'a1 t -> bool -> 'a1 coq_R_mem **)
  
  let coq_R_mem_correct x x0 res =
    let princ = fun x1 -> mem_rect x1 in
    Obj.magic princ x (fun y _ z _ -> R_mem_0 y) (fun y y1 y2 y3 _ _ _ z _ ->
      R_mem_1 (y, y1, y2, y3)) (fun y y1 y2 y3 _ _ _ z _ -> R_mem_2 (y, y1,
      y2, y3)) (fun y y1 y2 y3 _ _ _ y6 z _ -> R_mem_3 (y, y1, y2, y3,
      (mem x y3), (y6 (mem x y3) __))) x0 res __
  
  (** val find : key -> 'a1 t -> 'a1 option **)
  
  let rec find k = function
  | [] -> None
  | p :: s' ->
    let (k', x) = p in
    (match X.compare k k' with
     | LT -> None
     | EQ -> Some x
     | GT -> find k s')
  
  type 'elt coq_R_find =
  | R_find_0 of 'elt t
  | R_find_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_find_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_find_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt option
     * 'elt coq_R_find
  
  (** val coq_R_find_rect :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1
      t -> 'a1 option -> 'a1 coq_R_find -> 'a2 **)
  
  let rec coq_R_find_rect k f f0 f1 f2 s o = function
  | R_find_0 s0 -> f s0 __
  | R_find_1 (s0, k', x, s') -> f0 s0 k' x s' __ __ __
  | R_find_2 (s0, k', x, s') -> f1 s0 k' x s' __ __ __
  | R_find_3 (s0, k', x, s', res, r0) ->
    f2 s0 k' x s' __ __ __ res r0 (coq_R_find_rect k f f0 f1 f2 s' res r0)
  
  (** val coq_R_find_rec :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1
      t -> 'a1 option -> 'a1 coq_R_find -> 'a2 **)
  
  let rec coq_R_find_rec k f f0 f1 f2 s o = function
  | R_find_0 s0 -> f s0 __
  | R_find_1 (s0, k', x, s') -> f0 s0 k' x s' __ __ __
  | R_find_2 (s0, k', x, s') -> f1 s0 k' x s' __ __ __
  | R_find_3 (s0, k', x, s', res, r0) ->
    f2 s0 k' x s' __ __ __ res r0 (coq_R_find_rec k f f0 f1 f2 s' res r0)
  
  (** val find_rect :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let rec find_rect k f2 f1 f0 f s =
    let f3 = f2 s in
    let f4 = f1 s in
    let f5 = f0 s in
    let f6 = f s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (t0, e) = p in
       let f7 = f6 t0 e l __ in
       let f8 = fun _ _ ->
         let hrec = find_rect k f2 f1 f0 f l in f7 __ __ hrec
       in
       let f9 = f5 t0 e l __ in
       let f10 = f4 t0 e l __ in
       (match X.compare k t0 with
        | LT -> f10 __ __
        | EQ -> f9 __ __
        | GT -> f8 __ __))
  
  (** val find_rec :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let find_rec k =
    find_rect k
  
  (** val coq_R_find_correct :
      key -> 'a1 t -> 'a1 option -> 'a1 coq_R_find **)
  
  let coq_R_find_correct x x0 res =
    let princ = fun x1 -> find_rect x1 in
    Obj.magic princ x (fun y _ z _ -> R_find_0 y)
      (fun y y1 y2 y3 _ _ _ z _ -> R_find_1 (y, y1, y2, y3))
      (fun y y1 y2 y3 _ _ _ z _ -> R_find_2 (y, y1, y2, y3))
      (fun y y1 y2 y3 _ _ _ y6 z _ -> R_find_3 (y, y1, y2, y3, (find x y3),
      (y6 (find x y3) __))) x0 res __
  
  (** val add : key -> 'a1 -> 'a1 t -> 'a1 t **)
  
  let rec add k x s = match s with
  | [] -> (k, x) :: []
  | p :: l ->
    let (k', y) = p in
    (match X.compare k k' with
     | LT -> (k, x) :: s
     | EQ -> (k, x) :: l
     | GT -> (k', y) :: (add k x l))
  
  type 'elt coq_R_add =
  | R_add_0 of 'elt t
  | R_add_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_add_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_add_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt t
     * 'elt coq_R_add
  
  (** val coq_R_add_rect :
      key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_add -> 'a2 ->
      'a2) -> 'a1 t -> 'a1 t -> 'a1 coq_R_add -> 'a2 **)
  
  let rec coq_R_add_rect k x f f0 f1 f2 s t0 = function
  | R_add_0 s0 -> f s0 __
  | R_add_1 (s0, k', y, l) -> f0 s0 k' y l __ __ __
  | R_add_2 (s0, k', y, l) -> f1 s0 k' y l __ __ __
  | R_add_3 (s0, k', y, l, res, r0) ->
    f2 s0 k' y l __ __ __ res r0 (coq_R_add_rect k x f f0 f1 f2 l res r0)
  
  (** val coq_R_add_rec :
      key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_add -> 'a2 ->
      'a2) -> 'a1 t -> 'a1 t -> 'a1 coq_R_add -> 'a2 **)
  
  let rec coq_R_add_rec k x f f0 f1 f2 s t0 = function
  | R_add_0 s0 -> f s0 __
  | R_add_1 (s0, k', y, l) -> f0 s0 k' y l __ __ __
  | R_add_2 (s0, k', y, l) -> f1 s0 k' y l __ __ __
  | R_add_3 (s0, k', y, l, res, r0) ->
    f2 s0 k' y l __ __ __ res r0 (coq_R_add_rec k x f f0 f1 f2 l res r0)
  
  (** val add_rect :
      key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let rec add_rect k x f2 f1 f0 f s =
    let f3 = f2 s in
    let f4 = f1 s in
    let f5 = f0 s in
    let f6 = f s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (t0, e) = p in
       let f7 = f6 t0 e l __ in
       let f8 = fun _ _ ->
         let hrec = add_rect k x f2 f1 f0 f l in f7 __ __ hrec
       in
       let f9 = f5 t0 e l __ in
       let f10 = f4 t0 e l __ in
       (match X.compare k t0 with
        | LT -> f10 __ __
        | EQ -> f9 __ __
        | GT -> f8 __ __))
  
  (** val add_rec :
      key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let add_rec k x =
    add_rect k x
  
  (** val coq_R_add_correct :
      key -> 'a1 -> 'a1 t -> 'a1 t -> 'a1 coq_R_add **)
  
  let coq_R_add_correct x x0 x1 res =
    add_rect x x0 (fun y _ z _ -> R_add_0 y) (fun y y1 y2 y3 _ _ _ z _ ->
      R_add_1 (y, y1, y2, y3)) (fun y y1 y2 y3 _ _ _ z _ -> R_add_2 (y, y1,
      y2, y3)) (fun y y1 y2 y3 _ _ _ y6 z _ -> R_add_3 (y, y1, y2, y3,
      (add x x0 y3), (y6 (add x x0 y3) __))) x1 res __
  
  (** val remove : key -> 'a1 t -> 'a1 t **)
  
  let rec remove k s = match s with
  | [] -> []
  | p :: l ->
    let (k', x) = p in
    (match X.compare k k' with
     | LT -> s
     | EQ -> l
     | GT -> (k', x) :: (remove k l))
  
  type 'elt coq_R_remove =
  | R_remove_0 of 'elt t
  | R_remove_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_remove_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_remove_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt t
     * 'elt coq_R_remove
  
  (** val coq_R_remove_rect :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 t
      -> 'a1 t -> 'a1 coq_R_remove -> 'a2 **)
  
  let rec coq_R_remove_rect k f f0 f1 f2 s t0 = function
  | R_remove_0 s0 -> f s0 __
  | R_remove_1 (s0, k', x, l) -> f0 s0 k' x l __ __ __
  | R_remove_2 (s0, k', x, l) -> f1 s0 k' x l __ __ __
  | R_remove_3 (s0, k', x, l, res, r0) ->
    f2 s0 k' x l __ __ __ res r0 (coq_R_remove_rect k f f0 f1 f2 l res r0)
  
  (** val coq_R_remove_rec :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 t
      -> 'a1 t -> 'a1 coq_R_remove -> 'a2 **)
  
  let rec coq_R_remove_rec k f f0 f1 f2 s t0 = function
  | R_remove_0 s0 -> f s0 __
  | R_remove_1 (s0, k', x, l) -> f0 s0 k' x l __ __ __
  | R_remove_2 (s0, k', x, l) -> f1 s0 k' x l __ __ __
  | R_remove_3 (s0, k', x, l, res, r0) ->
    f2 s0 k' x l __ __ __ res r0 (coq_R_remove_rec k f f0 f1 f2 l res r0)
  
  (** val remove_rect :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let rec remove_rect k f2 f1 f0 f s =
    let f3 = f2 s in
    let f4 = f1 s in
    let f5 = f0 s in
    let f6 = f s in
    (match s with
     | [] -> f3 __
     | p :: l ->
       let (t0, e) = p in
       let f7 = f6 t0 e l __ in
       let f8 = fun _ _ ->
         let hrec = remove_rect k f2 f1 f0 f l in f7 __ __ hrec
       in
       let f9 = f5 t0 e l __ in
       let f10 = f4 t0 e l __ in
       (match X.compare k t0 with
        | LT -> f10 __ __
        | EQ -> f9 __ __
        | GT -> f8 __ __))
  
  (** val remove_rec :
      key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2 **)
  
  let remove_rec k =
    remove_rect k
  
  (** val coq_R_remove_correct :
      key -> 'a1 t -> 'a1 t -> 'a1 coq_R_remove **)
  
  let coq_R_remove_correct x x0 res =
    let princ = fun x1 -> remove_rect x1 in
    Obj.magic princ x (fun y _ z _ -> R_remove_0 y)
      (fun y y1 y2 y3 _ _ _ z _ -> R_remove_1 (y, y1, y2, y3))
      (fun y y1 y2 y3 _ _ _ z _ -> R_remove_2 (y, y1, y2, y3))
      (fun y y1 y2 y3 _ _ _ y6 z _ -> R_remove_3 (y, y1, y2, y3,
      (remove x y3), (y6 (remove x y3) __))) x0 res __
  
  (** val elements : 'a1 t -> 'a1 t **)
  
  let elements m =
    m
  
  (** val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 **)
  
  let rec fold f m acc =
    match m with
    | [] -> acc
    | p :: m' -> let (k, e) = p in fold f m' (f k e acc)
  
  type ('elt, 'a) coq_R_fold =
  | R_fold_0 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a
  | R_fold_1 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a * X.t * 'elt
     * (X.t * 'elt) list * 'a * ('elt, 'a) coq_R_fold
  
  (** val coq_R_fold_rect :
      (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
      (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1)
      list -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2 -> 'a2) -> (key -> 'a1
      -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a3 -> ('a1, 'a3) coq_R_fold -> 'a2 **)
  
  let rec coq_R_fold_rect f f0 f1 m acc a = function
  | R_fold_0 (f2, m0, acc0) -> Obj.magic f __ f2 m0 acc0 __
  | R_fold_1 (f2, m0, acc0, k, e, m', res, r0) ->
    Obj.magic f0 __ f2 m0 acc0 k e m' __ res r0
      (coq_R_fold_rect f f0 f2 m' (f2 k e acc0) res r0)
  
  (** val coq_R_fold_rec :
      (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
      (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1)
      list -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2 -> 'a2) -> (key -> 'a1
      -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a3 -> ('a1, 'a3) coq_R_fold -> 'a2 **)
  
  let rec coq_R_fold_rec f f0 f1 m acc a = function
  | R_fold_0 (f2, m0, acc0) -> Obj.magic f __ f2 m0 acc0 __
  | R_fold_1 (f2, m0, acc0, k, e, m', res, r0) ->
    Obj.magic f0 __ f2 m0 acc0 k e m' __ res r0
      (coq_R_fold_rec f f0 f2 m' (f2 k e acc0) res r0)
  
  (** val fold_rect :
      (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
      (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1)
      list -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3
      -> 'a2 **)
  
  let rec fold_rect f0 f f1 m acc =
    let f2 = Obj.magic f0 __ f1 m acc in
    let f3 = Obj.magic f __ f1 m acc in
    (match m with
     | [] -> f2 __
     | p :: l ->
       let (t0, e) = p in
       let f4 = f3 t0 e l __ in
       let hrec = fold_rect f0 f f1 l (f1 t0 e acc) in f4 hrec)
  
  (** val fold_rec :
      (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
      (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1)
      list -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3
      -> 'a2 **)
  
  let fold_rec f f0 f1 m acc =
    fold_rect f f0 f1 m acc
  
  (** val coq_R_fold_correct :
      (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 -> ('a1, 'a2)
      coq_R_fold **)
  
  let coq_R_fold_correct x0 x1 x2 res =
    let princ = fun x x3 -> fold_rect x x3 in
    Obj.magic princ (fun _ y1 y2 y3 _ z _ -> R_fold_0 (y1, y2, y3))
      (fun _ y1 y2 y3 y4 y5 y6 _ y7 z _ -> R_fold_1 (y1, y2, y3, y4, y5, y6,
      (fold y1 y6 (y1 y4 y5 y3)), (y7 (fold y1 y6 (y1 y4 y5 y3)) __))) x0 x1
      x2 res __
  
  (** val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool **)
  
  let rec equal cmp m m' =
    match m with
    | [] ->
      (match m' with
       | [] -> true
       | p :: l -> false)
    | p :: l ->
      let (x, e) = p in
      (match m' with
       | [] -> false
       | p0 :: l' ->
         let (x', e') = p0 in
         (match X.compare x x' with
          | EQ -> (&&) (cmp e e') (equal cmp l l')
          | _ -> false))
  
  type 'elt coq_R_equal =
  | R_equal_0 of 'elt t * 'elt t
  | R_equal_1 of 'elt t * 'elt t * X.t * 'elt * (X.t * 'elt) list * X.t
     * 'elt * (X.t * 'elt) list * bool * 'elt coq_R_equal
  | R_equal_2 of 'elt t * 'elt t * X.t * 'elt * (X.t * 'elt) list * X.t
     * 'elt * (X.t * 'elt) list * X.t compare
  | R_equal_3 of 'elt t * 'elt t * 'elt t * 'elt t
  
  (** val coq_R_equal_rect :
      ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t
      -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_equal -> 'a2 ->
      'a2) -> ('a1 t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t
      -> 'a1 -> (X.t * 'a1) list -> __ -> X.t compare -> __ -> __ -> 'a2) ->
      ('a1 t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t ->
      'a1 t -> bool -> 'a1 coq_R_equal -> 'a2 **)
  
  let rec coq_R_equal_rect cmp f f0 f1 f2 m m' b = function
  | R_equal_0 (m0, m'0) -> f m0 m'0 __ __
  | R_equal_1 (m0, m'0, x, e, l, x', e', l', res, r0) ->
    f0 m0 m'0 x e l __ x' e' l' __ __ __ res r0
      (coq_R_equal_rect cmp f f0 f1 f2 l l' res r0)
  | R_equal_2 (m0, m'0, x, e, l, x', e', l', _x) ->
    f1 m0 m'0 x e l __ x' e' l' __ _x __ __
  | R_equal_3 (m0, m'0, _x, _x0) -> f2 m0 m'0 _x __ _x0 __ __
  
  (** val coq_R_equal_rec :
      ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t
      -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_equal -> 'a2 ->
      'a2) -> ('a1 t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t
      -> 'a1 -> (X.t * 'a1) list -> __ -> X.t compare -> __ -> __ -> 'a2) ->
      ('a1 t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t ->
      'a1 t -> bool -> 'a1 coq_R_equal -> 'a2 **)
  
  let rec coq_R_equal_rec cmp f f0 f1 f2 m m' b = function
  | R_equal_0 (m0, m'0) -> f m0 m'0 __ __
  | R_equal_1 (m0, m'0, x, e, l, x', e', l', res, r0) ->
    f0 m0 m'0 x e l __ x' e' l' __ __ __ res r0
      (coq_R_equal_rec cmp f f0 f1 f2 l l' res r0)
  | R_equal_2 (m0, m'0, x, e, l, x', e', l', _x) ->
    f1 m0 m'0 x e l __ x' e' l' __ _x __ __
  | R_equal_3 (m0, m'0, _x, _x0) -> f2 m0 m'0 _x __ _x0 __ __
  
  (** val equal_rect :
      ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t
      -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> ('a1 t -> 'a1 t ->
      X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t ->
      __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t -> 'a2 **)
  
  let rec equal_rect cmp f2 f1 f0 f m m' =
    let f3 = f2 m m' in
    let f4 = f1 m m' in
    let f5 = f0 m m' in
    let f6 = f m m' in
    let f7 = f6 m __ in
    let f8 = f7 m' __ in
    (match m with
     | [] ->
       let f9 = f3 __ in
       (match m' with
        | [] -> f9 __
        | p :: l -> f8 __)
     | p :: l ->
       let (t0, e) = p in
       let f9 = f5 t0 e l __ in
       let f10 = f4 t0 e l __ in
       (match m' with
        | [] -> f8 __
        | p0 :: l0 ->
          let (t1, e0) = p0 in
          let f11 = f9 t1 e0 l0 __ in
          let f12 = let _x = X.compare t0 t1 in f11 _x __ in
          let f13 = f10 t1 e0 l0 __ in
          let f14 = fun _ _ ->
            let hrec = equal_rect cmp f2 f1 f0 f l l0 in f13 __ __ hrec
          in
          (match X.compare t0 t1 with
           | EQ -> f14 __ __
           | _ -> f12 __)))
  
  (** val equal_rec :
      ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t
      -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
      (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> ('a1 t -> 'a1 t ->
      X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 -> (X.t * 'a1) list
      -> __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t ->
      __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t -> 'a2 **)
  
  let equal_rec cmp =
    equal_rect cmp
  
  (** val coq_R_equal_correct :
      ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal **)
  
  let coq_R_equal_correct x x0 x1 res =
    equal_rect x (fun y y1 _ _ z _ -> R_equal_0 (y, y1))
      (fun y y1 y2 y3 y4 _ y5 y6 y7 _ _ _ y11 z _ -> R_equal_1 (y, y1, y2,
      y3, y4, y5, y6, y7, (equal x y4 y7), (y11 (equal x y4 y7) __)))
      (fun y y1 y2 y3 y4 _ y5 y6 y7 _ y9 _ _ z _ -> R_equal_2 (y, y1, y2, y3,
      y4, y5, y6, y7, y9)) (fun y y1 y2 _ y3 _ _ z _ -> R_equal_3 (y, y1, y2,
      y3)) x0 x1 res __
  
  (** val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t **)
  
  let rec map f = function
  | [] -> []
  | p :: m' -> let (k, e) = p in (k, (f e)) :: (map f m')
  
  (** val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t **)
  
  let rec mapi f = function
  | [] -> []
  | p :: m' -> let (k, e) = p in (k, (f k e)) :: (mapi f m')
  
  (** val option_cons :
      key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list **)
  
  let option_cons k o l =
    match o with
    | Some e -> (k, e) :: l
    | None -> l
  
  (** val map2_l :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t **)
  
  let rec map2_l f = function
  | [] -> []
  | p :: l -> let (k, e) = p in option_cons k (f (Some e) None) (map2_l f l)
  
  (** val map2_r :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t **)
  
  let rec map2_r f = function
  | [] -> []
  | p :: l' ->
    let (k, e') = p in option_cons k (f None (Some e')) (map2_r f l')
  
  (** val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t **)
  
  let rec map2 f m = match m with
  | [] -> map2_r f
  | p :: l ->
    let (k, e) = p in
    let rec map2_aux m' = match m' with
    | [] -> map2_l f m
    | p0 :: l' ->
      let (k', e') = p0 in
      (match X.compare k k' with
       | LT -> option_cons k (f (Some e) None) (map2 f l m')
       | EQ -> option_cons k (f (Some e) (Some e')) (map2 f l l')
       | GT -> option_cons k' (f None (Some e')) (map2_aux l'))
    in map2_aux
  
  (** val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t **)
  
  let rec combine m = match m with
  | [] -> map (fun e' -> (None, (Some e')))
  | p :: l ->
    let (k, e) = p in
    let rec combine_aux m' = match m' with
    | [] -> map (fun e0 -> ((Some e0), None)) m
    | p0 :: l' ->
      let (k', e') = p0 in
      (match X.compare k k' with
       | LT -> (k, ((Some e), None)) :: (combine l m')
       | EQ -> (k, ((Some e), (Some e'))) :: (combine l l')
       | GT -> (k', (None, (Some e'))) :: (combine_aux l'))
    in combine_aux
  
  (** val fold_right_pair :
      ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3 **)
  
  let fold_right_pair f l i =
    fold_right (fun p -> f (fst p) (snd p)) i l
  
  (** val map2_alt :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
      (key * 'a3) list **)
  
  let map2_alt f m m' =
    let m0 = combine m m' in
    let m1 = map (fun p -> f (fst p) (snd p)) m0 in
    fold_right_pair option_cons m1 []
  
  (** val at_least_one :
      'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option **)
  
  let at_least_one o o' =
    match o with
    | Some e -> Some (o, o')
    | None ->
      (match o' with
       | Some e -> Some (o, o')
       | None -> None)
  
  (** val at_least_one_then_f :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option ->
      'a3 option **)
  
  let at_least_one_then_f f o o' =
    match o with
    | Some e -> f o o'
    | None ->
      (match o' with
       | Some e -> f o o'
       | None -> None)
 end

module Pos = 
 struct 
  type t = Big.big_int
  
  (** val succ : Big.big_int -> Big.big_int **)
  
  let rec succ x =
    Big.positive_case
      (fun p -> Big.double
      (succ p))
      (fun p -> Big.doubleplusone
      p)
      (fun _ -> Big.double
      Big.one)
      x
  
  (** val add : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let rec add x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q -> Big.double
        (add_carry p q))
        (fun q -> Big.doubleplusone
        (add p q))
        (fun _ -> Big.double
        (succ p))
        y)
      (fun p ->
      Big.positive_case
        (fun q -> Big.doubleplusone
        (add p q))
        (fun q -> Big.double
        (add p q))
        (fun _ -> Big.doubleplusone
        p)
        y)
      (fun _ ->
      Big.positive_case
        (fun q -> Big.double
        (succ q))
        (fun q -> Big.doubleplusone
        q)
        (fun _ -> Big.double
        Big.one)
        y)
      x
  
  (** val add_carry : Big.big_int -> Big.big_int -> Big.big_int **)
  
  and add_carry x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q -> Big.doubleplusone
        (add_carry p q))
        (fun q -> Big.double
        (add_carry p q))
        (fun _ -> Big.doubleplusone
        (succ p))
        y)
      (fun p ->
      Big.positive_case
        (fun q -> Big.double
        (add_carry p q))
        (fun q -> Big.doubleplusone
        (add p q))
        (fun _ -> Big.double
        (succ p))
        y)
      (fun _ ->
      Big.positive_case
        (fun q -> Big.doubleplusone
        (succ q))
        (fun q -> Big.double
        (succ q))
        (fun _ -> Big.doubleplusone
        Big.one)
        y)
      x
  
  (** val pred_double : Big.big_int -> Big.big_int **)
  
  let rec pred_double x =
    Big.positive_case
      (fun p -> Big.doubleplusone (Big.double
      p))
      (fun p -> Big.doubleplusone
      (pred_double p))
      (fun _ ->
      Big.one)
      x
  
  (** val pred : Big.big_int -> Big.big_int **)
  
  let pred x =
    Big.positive_case
      (fun p -> Big.double
      p)
      (fun p ->
      pred_double p)
      (fun _ ->
      Big.one)
      x
  
  (** val pred_N : Big.big_int -> Big.big_int **)
  
  let pred_N x =
    Big.positive_case
      (fun p -> (Big.double
      p))
      (fun p ->
      (pred_double p))
      (fun _ ->
      Big.zero)
      x
  
  type mask =
  | IsNul
  | IsPos of Big.big_int
  | IsNeg
  
  (** val mask_rect : 'a1 -> (Big.big_int -> 'a1) -> 'a1 -> mask -> 'a1 **)
  
  let mask_rect f f0 f1 = function
  | IsNul -> f
  | IsPos x -> f0 x
  | IsNeg -> f1
  
  (** val mask_rec : 'a1 -> (Big.big_int -> 'a1) -> 'a1 -> mask -> 'a1 **)
  
  let mask_rec f f0 f1 = function
  | IsNul -> f
  | IsPos x -> f0 x
  | IsNeg -> f1
  
  (** val succ_double_mask : mask -> mask **)
  
  let succ_double_mask = function
  | IsNul -> IsPos Big.one
  | IsPos p -> IsPos (Big.doubleplusone p)
  | IsNeg -> IsNeg
  
  (** val double_mask : mask -> mask **)
  
  let double_mask = function
  | IsPos p -> IsPos (Big.double p)
  | x0 -> x0
  
  (** val double_pred_mask : Big.big_int -> mask **)
  
  let double_pred_mask x =
    Big.positive_case
      (fun p -> IsPos (Big.double (Big.double
      p)))
      (fun p -> IsPos (Big.double
      (pred_double p)))
      (fun _ ->
      IsNul)
      x
  
  (** val pred_mask : mask -> mask **)
  
  let pred_mask = function
  | IsPos q ->
    (Big.positive_case
       (fun p0 -> IsPos
       (pred q))
       (fun p0 -> IsPos
       (pred q))
       (fun _ ->
       IsNul)
       q)
  | _ -> IsNeg
  
  (** val sub_mask : Big.big_int -> Big.big_int -> mask **)
  
  let rec sub_mask x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q ->
        double_mask (sub_mask p q))
        (fun q ->
        succ_double_mask (sub_mask p q))
        (fun _ -> IsPos (Big.double
        p))
        y)
      (fun p ->
      Big.positive_case
        (fun q ->
        succ_double_mask (sub_mask_carry p q))
        (fun q ->
        double_mask (sub_mask p q))
        (fun _ -> IsPos
        (pred_double p))
        y)
      (fun _ ->
      Big.positive_case
        (fun p ->
        IsNeg)
        (fun p ->
        IsNeg)
        (fun _ ->
        IsNul)
        y)
      x
  
  (** val sub_mask_carry : Big.big_int -> Big.big_int -> mask **)
  
  and sub_mask_carry x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q ->
        succ_double_mask (sub_mask_carry p q))
        (fun q ->
        double_mask (sub_mask p q))
        (fun _ -> IsPos
        (pred_double p))
        y)
      (fun p ->
      Big.positive_case
        (fun q ->
        double_mask (sub_mask_carry p q))
        (fun q ->
        succ_double_mask (sub_mask_carry p q))
        (fun _ ->
        double_pred_mask p)
        y)
      (fun _ ->
      IsNeg)
      x
  
  (** val sub : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let sub x y =
    match sub_mask x y with
    | IsPos z -> z
    | _ -> Big.one
  
  (** val mul : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let rec mul x y =
    Big.positive_case
      (fun p ->
      add y (Big.double (mul p y)))
      (fun p -> Big.double
      (mul p y))
      (fun _ ->
      y)
      x
  
  (** val iter : Big.big_int -> ('a1 -> 'a1) -> 'a1 -> 'a1 **)
  
  let rec iter n f x =
    Big.positive_case
      (fun n' ->
      f (iter n' f (iter n' f x)))
      (fun n' ->
      iter n' f (iter n' f x))
      (fun _ ->
      f x)
      n
  
  (** val pow : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let pow x y =
    iter y (mul x) Big.one
  
  (** val square : Big.big_int -> Big.big_int **)
  
  let rec square p =
    Big.positive_case
      (fun p0 -> Big.doubleplusone (Big.double
      (add (square p0) p0)))
      (fun p0 -> Big.double (Big.double
      (square p0)))
      (fun _ ->
      Big.one)
      p
  
  (** val div2 : Big.big_int -> Big.big_int **)
  
  let div2 p =
    Big.positive_case
      (fun p0 ->
      p0)
      (fun p0 ->
      p0)
      (fun _ ->
      Big.one)
      p
  
  (** val div2_up : Big.big_int -> Big.big_int **)
  
  let div2_up p =
    Big.positive_case
      (fun p0 ->
      succ p0)
      (fun p0 ->
      p0)
      (fun _ ->
      Big.one)
      p
  
  (** val size_nat : Big.big_int -> nat **)
  
  let rec size_nat p =
    Big.positive_case
      (fun p0 -> S
      (size_nat p0))
      (fun p0 -> S
      (size_nat p0))
      (fun _ -> S
      O)
      p
  
  (** val size : Big.big_int -> Big.big_int **)
  
  let rec size p =
    Big.positive_case
      (fun p0 ->
      succ (size p0))
      (fun p0 ->
      succ (size p0))
      (fun _ ->
      Big.one)
      p
  
  (** val compare_cont :
      Big.big_int -> Big.big_int -> comparison -> comparison **)
  
  let rec compare_cont x y r =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q ->
        compare_cont p q r)
        (fun q ->
        compare_cont p q Gt)
        (fun _ ->
        Gt)
        y)
      (fun p ->
      Big.positive_case
        (fun q ->
        compare_cont p q Lt)
        (fun q ->
        compare_cont p q r)
        (fun _ ->
        Gt)
        y)
      (fun _ ->
      Big.positive_case
        (fun q ->
        Lt)
        (fun q ->
        Lt)
        (fun _ ->
        r)
        y)
      x
  
  (** val compare : Big.big_int -> Big.big_int -> comparison **)
  
  let compare x y =
    compare_cont x y Eq
  
  (** val min : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let min p p' =
    match compare p p' with
    | Gt -> p'
    | _ -> p
  
  (** val max : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let max p p' =
    match compare p p' with
    | Gt -> p
    | _ -> p'
  
  (** val eqb : Big.big_int -> Big.big_int -> bool **)
  
  let rec eqb p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        eqb p0 q0)
        (fun p1 ->
        false)
        (fun _ ->
        false)
        q)
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        false)
        (fun q0 ->
        eqb p0 q0)
        (fun _ ->
        false)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        false)
        (fun p0 ->
        false)
        (fun _ ->
        true)
        q)
      p
  
  (** val leb : Big.big_int -> Big.big_int -> bool **)
  
  let leb x y =
    match compare x y with
    | Gt -> false
    | _ -> true
  
  (** val ltb : Big.big_int -> Big.big_int -> bool **)
  
  let ltb x y =
    match compare x y with
    | Lt -> true
    | _ -> false
  
  (** val sqrtrem_step :
      (Big.big_int -> Big.big_int) -> (Big.big_int -> Big.big_int) ->
      (Big.big_int * mask) -> Big.big_int * mask **)
  
  let sqrtrem_step f g0 = function
  | (s, y) ->
    (match y with
     | IsPos r ->
       let s' = Big.doubleplusone (Big.double s) in
       let r' = g0 (f r) in
       if leb s' r'
       then ((Big.doubleplusone s), (sub_mask r' s'))
       else ((Big.double s), (IsPos r'))
     | _ ->
       ((Big.double s),
         (sub_mask (g0 (f Big.one)) (Big.double (Big.double Big.one)))))
  
  (** val sqrtrem : Big.big_int -> Big.big_int * mask **)
  
  let rec sqrtrem p =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        sqrtrem_step (fun x -> Big.doubleplusone x) (fun x ->
          Big.doubleplusone x) (sqrtrem p1))
        (fun p1 ->
        sqrtrem_step (fun x -> Big.double x) (fun x -> Big.doubleplusone x)
          (sqrtrem p1))
        (fun _ -> (Big.one, (IsPos (Big.double
        Big.one))))
        p0)
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        sqrtrem_step (fun x -> Big.doubleplusone x) (fun x -> Big.double x)
          (sqrtrem p1))
        (fun p1 ->
        sqrtrem_step (fun x -> Big.double x) (fun x -> Big.double x)
          (sqrtrem p1))
        (fun _ -> (Big.one, (IsPos
        Big.one)))
        p0)
      (fun _ -> (Big.one,
      IsNul))
      p
  
  (** val sqrt : Big.big_int -> Big.big_int **)
  
  let sqrt p =
    fst (sqrtrem p)
  
  (** val gcdn : nat -> Big.big_int -> Big.big_int -> Big.big_int **)
  
  let rec gcdn n a b =
    match n with
    | O -> Big.one
    | S n0 ->
      (Big.positive_case
         (fun a' ->
         Big.positive_case
           (fun b' ->
           match compare a' b' with
           | Eq -> a
           | Lt -> gcdn n0 (sub b' a') a
           | Gt -> gcdn n0 (sub a' b') b)
           (fun b0 ->
           gcdn n0 a b0)
           (fun _ ->
           Big.one)
           b)
         (fun a0 ->
         Big.positive_case
           (fun p ->
           gcdn
             n0
             a0
             b)
           (fun b0 ->
           Big.double
           (gcdn
             n0
             a0
             b0))
           (fun _ ->
           Big.one)
           b)
         (fun _ ->
         Big.one)
         a)
  
  (** val gcd :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let gcd a b =
    gcdn
      (plus
        (size_nat
          a)
        (size_nat
          b))
      a
      b
  
  (** val ggcdn :
      nat
      ->
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int * (Big.big_int * Big.big_int) **)
  
  let rec ggcdn n a b =
    match n with
    | O ->
      (Big.one,
        (a,
        b))
    | S n0 ->
      (Big.positive_case
         (fun a' ->
         Big.positive_case
           (fun b' ->
           match compare
                   a'
                   b' with
           | Eq ->
             (a,
               (Big.one,
               Big.one))
           | Lt ->
             let (g0,
                  p) =
               ggcdn
                 n0
                 (sub
                   b'
                   a')
                 a
             in
             let (ba,
                  aa) =
               p
             in
             (g0,
             (aa,
             (add
               aa
               (Big.double
               ba))))
           | Gt ->
             let (g0,
                  p) =
               ggcdn
                 n0
                 (sub
                   a'
                   b')
                 b
             in
             let (ab,
                  bb) =
               p
             in
             (g0,
             ((add
                bb
                (Big.double
                ab)),
             bb)))
           (fun b0 ->
           let (g0,
                p) =
             ggcdn
               n0
               a
               b0
           in
           let (aa,
                bb) =
             p
           in
           (g0,
           (aa,
           (Big.double
           bb))))
           (fun _ ->
           (Big.one,
           (a,
           Big.one)))
           b)
         (fun a0 ->
         Big.positive_case
           (fun p ->
           let (g0,
                p0) =
             ggcdn
               n0
               a0
               b
           in
           let (aa,
                bb) =
             p0
           in
           (g0,
           ((Big.double
           aa),
           bb)))
           (fun b0 ->
           let (g0,
                p) =
             ggcdn
               n0
               a0
               b0
           in
           ((Big.double
           g0),
           p))
           (fun _ ->
           (Big.one,
           (a,
           Big.one)))
           b)
         (fun _ ->
         (Big.one,
         (Big.one,
         b)))
         a)
  
  (** val ggcd :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int * (Big.big_int * Big.big_int) **)
  
  let ggcd a b =
    ggcdn
      (plus
        (size_nat
          a)
        (size_nat
          b))
      a
      b
  
  (** val coq_Nsucc_double :
      Big.big_int
      ->
      Big.big_int **)
  
  let coq_Nsucc_double x =
    Big.n_case
      (fun _ ->
      Big.one)
      (fun p ->
      (Big.doubleplusone
      p))
      x
  
  (** val coq_Ndouble :
      Big.big_int
      ->
      Big.big_int **)
  
  let coq_Ndouble n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Big.double
      p))
      n
  
  (** val coq_lor :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec coq_lor p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        Big.doubleplusone
        (coq_lor
          p0
          q0))
        (fun q0 ->
        Big.doubleplusone
        (coq_lor
          p0
          q0))
        (fun _ ->
        p)
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        Big.doubleplusone
        (coq_lor
          p0
          q0))
        (fun q0 ->
        Big.double
        (coq_lor
          p0
          q0))
        (fun _ ->
        Big.doubleplusone
        p0)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        q)
        (fun q0 ->
        Big.doubleplusone
        q0)
        (fun _ ->
        q)
        q)
      p
  
  (** val coq_land :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec coq_land p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Nsucc_double
          (coq_land
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (coq_land
            p0
            q0))
        (fun _ ->
        Big.one)
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (coq_land
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (coq_land
            p0
            q0))
        (fun _ ->
        Big.zero)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        Big.one)
        (fun q0 ->
        Big.zero)
        (fun _ ->
        Big.one)
        q)
      p
  
  (** val ldiff :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec ldiff p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (ldiff
            p0
            q0))
        (fun q0 ->
        coq_Nsucc_double
          (ldiff
            p0
            q0))
        (fun _ ->
        (Big.double
        p0))
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (ldiff
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (ldiff
            p0
            q0))
        (fun _ ->
        p)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        Big.zero)
        (fun q0 ->
        Big.one)
        (fun _ ->
        Big.zero)
        q)
      p
  
  (** val coq_lxor :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec coq_lxor p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (coq_lxor
            p0
            q0))
        (fun q0 ->
        coq_Nsucc_double
          (coq_lxor
            p0
            q0))
        (fun _ ->
        (Big.double
        p0))
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Nsucc_double
          (coq_lxor
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (coq_lxor
            p0
            q0))
        (fun _ ->
        (Big.doubleplusone
        p0))
        q)
      (fun _ ->
      Big.positive_case
        (fun q0 ->
        (Big.double
        q0))
        (fun q0 ->
        (Big.doubleplusone
        q0))
        (fun _ ->
        Big.zero)
        q)
      p
  
  (** val shiftl_nat :
      Big.big_int
      ->
      nat
      ->
      Big.big_int **)
  
  let shiftl_nat p n =
    nat_iter
      n
      (fun x ->
      Big.double
      x)
      p
  
  (** val shiftr_nat :
      Big.big_int
      ->
      nat
      ->
      Big.big_int **)
  
  let shiftr_nat p n =
    nat_iter
      n
      div2
      p
  
  (** val shiftl :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let shiftl p n =
    Big.n_case
      (fun _ ->
      p)
      (fun n0 ->
      iter
        n0
        (fun x ->
        Big.double
        x)
        p)
      n
  
  (** val shiftr :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let shiftr p n =
    Big.n_case
      (fun _ ->
      p)
      (fun n0 ->
      iter
        n0
        div2
        p)
      n
  
  (** val testbit_nat :
      Big.big_int
      ->
      nat
      ->
      bool **)
  
  let rec testbit_nat p n =
    Big.positive_case
      (fun p0 ->
      match n with
      | O ->
        true
      | S n' ->
        testbit_nat
          p0
          n')
      (fun p0 ->
      match n with
      | O ->
        false
      | S n' ->
        testbit_nat
          p0
          n')
      (fun _ ->
      match n with
      | O ->
        true
      | S n0 ->
        false)
      p
  
  (** val testbit :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let rec testbit p n =
    Big.positive_case
      (fun p0 ->
      Big.n_case
        (fun _ ->
        true)
        (fun n0 ->
        testbit
          p0
          (pred_N
            n0))
        n)
      (fun p0 ->
      Big.n_case
        (fun _ ->
        false)
        (fun n0 ->
        testbit
          p0
          (pred_N
            n0))
        n)
      (fun _ ->
      Big.n_case
        (fun _ ->
        true)
        (fun p0 ->
        false)
        n)
      p
  
  (** val iter_op :
      ('a1
      ->
      'a1
      ->
      'a1)
      ->
      Big.big_int
      ->
      'a1
      ->
      'a1 **)
  
  let rec iter_op op p a =
    Big.positive_case
      (fun p0 ->
      op
        a
        (iter_op
          op
          p0
          (op
            a
            a)))
      (fun p0 ->
      iter_op
        op
        p0
        (op
          a
          a))
      (fun _ ->
      a)
      p
  
  (** val to_nat :
      Big.big_int
      ->
      nat **)
  
  let to_nat x =
    iter_op
      plus
      x
      (S
      O)
  
  (** val of_nat :
      nat
      ->
      Big.big_int **)
  
  let rec of_nat = function
  | O ->
    Big.one
  | S x ->
    (match x with
     | O ->
       Big.one
     | S n0 ->
       succ
         (of_nat
           x))
  
  (** val of_succ_nat :
      nat
      ->
      Big.big_int **)
  
  let rec of_succ_nat = function
  | O ->
    Big.one
  | S x ->
    succ
      (of_succ_nat
        x)
 end

module Coq_Pos = 
 struct 
  type t
    =
    Big.big_int
  
  (** val succ :
      Big.big_int
      ->
      Big.big_int **)
  
  let rec succ = Big.succ
  
  (** val add :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec add = Big.add
  
  (** val add_carry :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  and add_carry x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q ->
        Big.doubleplusone
        (add_carry
          p
          q))
        (fun q ->
        Big.double
        (add_carry
          p
          q))
        (fun _ ->
        Big.doubleplusone
        (succ
          p))
        y)
      (fun p ->
      Big.positive_case
        (fun q ->
        Big.double
        (add_carry
          p
          q))
        (fun q ->
        Big.doubleplusone
        (add
          p
          q))
        (fun _ ->
        Big.double
        (succ
          p))
        y)
      (fun _ ->
      Big.positive_case
        (fun q ->
        Big.doubleplusone
        (succ
          q))
        (fun q ->
        Big.double
        (succ
          q))
        (fun _ ->
        Big.doubleplusone
        Big.one)
        y)
      x
  
  (** val pred_double :
      Big.big_int
      ->
      Big.big_int **)
  
  let rec pred_double x =
    Big.positive_case
      (fun p ->
      Big.doubleplusone
      (Big.double
      p))
      (fun p ->
      Big.doubleplusone
      (pred_double
        p))
      (fun _ ->
      Big.one)
      x
  
  (** val pred :
      Big.big_int
      ->
      Big.big_int **)
  
  let pred = fun n -> Big.max Big.one (Big.pred n)
  
  (** val pred_N :
      Big.big_int
      ->
      Big.big_int **)
  
  let pred_N x =
    Big.positive_case
      (fun p ->
      (Big.double
      p))
      (fun p ->
      (pred_double
        p))
      (fun _ ->
      Big.zero)
      x
  
  type mask = Pos.mask =
  | IsNul
  | IsPos of Big.big_int
  | IsNeg
  
  (** val mask_rect :
      'a1
      ->
      (Big.big_int
      ->
      'a1)
      ->
      'a1
      ->
      mask
      ->
      'a1 **)
  
  let mask_rect f f0 f1 = function
  | IsNul ->
    f
  | IsPos x ->
    f0
      x
  | IsNeg ->
    f1
  
  (** val mask_rec :
      'a1
      ->
      (Big.big_int
      ->
      'a1)
      ->
      'a1
      ->
      mask
      ->
      'a1 **)
  
  let mask_rec f f0 f1 = function
  | IsNul ->
    f
  | IsPos x ->
    f0
      x
  | IsNeg ->
    f1
  
  (** val succ_double_mask :
      mask
      ->
      mask **)
  
  let succ_double_mask = function
  | IsNul ->
    IsPos
      Big.one
  | IsPos p ->
    IsPos
      (Big.doubleplusone
      p)
  | IsNeg ->
    IsNeg
  
  (** val double_mask :
      mask
      ->
      mask **)
  
  let double_mask = function
  | IsPos p ->
    IsPos
      (Big.double
      p)
  | x0 ->
    x0
  
  (** val double_pred_mask :
      Big.big_int
      ->
      mask **)
  
  let double_pred_mask x =
    Big.positive_case
      (fun p ->
      IsPos
      (Big.double
      (Big.double
      p)))
      (fun p ->
      IsPos
      (Big.double
      (pred_double
        p)))
      (fun _ ->
      IsNul)
      x
  
  (** val pred_mask :
      mask
      ->
      mask **)
  
  let pred_mask = function
  | IsPos q ->
    (Big.positive_case
       (fun p0 ->
       IsPos
       (pred
         q))
       (fun p0 ->
       IsPos
       (pred
         q))
       (fun _ ->
       IsNul)
       q)
  | _ ->
    IsNeg
  
  (** val sub_mask :
      Big.big_int
      ->
      Big.big_int
      ->
      mask **)
  
  let rec sub_mask x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q ->
        double_mask
          (sub_mask
            p
            q))
        (fun q ->
        succ_double_mask
          (sub_mask
            p
            q))
        (fun _ ->
        IsPos
        (Big.double
        p))
        y)
      (fun p ->
      Big.positive_case
        (fun q ->
        succ_double_mask
          (sub_mask_carry
            p
            q))
        (fun q ->
        double_mask
          (sub_mask
            p
            q))
        (fun _ ->
        IsPos
        (pred_double
          p))
        y)
      (fun _ ->
      Big.positive_case
        (fun p ->
        IsNeg)
        (fun p ->
        IsNeg)
        (fun _ ->
        IsNul)
        y)
      x
  
  (** val sub_mask_carry :
      Big.big_int
      ->
      Big.big_int
      ->
      mask **)
  
  and sub_mask_carry x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q ->
        succ_double_mask
          (sub_mask_carry
            p
            q))
        (fun q ->
        double_mask
          (sub_mask
            p
            q))
        (fun _ ->
        IsPos
        (pred_double
          p))
        y)
      (fun p ->
      Big.positive_case
        (fun q ->
        double_mask
          (sub_mask_carry
            p
            q))
        (fun q ->
        succ_double_mask
          (sub_mask_carry
            p
            q))
        (fun _ ->
        double_pred_mask
          p)
        y)
      (fun _ ->
      IsNeg)
      x
  
  (** val sub :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let sub = fun n m -> Big.max Big.one (Big.sub n m)
  
  (** val mul :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec mul = Big.mult
  
  (** val iter :
      Big.big_int
      ->
      ('a1
      ->
      'a1)
      ->
      'a1
      ->
      'a1 **)
  
  let rec iter n f x =
    Big.positive_case
      (fun n' ->
      f
        (iter
          n'
          f
          (iter
            n'
            f
            x)))
      (fun n' ->
      iter
        n'
        f
        (iter
          n'
          f
          x))
      (fun _ ->
      f
        x)
      n
  
  (** val pow :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let pow x y =
    iter
      y
      (mul
        x)
      Big.one
  
  (** val square :
      Big.big_int
      ->
      Big.big_int **)
  
  let rec square p =
    Big.positive_case
      (fun p0 ->
      Big.doubleplusone
      (Big.double
      (add
        (square
          p0)
        p0)))
      (fun p0 ->
      Big.double
      (Big.double
      (square
        p0)))
      (fun _ ->
      Big.one)
      p
  
  (** val div2 :
      Big.big_int
      ->
      Big.big_int **)
  
  let div2 p =
    Big.positive_case
      (fun p0 ->
      p0)
      (fun p0 ->
      p0)
      (fun _ ->
      Big.one)
      p
  
  (** val div2_up :
      Big.big_int
      ->
      Big.big_int **)
  
  let div2_up p =
    Big.positive_case
      (fun p0 ->
      succ
        p0)
      (fun p0 ->
      p0)
      (fun _ ->
      Big.one)
      p
  
  (** val size_nat :
      Big.big_int
      ->
      nat **)
  
  let rec size_nat p =
    Big.positive_case
      (fun p0 ->
      S
      (size_nat
        p0))
      (fun p0 ->
      S
      (size_nat
        p0))
      (fun _ ->
      S
      O)
      p
  
  (** val size :
      Big.big_int
      ->
      Big.big_int **)
  
  let rec size p =
    Big.positive_case
      (fun p0 ->
      succ
        (size
          p0))
      (fun p0 ->
      succ
        (size
          p0))
      (fun _ ->
      Big.one)
      p
  
  (** val compare_cont :
      Big.big_int
      ->
      Big.big_int
      ->
      comparison
      ->
      comparison **)
  
  let rec compare_cont = fun x y c -> Big.compare_case c Lt Gt x y
  
  (** val compare :
      Big.big_int
      ->
      Big.big_int
      ->
      comparison **)
  
  let compare = fun x y -> Big.compare_case Eq Lt Gt x y
  
  (** val min :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let min = Big.min
  
  (** val max :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let max = Big.max
  
  (** val eqb :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let rec eqb p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        eqb
          p0
          q0)
        (fun p1 ->
        false)
        (fun _ ->
        false)
        q)
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        false)
        (fun q0 ->
        eqb
          p0
          q0)
        (fun _ ->
        false)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        false)
        (fun p0 ->
        false)
        (fun _ ->
        true)
        q)
      p
  
  (** val leb :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let leb x y =
    match compare
            x
            y with
    | Gt ->
      false
    | _ ->
      true
  
  (** val ltb :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let ltb x y =
    match compare
            x
            y with
    | Lt ->
      true
    | _ ->
      false
  
  (** val sqrtrem_step :
      (Big.big_int
      ->
      Big.big_int)
      ->
      (Big.big_int
      ->
      Big.big_int)
      ->
      (Big.big_int * mask)
      ->
      Big.big_int * mask **)
  
  let sqrtrem_step f g0 = function
  | (s,
     y) ->
    (match y with
     | IsPos r ->
       let s' =
         Big.doubleplusone
         (Big.double
         s)
       in
       let r' =
         g0
           (f
             r)
       in
       if leb
            s'
            r'
       then ((Big.doubleplusone
              s),
              (sub_mask
                r'
                s'))
       else ((Big.double
              s),
              (IsPos
              r'))
     | _ ->
       ((Big.double
         s),
         (sub_mask
           (g0
             (f
               Big.one))
           (Big.double
           (Big.double
           Big.one)))))
  
  (** val sqrtrem :
      Big.big_int
      ->
      Big.big_int * mask **)
  
  let rec sqrtrem p =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        sqrtrem_step
          (fun x ->
          Big.doubleplusone
          x)
          (fun x ->
          Big.doubleplusone
          x)
          (sqrtrem
            p1))
        (fun p1 ->
        sqrtrem_step
          (fun x ->
          Big.double
          x)
          (fun x ->
          Big.doubleplusone
          x)
          (sqrtrem
            p1))
        (fun _ ->
        (Big.one,
        (IsPos
        (Big.double
        Big.one))))
        p0)
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        sqrtrem_step
          (fun x ->
          Big.doubleplusone
          x)
          (fun x ->
          Big.double
          x)
          (sqrtrem
            p1))
        (fun p1 ->
        sqrtrem_step
          (fun x ->
          Big.double
          x)
          (fun x ->
          Big.double
          x)
          (sqrtrem
            p1))
        (fun _ ->
        (Big.one,
        (IsPos
        Big.one)))
        p0)
      (fun _ ->
      (Big.one,
      IsNul))
      p
  
  (** val sqrt :
      Big.big_int
      ->
      Big.big_int **)
  
  let sqrt p =
    fst
      (sqrtrem
        p)
  
  (** val gcdn :
      nat
      ->
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec gcdn n a b =
    match n with
    | O ->
      Big.one
    | S n0 ->
      (Big.positive_case
         (fun a' ->
         Big.positive_case
           (fun b' ->
           match compare
                   a'
                   b' with
           | Eq ->
             a
           | Lt ->
             gcdn
               n0
               (sub
                 b'
                 a')
               a
           | Gt ->
             gcdn
               n0
               (sub
                 a'
                 b')
               b)
           (fun b0 ->
           gcdn
             n0
             a
             b0)
           (fun _ ->
           Big.one)
           b)
         (fun a0 ->
         Big.positive_case
           (fun p ->
           gcdn
             n0
             a0
             b)
           (fun b0 ->
           Big.double
           (gcdn
             n0
             a0
             b0))
           (fun _ ->
           Big.one)
           b)
         (fun _ ->
         Big.one)
         a)
  
  (** val gcd :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let gcd a b =
    gcdn
      (plus
        (size_nat
          a)
        (size_nat
          b))
      a
      b
  
  (** val ggcdn :
      nat
      ->
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int * (Big.big_int * Big.big_int) **)
  
  let rec ggcdn n a b =
    match n with
    | O ->
      (Big.one,
        (a,
        b))
    | S n0 ->
      (Big.positive_case
         (fun a' ->
         Big.positive_case
           (fun b' ->
           match compare
                   a'
                   b' with
           | Eq ->
             (a,
               (Big.one,
               Big.one))
           | Lt ->
             let (g0,
                  p) =
               ggcdn
                 n0
                 (sub
                   b'
                   a')
                 a
             in
             let (ba,
                  aa) =
               p
             in
             (g0,
             (aa,
             (add
               aa
               (Big.double
               ba))))
           | Gt ->
             let (g0,
                  p) =
               ggcdn
                 n0
                 (sub
                   a'
                   b')
                 b
             in
             let (ab,
                  bb) =
               p
             in
             (g0,
             ((add
                bb
                (Big.double
                ab)),
             bb)))
           (fun b0 ->
           let (g0,
                p) =
             ggcdn
               n0
               a
               b0
           in
           let (aa,
                bb) =
             p
           in
           (g0,
           (aa,
           (Big.double
           bb))))
           (fun _ ->
           (Big.one,
           (a,
           Big.one)))
           b)
         (fun a0 ->
         Big.positive_case
           (fun p ->
           let (g0,
                p0) =
             ggcdn
               n0
               a0
               b
           in
           let (aa,
                bb) =
             p0
           in
           (g0,
           ((Big.double
           aa),
           bb)))
           (fun b0 ->
           let (g0,
                p) =
             ggcdn
               n0
               a0
               b0
           in
           ((Big.double
           g0),
           p))
           (fun _ ->
           (Big.one,
           (a,
           Big.one)))
           b)
         (fun _ ->
         (Big.one,
         (Big.one,
         b)))
         a)
  
  (** val ggcd :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int * (Big.big_int * Big.big_int) **)
  
  let ggcd a b =
    ggcdn
      (plus
        (size_nat
          a)
        (size_nat
          b))
      a
      b
  
  (** val coq_Nsucc_double :
      Big.big_int
      ->
      Big.big_int **)
  
  let coq_Nsucc_double x =
    Big.n_case
      (fun _ ->
      Big.one)
      (fun p ->
      (Big.doubleplusone
      p))
      x
  
  (** val coq_Ndouble :
      Big.big_int
      ->
      Big.big_int **)
  
  let coq_Ndouble n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Big.double
      p))
      n
  
  (** val coq_lor :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec coq_lor p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        Big.doubleplusone
        (coq_lor
          p0
          q0))
        (fun q0 ->
        Big.doubleplusone
        (coq_lor
          p0
          q0))
        (fun _ ->
        p)
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        Big.doubleplusone
        (coq_lor
          p0
          q0))
        (fun q0 ->
        Big.double
        (coq_lor
          p0
          q0))
        (fun _ ->
        Big.doubleplusone
        p0)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        q)
        (fun q0 ->
        Big.doubleplusone
        q0)
        (fun _ ->
        q)
        q)
      p
  
  (** val coq_land :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec coq_land p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Nsucc_double
          (coq_land
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (coq_land
            p0
            q0))
        (fun _ ->
        Big.one)
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (coq_land
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (coq_land
            p0
            q0))
        (fun _ ->
        Big.zero)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        Big.one)
        (fun q0 ->
        Big.zero)
        (fun _ ->
        Big.one)
        q)
      p
  
  (** val ldiff :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec ldiff p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (ldiff
            p0
            q0))
        (fun q0 ->
        coq_Nsucc_double
          (ldiff
            p0
            q0))
        (fun _ ->
        (Big.double
        p0))
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (ldiff
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (ldiff
            p0
            q0))
        (fun _ ->
        p)
        q)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        Big.zero)
        (fun q0 ->
        Big.one)
        (fun _ ->
        Big.zero)
        q)
      p
  
  (** val coq_lxor :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let rec coq_lxor p q =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Ndouble
          (coq_lxor
            p0
            q0))
        (fun q0 ->
        coq_Nsucc_double
          (coq_lxor
            p0
            q0))
        (fun _ ->
        (Big.double
        p0))
        q)
      (fun p0 ->
      Big.positive_case
        (fun q0 ->
        coq_Nsucc_double
          (coq_lxor
            p0
            q0))
        (fun q0 ->
        coq_Ndouble
          (coq_lxor
            p0
            q0))
        (fun _ ->
        (Big.doubleplusone
        p0))
        q)
      (fun _ ->
      Big.positive_case
        (fun q0 ->
        (Big.double
        q0))
        (fun q0 ->
        (Big.doubleplusone
        q0))
        (fun _ ->
        Big.zero)
        q)
      p
  
  (** val shiftl_nat :
      Big.big_int
      ->
      nat
      ->
      Big.big_int **)
  
  let shiftl_nat p n =
    nat_iter
      n
      (fun x ->
      Big.double
      x)
      p
  
  (** val shiftr_nat :
      Big.big_int
      ->
      nat
      ->
      Big.big_int **)
  
  let shiftr_nat p n =
    nat_iter
      n
      div2
      p
  
  (** val shiftl :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let shiftl p n =
    Big.n_case
      (fun _ ->
      p)
      (fun n0 ->
      iter
        n0
        (fun x ->
        Big.double
        x)
        p)
      n
  
  (** val shiftr :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let shiftr p n =
    Big.n_case
      (fun _ ->
      p)
      (fun n0 ->
      iter
        n0
        div2
        p)
      n
  
  (** val testbit_nat :
      Big.big_int
      ->
      nat
      ->
      bool **)
  
  let rec testbit_nat p n =
    Big.positive_case
      (fun p0 ->
      match n with
      | O ->
        true
      | S n' ->
        testbit_nat
          p0
          n')
      (fun p0 ->
      match n with
      | O ->
        false
      | S n' ->
        testbit_nat
          p0
          n')
      (fun _ ->
      match n with
      | O ->
        true
      | S n0 ->
        false)
      p
  
  (** val testbit :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let rec testbit p n =
    Big.positive_case
      (fun p0 ->
      Big.n_case
        (fun _ ->
        true)
        (fun n0 ->
        testbit
          p0
          (pred_N
            n0))
        n)
      (fun p0 ->
      Big.n_case
        (fun _ ->
        false)
        (fun n0 ->
        testbit
          p0
          (pred_N
            n0))
        n)
      (fun _ ->
      Big.n_case
        (fun _ ->
        true)
        (fun p0 ->
        false)
        n)
      p
  
  (** val iter_op :
      ('a1
      ->
      'a1
      ->
      'a1)
      ->
      Big.big_int
      ->
      'a1
      ->
      'a1 **)
  
  let rec iter_op op p a =
    Big.positive_case
      (fun p0 ->
      op
        a
        (iter_op
          op
          p0
          (op
            a
            a)))
      (fun p0 ->
      iter_op
        op
        p0
        (op
          a
          a))
      (fun _ ->
      a)
      p
  
  (** val to_nat :
      Big.big_int
      ->
      nat **)
  
  let to_nat x =
    iter_op
      plus
      x
      (S
      O)
  
  (** val of_nat :
      nat
      ->
      Big.big_int **)
  
  let rec of_nat = function
  | O ->
    Big.one
  | S x ->
    (match x with
     | O ->
       Big.one
     | S n0 ->
       succ
         (of_nat
           x))
  
  (** val of_succ_nat :
      nat
      ->
      Big.big_int **)
  
  let rec of_succ_nat = function
  | O ->
    Big.one
  | S x ->
    succ
      (of_succ_nat
        x)
  
  (** val eq_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let rec eq_dec p y1 =
    Big.positive_case
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        eq_dec
          p0
          p1)
        (fun p1 ->
        false)
        (fun _ ->
        false)
        y1)
      (fun p0 ->
      Big.positive_case
        (fun p1 ->
        false)
        (fun p1 ->
        eq_dec
          p0
          p1)
        (fun _ ->
        false)
        y1)
      (fun _ ->
      Big.positive_case
        (fun p0 ->
        false)
        (fun p0 ->
        false)
        (fun _ ->
        true)
        y1)
      p
  
  (** val peano_rect :
      'a1
      ->
      (Big.big_int
      ->
      'a1
      ->
      'a1)
      ->
      Big.big_int
      ->
      'a1 **)
  
  let rec peano_rect a f p =
    let f2 =
      peano_rect
        (f
          Big.one
          a)
        (fun p0 x ->
        f
          (succ
            (Big.double
            p0))
          (f
            (Big.double
            p0)
            x))
    in
    (Big.positive_case
       (fun q ->
       f
         (Big.double
         q)
         (f2
           q))
       (fun q ->
       f2
         q)
       (fun _ ->
       a)
       p)
  
  (** val peano_rec :
      'a1
      ->
      (Big.big_int
      ->
      'a1
      ->
      'a1)
      ->
      Big.big_int
      ->
      'a1 **)
  
  let peano_rec =
    peano_rect
  
  type coq_PeanoView =
  | PeanoOne
  | PeanoSucc of Big.big_int
     * coq_PeanoView
  
  (** val coq_PeanoView_rect :
      'a1
      ->
      (Big.big_int
      ->
      coq_PeanoView
      ->
      'a1
      ->
      'a1)
      ->
      Big.big_int
      ->
      coq_PeanoView
      ->
      'a1 **)
  
  let rec coq_PeanoView_rect f f0 p = function
  | PeanoOne ->
    f
  | PeanoSucc (p1,
               p2) ->
    f0
      p1
      p2
      (coq_PeanoView_rect
        f
        f0
        p1
        p2)
  
  (** val coq_PeanoView_rec :
      'a1
      ->
      (Big.big_int
      ->
      coq_PeanoView
      ->
      'a1
      ->
      'a1)
      ->
      Big.big_int
      ->
      coq_PeanoView
      ->
      'a1 **)
  
  let rec coq_PeanoView_rec f f0 p = function
  | PeanoOne ->
    f
  | PeanoSucc (p1,
               p2) ->
    f0
      p1
      p2
      (coq_PeanoView_rec
        f
        f0
        p1
        p2)
  
  (** val peanoView_xO :
      Big.big_int
      ->
      coq_PeanoView
      ->
      coq_PeanoView **)
  
  let rec peanoView_xO p = function
  | PeanoOne ->
    PeanoSucc
      (Big.one,
      PeanoOne)
  | PeanoSucc (p0,
               q0) ->
    PeanoSucc
      ((succ
         (Big.double
         p0)),
      (PeanoSucc
      ((Big.double
      p0),
      (peanoView_xO
        p0
        q0))))
  
  (** val peanoView_xI :
      Big.big_int
      ->
      coq_PeanoView
      ->
      coq_PeanoView **)
  
  let rec peanoView_xI p = function
  | PeanoOne ->
    PeanoSucc
      ((succ
         Big.one),
      (PeanoSucc
      (Big.one,
      PeanoOne)))
  | PeanoSucc (p0,
               q0) ->
    PeanoSucc
      ((succ
         (Big.doubleplusone
         p0)),
      (PeanoSucc
      ((Big.doubleplusone
      p0),
      (peanoView_xI
        p0
        q0))))
  
  (** val peanoView :
      Big.big_int
      ->
      coq_PeanoView **)
  
  let rec peanoView p =
    Big.positive_case
      (fun p0 ->
      peanoView_xI
        p0
        (peanoView
          p0))
      (fun p0 ->
      peanoView_xO
        p0
        (peanoView
          p0))
      (fun _ ->
      PeanoOne)
      p
  
  (** val coq_PeanoView_iter :
      'a1
      ->
      (Big.big_int
      ->
      'a1
      ->
      'a1)
      ->
      Big.big_int
      ->
      coq_PeanoView
      ->
      'a1 **)
  
  let rec coq_PeanoView_iter a f p = function
  | PeanoOne ->
    a
  | PeanoSucc (p0,
               q0) ->
    f
      p0
      (coq_PeanoView_iter
        a
        f
        p0
        q0)
  
  (** val eqb_spec :
      Big.big_int
      ->
      Big.big_int
      ->
      reflect **)
  
  let eqb_spec x y =
    iff_reflect
      (eqb
        x
        y)
  
  (** val switch_Eq :
      comparison
      ->
      comparison
      ->
      comparison **)
  
  let switch_Eq c = function
  | Eq ->
    c
  | x ->
    x
  
  (** val mask2cmp :
      mask
      ->
      comparison **)
  
  let mask2cmp = function
  | IsNul ->
    Eq
  | IsPos p0 ->
    Gt
  | IsNeg ->
    Lt
  
  (** val leb_spec0 :
      Big.big_int
      ->
      Big.big_int
      ->
      reflect **)
  
  let leb_spec0 x y =
    iff_reflect
      (leb
        x
        y)
  
  (** val ltb_spec0 :
      Big.big_int
      ->
      Big.big_int
      ->
      reflect **)
  
  let ltb_spec0 x y =
    iff_reflect
      (ltb
        x
        y)
  
  module Private_Tac = 
   struct 
    
   end
  
  module Private_Dec = 
   struct 
    (** val max_case_strong :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        'a1 **)
    
    let max_case_strong n m compat hl hr =
      let c =
        compSpec2Type
          n
          m
          (compare
            n
            m)
      in
      (match c with
       | CompGtT ->
         compat
           n
           (max
             n
             m)
           __
           (hl
             __)
       | _ ->
         compat
           m
           (max
             n
             m)
           __
           (hr
             __))
    
    (** val max_case :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        'a1
        ->
        'a1
        ->
        'a1 **)
    
    let max_case n m x x0 x1 =
      max_case_strong
        n
        m
        x
        (fun _ ->
        x0)
        (fun _ ->
        x1)
    
    (** val max_dec :
        Big.big_int
        ->
        Big.big_int
        ->
        bool **)
    
    let max_dec n m =
      max_case
        n
        m
        (fun x y _ h0 ->
        h0)
        true
        false
    
    (** val min_case_strong :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        'a1 **)
    
    let min_case_strong n m compat hl hr =
      let c =
        compSpec2Type
          n
          m
          (compare
            n
            m)
      in
      (match c with
       | CompGtT ->
         compat
           m
           (min
             n
             m)
           __
           (hr
             __)
       | _ ->
         compat
           n
           (min
             n
             m)
           __
           (hl
             __))
    
    (** val min_case :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        'a1
        ->
        'a1
        ->
        'a1 **)
    
    let min_case n m x x0 x1 =
      min_case_strong
        n
        m
        x
        (fun _ ->
        x0)
        (fun _ ->
        x1)
    
    (** val min_dec :
        Big.big_int
        ->
        Big.big_int
        ->
        bool **)
    
    let min_dec n m =
      min_case
        n
        m
        (fun x y _ h0 ->
        h0)
        true
        false
   end
  
  (** val max_case_strong :
      Big.big_int
      ->
      Big.big_int
      ->
      (__
      ->
      'a1)
      ->
      (__
      ->
      'a1)
      ->
      'a1 **)
  
  let max_case_strong n m x x0 =
    Private_Dec.max_case_strong
      n
      m
      (fun x1 y _ x2 ->
      x2)
      x
      x0
  
  (** val max_case :
      Big.big_int
      ->
      Big.big_int
      ->
      'a1
      ->
      'a1
      ->
      'a1 **)
  
  let max_case n m x x0 =
    max_case_strong
      n
      m
      (fun _ ->
      x)
      (fun _ ->
      x0)
  
  (** val max_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let max_dec =
    Private_Dec.max_dec
  
  (** val min_case_strong :
      Big.big_int
      ->
      Big.big_int
      ->
      (__
      ->
      'a1)
      ->
      (__
      ->
      'a1)
      ->
      'a1 **)
  
  let min_case_strong n m x x0 =
    Private_Dec.min_case_strong
      n
      m
      (fun x1 y _ x2 ->
      x2)
      x
      x0
  
  (** val min_case :
      Big.big_int
      ->
      Big.big_int
      ->
      'a1
      ->
      'a1
      ->
      'a1 **)
  
  let min_case n m x x0 =
    min_case_strong
      n
      m
      (fun _ ->
      x)
      (fun _ ->
      x0)
  
  (** val min_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let min_dec =
    Private_Dec.min_dec
 end

module N = 
 struct 
  type t
    =
    Big.big_int
  
  (** val zero :
      Big.big_int **)
  
  let zero =
    Big.zero
  
  (** val one :
      Big.big_int **)
  
  let one =
    Big.one
  
  (** val two :
      Big.big_int **)
  
  let two =
    (Big.double
      Big.one)
  
  (** val succ_double :
      Big.big_int
      ->
      Big.big_int **)
  
  let succ_double x =
    Big.n_case
      (fun _ ->
      Big.one)
      (fun p ->
      (Big.doubleplusone
      p))
      x
  
  (** val double :
      Big.big_int
      ->
      Big.big_int **)
  
  let double n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Big.double
      p))
      n
  
  (** val succ :
      Big.big_int
      ->
      Big.big_int **)
  
  let succ = Big.succ
  
  (** val pred :
      Big.big_int
      ->
      Big.big_int **)
  
  let pred = fun n -> Big.max Big.zero (Big.pred n)
  
  (** val succ_pos :
      Big.big_int
      ->
      Big.big_int **)
  
  let succ_pos n =
    Big.n_case
      (fun _ ->
      Big.one)
      (fun p ->
      Coq_Pos.succ
        p)
      n
  
  (** val add :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let add = Big.add
  
  (** val sub :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let sub = fun n m -> Big.max Big.zero (Big.sub n m)
  
  (** val mul :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let mul = Big.mult
  
  (** val compare :
      Big.big_int
      ->
      Big.big_int
      ->
      comparison **)
  
  let compare = Big.compare_case Eq Lt Gt
  
  (** val eqb :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let rec eqb n m =
    Big.n_case
      (fun _ ->
      Big.n_case
        (fun _ ->
        true)
        (fun p ->
        false)
        m)
      (fun p ->
      Big.n_case
        (fun _ ->
        false)
        (fun q ->
        Coq_Pos.eqb
          p
          q)
        m)
      n
  
  (** val leb :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let leb x y =
    match compare
            x
            y with
    | Gt ->
      false
    | _ ->
      true
  
  (** val ltb :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let ltb x y =
    match compare
            x
            y with
    | Lt ->
      true
    | _ ->
      false
  
  (** val min :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let min = Big.min
  
  (** val max :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let max = Big.max
  
  (** val div2 :
      Big.big_int
      ->
      Big.big_int **)
  
  let div2 n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p0 ->
      Big.positive_case
        (fun p ->
        p)
        (fun p ->
        p)
        (fun _ ->
        Big.zero)
        p0)
      n
  
  (** val even :
      Big.big_int
      ->
      bool **)
  
  let even n =
    Big.n_case
      (fun _ ->
      true)
      (fun p ->
      Big.positive_case
        (fun p0 ->
        false)
        (fun p0 ->
        true)
        (fun _ ->
        false)
        p)
      n
  
  (** val odd :
      Big.big_int
      ->
      bool **)
  
  let odd n =
    negb
      (even
        n)
  
  (** val pow :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let pow n p =
    Big.n_case
      (fun _ ->
      Big.one)
      (fun p0 ->
      Big.n_case
        (fun _ ->
        Big.zero)
        (fun q ->
        (Coq_Pos.pow q p0))
        n)
      p
  
  (** val square : Big.big_int -> Big.big_int **)
  
  let square n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Coq_Pos.square p))
      n
  
  (** val log2 : Big.big_int -> Big.big_int **)
  
  let log2 n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p0 ->
      Big.positive_case
        (fun p ->
        (Coq_Pos.size p))
        (fun p ->
        (Coq_Pos.size p))
        (fun _ ->
        Big.zero)
        p0)
      n
  
  (** val size : Big.big_int -> Big.big_int **)
  
  let size n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Coq_Pos.size p))
      n
  
  (** val size_nat : Big.big_int -> nat **)
  
  let size_nat n =
    Big.n_case
      (fun _ ->
      O)
      (fun p ->
      Coq_Pos.size_nat p)
      n
  
  (** val pos_div_eucl :
      Big.big_int -> Big.big_int -> Big.big_int * Big.big_int **)
  
  let rec pos_div_eucl a b =
    Big.positive_case
      (fun a' ->
      let (q, r) = pos_div_eucl a' b in
      let r' = succ_double r in
      if leb b r' then ((succ_double q), (sub r' b)) else ((double q), r'))
      (fun a' ->
      let (q, r) = pos_div_eucl a' b in
      let r' = double r in
      if leb b r' then ((succ_double q), (sub r' b)) else ((double q), r'))
      (fun _ ->
      Big.n_case
        (fun _ -> (Big.zero,
        Big.one))
        (fun p ->
        Big.positive_case
          (fun p0 -> (Big.zero,
          Big.one))
          (fun p0 -> (Big.zero,
          Big.one))
          (fun _ -> (Big.one,
          Big.zero))
          p)
        b)
      a
  
  (** val div_eucl :
      Big.big_int -> Big.big_int -> Big.big_int * Big.big_int **)
  
  let div_eucl a b =
    Big.n_case
      (fun _ -> (Big.zero,
      Big.zero))
      (fun na ->
      Big.n_case
        (fun _ -> (Big.zero,
        a))
        (fun p ->
        pos_div_eucl na b)
        b)
      a
  
  (** val div : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let div = fun a b -> if Big.eq b Big.zero then Big.zero else Big.div a b
  
  (** val modulo : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let modulo = fun a b -> if Big.eq b Big.zero then Big.zero else Big.modulo a b
  
  (** val gcd : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let gcd a b =
    Big.n_case
      (fun _ ->
      b)
      (fun p ->
      Big.n_case
        (fun _ ->
        a)
        (fun q ->
        (Coq_Pos.gcd p q))
        b)
      a
  
  (** val ggcd :
      Big.big_int -> Big.big_int -> Big.big_int * (Big.big_int * Big.big_int) **)
  
  let ggcd a b =
    Big.n_case
      (fun _ -> (b, (Big.zero,
      Big.one)))
      (fun p ->
      Big.n_case
        (fun _ -> (a, (Big.one,
        Big.zero)))
        (fun q ->
        let (g0, p0) = Coq_Pos.ggcd p q in
        let (aa, bb) = p0 in (g0, (aa, bb)))
        b)
      a
  
  (** val sqrtrem : Big.big_int -> Big.big_int * Big.big_int **)
  
  let sqrtrem n =
    Big.n_case
      (fun _ -> (Big.zero,
      Big.zero))
      (fun p ->
      let (s, m) = Coq_Pos.sqrtrem p in
      (match m with
       | Coq_Pos.IsPos r -> (s, r)
       | _ -> (s, Big.zero)))
      n
  
  (** val sqrt : Big.big_int -> Big.big_int **)
  
  let sqrt n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Coq_Pos.sqrt p))
      n
  
  (** val coq_lor : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let coq_lor n m =
    Big.n_case
      (fun _ ->
      m)
      (fun p ->
      Big.n_case
        (fun _ ->
        n)
        (fun q ->
        (Coq_Pos.coq_lor p q))
        m)
      n
  
  (** val coq_land : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let coq_land n m =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      Big.n_case
        (fun _ ->
        Big.zero)
        (fun q ->
        Coq_Pos.coq_land p q)
        m)
      n
  
  (** val ldiff : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let rec ldiff n m =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun p ->
      Big.n_case
        (fun _ ->
        n)
        (fun q ->
        Coq_Pos.ldiff p q)
        m)
      n
  
  (** val coq_lxor : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let coq_lxor n m =
    Big.n_case
      (fun _ ->
      m)
      (fun p ->
      Big.n_case
        (fun _ ->
        n)
        (fun q ->
        Coq_Pos.coq_lxor p q)
        m)
      n
  
  (** val shiftl_nat : Big.big_int -> nat -> Big.big_int **)
  
  let shiftl_nat a n =
    nat_iter n double a
  
  (** val shiftr_nat : Big.big_int -> nat -> Big.big_int **)
  
  let shiftr_nat a n =
    nat_iter n div2 a
  
  (** val shiftl : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let shiftl a n =
    Big.n_case
      (fun _ ->
      Big.zero)
      (fun a0 ->
      (Coq_Pos.shiftl a0 n))
      a
  
  (** val shiftr : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let shiftr a n =
    Big.n_case
      (fun _ ->
      a)
      (fun p ->
      Coq_Pos.iter p div2 a)
      n
  
  (** val testbit_nat : Big.big_int -> nat -> bool **)
  
  let testbit_nat a =
    Big.n_case
      (fun _ x ->
      false)
      (fun p ->
      Coq_Pos.testbit_nat p)
      a
  
  (** val testbit : Big.big_int -> Big.big_int -> bool **)
  
  let testbit a n =
    Big.n_case
      (fun _ ->
      false)
      (fun p ->
      Coq_Pos.testbit p n)
      a
  
  (** val to_nat : Big.big_int -> nat **)
  
  let to_nat a =
    Big.n_case
      (fun _ ->
      O)
      (fun p ->
      Coq_Pos.to_nat p)
      a
  
  (** val of_nat : nat -> Big.big_int **)
  
  let of_nat = function
  | O -> Big.zero
  | S n' -> (Coq_Pos.of_succ_nat n')
  
  (** val iter : Big.big_int -> ('a1 -> 'a1) -> 'a1 -> 'a1 **)
  
  let iter n f x =
    Big.n_case
      (fun _ ->
      x)
      (fun p ->
      Coq_Pos.iter p f x)
      n
  
  (** val eq_dec : Big.big_int -> Big.big_int -> bool **)
  
  let eq_dec n m =
    Big.n_case
      (fun _ ->
      Big.n_case
        (fun _ ->
        true)
        (fun p ->
        false)
        m)
      (fun x ->
      Big.n_case
        (fun _ ->
        false)
        (fun p0 ->
        Coq_Pos.eq_dec x p0)
        m)
      n
  
  (** val discr : Big.big_int -> Big.big_int option **)
  
  let discr n =
    Big.n_case
      (fun _ ->
      None)
      (fun p -> Some
      p)
      n
  
  (** val binary_rect :
      'a1 -> (Big.big_int -> 'a1 -> 'a1) -> (Big.big_int -> 'a1 -> 'a1) ->
      Big.big_int -> 'a1 **)
  
  let binary_rect f0 f2 fS2 n =
    let f2' = fun p -> f2 p in
    let fS2' = fun p -> fS2 p in
    (Big.n_case
       (fun _ ->
       f0)
       (fun p ->
       let rec f p0 =
         Big.positive_case
           (fun p1 ->
           fS2' p1 (f p1))
           (fun p1 ->
           f2' p1 (f p1))
           (fun _ ->
           fS2 Big.zero f0)
           p0
       in f p)
       n)
  
  (** val binary_rec :
      'a1 -> (Big.big_int -> 'a1 -> 'a1) -> (Big.big_int -> 'a1 -> 'a1) ->
      Big.big_int -> 'a1 **)
  
  let binary_rec =
    binary_rect
  
  (** val peano_rect :
      'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1 **)
  
  let peano_rect f0 f n =
    let f' = fun p -> f p in
    (Big.n_case
       (fun _ ->
       f0)
       (fun p ->
       Coq_Pos.peano_rect (f Big.zero f0) f' p)
       n)
  
  (** val peano_rec :
      'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1 **)
  
  let peano_rec =
    peano_rect
  
  (** val leb_spec0 : Big.big_int -> Big.big_int -> reflect **)
  
  let leb_spec0 x y =
    iff_reflect (leb x y)
  
  (** val ltb_spec0 : Big.big_int -> Big.big_int -> reflect **)
  
  let ltb_spec0 x y =
    iff_reflect (ltb x y)
  
  module Private_BootStrap = 
   struct 
    
   end
  
  (** val recursion :
      'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1 **)
  
  let recursion x =
    peano_rect x
  
  module Private_OrderTac = 
   struct 
    module IsTotal = 
     struct 
      
     end
    
    module Tac = 
     struct 
      
     end
   end
  
  module Private_NZPow = 
   struct 
    
   end
  
  module Private_NZSqrt = 
   struct 
    
   end
  
  (** val sqrt_up : Big.big_int -> Big.big_int **)
  
  let sqrt_up a =
    match compare Big.zero a with
    | Lt -> succ (sqrt (pred a))
    | _ -> Big.zero
  
  (** val log2_up : Big.big_int -> Big.big_int **)
  
  let log2_up a =
    match compare Big.one a with
    | Lt -> succ (log2 (pred a))
    | _ -> Big.zero
  
  module Private_NZDiv = 
   struct 
    
   end
  
  (** val lcm : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let lcm a b =
    mul a (div b (gcd a b))
  
  (** val eqb_spec : Big.big_int -> Big.big_int -> reflect **)
  
  let eqb_spec x y =
    iff_reflect (eqb x y)
  
  (** val b2n : bool -> Big.big_int **)
  
  let b2n = function
  | true -> Big.one
  | false -> Big.zero
  
  (** val setbit : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let setbit a n =
    coq_lor a (shiftl Big.one n)
  
  (** val clearbit : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let clearbit a n =
    ldiff a (shiftl Big.one n)
  
  (** val ones : Big.big_int -> Big.big_int **)
  
  let ones n =
    pred (shiftl Big.one n)
  
  (** val lnot : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let lnot a n =
    coq_lxor a (ones n)
  
  module Private_Tac = 
   struct 
    
   end
  
  module Private_Dec = 
   struct 
    (** val max_case_strong :
        Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ ->
        'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1 **)
    
    let max_case_strong n m compat hl hr =
      let c = compSpec2Type n m (compare n m) in
      (match c with
       | CompGtT -> compat n (max n m) __ (hl __)
       | _ -> compat m (max n m) __ (hr __))
    
    (** val max_case :
        Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ ->
        'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1 **)
    
    let max_case n m x x0 x1 =
      max_case_strong n m x (fun _ -> x0) (fun _ -> x1)
    
    (** val max_dec : Big.big_int -> Big.big_int -> bool **)
    
    let max_dec n m =
      max_case n m (fun x y _ h0 -> h0) true false
    
    (** val min_case_strong :
        Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ ->
        'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1 **)
    
    let min_case_strong n m compat hl hr =
      let c = compSpec2Type n m (compare n m) in
      (match c with
       | CompGtT -> compat m (min n m) __ (hr __)
       | _ -> compat n (min n m) __ (hl __))
    
    (** val min_case :
        Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ ->
        'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1 **)
    
    let min_case n m x x0 x1 =
      min_case_strong n m x (fun _ -> x0) (fun _ -> x1)
    
    (** val min_dec : Big.big_int -> Big.big_int -> bool **)
    
    let min_dec n m =
      min_case n m (fun x y _ h0 -> h0) true false
   end
  
  (** val max_case_strong :
      Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1 **)
  
  let max_case_strong n m x x0 =
    Private_Dec.max_case_strong n m (fun x1 y _ x2 -> x2) x x0
  
  (** val max_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1 **)
  
  let max_case n m x x0 =
    max_case_strong n m (fun _ -> x) (fun _ -> x0)
  
  (** val max_dec : Big.big_int -> Big.big_int -> bool **)
  
  let max_dec =
    Private_Dec.max_dec
  
  (** val min_case_strong :
      Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1 **)
  
  let min_case_strong n m x x0 =
    Private_Dec.min_case_strong n m (fun x1 y _ x2 -> x2) x x0
  
  (** val min_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1 **)
  
  let min_case n m x x0 =
    min_case_strong n m (fun _ -> x) (fun _ -> x0)
  
  (** val min_dec : Big.big_int -> Big.big_int -> bool **)
  
  let min_dec =
    Private_Dec.min_dec
 end

(** val leb0 : nat -> nat -> bool **)

let rec leb0 m x =
  match m with
  | O -> true
  | S m' ->
    (match x with
     | O -> false
     | S n' -> leb0 m' n')

module Z = 
 struct 
  type t = Big.big_int
  
  (** val zero : Big.big_int **)
  
  let zero =
    Big.zero
  
  (** val one : Big.big_int **)
  
  let one =
    Big.one
  
  (** val two : Big.big_int **)
  
  let two =
    (Big.double Big.one)
  
  (** val double : Big.big_int -> Big.big_int **)
  
  let double x =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p -> (Big.double
      p))
      (fun p -> Big.opp (Big.double
      p))
      x
  
  (** val succ_double : Big.big_int -> Big.big_int **)
  
  let succ_double x =
    Big.z_case
      (fun _ ->
      Big.one)
      (fun p -> (Big.doubleplusone
      p))
      (fun p -> Big.opp
      (Coq_Pos.pred_double p))
      x
  
  (** val pred_double : Big.big_int -> Big.big_int **)
  
  let pred_double x =
    Big.z_case
      (fun _ -> Big.opp
      Big.one)
      (fun p ->
      (Coq_Pos.pred_double p))
      (fun p -> Big.opp (Big.doubleplusone
      p))
      x
  
  (** val pos_sub : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let rec pos_sub x y =
    Big.positive_case
      (fun p ->
      Big.positive_case
        (fun q ->
        double (pos_sub p q))
        (fun q ->
        succ_double (pos_sub p q))
        (fun _ -> (Big.double
        p))
        y)
      (fun p ->
      Big.positive_case
        (fun q ->
        pred_double (pos_sub p q))
        (fun q ->
        double (pos_sub p q))
        (fun _ ->
        (Coq_Pos.pred_double p))
        y)
      (fun _ ->
      Big.positive_case
        (fun q -> Big.opp (Big.double
        q))
        (fun q -> Big.opp
        (Coq_Pos.pred_double q))
        (fun _ ->
        Big.zero)
        y)
      x
  
  (** val add : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let add = Big.add
  
  (** val opp : Big.big_int -> Big.big_int **)
  
  let opp = Big.opp
  
  (** val succ : Big.big_int -> Big.big_int **)
  
  let succ = Big.succ
  
  (** val pred : Big.big_int -> Big.big_int **)
  
  let pred = Big.pred
  
  (** val sub : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let sub = Big.sub
  
  (** val mul : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let mul = Big.mult
  
  (** val pow_pos : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let pow_pos z n =
    Coq_Pos.iter n (mul z) Big.one
  
  (** val pow : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let pow x y =
    Big.z_case
      (fun _ ->
      Big.one)
      (fun p ->
      pow_pos x p)
      (fun p ->
      Big.zero)
      y
  
  (** val square : Big.big_int -> Big.big_int **)
  
  let square x =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Coq_Pos.square p))
      (fun p ->
      (Coq_Pos.square p))
      x
  
  (** val compare : Big.big_int -> Big.big_int -> comparison **)
  
  let compare = Big.compare_case Eq Lt Gt
  
  (** val sgn : Big.big_int -> Big.big_int **)
  
  let sgn z =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p ->
      Big.one)
      (fun p -> Big.opp
      Big.one)
      z
  
  (** val leb : Big.big_int -> Big.big_int -> bool **)
  
  let leb x y =
    match compare x y with
    | Gt -> false
    | _ -> true
  
  (** val ltb : Big.big_int -> Big.big_int -> bool **)
  
  let ltb x y =
    match compare x y with
    | Lt -> true
    | _ -> false
  
  (** val geb : Big.big_int -> Big.big_int -> bool **)
  
  let geb x y =
    match compare x y with
    | Lt -> false
    | _ -> true
  
  (** val gtb : Big.big_int -> Big.big_int -> bool **)
  
  let gtb x y =
    match compare x y with
    | Gt -> true
    | _ -> false
  
  (** val eqb : Big.big_int -> Big.big_int -> bool **)
  
  let rec eqb x y =
    Big.z_case
      (fun _ ->
      Big.z_case
        (fun _ ->
        true)
        (fun p ->
        false)
        (fun p ->
        false)
        y)
      (fun p ->
      Big.z_case
        (fun _ ->
        false)
        (fun q ->
        Coq_Pos.eqb p q)
        (fun p0 ->
        false)
        y)
      (fun p ->
      Big.z_case
        (fun _ ->
        false)
        (fun p0 ->
        false)
        (fun q ->
        Coq_Pos.eqb p q)
        y)
      x
  
  (** val max : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let max = Big.max
  
  (** val min : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let min = Big.min
  
  (** val abs : Big.big_int -> Big.big_int **)
  
  let abs = Big.abs
  
  (** val abs_nat : Big.big_int -> nat **)
  
  let abs_nat z =
    Big.z_case
      (fun _ ->
      O)
      (fun p ->
      Coq_Pos.to_nat p)
      (fun p ->
      Coq_Pos.to_nat p)
      z
  
  (** val abs_N : Big.big_int -> Big.big_int **)
  
  let abs_N = Big.abs
  
  (** val to_nat : Big.big_int -> nat **)
  
  let to_nat z =
    Big.z_case
      (fun _ ->
      O)
      (fun p ->
      Coq_Pos.to_nat p)
      (fun p ->
      O)
      z
  
  (** val to_N : Big.big_int -> Big.big_int **)
  
  let to_N z =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p ->
      p)
      (fun p ->
      Big.zero)
      z
  
  (** val of_nat : nat -> Big.big_int **)
  
  let of_nat = function
  | O -> Big.zero
  | S n0 -> (Coq_Pos.of_succ_nat n0)
  
  (** val of_N : Big.big_int -> Big.big_int **)
  
  let of_N = fun p -> p
  
  (** val to_pos : Big.big_int -> Big.big_int **)
  
  let to_pos z =
    Big.z_case
      (fun _ ->
      Big.one)
      (fun p ->
      p)
      (fun p ->
      Big.one)
      z
  
  (** val iter : Big.big_int -> ('a1 -> 'a1) -> 'a1 -> 'a1 **)
  
  let iter n f x =
    Big.z_case
      (fun _ ->
      x)
      (fun p ->
      Coq_Pos.iter p f x)
      (fun p ->
      x)
      n
  
  (** val pos_div_eucl :
      Big.big_int -> Big.big_int -> Big.big_int * Big.big_int **)
  
  let rec pos_div_eucl a b =
    Big.positive_case
      (fun a' ->
      let (q, r) = pos_div_eucl a' b in
      let r' = add (mul (Big.double Big.one) r) Big.one in
      if ltb r' b
      then ((mul (Big.double Big.one) q), r')
      else ((add (mul (Big.double Big.one) q) Big.one), (sub r' b)))
      (fun a' ->
      let (q, r) = pos_div_eucl a' b in
      let r' = mul (Big.double Big.one) r in
      if ltb r' b
      then ((mul (Big.double Big.one) q), r')
      else ((add (mul (Big.double Big.one) q) Big.one), (sub r' b)))
      (fun _ ->
      if leb (Big.double Big.one) b
      then (Big.zero, Big.one)
      else (Big.one, Big.zero))
      a
  
  (** val div_eucl :
      Big.big_int -> Big.big_int -> Big.big_int * Big.big_int **)
  
  let div_eucl a b =
    Big.z_case
      (fun _ -> (Big.zero,
      Big.zero))
      (fun a' ->
      Big.z_case
        (fun _ -> (Big.zero,
        Big.zero))
        (fun p ->
        pos_div_eucl a' b)
        (fun b' ->
        let (q, r) = pos_div_eucl a' b' in
        (Big.z_case
           (fun _ -> ((opp q),
           Big.zero))
           (fun p -> ((opp (add q Big.one)),
           (add b r)))
           (fun p -> ((opp (add q Big.one)),
           (add b r)))
           r))
        b)
      (fun a' ->
      Big.z_case
        (fun _ -> (Big.zero,
        Big.zero))
        (fun p ->
        let (q, r) = pos_div_eucl a' b in
        (Big.z_case
           (fun _ -> ((opp q),
           Big.zero))
           (fun p0 -> ((opp (add q Big.one)),
           (sub b r)))
           (fun p0 -> ((opp (add q Big.one)),
           (sub b r)))
           r))
        (fun b' ->
        let (q, r) = pos_div_eucl a' b' in (q, (opp r)))
        b)
      a
  
  (** val div : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let div a b =
    let (q, x) = div_eucl a b in q
  
  (** val modulo : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let modulo a b =
    let (x, r) = div_eucl a b in r
  
  (** val quotrem :
      Big.big_int -> Big.big_int -> Big.big_int * Big.big_int **)
  
  let quotrem a b =
    Big.z_case
      (fun _ -> (Big.zero,
      Big.zero))
      (fun a0 ->
      Big.z_case
        (fun _ -> (Big.zero,
        a))
        (fun b0 ->
        let (q, r) = N.pos_div_eucl a0 b0 in ((of_N q), (of_N r)))
        (fun b0 ->
        let (q, r) = N.pos_div_eucl a0 b0 in ((opp (of_N q)), (of_N r)))
        b)
      (fun a0 ->
      Big.z_case
        (fun _ -> (Big.zero,
        a))
        (fun b0 ->
        let (q, r) = N.pos_div_eucl a0 b0 in ((opp (of_N q)), (opp (of_N r))))
        (fun b0 ->
        let (q, r) = N.pos_div_eucl a0 b0 in ((of_N q), (opp (of_N r))))
        b)
      a
  
  (** val quot : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let quot a b =
    fst (quotrem a b)
  
  (** val rem : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let rem a b =
    snd (quotrem a b)
  
  (** val even : Big.big_int -> bool **)
  
  let even z =
    Big.z_case
      (fun _ ->
      true)
      (fun p ->
      Big.positive_case
        (fun p0 ->
        false)
        (fun p0 ->
        true)
        (fun _ ->
        false)
        p)
      (fun p ->
      Big.positive_case
        (fun p0 ->
        false)
        (fun p0 ->
        true)
        (fun _ ->
        false)
        p)
      z
  
  (** val odd : Big.big_int -> bool **)
  
  let odd z =
    Big.z_case
      (fun _ ->
      false)
      (fun p ->
      Big.positive_case
        (fun p0 ->
        true)
        (fun p0 ->
        false)
        (fun _ ->
        true)
        p)
      (fun p ->
      Big.positive_case
        (fun p0 ->
        true)
        (fun p0 ->
        false)
        (fun _ ->
        true)
        p)
      z
  
  (** val div2 : Big.big_int -> Big.big_int **)
  
  let div2 z =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p ->
      Big.positive_case
        (fun p0 ->
        (Coq_Pos.div2 p))
        (fun p0 ->
        (Coq_Pos.div2 p))
        (fun _ ->
        Big.zero)
        p)
      (fun p -> Big.opp
      (Coq_Pos.div2_up p))
      z
  
  (** val quot2 : Big.big_int -> Big.big_int **)
  
  let quot2 z =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p ->
      Big.positive_case
        (fun p0 ->
        (Coq_Pos.div2 p))
        (fun p0 ->
        (Coq_Pos.div2 p))
        (fun _ ->
        Big.zero)
        p)
      (fun p ->
      Big.positive_case
        (fun p0 -> Big.opp
        (Coq_Pos.div2 p))
        (fun p0 -> Big.opp
        (Coq_Pos.div2 p))
        (fun _ ->
        Big.zero)
        p)
      z
  
  (** val log2 : Big.big_int -> Big.big_int **)
  
  let log2 z =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p0 ->
      Big.positive_case
        (fun p ->
        (Coq_Pos.size p))
        (fun p ->
        (Coq_Pos.size p))
        (fun _ ->
        Big.zero)
        p0)
      (fun p ->
      Big.zero)
      z
  
  (** val sqrtrem : Big.big_int -> Big.big_int * Big.big_int **)
  
  let sqrtrem n =
    Big.z_case
      (fun _ -> (Big.zero,
      Big.zero))
      (fun p ->
      let (s, m) = Coq_Pos.sqrtrem p in
      (match m with
       | Coq_Pos.IsPos r -> (s, r)
       | _ -> (s, Big.zero)))
      (fun p -> (Big.zero,
      Big.zero))
      n
  
  (** val sqrt : Big.big_int -> Big.big_int **)
  
  let sqrt n =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun p ->
      (Coq_Pos.sqrt p))
      (fun p ->
      Big.zero)
      n
  
  (** val gcd : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let gcd a b =
    Big.z_case
      (fun _ ->
      abs b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        abs a)
        (fun b0 ->
        (Coq_Pos.gcd a0 b0))
        (fun b0 ->
        (Coq_Pos.gcd a0 b0))
        b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        abs a)
        (fun b0 ->
        (Coq_Pos.gcd a0 b0))
        (fun b0 ->
        (Coq_Pos.gcd a0 b0))
        b)
      a
  
  (** val ggcd :
      Big.big_int -> Big.big_int -> Big.big_int * (Big.big_int * Big.big_int) **)
  
  let ggcd a b =
    Big.z_case
      (fun _ -> ((abs b), (Big.zero,
      (sgn b))))
      (fun a0 ->
      Big.z_case
        (fun _ -> ((abs a), ((sgn a),
        Big.zero)))
        (fun b0 ->
        let (g0, p) = Coq_Pos.ggcd a0 b0 in
        let (aa, bb) = p in (g0, (aa, bb)))
        (fun b0 ->
        let (g0, p) = Coq_Pos.ggcd a0 b0 in
        let (aa, bb) = p in (g0, (aa, (Big.opp bb))))
        b)
      (fun a0 ->
      Big.z_case
        (fun _ -> ((abs a), ((sgn a),
        Big.zero)))
        (fun b0 ->
        let (g0, p) = Coq_Pos.ggcd a0 b0 in
        let (aa, bb) = p in (g0, ((Big.opp aa), bb)))
        (fun b0 ->
        let (g0, p) = Coq_Pos.ggcd a0 b0 in
        let (aa, bb) = p in (g0, ((Big.opp aa), (Big.opp bb))))
        b)
      a
  
  (** val testbit : Big.big_int -> Big.big_int -> bool **)
  
  let testbit a n =
    Big.z_case
      (fun _ ->
      odd a)
      (fun p ->
      Big.z_case
        (fun _ ->
        false)
        (fun a0 ->
        Coq_Pos.testbit a0 p)
        (fun a0 ->
        negb (N.testbit (Coq_Pos.pred_N a0) p))
        a)
      (fun p ->
      false)
      n
  
  (** val shiftl : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let shiftl a n =
    Big.z_case
      (fun _ ->
      a)
      (fun p ->
      Coq_Pos.iter p (mul (Big.double Big.one)) a)
      (fun p ->
      Coq_Pos.iter p div2 a)
      n
  
  (** val shiftr : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let shiftr a n =
    shiftl a (opp n)
  
  (** val coq_lor : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let coq_lor a b =
    Big.z_case
      (fun _ ->
      b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        a)
        (fun b0 ->
        (Coq_Pos.coq_lor a0 b0))
        (fun b0 -> Big.opp
        (N.succ_pos (N.ldiff (Coq_Pos.pred_N b0) a0)))
        b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        a)
        (fun b0 -> Big.opp
        (N.succ_pos (N.ldiff (Coq_Pos.pred_N a0) b0)))
        (fun b0 -> Big.opp
        (N.succ_pos (N.coq_land (Coq_Pos.pred_N a0) (Coq_Pos.pred_N b0))))
        b)
      a
  
  (** val coq_land : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let coq_land a b =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        Big.zero)
        (fun b0 ->
        of_N (Coq_Pos.coq_land a0 b0))
        (fun b0 ->
        of_N (N.ldiff a0 (Coq_Pos.pred_N b0)))
        b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        Big.zero)
        (fun b0 ->
        of_N (N.ldiff b0 (Coq_Pos.pred_N a0)))
        (fun b0 -> Big.opp
        (N.succ_pos (N.coq_lor (Coq_Pos.pred_N a0) (Coq_Pos.pred_N b0))))
        b)
      a
  
  (** val ldiff : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let ldiff a b =
    Big.z_case
      (fun _ ->
      Big.zero)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        a)
        (fun b0 ->
        of_N (Coq_Pos.ldiff a0 b0))
        (fun b0 ->
        of_N (N.coq_land a0 (Coq_Pos.pred_N b0)))
        b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        a)
        (fun b0 -> Big.opp
        (N.succ_pos (N.coq_lor (Coq_Pos.pred_N a0) b0)))
        (fun b0 ->
        of_N (N.ldiff (Coq_Pos.pred_N b0) (Coq_Pos.pred_N a0)))
        b)
      a
  
  (** val coq_lxor : Big.big_int -> Big.big_int -> Big.big_int **)
  
  let coq_lxor a b =
    Big.z_case
      (fun _ ->
      b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        a)
        (fun b0 ->
        of_N (Coq_Pos.coq_lxor a0 b0))
        (fun b0 -> Big.opp
        (N.succ_pos (N.coq_lxor a0 (Coq_Pos.pred_N b0))))
        b)
      (fun a0 ->
      Big.z_case
        (fun _ ->
        a)
        (fun b0 -> Big.opp
        (N.succ_pos (N.coq_lxor (Coq_Pos.pred_N a0) b0)))
        (fun b0 ->
        of_N (N.coq_lxor (Coq_Pos.pred_N a0) (Coq_Pos.pred_N b0)))
        b)
      a
  
  (** val eq_dec : Big.big_int -> Big.big_int -> bool **)
  
  let eq_dec x y =
    Big.z_case
      (fun _ ->
      Big.z_case
        (fun _ ->
        true)
        (fun p ->
        false)
        (fun p ->
        false)
        y)
      (fun x0 ->
      Big.z_case
        (fun _ ->
        false)
        (fun p0 ->
        Coq_Pos.eq_dec x0 p0)
        (fun p0 ->
        false)
        y)
      (fun x0 ->
      Big.z_case
        (fun _ ->
        false)
        (fun p0 ->
        false)
        (fun p0 ->
        Coq_Pos.eq_dec x0 p0)
        y)
      x
  
  module Private_BootStrap = 
   struct 
    
   end
  
  (** val leb_spec0 : Big.big_int -> Big.big_int -> reflect **)
  
  let leb_spec0 x y =
    iff_reflect (leb x y)
  
  (** val ltb_spec0 : Big.big_int -> Big.big_int -> reflect **)
  
  let ltb_spec0 x y =
    iff_reflect (ltb x y)
  
  module Private_OrderTac = 
   struct 
    module IsTotal = 
     struct 
      
     end
    
    module Tac = 
     struct 
      
     end
   end
  
  (** val sqrt_up : Big.big_int -> Big.big_int **)
  
  let sqrt_up a =
    match compare Big.zero a with
    | Lt -> succ (sqrt (pred a))
    | _ -> Big.zero
  
  (** val log2_up : Big.big_int -> Big.big_int **)
  
  let log2_up a =
    match compare Big.one a with
    | Lt -> succ (log2 (pred a))
    | _ -> Big.zero
  
  module Private_NZDiv = 
   struct 
    
   end
  
  module Private_Div = 
   struct 
    module Quot2Div = 
     struct 
      (** val div :
          Big.big_int
          ->
          Big.big_int
          ->
          Big.big_int **)
      
      let div =
        quot
      
      (** val modulo :
          Big.big_int
          ->
          Big.big_int
          ->
          Big.big_int **)
      
      let modulo =
        rem
     end
    
    module NZQuot = 
     struct 
      
     end
   end
  
  (** val lcm :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let lcm a b =
    abs
      (mul
        a
        (div
          b
          (gcd
            a
            b)))
  
  (** val eqb_spec :
      Big.big_int
      ->
      Big.big_int
      ->
      reflect **)
  
  let eqb_spec x y =
    iff_reflect
      (eqb
        x
        y)
  
  (** val b2z :
      bool
      ->
      Big.big_int **)
  
  let b2z = function
  | true ->
    Big.one
  | false ->
    Big.zero
  
  (** val setbit :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let setbit a n =
    coq_lor
      a
      (shiftl
        Big.one
        n)
  
  (** val clearbit :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let clearbit a n =
    ldiff
      a
      (shiftl
        Big.one
        n)
  
  (** val lnot :
      Big.big_int
      ->
      Big.big_int **)
  
  let lnot a =
    pred
      (opp
        a)
  
  (** val ones :
      Big.big_int
      ->
      Big.big_int **)
  
  let ones n =
    pred
      (shiftl
        Big.one
        n)
  
  module Private_Tac = 
   struct 
    
   end
  
  module Private_Dec = 
   struct 
    (** val max_case_strong :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        'a1 **)
    
    let max_case_strong n m compat hl hr =
      let c =
        compSpec2Type
          n
          m
          (compare
            n
            m)
      in
      (match c with
       | CompGtT ->
         compat
           n
           (max
             n
             m)
           __
           (hl
             __)
       | _ ->
         compat
           m
           (max
             n
             m)
           __
           (hr
             __))
    
    (** val max_case :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        'a1
        ->
        'a1
        ->
        'a1 **)
    
    let max_case n m x x0 x1 =
      max_case_strong
        n
        m
        x
        (fun _ ->
        x0)
        (fun _ ->
        x1)
    
    (** val max_dec :
        Big.big_int
        ->
        Big.big_int
        ->
        bool **)
    
    let max_dec n m =
      max_case
        n
        m
        (fun x y _ h0 ->
        h0)
        true
        false
    
    (** val min_case_strong :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        (__
        ->
        'a1)
        ->
        'a1 **)
    
    let min_case_strong n m compat hl hr =
      let c =
        compSpec2Type
          n
          m
          (compare
            n
            m)
      in
      (match c with
       | CompGtT ->
         compat
           m
           (min
             n
             m)
           __
           (hr
             __)
       | _ ->
         compat
           n
           (min
             n
             m)
           __
           (hl
             __))
    
    (** val min_case :
        Big.big_int
        ->
        Big.big_int
        ->
        (Big.big_int
        ->
        Big.big_int
        ->
        __
        ->
        'a1
        ->
        'a1)
        ->
        'a1
        ->
        'a1
        ->
        'a1 **)
    
    let min_case n m x x0 x1 =
      min_case_strong
        n
        m
        x
        (fun _ ->
        x0)
        (fun _ ->
        x1)
    
    (** val min_dec :
        Big.big_int
        ->
        Big.big_int
        ->
        bool **)
    
    let min_dec n m =
      min_case
        n
        m
        (fun x y _ h0 ->
        h0)
        true
        false
   end
  
  (** val max_case_strong :
      Big.big_int
      ->
      Big.big_int
      ->
      (__
      ->
      'a1)
      ->
      (__
      ->
      'a1)
      ->
      'a1 **)
  
  let max_case_strong n m x x0 =
    Private_Dec.max_case_strong
      n
      m
      (fun x1 y _ x2 ->
      x2)
      x
      x0
  
  (** val max_case :
      Big.big_int
      ->
      Big.big_int
      ->
      'a1
      ->
      'a1
      ->
      'a1 **)
  
  let max_case n m x x0 =
    max_case_strong
      n
      m
      (fun _ ->
      x)
      (fun _ ->
      x0)
  
  (** val max_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let max_dec =
    Private_Dec.max_dec
  
  (** val min_case_strong :
      Big.big_int
      ->
      Big.big_int
      ->
      (__
      ->
      'a1)
      ->
      (__
      ->
      'a1)
      ->
      'a1 **)
  
  let min_case_strong n m x x0 =
    Private_Dec.min_case_strong
      n
      m
      (fun x1 y _ x2 ->
      x2)
      x
      x0
  
  (** val min_case :
      Big.big_int
      ->
      Big.big_int
      ->
      'a1
      ->
      'a1
      ->
      'a1 **)
  
  let min_case n m x x0 =
    min_case_strong
      n
      m
      (fun _ ->
      x)
      (fun _ ->
      x0)
  
  (** val min_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let min_dec =
    Private_Dec.min_dec
 end

(** val beq_nat :
    nat
    ->
    nat
    ->
    bool **)

let rec beq_nat n m =
  match n with
  | O ->
    (match m with
     | O ->
       true
     | S n0 ->
       false)
  | S n1 ->
    (match m with
     | O ->
       false
     | S m1 ->
       beq_nat
         n1
         m1)

(** val sumbool_of_bool :
    bool
    ->
    bool **)

let sumbool_of_bool = function
| true ->
  true
| false ->
  false

(** val leb1 :
    nat
    ->
    nat
    ->
    bool **)

let rec leb1 n m =
  match n with
  | O ->
    true
  | S n' ->
    (match m with
     | O ->
       false
     | S m' ->
       leb1
         n'
         m')

(** val ltb0 :
    nat
    ->
    nat
    ->
    bool **)

let ltb0 n m =
  leb1
    (S
    n)
    m

(** val divmod :
    nat
    ->
    nat
    ->
    nat
    ->
    nat
    ->
    nat * nat **)

let rec divmod x y q u =
  match x with
  | O ->
    (q,
      u)
  | S x' ->
    (match u with
     | O ->
       divmod
         x'
         y
         (S
         q)
         y
     | S u' ->
       divmod
         x'
         y
         q
         u')

(** val div0 :
    nat
    ->
    nat
    ->
    nat **)

let div0 x y = match y with
| O ->
  y
| S y' ->
  fst
    (divmod
      x
      y'
      O
      y')

(** val z_gt_dec :
    Big.big_int
    ->
    Big.big_int
    ->
    bool **)

let z_gt_dec x y =
  match Z.compare
          x
          y with
  | Gt ->
    true
  | _ ->
    false

(** val z_ge_dec :
    Big.big_int
    ->
    Big.big_int
    ->
    bool **)

let z_ge_dec x y =
  match Z.compare
          x
          y with
  | Lt ->
    false
  | _ ->
    true

(** val z_gt_le_dec :
    Big.big_int
    ->
    Big.big_int
    ->
    bool **)

let z_gt_le_dec x y =
  z_gt_dec
    x
    y

(** val z_ge_lt_dec :
    Big.big_int
    ->
    Big.big_int
    ->
    bool **)

let z_ge_lt_dec x y =
  z_ge_dec
    x
    y

module type Int = 
 sig 
  type t 
  
  val i2z :
    t
    ->
    Big.big_int
  
  val _0 :
    t
  
  val _1 :
    t
  
  val _2 :
    t
  
  val _3 :
    t
  
  val plus :
    t
    ->
    t
    ->
    t
  
  val opp :
    t
    ->
    t
  
  val minus :
    t
    ->
    t
    ->
    t
  
  val mult :
    t
    ->
    t
    ->
    t
  
  val max :
    t
    ->
    t
    ->
    t
  
  val gt_le_dec :
    t
    ->
    t
    ->
    bool
  
  val ge_lt_dec :
    t
    ->
    t
    ->
    bool
  
  val eq_dec :
    t
    ->
    t
    ->
    bool
 end

module Z_as_Int = 
 struct 
  type t
    =
    Big.big_int
  
  (** val _0 :
      Big.big_int **)
  
  let _0 =
    Big.zero
  
  (** val _1 :
      Big.big_int **)
  
  let _1 =
    Big.one
  
  (** val _2 :
      Big.big_int **)
  
  let _2 =
    (Big.double
      Big.one)
  
  (** val _3 :
      Big.big_int **)
  
  let _3 =
    (Big.doubleplusone
      Big.one)
  
  (** val plus :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let plus =
    Z.add
  
  (** val opp :
      Big.big_int
      ->
      Big.big_int **)
  
  let opp =
    Z.opp
  
  (** val minus :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let minus =
    Z.sub
  
  (** val mult :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let mult =
    Z.mul
  
  (** val max :
      Big.big_int
      ->
      Big.big_int
      ->
      Big.big_int **)
  
  let max =
    Z.max
  
  (** val gt_le_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let gt_le_dec =
    z_gt_le_dec
  
  (** val ge_lt_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let ge_lt_dec =
    z_ge_lt_dec
  
  (** val eq_dec :
      Big.big_int
      ->
      Big.big_int
      ->
      bool **)
  
  let eq_dec =
    Z.eq_dec
  
  (** val i2z :
      t
      ->
      Big.big_int **)
  
  let i2z n =
    n
 end

module Coq_Raw = 
 functor (I:Int) ->
 functor (X:OrderedType) ->
 struct 
  type key
    =
    X.t
  
  type 'elt tree =
  | Leaf
  | Node of 'elt
            tree
     * key
     * 'elt
     * 'elt
       tree
     * I.t
  
  (** val tree_rect :
      'a2
      ->
      ('a1
      tree
      ->
      'a2
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a2
      ->
      I.t
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2 **)
  
  let rec tree_rect f f0 = function
  | Leaf ->
    f
  | Node (t1,
          k,
          e,
          t2,
          t3) ->
    f0
      t1
      (tree_rect
        f
        f0
        t1)
      k
      e
      t2
      (tree_rect
        f
        f0
        t2)
      t3
  
  (** val tree_rec :
      'a2
      ->
      ('a1
      tree
      ->
      'a2
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a2
      ->
      I.t
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2 **)
  
  let rec tree_rec f f0 = function
  | Leaf ->
    f
  | Node (t1,
          k,
          e,
          t2,
          t3) ->
    f0
      t1
      (tree_rec
        f
        f0
        t1)
      k
      e
      t2
      (tree_rec
        f
        f0
        t2)
      t3
  
  (** val height :
      'a1
      tree
      ->
      I.t **)
  
  let height = function
  | Leaf ->
    I._0
  | Node (t0,
          k,
          e,
          t1,
          h0) ->
    h0
  
  (** val cardinal :
      'a1
      tree
      ->
      nat **)
  
  let rec cardinal = function
  | Leaf ->
    O
  | Node (l,
          k,
          e,
          r,
          t0) ->
    S
      (plus
        (cardinal
          l)
        (cardinal
          r))
  
  (** val empty :
      'a1
      tree **)
  
  let empty =
    Leaf
  
  (** val is_empty :
      'a1
      tree
      ->
      bool **)
  
  let is_empty = function
  | Leaf ->
    true
  | Node (t0,
          k,
          e,
          t1,
          t2) ->
    false
  
  (** val mem :
      X.t
      ->
      'a1
      tree
      ->
      bool **)
  
  let rec mem x = function
  | Leaf ->
    false
  | Node (l,
          y,
          e,
          r,
          t0) ->
    (match X.compare
             x
             y with
     | LT ->
       mem
         x
         l
     | EQ ->
       true
     | GT ->
       mem
         x
         r)
  
  (** val find :
      X.t
      ->
      'a1
      tree
      ->
      'a1
      option **)
  
  let rec find x = function
  | Leaf ->
    None
  | Node (l,
          y,
          d,
          r,
          t0) ->
    (match X.compare
             x
             y with
     | LT ->
       find
         x
         l
     | EQ ->
       Some
         d
     | GT ->
       find
         x
         r)
  
  (** val create :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let create l x e r =
    Node
      (l,
      x,
      e,
      r,
      (I.plus
        (I.max
          (height
            l)
          (height
            r))
        I._1))
  
  (** val assert_false :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let assert_false =
    create
  
  (** val bal :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let bal l x d r =
    let hl =
      height
        l
    in
    let hr =
      height
        r
    in
    if I.gt_le_dec
         hl
         (I.plus
           hr
           I._2)
    then (match l with
          | Leaf ->
            assert_false
              l
              x
              d
              r
          | Node (ll,
                  lx,
                  ld,
                  lr,
                  t0) ->
            if I.ge_lt_dec
                 (height
                   ll)
                 (height
                   lr)
            then create
                   ll
                   lx
                   ld
                   (create
                     lr
                     x
                     d
                     r)
            else (match lr with
                  | Leaf ->
                    assert_false
                      l
                      x
                      d
                      r
                  | Node (lrl,
                          lrx,
                          lrd,
                          lrr,
                          t1) ->
                    create
                      (create
                        ll
                        lx
                        ld
                        lrl)
                      lrx
                      lrd
                      (create
                        lrr
                        x
                        d
                        r)))
    else if I.gt_le_dec
              hr
              (I.plus
                hl
                I._2)
         then (match r with
               | Leaf ->
                 assert_false
                   l
                   x
                   d
                   r
               | Node (rl,
                       rx,
                       rd,
                       rr,
                       t0) ->
                 if I.ge_lt_dec
                      (height
                        rr)
                      (height
                        rl)
                 then create
                        (create
                          l
                          x
                          d
                          rl)
                        rx
                        rd
                        rr
                 else (match rl with
                       | Leaf ->
                         assert_false
                           l
                           x
                           d
                           r
                       | Node (rll,
                               rlx,
                               rld,
                               rlr,
                               t1) ->
                         create
                           (create
                             l
                             x
                             d
                             rll)
                           rlx
                           rld
                           (create
                             rlr
                             rx
                             rd
                             rr)))
         else create
                l
                x
                d
                r
  
  (** val add :
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let rec add x d = function
  | Leaf ->
    Node
      (Leaf,
      x,
      d,
      Leaf,
      I._1)
  | Node (l,
          y,
          d',
          r,
          h0) ->
    (match X.compare
             x
             y with
     | LT ->
       bal
         (add
           x
           d
           l)
         y
         d'
         r
     | EQ ->
       Node
         (l,
         y,
         d,
         r,
         h0)
     | GT ->
       bal
         l
         y
         d'
         (add
           x
           d
           r))
  
  (** val remove_min :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree * (key * 'a1) **)
  
  let rec remove_min l x d r =
    match l with
    | Leaf ->
      (r,
        (x,
        d))
    | Node (ll,
            lx,
            ld,
            lr,
            lh) ->
      let (l',
           m) =
        remove_min
          ll
          lx
          ld
          lr
      in
      ((bal
         l'
         x
         d
         r),
      m)
  
  (** val merge :
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let merge s1 s2 =
    match s1 with
    | Leaf ->
      s2
    | Node (t0,
            k,
            e,
            t1,
            t2) ->
      (match s2 with
       | Leaf ->
         s1
       | Node (l2,
               x2,
               d2,
               r2,
               h2) ->
         let (s2',
              p) =
           remove_min
             l2
             x2
             d2
             r2
         in
         let (x,
              d) =
           p
         in
         bal
           s1
           x
           d
           s2')
  
  (** val remove :
      X.t
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let rec remove x = function
  | Leaf ->
    Leaf
  | Node (l,
          y,
          d,
          r,
          h0) ->
    (match X.compare
             x
             y with
     | LT ->
       bal
         (remove
           x
           l)
         y
         d
         r
     | EQ ->
       merge
         l
         r
     | GT ->
       bal
         l
         y
         d
         (remove
           x
           r))
  
  (** val join :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let rec join l = match l with
  | Leaf ->
    add
  | Node (ll,
          lx,
          ld,
          lr,
          lh) ->
    (fun x d ->
      let rec join_aux r = match r with
      | Leaf ->
        add
          x
          d
          l
      | Node (rl,
              rx,
              rd,
              rr,
              rh) ->
        if I.gt_le_dec
             lh
             (I.plus
               rh
               I._2)
        then bal
               ll
               lx
               ld
               (join
                 lr
                 x
                 d
                 r)
        else if I.gt_le_dec
                  rh
                  (I.plus
                    lh
                    I._2)
             then bal
                    (join_aux
                      rl)
                    rx
                    rd
                    rr
             else create
                    l
                    x
                    d
                    r
      in join_aux)
  
  type 'elt triple = { t_left : 'elt
                                tree;
                       t_opt : 'elt
                               option;
                       t_right : 'elt
                                 tree }
  
  (** val triple_rect :
      ('a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      'a2)
      ->
      'a1
      triple
      ->
      'a2 **)
  
  let triple_rect f t0 =
    let { t_left =
      x;
      t_opt =
      x0;
      t_right =
      x1 } =
      t0
    in
    f
      x
      x0
      x1
  
  (** val triple_rec :
      ('a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      'a2)
      ->
      'a1
      triple
      ->
      'a2 **)
  
  let triple_rec f t0 =
    let { t_left =
      x;
      t_opt =
      x0;
      t_right =
      x1 } =
      t0
    in
    f
      x
      x0
      x1
  
  (** val t_left :
      'a1
      triple
      ->
      'a1
      tree **)
  
  let t_left t0 =
    t0.t_left
  
  (** val t_opt :
      'a1
      triple
      ->
      'a1
      option **)
  
  let t_opt t0 =
    t0.t_opt
  
  (** val t_right :
      'a1
      triple
      ->
      'a1
      tree **)
  
  let t_right t0 =
    t0.t_right
  
  (** val split :
      X.t
      ->
      'a1
      tree
      ->
      'a1
      triple **)
  
  let rec split x = function
  | Leaf ->
    { t_left =
      Leaf;
      t_opt =
      None;
      t_right =
      Leaf }
  | Node (l,
          y,
          d,
          r,
          h0) ->
    (match X.compare
             x
             y with
     | LT ->
       let { t_left =
         ll;
         t_opt =
         o;
         t_right =
         rl } =
         split
           x
           l
       in
       { t_left =
       ll;
       t_opt =
       o;
       t_right =
       (join
         rl
         y
         d
         r) }
     | EQ ->
       { t_left =
         l;
         t_opt =
         (Some
         d);
         t_right =
         r }
     | GT ->
       let { t_left =
         rl;
         t_opt =
         o;
         t_right =
         rr } =
         split
           x
           r
       in
       { t_left =
       (join
         l
         y
         d
         rl);
       t_opt =
       o;
       t_right =
       rr })
  
  (** val concat :
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree **)
  
  let concat m1 m2 =
    match m1 with
    | Leaf ->
      m2
    | Node (t0,
            k,
            e,
            t1,
            t2) ->
      (match m2 with
       | Leaf ->
         m1
       | Node (l2,
               x2,
               d2,
               r2,
               t3) ->
         let (m2',
              xd) =
           remove_min
             l2
             x2
             d2
             r2
         in
         join
           m1
           (fst
             xd)
           (snd
             xd)
           m2')
  
  (** val elements_aux :
      (key * 'a1)
      list
      ->
      'a1
      tree
      ->
      (key * 'a1)
      list **)
  
  let rec elements_aux acc = function
  | Leaf ->
    acc
  | Node (l,
          x,
          d,
          r,
          t0) ->
    elements_aux
      ((x,
      d) :: (elements_aux
              acc
              r))
      l
  
  (** val elements :
      'a1
      tree
      ->
      (key * 'a1)
      list **)
  
  let elements m =
    elements_aux
      []
      m
  
  (** val fold :
      (key
      ->
      'a1
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
      ->
      'a2 **)
  
  let rec fold f m a =
    match m with
    | Leaf ->
      a
    | Node (l,
            x,
            d,
            r,
            t0) ->
      fold
        f
        r
        (f
          x
          d
          (fold
            f
            l
            a))
  
  type 'elt enumeration =
  | End
  | More of key
     * 'elt
     * 'elt
       tree
     * 'elt
       enumeration
  
  (** val enumeration_rect :
      'a2
      ->
      (key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      enumeration
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      enumeration
      ->
      'a2 **)
  
  let rec enumeration_rect f f0 = function
  | End ->
    f
  | More (k,
          e0,
          t0,
          e1) ->
    f0
      k
      e0
      t0
      e1
      (enumeration_rect
        f
        f0
        e1)
  
  (** val enumeration_rec :
      'a2
      ->
      (key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      enumeration
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      enumeration
      ->
      'a2 **)
  
  let rec enumeration_rec f f0 = function
  | End ->
    f
  | More (k,
          e0,
          t0,
          e1) ->
    f0
      k
      e0
      t0
      e1
      (enumeration_rec
        f
        f0
        e1)
  
  (** val cons :
      'a1
      tree
      ->
      'a1
      enumeration
      ->
      'a1
      enumeration **)
  
  let rec cons m e =
    match m with
    | Leaf ->
      e
    | Node (l,
            x,
            d,
            r,
            h0) ->
      cons
        l
        (More
        (x,
        d,
        r,
        e))
  
  (** val equal_more :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      X.t
      ->
      'a1
      ->
      ('a1
      enumeration
      ->
      bool)
      ->
      'a1
      enumeration
      ->
      bool **)
  
  let equal_more cmp x1 d1 cont = function
  | End ->
    false
  | More (x2,
          d2,
          r2,
          e3) ->
    (match X.compare
             x1
             x2 with
     | EQ ->
       if cmp
            d1
            d2
       then cont
              (cons
                r2
                e3)
       else false
     | _ ->
       false)
  
  (** val equal_cont :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      'a1
      tree
      ->
      ('a1
      enumeration
      ->
      bool)
      ->
      'a1
      enumeration
      ->
      bool **)
  
  let rec equal_cont cmp m1 cont e2 =
    match m1 with
    | Leaf ->
      cont
        e2
    | Node (l1,
            x1,
            d1,
            r1,
            t0) ->
      equal_cont
        cmp
        l1
        (equal_more
          cmp
          x1
          d1
          (equal_cont
            cmp
            r1
            cont))
        e2
  
  (** val equal_end :
      'a1
      enumeration
      ->
      bool **)
  
  let equal_end = function
  | End ->
    true
  | More (k,
          e,
          t0,
          e0) ->
    false
  
  (** val equal :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      bool **)
  
  let equal cmp m1 m2 =
    equal_cont
      cmp
      m1
      equal_end
      (cons
        m2
        End)
  
  (** val map :
      ('a1
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
      tree **)
  
  let rec map f = function
  | Leaf ->
    Leaf
  | Node (l,
          x,
          d,
          r,
          h0) ->
    Node
      ((map
         f
         l),
      x,
      (f
        d),
      (map
        f
        r),
      h0)
  
  (** val mapi :
      (key
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
      tree **)
  
  let rec mapi f = function
  | Leaf ->
    Leaf
  | Node (l,
          x,
          d,
          r,
          h0) ->
    Node
      ((mapi
         f
         l),
      x,
      (f
        x
        d),
      (mapi
        f
        r),
      h0)
  
  (** val map_option :
      (key
      ->
      'a1
      ->
      'a2
      option)
      ->
      'a1
      tree
      ->
      'a2
      tree **)
  
  let rec map_option f = function
  | Leaf ->
    Leaf
  | Node (l,
          x,
          d,
          r,
          h0) ->
    (match f
             x
             d with
     | Some d' ->
       join
         (map_option
           f
           l)
         x
         d'
         (map_option
           f
           r)
     | None ->
       concat
         (map_option
           f
           l)
         (map_option
           f
           r))
  
  (** val map2_opt :
      (key
      ->
      'a1
      ->
      'a2
      option
      ->
      'a3
      option)
      ->
      ('a1
      tree
      ->
      'a3
      tree)
      ->
      ('a2
      tree
      ->
      'a3
      tree)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      'a3
      tree **)
  
  let rec map2_opt f mapl mapr m1 m2 =
    match m1 with
    | Leaf ->
      mapr
        m2
    | Node (l1,
            x1,
            d1,
            r1,
            h1) ->
      (match m2 with
       | Leaf ->
         mapl
           m1
       | Node (t0,
               k,
               y,
               t1,
               t2) ->
         let { t_left =
           l2';
           t_opt =
           o2;
           t_right =
           r2' } =
           split
             x1
             m2
         in
         (match f
                  x1
                  d1
                  o2 with
          | Some e ->
            join
              (map2_opt
                f
                mapl
                mapr
                l1
                l2')
              x1
              e
              (map2_opt
                f
                mapl
                mapr
                r1
                r2')
          | None ->
            concat
              (map2_opt
                f
                mapl
                mapr
                l1
                l2')
              (map2_opt
                f
                mapl
                mapr
                r1
                r2')))
  
  (** val map2 :
      ('a1
      option
      ->
      'a2
      option
      ->
      'a3
      option)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      'a3
      tree **)
  
  let map2 f =
    map2_opt
      (fun x d o ->
      f
        (Some
        d)
        o)
      (map_option
        (fun x d ->
        f
          (Some
          d)
          None))
      (map_option
        (fun x d' ->
        f
          None
          (Some
          d')))
  
  module Proofs = 
   struct 
    module MX = OrderedTypeFacts(X)
    
    module PX = KeyOrderedType(X)
    
    module L = Raw(X)
    
    type 'elt coq_R_mem =
    | R_mem_0 of 'elt
                 tree
    | R_mem_1 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * bool
       * 'elt
         coq_R_mem
    | R_mem_2 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_mem_3 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * bool
       * 'elt
         coq_R_mem
    
    (** val coq_R_mem_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2 **)
    
    let rec coq_R_mem_rect x f f0 f1 f2 m b = function
    | R_mem_0 m0 ->
      f
        m0
        __
    | R_mem_1 (m0,
               l,
               y,
               _x,
               r0,
               _x0,
               res,
               r1) ->
      f0
        m0
        l
        y
        _x
        r0
        _x0
        __
        __
        __
        res
        r1
        (coq_R_mem_rect
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_mem_2 (m0,
               l,
               y,
               _x,
               r0,
               _x0) ->
      f1
        m0
        l
        y
        _x
        r0
        _x0
        __
        __
        __
    | R_mem_3 (m0,
               l,
               y,
               _x,
               r0,
               _x0,
               res,
               r1) ->
      f2
        m0
        l
        y
        _x
        r0
        _x0
        __
        __
        __
        res
        r1
        (coq_R_mem_rect
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    (** val coq_R_mem_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2 **)
    
    let rec coq_R_mem_rec x f f0 f1 f2 m b = function
    | R_mem_0 m0 ->
      f
        m0
        __
    | R_mem_1 (m0,
               l,
               y,
               _x,
               r0,
               _x0,
               res,
               r1) ->
      f0
        m0
        l
        y
        _x
        r0
        _x0
        __
        __
        __
        res
        r1
        (coq_R_mem_rec
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_mem_2 (m0,
               l,
               y,
               _x,
               r0,
               _x0) ->
      f1
        m0
        l
        y
        _x
        r0
        _x0
        __
        __
        __
    | R_mem_3 (m0,
               l,
               y,
               _x,
               r0,
               _x0,
               res,
               r1) ->
      f2
        m0
        l
        y
        _x
        r0
        _x0
        __
        __
        __
        res
        r1
        (coq_R_mem_rec
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    type 'elt coq_R_find =
    | R_find_0 of 'elt
                  tree
    | R_find_1 of 'elt
                  tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         option
       * 'elt
         coq_R_find
    | R_find_2 of 'elt
                  tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_find_3 of 'elt
                  tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         option
       * 'elt
         coq_R_find
    
    (** val coq_R_find_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2 **)
    
    let rec coq_R_find_rect x f f0 f1 f2 m o = function
    | R_find_0 m0 ->
      f
        m0
        __
    | R_find_1 (m0,
                l,
                y,
                d,
                r0,
                _x,
                res,
                r1) ->
      f0
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_find_rect
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_find_2 (m0,
                l,
                y,
                d,
                r0,
                _x) ->
      f1
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
    | R_find_3 (m0,
                l,
                y,
                d,
                r0,
                _x,
                res,
                r1) ->
      f2
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_find_rect
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    (** val coq_R_find_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2 **)
    
    let rec coq_R_find_rec x f f0 f1 f2 m o = function
    | R_find_0 m0 ->
      f
        m0
        __
    | R_find_1 (m0,
                l,
                y,
                d,
                r0,
                _x,
                res,
                r1) ->
      f0
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_find_rec
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_find_2 (m0,
                l,
                y,
                d,
                r0,
                _x) ->
      f1
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
    | R_find_3 (m0,
                l,
                y,
                d,
                r0,
                _x,
                res,
                r1) ->
      f2
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_find_rec
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    type 'elt coq_R_bal =
    | R_bal_0 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
    | R_bal_1 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_2 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_3 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_4 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
    | R_bal_5 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_6 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_7 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_8 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
    
    (** val coq_R_bal_rect :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_bal
        ->
        'a2 **)
    
    let coq_R_bal_rect f f0 f1 f2 f3 f4 f5 f6 f7 l x d r t0 = function
    | R_bal_0 (x0,
               x1,
               x2,
               x3) ->
      f
        x0
        x1
        x2
        x3
        __
        __
        __
    | R_bal_1 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f0
        x0
        x1
        x2
        x3
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
    | R_bal_2 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f1
        x0
        x1
        x2
        x3
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        __
    | R_bal_3 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8,
               x9,
               x10,
               x11,
               x12,
               x13) ->
      f2
        x0
        x1
        x2
        x3
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        x9
        x10
        x11
        x12
        x13
        __
    | R_bal_4 (x0,
               x1,
               x2,
               x3) ->
      f3
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        __
    | R_bal_5 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f4
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
    | R_bal_6 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f5
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        __
    | R_bal_7 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8,
               x9,
               x10,
               x11,
               x12,
               x13) ->
      f6
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        x9
        x10
        x11
        x12
        x13
        __
    | R_bal_8 (x0,
               x1,
               x2,
               x3) ->
      f7
        x0
        x1
        x2
        x3
        __
        __
        __
        __
    
    (** val coq_R_bal_rec :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_bal
        ->
        'a2 **)
    
    let coq_R_bal_rec f f0 f1 f2 f3 f4 f5 f6 f7 l x d r t0 = function
    | R_bal_0 (x0,
               x1,
               x2,
               x3) ->
      f
        x0
        x1
        x2
        x3
        __
        __
        __
    | R_bal_1 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f0
        x0
        x1
        x2
        x3
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
    | R_bal_2 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f1
        x0
        x1
        x2
        x3
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        __
    | R_bal_3 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8,
               x9,
               x10,
               x11,
               x12,
               x13) ->
      f2
        x0
        x1
        x2
        x3
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        x9
        x10
        x11
        x12
        x13
        __
    | R_bal_4 (x0,
               x1,
               x2,
               x3) ->
      f3
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        __
    | R_bal_5 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f4
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
    | R_bal_6 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8) ->
      f5
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        __
    | R_bal_7 (x0,
               x1,
               x2,
               x3,
               x4,
               x5,
               x6,
               x7,
               x8,
               x9,
               x10,
               x11,
               x12,
               x13) ->
      f6
        x0
        x1
        x2
        x3
        __
        __
        __
        __
        x4
        x5
        x6
        x7
        x8
        __
        __
        __
        x9
        x10
        x11
        x12
        x13
        __
    | R_bal_8 (x0,
               x1,
               x2,
               x3) ->
      f7
        x0
        x1
        x2
        x3
        __
        __
        __
        __
    
    type 'elt coq_R_add =
    | R_add_0 of 'elt
                 tree
    | R_add_1 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_add
    | R_add_2 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_add_3 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_add
    
    (** val coq_R_add_rect :
        key
        ->
        'a1
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2 **)
    
    let rec coq_R_add_rect x d f f0 f1 f2 m t0 = function
    | R_add_0 m0 ->
      f
        m0
        __
    | R_add_1 (m0,
               l,
               y,
               d',
               r0,
               h0,
               res,
               r1) ->
      f0
        m0
        l
        y
        d'
        r0
        h0
        __
        __
        __
        res
        r1
        (coq_R_add_rect
          x
          d
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_add_2 (m0,
               l,
               y,
               d',
               r0,
               h0) ->
      f1
        m0
        l
        y
        d'
        r0
        h0
        __
        __
        __
    | R_add_3 (m0,
               l,
               y,
               d',
               r0,
               h0,
               res,
               r1) ->
      f2
        m0
        l
        y
        d'
        r0
        h0
        __
        __
        __
        res
        r1
        (coq_R_add_rect
          x
          d
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    (** val coq_R_add_rec :
        key
        ->
        'a1
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2 **)
    
    let rec coq_R_add_rec x d f f0 f1 f2 m t0 = function
    | R_add_0 m0 ->
      f
        m0
        __
    | R_add_1 (m0,
               l,
               y,
               d',
               r0,
               h0,
               res,
               r1) ->
      f0
        m0
        l
        y
        d'
        r0
        h0
        __
        __
        __
        res
        r1
        (coq_R_add_rec
          x
          d
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_add_2 (m0,
               l,
               y,
               d',
               r0,
               h0) ->
      f1
        m0
        l
        y
        d'
        r0
        h0
        __
        __
        __
    | R_add_3 (m0,
               l,
               y,
               d',
               r0,
               h0,
               res,
               r1) ->
      f2
        m0
        l
        y
        d'
        r0
        h0
        __
        __
        __
        res
        r1
        (coq_R_add_rec
          x
          d
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    type 'elt coq_R_remove_min =
    | R_remove_min_0 of 'elt
                        tree
       * key
       * 'elt
       * 'elt
         tree
    | R_remove_min_1 of 'elt
                        tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * ('elt
         tree * (key * 'elt))
       * 'elt
         coq_R_remove_min
       * 'elt
         tree
       * (key * 'elt)
    
    (** val coq_R_remove_min_rect :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2 **)
    
    let rec coq_R_remove_min_rect f f0 l x d r p = function
    | R_remove_min_0 (l0,
                      x0,
                      d0,
                      r1) ->
      f
        l0
        x0
        d0
        r1
        __
    | R_remove_min_1 (l0,
                      x0,
                      d0,
                      r1,
                      ll,
                      lx,
                      ld,
                      lr,
                      _x,
                      res,
                      r2,
                      l',
                      m) ->
      f0
        l0
        x0
        d0
        r1
        ll
        lx
        ld
        lr
        _x
        __
        res
        r2
        (coq_R_remove_min_rect
          f
          f0
          ll
          lx
          ld
          lr
          res
          r2)
        l'
        m
        __
    
    (** val coq_R_remove_min_rec :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2 **)
    
    let rec coq_R_remove_min_rec f f0 l x d r p = function
    | R_remove_min_0 (l0,
                      x0,
                      d0,
                      r1) ->
      f
        l0
        x0
        d0
        r1
        __
    | R_remove_min_1 (l0,
                      x0,
                      d0,
                      r1,
                      ll,
                      lx,
                      ld,
                      lr,
                      _x,
                      res,
                      r2,
                      l',
                      m) ->
      f0
        l0
        x0
        d0
        r1
        ll
        lx
        ld
        lr
        _x
        __
        res
        r2
        (coq_R_remove_min_rec
          f
          f0
          ll
          lx
          ld
          lr
          res
          r2)
        l'
        m
        __
    
    type 'elt coq_R_merge =
    | R_merge_0 of 'elt
                   tree
       * 'elt
         tree
    | R_merge_1 of 'elt
                   tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_merge_2 of 'elt
                   tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * (key * 'elt)
       * key
       * 'elt
    
    (** val coq_R_merge_rect :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        key
        ->
        'a1
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_merge
        ->
        'a2 **)
    
    let coq_R_merge_rect f f0 f1 s1 s2 t0 = function
    | R_merge_0 (x,
                 x0) ->
      f
        x
        x0
        __
    | R_merge_1 (x,
                 x0,
                 x1,
                 x2,
                 x3,
                 x4,
                 x5) ->
      f0
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        __
    | R_merge_2 (x,
                 x0,
                 x1,
                 x2,
                 x3,
                 x4,
                 x5,
                 x6,
                 x7,
                 x8,
                 x9,
                 x10,
                 x11,
                 x12,
                 x13,
                 x14) ->
      f1
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        x6
        x7
        x8
        x9
        x10
        __
        x11
        x12
        __
        x13
        x14
        __
    
    (** val coq_R_merge_rec :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        key
        ->
        'a1
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_merge
        ->
        'a2 **)
    
    let coq_R_merge_rec f f0 f1 s1 s2 t0 = function
    | R_merge_0 (x,
                 x0) ->
      f
        x
        x0
        __
    | R_merge_1 (x,
                 x0,
                 x1,
                 x2,
                 x3,
                 x4,
                 x5) ->
      f0
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        __
    | R_merge_2 (x,
                 x0,
                 x1,
                 x2,
                 x3,
                 x4,
                 x5,
                 x6,
                 x7,
                 x8,
                 x9,
                 x10,
                 x11,
                 x12,
                 x13,
                 x14) ->
      f1
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        x6
        x7
        x8
        x9
        x10
        __
        x11
        x12
        __
        x13
        x14
        __
    
    type 'elt coq_R_remove =
    | R_remove_0 of 'elt
                    tree
    | R_remove_1 of 'elt
                    tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_remove
    | R_remove_2 of 'elt
                    tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_remove_3 of 'elt
                    tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_remove
    
    (** val coq_R_remove_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2 **)
    
    let rec coq_R_remove_rect x f f0 f1 f2 m t0 = function
    | R_remove_0 m0 ->
      f
        m0
        __
    | R_remove_1 (m0,
                  l,
                  y,
                  d,
                  r0,
                  _x,
                  res,
                  r1) ->
      f0
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_remove_rect
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_remove_2 (m0,
                  l,
                  y,
                  d,
                  r0,
                  _x) ->
      f1
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
    | R_remove_3 (m0,
                  l,
                  y,
                  d,
                  r0,
                  _x,
                  res,
                  r1) ->
      f2
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_remove_rect
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    (** val coq_R_remove_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2 **)
    
    let rec coq_R_remove_rec x f f0 f1 f2 m t0 = function
    | R_remove_0 m0 ->
      f
        m0
        __
    | R_remove_1 (m0,
                  l,
                  y,
                  d,
                  r0,
                  _x,
                  res,
                  r1) ->
      f0
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_remove_rec
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
    | R_remove_2 (m0,
                  l,
                  y,
                  d,
                  r0,
                  _x) ->
      f1
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
    | R_remove_3 (m0,
                  l,
                  y,
                  d,
                  r0,
                  _x,
                  res,
                  r1) ->
      f2
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_remove_rec
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
    
    type 'elt coq_R_concat =
    | R_concat_0 of 'elt
                    tree
       * 'elt
         tree
    | R_concat_1 of 'elt
                    tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_concat_2 of 'elt
                    tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * (key * 'elt)
    
    (** val coq_R_concat_rect :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_concat
        ->
        'a2 **)
    
    let coq_R_concat_rect f f0 f1 m1 m2 t0 = function
    | R_concat_0 (x,
                  x0) ->
      f
        x
        x0
        __
    | R_concat_1 (x,
                  x0,
                  x1,
                  x2,
                  x3,
                  x4,
                  x5) ->
      f0
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        __
    | R_concat_2 (x,
                  x0,
                  x1,
                  x2,
                  x3,
                  x4,
                  x5,
                  x6,
                  x7,
                  x8,
                  x9,
                  x10,
                  x11,
                  x12) ->
      f1
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        x6
        x7
        x8
        x9
        x10
        __
        x11
        x12
        __
    
    (** val coq_R_concat_rec :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_concat
        ->
        'a2 **)
    
    let coq_R_concat_rec f f0 f1 m1 m2 t0 = function
    | R_concat_0 (x,
                  x0) ->
      f
        x
        x0
        __
    | R_concat_1 (x,
                  x0,
                  x1,
                  x2,
                  x3,
                  x4,
                  x5) ->
      f0
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        __
    | R_concat_2 (x,
                  x0,
                  x1,
                  x2,
                  x3,
                  x4,
                  x5,
                  x6,
                  x7,
                  x8,
                  x9,
                  x10,
                  x11,
                  x12) ->
      f1
        x
        x0
        x1
        x2
        x3
        x4
        x5
        __
        x6
        x7
        x8
        x9
        x10
        __
        x11
        x12
        __
    
    type 'elt coq_R_split =
    | R_split_0 of 'elt
                   tree
    | R_split_1 of 'elt
                   tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         triple
       * 'elt
         coq_R_split
       * 'elt
         tree
       * 'elt
         option
       * 'elt
         tree
    | R_split_2 of 'elt
                   tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_split_3 of 'elt
                   tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         triple
       * 'elt
         coq_R_split
       * 'elt
         tree
       * 'elt
         option
       * 'elt
         tree
    
    (** val coq_R_split_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2 **)
    
    let rec coq_R_split_rect x f f0 f1 f2 m t0 = function
    | R_split_0 m0 ->
      f
        m0
        __
    | R_split_1 (m0,
                 l,
                 y,
                 d,
                 r0,
                 _x,
                 res,
                 r1,
                 ll,
                 o,
                 rl) ->
      f0
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_split_rect
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
        ll
        o
        rl
        __
    | R_split_2 (m0,
                 l,
                 y,
                 d,
                 r0,
                 _x) ->
      f1
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
    | R_split_3 (m0,
                 l,
                 y,
                 d,
                 r0,
                 _x,
                 res,
                 r1,
                 rl,
                 o,
                 rr) ->
      f2
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_split_rect
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
        rl
        o
        rr
        __
    
    (** val coq_R_split_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2 **)
    
    let rec coq_R_split_rec x f f0 f1 f2 m t0 = function
    | R_split_0 m0 ->
      f
        m0
        __
    | R_split_1 (m0,
                 l,
                 y,
                 d,
                 r0,
                 _x,
                 res,
                 r1,
                 ll,
                 o,
                 rl) ->
      f0
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_split_rec
          x
          f
          f0
          f1
          f2
          l
          res
          r1)
        ll
        o
        rl
        __
    | R_split_2 (m0,
                 l,
                 y,
                 d,
                 r0,
                 _x) ->
      f1
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
    | R_split_3 (m0,
                 l,
                 y,
                 d,
                 r0,
                 _x,
                 res,
                 r1,
                 rl,
                 o,
                 rr) ->
      f2
        m0
        l
        y
        d
        r0
        _x
        __
        __
        __
        res
        r1
        (coq_R_split_rec
          x
          f
          f0
          f1
          f2
          r0
          res
          r1)
        rl
        o
        rr
        __
    
    type ('elt,
          'elt') coq_R_map_option =
    | R_map_option_0 of 'elt
                        tree
    | R_map_option_1 of 'elt
                        tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
    | R_map_option_2 of 'elt
                        tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
    
    (** val coq_R_map_option_rect :
        (key
        ->
        'a1
        ->
        'a2
        option)
        ->
        ('a1
        tree
        ->
        __
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3 **)
    
    let rec coq_R_map_option_rect f f0 f1 f2 m t0 = function
    | R_map_option_0 m0 ->
      f0
        m0
        __
    | R_map_option_1 (m0,
                      l,
                      x,
                      d,
                      r0,
                      _x,
                      d',
                      res0,
                      r1,
                      res,
                      r2) ->
      f1
        m0
        l
        x
        d
        r0
        _x
        __
        d'
        __
        res0
        r1
        (coq_R_map_option_rect
          f
          f0
          f1
          f2
          l
          res0
          r1)
        res
        r2
        (coq_R_map_option_rect
          f
          f0
          f1
          f2
          r0
          res
          r2)
    | R_map_option_2 (m0,
                      l,
                      x,
                      d,
                      r0,
                      _x,
                      res0,
                      r1,
                      res,
                      r2) ->
      f2
        m0
        l
        x
        d
        r0
        _x
        __
        __
        res0
        r1
        (coq_R_map_option_rect
          f
          f0
          f1
          f2
          l
          res0
          r1)
        res
        r2
        (coq_R_map_option_rect
          f
          f0
          f1
          f2
          r0
          res
          r2)
    
    (** val coq_R_map_option_rec :
        (key
        ->
        'a1
        ->
        'a2
        option)
        ->
        ('a1
        tree
        ->
        __
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3 **)
    
    let rec coq_R_map_option_rec f f0 f1 f2 m t0 = function
    | R_map_option_0 m0 ->
      f0
        m0
        __
    | R_map_option_1 (m0,
                      l,
                      x,
                      d,
                      r0,
                      _x,
                      d',
                      res0,
                      r1,
                      res,
                      r2) ->
      f1
        m0
        l
        x
        d
        r0
        _x
        __
        d'
        __
        res0
        r1
        (coq_R_map_option_rec
          f
          f0
          f1
          f2
          l
          res0
          r1)
        res
        r2
        (coq_R_map_option_rec
          f
          f0
          f1
          f2
          r0
          res
          r2)
    | R_map_option_2 (m0,
                      l,
                      x,
                      d,
                      r0,
                      _x,
                      res0,
                      r1,
                      res,
                      r2) ->
      f2
        m0
        l
        x
        d
        r0
        _x
        __
        __
        res0
        r1
        (coq_R_map_option_rec
          f
          f0
          f1
          f2
          l
          res0
          r1)
        res
        r2
        (coq_R_map_option_rec
          f
          f0
          f1
          f2
          r0
          res
          r2)
    
    type ('elt,
          'elt',
          'elt'') coq_R_map2_opt =
    | R_map2_opt_0 of 'elt
                      tree
       * 'elt'
         tree
    | R_map2_opt_1 of 'elt
                      tree
       * 'elt'
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_map2_opt_2 of 'elt
                      tree
       * 'elt'
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
         tree
       * key
       * 'elt'
       * 'elt'
         tree
       * I.t
       * 'elt'
         tree
       * 'elt'
         option
       * 'elt'
         tree
       * 'elt''
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
    | R_map2_opt_3 of 'elt
                      tree
       * 'elt'
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
         tree
       * key
       * 'elt'
       * 'elt'
         tree
       * I.t
       * 'elt'
         tree
       * 'elt'
         option
       * 'elt'
         tree
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
    
    (** val coq_R_map2_opt_rect :
        (key
        ->
        'a1
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        ('a1
        tree
        ->
        'a3
        tree)
        ->
        ('a2
        tree
        ->
        'a3
        tree)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        'a3
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4 **)
    
    let rec coq_R_map2_opt_rect f mapl mapr f0 f1 f2 f3 m1 m2 t0 = function
    | R_map2_opt_0 (m3,
                    m4) ->
      f0
        m3
        m4
        __
    | R_map2_opt_1 (m3,
                    m4,
                    l1,
                    x1,
                    d1,
                    r1,
                    _x) ->
      f1
        m3
        m4
        l1
        x1
        d1
        r1
        _x
        __
        __
    | R_map2_opt_2 (m3,
                    m4,
                    l1,
                    x1,
                    d1,
                    r1,
                    _x,
                    _x0,
                    _x1,
                    _x2,
                    _x3,
                    _x4,
                    l2',
                    o2,
                    r2',
                    e,
                    res0,
                    r0,
                    res,
                    r2) ->
      f2
        m3
        m4
        l1
        x1
        d1
        r1
        _x
        __
        _x0
        _x1
        _x2
        _x3
        _x4
        __
        l2'
        o2
        r2'
        __
        e
        __
        res0
        r0
        (coq_R_map2_opt_rect
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          l1
          l2'
          res0
          r0)
        res
        r2
        (coq_R_map2_opt_rect
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          r1
          r2'
          res
          r2)
    | R_map2_opt_3 (m3,
                    m4,
                    l1,
                    x1,
                    d1,
                    r1,
                    _x,
                    _x0,
                    _x1,
                    _x2,
                    _x3,
                    _x4,
                    l2',
                    o2,
                    r2',
                    res0,
                    r0,
                    res,
                    r2) ->
      f3
        m3
        m4
        l1
        x1
        d1
        r1
        _x
        __
        _x0
        _x1
        _x2
        _x3
        _x4
        __
        l2'
        o2
        r2'
        __
        __
        res0
        r0
        (coq_R_map2_opt_rect
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          l1
          l2'
          res0
          r0)
        res
        r2
        (coq_R_map2_opt_rect
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          r1
          r2'
          res
          r2)
    
    (** val coq_R_map2_opt_rec :
        (key
        ->
        'a1
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        ('a1
        tree
        ->
        'a3
        tree)
        ->
        ('a2
        tree
        ->
        'a3
        tree)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        'a3
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4 **)
    
    let rec coq_R_map2_opt_rec f mapl mapr f0 f1 f2 f3 m1 m2 t0 = function
    | R_map2_opt_0 (m3,
                    m4) ->
      f0
        m3
        m4
        __
    | R_map2_opt_1 (m3,
                    m4,
                    l1,
                    x1,
                    d1,
                    r1,
                    _x) ->
      f1
        m3
        m4
        l1
        x1
        d1
        r1
        _x
        __
        __
    | R_map2_opt_2 (m3,
                    m4,
                    l1,
                    x1,
                    d1,
                    r1,
                    _x,
                    _x0,
                    _x1,
                    _x2,
                    _x3,
                    _x4,
                    l2',
                    o2,
                    r2',
                    e,
                    res0,
                    r0,
                    res,
                    r2) ->
      f2
        m3
        m4
        l1
        x1
        d1
        r1
        _x
        __
        _x0
        _x1
        _x2
        _x3
        _x4
        __
        l2'
        o2
        r2'
        __
        e
        __
        res0
        r0
        (coq_R_map2_opt_rec
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          l1
          l2'
          res0
          r0)
        res
        r2
        (coq_R_map2_opt_rec
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          r1
          r2'
          res
          r2)
    | R_map2_opt_3 (m3,
                    m4,
                    l1,
                    x1,
                    d1,
                    r1,
                    _x,
                    _x0,
                    _x1,
                    _x2,
                    _x3,
                    _x4,
                    l2',
                    o2,
                    r2',
                    res0,
                    r0,
                    res,
                    r2) ->
      f3
        m3
        m4
        l1
        x1
        d1
        r1
        _x
        __
        _x0
        _x1
        _x2
        _x3
        _x4
        __
        l2'
        o2
        r2'
        __
        __
        res0
        r0
        (coq_R_map2_opt_rec
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          l1
          l2'
          res0
          r0)
        res
        r2
        (coq_R_map2_opt_rec
          f
          mapl
          mapr
          f0
          f1
          f2
          f3
          r1
          r2'
          res
          r2)
    
    (** val fold' :
        (key
        ->
        'a1
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a2
        ->
        'a2 **)
    
    let fold' f s =
      L.fold
        f
        (elements
          s)
    
    (** val flatten_e :
        'a1
        enumeration
        ->
        (key * 'a1)
        list **)
    
    let rec flatten_e = function
    | End ->
      []
    | More (x,
            e0,
            t0,
            r) ->
      (x,
        e0) :: (app
                 (elements
                   t0)
                 (flatten_e
                   r))
   end
 end

module IntMake = 
 functor (I:Int) ->
 functor (X:OrderedType) ->
 struct 
  module E = X
  
  module Raw = Coq_Raw(I)(X)
  
  type 'elt bst =
    'elt
    Raw.tree
    (* singleton inductive, whose constructor was Bst *)
  
  (** val bst_rect :
      ('a1
      Raw.tree
      ->
      __
      ->
      'a2)
      ->
      'a1
      bst
      ->
      'a2 **)
  
  let bst_rect f b =
    f
      b
      __
  
  (** val bst_rec :
      ('a1
      Raw.tree
      ->
      __
      ->
      'a2)
      ->
      'a1
      bst
      ->
      'a2 **)
  
  let bst_rec f b =
    f
      b
      __
  
  (** val this :
      'a1
      bst
      ->
      'a1
      Raw.tree **)
  
  let this b =
    b
  
  type 'elt t
    =
    'elt
    bst
  
  type key
    =
    E.t
  
  (** val empty :
      'a1
      t **)
  
  let empty =
    Raw.empty
  
  (** val is_empty :
      'a1
      t
      ->
      bool **)
  
  let is_empty m =
    Raw.is_empty
      (this
        m)
  
  (** val add :
      key
      ->
      'a1
      ->
      'a1
      t
      ->
      'a1
      t **)
  
  let add x e m =
    Raw.add
      x
      e
      (this
        m)
  
  (** val remove :
      key
      ->
      'a1
      t
      ->
      'a1
      t **)
  
  let remove x m =
    Raw.remove
      x
      (this
        m)
  
  (** val mem :
      key
      ->
      'a1
      t
      ->
      bool **)
  
  let mem x m =
    Raw.mem
      x
      (this
        m)
  
  (** val find :
      key
      ->
      'a1
      t
      ->
      'a1
      option **)
  
  let find x m =
    Raw.find
      x
      (this
        m)
  
  (** val map :
      ('a1
      ->
      'a2)
      ->
      'a1
      t
      ->
      'a2
      t **)
  
  let map f m =
    Raw.map
      f
      (this
        m)
  
  (** val mapi :
      (key
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      t
      ->
      'a2
      t **)
  
  let mapi f m =
    Raw.mapi
      f
      (this
        m)
  
  (** val map2 :
      ('a1
      option
      ->
      'a2
      option
      ->
      'a3
      option)
      ->
      'a1
      t
      ->
      'a2
      t
      ->
      'a3
      t **)
  
  let map2 f m m' =
    Raw.map2
      f
      (this
        m)
      (this
        m')
  
  (** val elements :
      'a1
      t
      ->
      (key * 'a1)
      list **)
  
  let elements m =
    Raw.elements
      (this
        m)
  
  (** val cardinal :
      'a1
      t
      ->
      nat **)
  
  let cardinal m =
    Raw.cardinal
      (this
        m)
  
  (** val fold :
      (key
      ->
      'a1
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      t
      ->
      'a2
      ->
      'a2 **)
  
  let fold f m i =
    Raw.fold
      f
      (this
        m)
      i
  
  (** val equal :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      'a1
      t
      ->
      'a1
      t
      ->
      bool **)
  
  let equal cmp m m' =
    Raw.equal
      cmp
      (this
        m)
      (this
        m')
 end

module Make = 
 functor (X:OrderedType) ->
 IntMake(Z_as_Int)(X)

type 'world action
  =
  'world
  ->
  'world

type ('input,
      'world) process = ('input,
                         'world) __process Lazy.t
and ('input,
     'world) __process =
| Step of ('input
          ->
          'world
          action * ('input,
          'world)
          process)

type ('input,
      'world) stackWorld =
| StackDone
| StackPush of 'input
   * ('input,
     'world)
     stackWorld
| StackLift of 'world
               action
   * ('input,
     'world)
     stackWorld

type ('input,
      'world) stackProcess
  =
  ('input,
  ('input,
  'world)
  stackWorld)
  process

(** val stepStackProcess :
    (('a1,
    'a2)
    stackWorld * ('a1,
    'a2)
    stackProcess)
    ->
    'a2
    action * ('a1,
    'a2)
    stackProcess **)

let rec stepStackProcess = function
| (s,
   x) ->
  (match s with
   | StackDone ->
     (id,
       x)
   | StackPush (m,
                sw') ->
     let Step pf =
       Lazy.force
       x
     in
     let sap1 =
       pf
         m
     in
     let sw =
       fst
         sap1
         StackDone
     in
     let p =
       stepStackProcess
         (sw,
         (snd
           sap1))
     in
     let (a2,
          s0) =
       p
     in
     let p0 =
       stepStackProcess
         (sw',
         s0)
     in
     let (a3,
          s1) =
       p0
     in
     ((fun w ->
     a2
       (a3
         w)),
     s1)
   | StackLift (a,
                sw') ->
     let p0 =
       stepStackProcess
         (sw',
         x)
     in
     let (a2,
          s0) =
       p0
     in
     ((fun w ->
     a
       (a2
         w)),
     s0))

(** val runStackProcess :
    ('a1,
    'a2)
    stackProcess
    ->
    ('a1,
    'a2)
    process **)

let rec runStackProcess p =
  lazy (Step (fun i ->
    let Step pf =
      Lazy.force
      p
    in
    let sap1 =
      pf
        i
    in
    let sw =
      fst
        sap1
        StackDone
    in
    let stepped =
      stepStackProcess
        (sw,
        (snd
          sap1))
    in
    ((fst
       stepped),
    (runStackProcess
      (snd
        stepped)))))

(** val zero0 :
    char **)

let zero0 = '\000'

(** val one0 :
    char **)

let one0 = '\001'

(** val shift :
    bool
    ->
    char
    ->
    char **)

let shift = fun b c -> Char.chr (((Char.code c) lsl 1) land 255 + if b then 1 else 0)

(** val ascii_of_pos :
    Big.big_int
    ->
    char **)

let ascii_of_pos =
  let rec loop n p =
    match n with
    | O ->
      zero0
    | S n' ->
      (Big.positive_case
         (fun p' ->
         shift
           true
           (loop
             n'
             p'))
         (fun p' ->
         shift
           false
           (loop
             n'
             p'))
         (fun _ ->
         one0)
         p)
  in loop
       (S
       (S
       (S
       (S
       (S
       (S
       (S
       (S
       O))))))))

(** val ascii_of_N :
    Big.big_int
    ->
    char **)

let ascii_of_N n =
  Big.n_case
    (fun _ ->
    zero0)
    (fun p ->
    ascii_of_pos
      p)
    n

(** val n_of_digits :
    bool
    list
    ->
    Big.big_int **)

let rec n_of_digits = function
| [] ->
  Big.zero
| b :: l' ->
  N.add
    (if b
     then Big.one
     else Big.zero)
    (N.mul
      (Big.double
      Big.one)
      (n_of_digits
        l'))

(** val n_of_ascii :
    char
    ->
    Big.big_int **)

let n_of_ascii a =
  (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
    (fun a0 a1 a2 a3 a4 a5 a6 a7 ->
    n_of_digits
      (a0 :: (a1 :: (a2 :: (a3 :: (a4 :: (a5 :: (a6 :: (a7 :: [])))))))))
    a

(** val string_dec :
    char list
    ->
    char list
    ->
    bool **)

let rec string_dec s s0 =
  match s with
  | [] ->
    (match s0 with
     | [] ->
       true
     | a::s1 ->
       false)
  | a::s1 ->
    (match s0 with
     | [] ->
       false
     | a0::s2 ->
       if (=)
            a
            a0
       then string_dec
              s1
              s2
       else false)

(** val append :
    char list
    ->
    char list
    ->
    char list **)

let rec append s1 s2 =
  match s1 with
  | [] ->
    s2
  | c::s1' ->
    c::(append
         s1'
         s2)

(** val length0 :
    char list
    ->
    nat **)

let rec length0 = function
| [] ->
  O
| c::s' ->
  S
    (length0
      s')

(** val substring :
    nat
    ->
    nat
    ->
    char list
    ->
    char list **)

let rec substring n m s =
  match n with
  | O ->
    (match m with
     | O ->
       []
     | S m' ->
       (match s with
        | [] ->
          s
        | c::s' ->
          c::(substring
               O
               m'
               s')))
  | S n' ->
    (match s with
     | [] ->
       s
     | c::s' ->
       substring
         n'
         m
         s')

type ('world,
      't) abortable =
| Started of 'world
             action
| Done of 't

type httpStatus =
| HttpOk
| HttpPreconditionFailed
| HttpUnrecognizedCode

type httpResponse = { httpResponseStatus : httpStatus;
                      httpResponseStatusText : char list;
                      httpResponseProtocol : char list;
                      httpResponseHeader : (char list * char list)
                                           list;
                      httpResponseBody : char list }

(** val httpResponseStatus :
    httpResponse
    ->
    httpStatus **)

let httpResponseStatus x = x.httpResponseStatus

(** val httpResponseBody :
    httpResponse
    ->
    char list **)

let httpResponseBody x = x.httpResponseBody

type ('input,
      'world) systemActions = { consoleErr : (char list
                                             ->
                                             'world
                                             action);
                                consoleIn : ((char list
                                            ->
                                            'input)
                                            ->
                                            'world
                                            action);
                                consoleOut : (char list
                                             ->
                                             'world
                                             action);
                                exit : (Big.big_int
                                       ->
                                       'world
                                       action);
                                getArgv : ((char list
                                          list
                                          ->
                                          'input)
                                          ->
                                          'world
                                          action);
                                getNanosecs : ((Big.big_int
                                              ->
                                              'input)
                                              ->
                                              'world
                                              action);
                                getRandomness : (Big.big_int
                                                ->
                                                (char list
                                                ->
                                                'input)
                                                ->
                                                'world
                                                action);
                                httpPOST : (char list
                                           ->
                                           (char list * char list)
                                           list
                                           ->
                                           (('world,
                                           httpResponse)
                                           abortable
                                           ->
                                           'input)
                                           ->
                                           'world
                                           action);
                                setDebug : (Big.big_int
                                           ->
                                           'world
                                           action);
                                sleepNanosecs : (Big.big_int
                                                ->
                                                'input
                                                ->
                                                'world
                                                action) }

(** val consoleErr :
    ('a1,
    'a2)
    systemActions
    ->
    char list
    ->
    'a2
    action **)

let consoleErr x = x.consoleErr

(** val consoleIn :
    ('a1, 'a2) systemActions -> (char list -> 'a1) -> 'a2 action **)

let consoleIn x = x.consoleIn

(** val consoleOut : ('a1, 'a2) systemActions -> char list -> 'a2 action **)

let consoleOut x = x.consoleOut

(** val exit : ('a1, 'a2) systemActions -> Big.big_int -> 'a2 action **)

let exit x = x.exit

(** val getArgv :
    ('a1, 'a2) systemActions -> (char list list -> 'a1) -> 'a2 action **)

let getArgv x = x.getArgv

(** val getNanosecs :
    ('a1, 'a2) systemActions -> (Big.big_int -> 'a1) -> 'a2 action **)

let getNanosecs x = x.getNanosecs

(** val getRandomness :
    ('a1, 'a2) systemActions -> Big.big_int -> (char list -> 'a1) -> 'a2
    action **)

let getRandomness x = x.getRandomness

(** val httpPOST :
    ('a1, 'a2) systemActions -> char list -> (char list * char list) list ->
    (('a2, httpResponse) abortable -> 'a1) -> 'a2 action **)

let httpPOST x = x.httpPOST

(** val setDebug : ('a1, 'a2) systemActions -> Big.big_int -> 'a2 action **)

let setDebug x = x.setDebug

(** val sleepNanosecs :
    ('a1, 'a2) systemActions -> Big.big_int -> 'a1 -> 'a2 action **)

let sleepNanosecs x = x.sleepNanosecs

(** val apply : ('a1 -> 'a2) -> 'a1 -> 'a2 **)

let apply f x =
  f x

(** val flip0 : ('a1 -> 'a2 -> 'a3) -> 'a2 -> 'a1 -> 'a3 **)

let flip0 f b a =
  f a b

(** val msum : 'a1 option list -> 'a1 option **)

let rec msum = function
| [] -> None
| o :: ls0 ->
  (match o with
   | Some a -> Some a
   | None -> msum ls0)

(** val default : 'a1 -> 'a1 option -> 'a1 **)

let default def = function
| Some a -> a
| None -> def

(** val splitn : nat -> 'a1 list -> 'a1 list * 'a1 list **)

let splitn n ls =
  ((firstn n ls), (skipn n ls))

(** val flat : 'a1 list list -> 'a1 list **)

let flat ls =
  flat_map id ls

(** val sum0 : 'a1 -> ('a1 -> 'a1 -> 'a1) -> 'a1 list -> 'a1 **)

let sum0 zero1 add0 ls =
  fold_left add0 ls zero1

(** val repeat : 'a1 -> nat -> 'a1 list **)

let rec repeat a = function
| O -> []
| S n0 -> a :: (repeat a n0)

(** val lcshift : nat -> 'a1 list -> 'a1 list **)

let lcshift n ls =
  app (skipn n ls) (firstn n ls)

(** val range : nat -> nat -> 'a1 list -> 'a1 list **)

let range begin0 len0 ls =
  firstn len0 (skipn begin0 ls)

(** val forall2 : ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool **)

let rec forall2 p ls1 ls2 =
  match ls1 with
  | [] ->
    (match ls2 with
     | [] -> true
     | y :: l -> false)
  | a :: ls3 ->
    (match ls2 with
     | [] -> false
     | b :: ls4 -> (&&) (p a b) (forall2 p ls3 ls4))

(** val map0 : ('a1 -> 'a2 -> 'a3) -> 'a1 list -> 'a2 list -> 'a3 list **)

let rec map0 f ls1 ls2 =
  match ls1 with
  | [] -> []
  | a :: ls3 ->
    (match ls2 with
     | [] -> []
     | b :: ls4 -> (f a b) :: (map0 f ls3 ls4))

(** val mapi' : nat -> (nat -> 'a1 -> 'a2) -> 'a1 list -> 'a2 list **)

let rec mapi' base f = function
| [] -> []
| x :: xs -> (f base x) :: (mapi' (S base) f xs)

(** val mapi0 : (nat -> 'a1 -> 'a2) -> 'a1 list -> 'a2 list **)

let mapi0 f =
  mapi' O f

(** val iter_range : ('a1 -> nat -> 'a1) -> nat -> nat -> 'a1 -> 'a1 **)

let rec iter_range f begin0 len0 init =
  match len0 with
  | O -> init
  | S n' -> iter_range f (S begin0) n' (f init begin0)

(** val iter_range_collect_rev :
    ('a1 -> nat -> 'a1) -> nat -> nat -> 'a1 -> 'a1 list -> 'a1 list **)

let iter_range_collect_rev f begin0 len0 init init_res =
  snd
    (iter_range (fun p n ->
      let old = fst p in
      let ls = snd p in let new0 = f old n in (new0, (new0 :: ls))) begin0
      len0 (init, init_res))

(** val iter_range_collect :
    ('a1 -> nat -> 'a1) -> nat -> nat -> 'a1 -> 'a1 list -> 'a1 list **)

let iter_range_collect f begin0 len0 init init_res =
  rev (iter_range_collect_rev f begin0 len0 init (rev init_res))

(** val iter_collect :
    ('a1 -> nat -> 'a1) -> nat -> 'a1 -> 'a1 list -> 'a1 list **)

let iter_collect f n =
  iter_range_collect f O n

(** val for_range : nat -> nat -> (nat -> 'a1) -> 'a1 list **)

let rec for_range begin0 len0 f =
  match len0 with
  | O -> []
  | S n -> (f begin0) :: (for_range (S begin0) n f)

(** val for_n : nat -> (nat -> 'a1) -> 'a1 list **)

let for_n len0 =
  for_range O len0

(** val slice' : nat -> nat -> 'a1 list -> 'a1 list list **)

let rec slice' count width ls =
  match count with
  | O -> []
  | S count0 -> (firstn width ls) :: (slice' count0 width (skipn width ls))

(** val slice : nat -> 'a1 list -> 'a1 list list **)

let slice width ls =
  let n = div0 (length ls) width in
  let res = slice' n width ls in
  let len0 = mult width n in
  (match minus (length ls) len0 with
   | O -> res
   | S n0 -> app res ((skipn len0 ls) :: []))

(** val mapi_every :
    nat -> (nat -> 'a1 list -> 'a1 list) -> 'a1 list -> 'a1 list **)

let mapi_every width f ls =
  flat (mapi0 f (slice width ls))

(** val map_every : nat -> ('a1 list -> 'a1 list) -> 'a1 list -> 'a1 list **)

let map_every n f =
  mapi_every n (fun x e -> f e)

(** val n_of_ascii_in :
    char -> char -> Big.big_int -> char -> Big.big_int option **)

let n_of_ascii_in a b base ch =
  let asc = n_of_ascii ch in
  let ascA = n_of_ascii a in
  let ascB = n_of_ascii b in
  if (&&) (N.leb ascA asc) (N.leb asc ascB)
  then Some (N.add (N.sub asc ascA) base)
  else None

(** val str_to_list : char list -> char list **)

let rec str_to_list = function
| [] -> []
| c::s -> c :: (str_to_list s)

(** val list_to_str : char list -> char list **)

let rec list_to_str = function
| [] -> []
| c :: ls0 -> c::(list_to_str ls0)

type bitvec = bool list

type b128 = bitvec

type b352 = bitvec

type byte = bitvec

(** val get_slice : 'a1 list -> nat -> nat -> 'a1 list **)

let get_slice vec begin0 len0 =
  firstn len0 (skipn begin0 vec)

(** val get : nat -> bitvec -> nat -> bool list **)

let get width vec idx =
  get_slice vec (mult width idx) width

(** val set_slice : 'a1 list -> nat -> 'a1 list -> 'a1 list **)

let set_slice vec begin0 value =
  app (firstn begin0 vec)
    (app value (skipn (plus begin0 (length value)) vec))

(** val set : nat -> bitvec -> nat -> bool list -> bool list **)

let set width vec idx value =
  set_slice vec (mult width idx) value

type key_t = b128

type key_schedule_t = b352

(** val zeros : nat -> bool list **)

let zeros =
  repeat false

(** val of_bin_ascii : char -> bool **)

let of_bin_ascii ch =
  (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
    (fun b b0 b1 b2 b3 b4 b5 b6 ->
    if b
    then true
    else if b0
         then true
         else if b1
              then true
              else if b2
                   then true
                   else if b3
                        then if b4 then if b5 then true else b6 else true
                        else true)
    ch

(** val bitvec_of_bin_str : char list -> bitvec **)

let bitvec_of_bin_str =
  compose (map of_bin_ascii) str_to_list

(** val right_trunc_pad_to : nat -> bitvec -> bitvec **)

let right_trunc_pad_to len0 vec =
  app (firstn len0 vec) (zeros (minus len0 (length vec)))

(** val lsb_of_pos : Big.big_int -> bitvec **)

let rec lsb_of_pos p =
  Big.positive_case
    (fun p0 ->
    true :: (lsb_of_pos p0))
    (fun p0 ->
    false :: (lsb_of_pos p0))
    (fun _ ->
    true :: [])
    p

(** val lsb_of_N : Big.big_int -> byte **)

let lsb_of_N n =
  Big.n_case
    (fun _ ->
    false :: [])
    (fun p ->
    lsb_of_pos p)
    n

(** val lsb_to_N : bitvec -> Big.big_int **)

let rec lsb_to_N = function
| [] -> Big.zero
| b :: vec0 ->
  (Big.n_case
     (fun _ ->
     if b then Big.one else Big.zero)
     (fun p ->
     let p0 = if b then Big.doubleplusone p else Big.double p in p0)
     (lsb_to_N vec0))

(** val lsb_to_nat : bitvec -> nat **)

let lsb_to_nat =
  flip compose lsb_to_N N.to_nat

(** val msb_to_N : bool list -> Big.big_int **)

let msb_to_N =
  flip compose rev lsb_to_N

(** val msb_to_nat : bool list -> nat **)

let msb_to_nat =
  flip compose rev lsb_to_nat

(** val msb_of_N : nat -> Big.big_int -> bitvec **)

let msb_of_N width n =
  apply rev (right_trunc_pad_to width (lsb_of_N n))

(** val msb_of_nat : nat -> nat -> bitvec **)

let msb_of_nat width n =
  msb_of_N width (N.of_nat n)

(** val byte_of_N : Big.big_int -> byte **)

let byte_of_N n =
  msb_of_N (S (S (S (S (S (S (S (S O)))))))) n

(** val byte_of_nat : nat -> byte **)

let byte_of_nat n =
  msb_of_nat (S (S (S (S (S (S (S (S O)))))))) n

(** val byte_to_nat : byte -> nat **)

let byte_to_nat b =
  msb_to_nat b

(** val n_of_hex_ascii : char -> Big.big_int **)

let n_of_hex_ascii ch =
  apply (default Big.zero)
    (apply msum
      (map (fun x ->
        let (p, base) = x in n_of_ascii_in (fst p) (snd p) base ch) ((('0',
        '9'), Big.zero) :: ((('A', 'F'), (Big.double (Big.doubleplusone
        (Big.double Big.one)))) :: ((('a', 'f'), (Big.double
        (Big.doubleplusone (Big.double Big.one)))) :: [])))))

(** val map_byte : (byte -> byte) -> bitvec -> bitvec **)

let map_byte f vec =
  map_every (S (S (S (S (S (S (S (S O)))))))) f vec

(** val halfbyte_of_hex_ascii : char -> bool list **)

let halfbyte_of_hex_ascii =
  compose
    (compose (compose rev (right_trunc_pad_to (S (S (S (S O)))))) lsb_of_N)
    n_of_hex_ascii

(** val remove_space : char -> bool **)

let remove_space ch =
  (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
    (fun b b0 b1 b2 b3 b4 b5 b6 ->
    if b
    then true
    else if b0
         then true
         else if b1
              then true
              else if b2
                   then true
                   else if b3
                        then true
                        else if b4 then if b5 then true else b6 else true)
    ch

(** val bitvec_of_hex : char list -> bitvec **)

let bitvec_of_hex =
  compose
    (compose (compose flat (map halfbyte_of_hex_ascii))
      (filter remove_space)) str_to_list

(** val left_trunc_pad_to : nat -> bool list -> bool list **)

let left_trunc_pad_to n =
  compose (compose rev (right_trunc_pad_to n)) rev

(** val byte_of_hex : char list -> byte **)

let byte_of_hex =
  compose (left_trunc_pad_to (S (S (S (S (S (S (S (S O))))))))) bitvec_of_hex

(** val bitvec_eqb : bool list -> bool list -> bool **)

let bitvec_eqb =
  forall2 eqb

(** val bit_xor : bool -> bool -> bool **)

let bit_xor a b =
  if a then if b then false else true else b

(** val xor : bitvec -> bitvec -> bitvec **)

let xor a b =
  map0 bit_xor a b

(** val rshift : nat -> bitvec -> bool list **)

let rshift n v =
  app (zeros n) (firstn (minus (length v) n) v)

(** val f231 : ('a1 -> 'a2 -> 'a3 -> 'a4) -> 'a2 -> 'a3 -> 'a1 -> 'a4 **)

let f231 f b c a =
  f a b c

(** val gf_mul : nat -> bitvec -> bitvec -> bitvec -> bitvec **)

let gf_mul n r a b =
  let r0 = right_trunc_pad_to n r in
  apply fst
    (f231 fold_left b ((zeros n), a) (fun st bi ->
      let (z, v) = st in
      let z0 = if bi then xor z v else z in
      let v0 =
        if nth (minus n (S O)) v false
        then xor (rshift (S O) v) r0
        else rshift (S O) v
      in
      (z0, v0)))

(** val ascii_to_byte : char -> byte **)

let ascii_to_byte =
  flip compose n_of_ascii byte_of_N

(** val str_to_bitvec : char list -> bool list **)

let str_to_bitvec =
  flip compose (flip compose str_to_list (map ascii_to_byte)) flat

(** val byte_to_ascii : bool list -> char **)

let byte_to_ascii =
  flip compose msb_to_N ascii_of_N

(** val bitvec_to_str : bool list -> char list **)

let bitvec_to_str =
  flip compose
    (flip compose (slice (S (S (S (S (S (S (S (S O)))))))))
      (map byte_to_ascii)) list_to_str

(** val s_box : byte list **)

let s_box =
  map byte_of_hex
    (('6'::('3'::[])) :: (('7'::('C'::[])) :: (('7'::('7'::[])) :: (('7'::('B'::[])) :: (('F'::('2'::[])) :: (('6'::('B'::[])) :: (('6'::('F'::[])) :: (('C'::('5'::[])) :: (('3'::('0'::[])) :: (('0'::('1'::[])) :: (('6'::('7'::[])) :: (('2'::('B'::[])) :: (('F'::('E'::[])) :: (('D'::('7'::[])) :: (('A'::('B'::[])) :: (('7'::('6'::[])) :: (('C'::('A'::[])) :: (('8'::('2'::[])) :: (('C'::('9'::[])) :: (('7'::('D'::[])) :: (('F'::('A'::[])) :: (('5'::('9'::[])) :: (('4'::('7'::[])) :: (('F'::('0'::[])) :: (('A'::('D'::[])) :: (('D'::('4'::[])) :: (('A'::('2'::[])) :: (('A'::('F'::[])) :: (('9'::('C'::[])) :: (('A'::('4'::[])) :: (('7'::('2'::[])) :: (('C'::('0'::[])) :: (('B'::('7'::[])) :: (('F'::('D'::[])) :: (('9'::('3'::[])) :: (('2'::('6'::[])) :: (('3'::('6'::[])) :: (('3'::('F'::[])) :: (('F'::('7'::[])) :: (('C'::('C'::[])) :: (('3'::('4'::[])) :: (('A'::('5'::[])) :: (('E'::('5'::[])) :: (('F'::('1'::[])) :: (('7'::('1'::[])) :: (('D'::('8'::[])) :: (('3'::('1'::[])) :: (('1'::('5'::[])) :: (('0'::('4'::[])) :: (('C'::('7'::[])) :: (('2'::('3'::[])) :: (('C'::('3'::[])) :: (('1'::('8'::[])) :: (('9'::('6'::[])) :: (('0'::('5'::[])) :: (('9'::('A'::[])) :: (('0'::('7'::[])) :: (('1'::('2'::[])) :: (('8'::('0'::[])) :: (('E'::('2'::[])) :: (('E'::('B'::[])) :: (('2'::('7'::[])) :: (('B'::('2'::[])) :: (('7'::('5'::[])) :: (('0'::('9'::[])) :: (('8'::('3'::[])) :: (('2'::('C'::[])) :: (('1'::('A'::[])) :: (('1'::('B'::[])) :: (('6'::('E'::[])) :: (('5'::('A'::[])) :: (('A'::('0'::[])) :: (('5'::('2'::[])) :: (('3'::('B'::[])) :: (('D'::('6'::[])) :: (('B'::('3'::[])) :: (('2'::('9'::[])) :: (('E'::('3'::[])) :: (('2'::('F'::[])) :: (('8'::('4'::[])) :: (('5'::('3'::[])) :: (('D'::('1'::[])) :: (('0'::('0'::[])) :: (('E'::('D'::[])) :: (('2'::('0'::[])) :: (('F'::('C'::[])) :: (('B'::('1'::[])) :: (('5'::('B'::[])) :: (('6'::('A'::[])) :: (('C'::('B'::[])) :: (('B'::('E'::[])) :: (('3'::('9'::[])) :: (('4'::('A'::[])) :: (('4'::('C'::[])) :: (('5'::('8'::[])) :: (('C'::('F'::[])) :: (('D'::('0'::[])) :: (('E'::('F'::[])) :: (('A'::('A'::[])) :: (('F'::('B'::[])) :: (('4'::('3'::[])) :: (('4'::('D'::[])) :: (('3'::('3'::[])) :: (('8'::('5'::[])) :: (('4'::('5'::[])) :: (('F'::('9'::[])) :: (('0'::('2'::[])) :: (('7'::('F'::[])) :: (('5'::('0'::[])) :: (('3'::('C'::[])) :: (('9'::('F'::[])) :: (('A'::('8'::[])) :: (('5'::('1'::[])) :: (('A'::('3'::[])) :: (('4'::('0'::[])) :: (('8'::('F'::[])) :: (('9'::('2'::[])) :: (('9'::('D'::[])) :: (('3'::('8'::[])) :: (('F'::('5'::[])) :: (('B'::('C'::[])) :: (('B'::('6'::[])) :: (('D'::('A'::[])) :: (('2'::('1'::[])) :: (('1'::('0'::[])) :: (('F'::('F'::[])) :: (('F'::('3'::[])) :: (('D'::('2'::[])) :: (('C'::('D'::[])) :: (('0'::('C'::[])) :: (('1'::('3'::[])) :: (('E'::('C'::[])) :: (('5'::('F'::[])) :: (('9'::('7'::[])) :: (('4'::('4'::[])) :: (('1'::('7'::[])) :: (('C'::('4'::[])) :: (('A'::('7'::[])) :: (('7'::('E'::[])) :: (('3'::('D'::[])) :: (('6'::('4'::[])) :: (('5'::('D'::[])) :: (('1'::('9'::[])) :: (('7'::('3'::[])) :: (('6'::('0'::[])) :: (('8'::('1'::[])) :: (('4'::('F'::[])) :: (('D'::('C'::[])) :: (('2'::('2'::[])) :: (('2'::('A'::[])) :: (('9'::('0'::[])) :: (('8'::('8'::[])) :: (('4'::('6'::[])) :: (('E'::('E'::[])) :: (('B'::('8'::[])) :: (('1'::('4'::[])) :: (('D'::('E'::[])) :: (('5'::('E'::[])) :: (('0'::('B'::[])) :: (('D'::('B'::[])) :: (('E'::('0'::[])) :: (('3'::('2'::[])) :: (('3'::('A'::[])) :: (('0'::('A'::[])) :: (('4'::('9'::[])) :: (('0'::('6'::[])) :: (('2'::('4'::[])) :: (('5'::('C'::[])) :: (('C'::('2'::[])) :: (('D'::('3'::[])) :: (('A'::('C'::[])) :: (('6'::('2'::[])) :: (('9'::('1'::[])) :: (('9'::('5'::[])) :: (('E'::('4'::[])) :: (('7'::('9'::[])) :: (('E'::('7'::[])) :: (('C'::('8'::[])) :: (('3'::('7'::[])) :: (('6'::('D'::[])) :: (('8'::('D'::[])) :: (('D'::('5'::[])) :: (('4'::('E'::[])) :: (('A'::('9'::[])) :: (('6'::('C'::[])) :: (('5'::('6'::[])) :: (('F'::('4'::[])) :: (('E'::('A'::[])) :: (('6'::('5'::[])) :: (('7'::('A'::[])) :: (('A'::('E'::[])) :: (('0'::('8'::[])) :: (('B'::('A'::[])) :: (('7'::('8'::[])) :: (('2'::('5'::[])) :: (('2'::('E'::[])) :: (('1'::('C'::[])) :: (('A'::('6'::[])) :: (('B'::('4'::[])) :: (('C'::('6'::[])) :: (('E'::('8'::[])) :: (('D'::('D'::[])) :: (('7'::('4'::[])) :: (('1'::('F'::[])) :: (('4'::('B'::[])) :: (('B'::('D'::[])) :: (('8'::('B'::[])) :: (('8'::('A'::[])) :: (('7'::('0'::[])) :: (('3'::('E'::[])) :: (('B'::('5'::[])) :: (('6'::('6'::[])) :: (('4'::('8'::[])) :: (('0'::('3'::[])) :: (('F'::('6'::[])) :: (('0'::('E'::[])) :: (('6'::('1'::[])) :: (('3'::('5'::[])) :: (('5'::('7'::[])) :: (('B'::('9'::[])) :: (('8'::('6'::[])) :: (('C'::('1'::[])) :: (('1'::('D'::[])) :: (('9'::('E'::[])) :: (('E'::('1'::[])) :: (('F'::('8'::[])) :: (('9'::('8'::[])) :: (('1'::('1'::[])) :: (('6'::('9'::[])) :: (('D'::('9'::[])) :: (('8'::('E'::[])) :: (('9'::('4'::[])) :: (('9'::('B'::[])) :: (('1'::('E'::[])) :: (('8'::('7'::[])) :: (('E'::('9'::[])) :: (('C'::('E'::[])) :: (('5'::('5'::[])) :: (('2'::('8'::[])) :: (('D'::('F'::[])) :: (('8'::('C'::[])) :: (('A'::('1'::[])) :: (('8'::('9'::[])) :: (('0'::('D'::[])) :: (('B'::('F'::[])) :: (('E'::('6'::[])) :: (('4'::('2'::[])) :: (('6'::('8'::[])) :: (('4'::('1'::[])) :: (('9'::('9'::[])) :: (('2'::('D'::[])) :: (('0'::('F'::[])) :: (('B'::('0'::[])) :: (('5'::('4'::[])) :: (('B'::('B'::[])) :: (('1'::('6'::[])) :: []))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val rC : byte list **)

let rC =
  map byte_of_hex
    (('0'::('1'::[])) :: (('0'::('2'::[])) :: (('0'::('4'::[])) :: (('0'::('8'::[])) :: (('1'::('0'::[])) :: (('2'::('0'::[])) :: (('4'::('0'::[])) :: (('8'::('0'::[])) :: (('1'::('b'::[])) :: (('3'::('6'::[])) :: []))))))))))

(** val list_get : byte list -> nat -> byte **)

let list_get ls idx =
  nth idx ls (byte_of_nat O)

(** val sub_byte : byte -> byte **)

let sub_byte b =
  list_get s_box (byte_to_nat b)

(** val get_byte : bitvec -> nat -> bool list **)

let get_byte =
  get (S (S (S (S (S (S (S (S O))))))))

(** val set_byte : bitvec -> nat -> bool list -> bool list **)

let set_byte =
  set (S (S (S (S (S (S (S (S O))))))))

(** val lcshift_byte : bool list -> bool list **)

let lcshift_byte =
  lcshift (S (S (S (S (S (S (S (S O))))))))

(** val g : nat -> key_t -> bool list **)

let g n w =
  let w0 = lcshift_byte w in
  let w1 = map_byte sub_byte w0 in
  set_byte w1 O (xor (get_byte w1 O) (list_get rC n))

(** val gen_round_key : key_t -> nat -> key_t **)

let gen_round_key w n =
  let w0 =
    get (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))) w O
  in
  let w1 =
    get (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))) w (S O)
  in
  let w2 =
    get (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))) w (S (S
      O))
  in
  let w3 =
    get (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))) w (S (S (S
      O)))
  in
  let w0' = xor w0 (g n w3) in
  let w1' = xor w0' w1 in
  let w2' = xor w1' w2 in
  let w3' = xor w2' w3 in flat (w0' :: (w1' :: (w2' :: (w3' :: []))))

(** val key_schedule : key_t -> key_schedule_t **)

let key_schedule key0 =
  flat
    (iter_collect gen_round_key (S (S (S (S (S (S (S (S (S (S O))))))))))
      key0 (key0 :: []))

type 'a matrix = 'a list list

(** val trans_mx : 'a1 -> 'a1 matrix -> nat -> nat -> 'a1 matrix **)

let trans_mx def mx m n =
  for_n n (fun j -> flip0 map mx (fun row -> nth j row def))

(** val to_row_major_mx : nat -> nat -> 'a1 list -> 'a1 matrix **)

let to_row_major_mx m n ls =
  slice n ls

(** val to_col_major_mx : 'a1 -> nat -> nat -> 'a1 list -> 'a1 matrix **)

let to_col_major_mx def m n ls =
  trans_mx def (to_row_major_mx n m ls) n m

(** val of_row_major_mx : 'a1 matrix -> nat -> nat -> 'a1 list **)

let of_row_major_mx mx m n =
  flat mx

(** val of_col_major_mx : 'a1 -> 'a1 matrix -> nat -> nat -> 'a1 list **)

let of_col_major_mx def mx m n =
  of_row_major_mx (trans_mx def mx m n) n m

(** val mx_mul :
    'a1 -> ('a1 -> 'a1 -> 'a1) -> ('a1 -> 'a1 -> 'a1) -> 'a1 matrix -> nat ->
    nat -> 'a1 matrix -> nat -> 'a1 matrix **)

let mx_mul def add0 mul0 a m n b r =
  let b0 = trans_mx def b n r in
  flip0 mapi0 a (fun i arow ->
    flip0 mapi0 b0 (fun j bcol -> sum0 def add0 (map0 mul0 arow bcol)))

(** val shift_rows : byte matrix -> byte list list **)

let shift_rows mx =
  mapi0 (fun n row -> lcshift n row) mx

(** val mix_matrix : byte matrix **)

let mix_matrix =
  apply (to_row_major_mx (S (S (S (S O)))) (S (S (S (S O)))))
    (map byte_of_nat ((S (S O)) :: ((S (S (S O))) :: ((S O) :: ((S O) :: ((S
      O) :: ((S (S O)) :: ((S (S (S O))) :: ((S O) :: ((S O) :: ((S O) :: ((S
      (S O)) :: ((S (S (S O))) :: ((S (S (S O))) :: ((S O) :: ((S O) :: ((S
      (S O)) :: [])))))))))))))))))

(** val gf8_byte_mul : byte -> byte -> byte **)

let gf8_byte_mul a b =
  apply rev
    (gf_mul (S (S (S (S (S (S (S (S O))))))))
      (bitvec_of_bin_str ('1'::('1'::('0'::('1'::('1'::[])))))) (rev a)
      (rev b))

(** val mix_rows : byte matrix -> byte matrix **)

let mix_rows mx =
  mx_mul (byte_of_nat O) xor gf8_byte_mul mix_matrix (S (S (S (S O)))) (S (S
    (S (S O)))) mx (S (S (S (S O))))

(** val add_round_key : b128 -> b128 -> bitvec **)

let add_round_key text round_key =
  xor text round_key

(** val round : bool -> b128 -> b128 -> bool list **)

let round is_last bits round_key =
  let mx =
    to_col_major_mx (byte_of_nat O) (S (S (S (S O)))) (S (S (S (S O))))
      (slice (S (S (S (S (S (S (S (S O)))))))) bits)
  in
  let mx0 = map (map sub_byte) mx in
  let mx1 = shift_rows mx0 in
  let mx2 = if is_last then mx1 else mix_rows mx1 in
  let round_key_mx =
    to_col_major_mx (byte_of_nat O) (S (S (S (S O)))) (S (S (S (S O))))
      (slice (S (S (S (S (S (S (S (S O)))))))) round_key)
  in
  let mx3 = map0 (map0 add_round_key) mx2 round_key_mx in
  flat
    (of_col_major_mx (byte_of_nat O) mx3 (S (S (S (S O)))) (S (S (S (S O)))))

module Coq__1 = struct 
 (** val encrypt : key_t -> b128 -> bool list **)
 
 let encrypt key0 plaintext =
   let keys =
     slice (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
       (key_schedule key0)
   in
   let get_key = fun n ->
     nth n keys
       (zeros (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
   in
   let after0 = add_round_key plaintext (get_key O) in
   let after9 =
     fold_left (round false)
       (range (S O) (S (S (S (S (S (S (S (S (S O))))))))) keys) after0
   in
   round true after9 (get_key (S (S (S (S (S (S (S (S (S (S O)))))))))))
end
let encrypt = Coq__1.encrypt

(** val stateful_map :
    ('a1 -> 'a1) -> 'a1 -> ('a2 -> 'a1 -> 'a2) -> 'a2 list -> 'a2 list * 'a1 **)

let stateful_map upd init f ls =
  let step = fun p x ->
    let (acc, st) = p in let y = f x st in ((y :: acc), (upd st))
  in
  let (ls0, final) = fold_left step ls ([], init) in ((rev ls0), final)

(** val fold_left_i :
    (nat -> 'a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> nat -> 'a1 **)

let fold_left_i f ls init init_i =
  apply fst
    (fold_left (fun p x -> let (a, i) = p in ((f i a x), (S i))) ls (init,
      init_i))

(** val len : 'a1 list -> bitvec **)

let len x =
  flip compose length
    (msb_of_nat (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) x

(** val gf128_mul : bitvec -> bitvec -> bitvec **)

let gf128_mul =
  gf_mul (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    (S (S (S (S (S (S (S (S (S
    O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
    (bitvec_of_bin_str
      ('1'::('1'::('1'::('0'::('0'::('0'::('0'::('1'::[])))))))))

(** val gHASH : b128 -> bitvec -> bitvec -> b128 **)

let gHASH h0 a c =
  let as0 =
    slice (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S
      O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      a
  in
  let cs =
    slice (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S
      O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      c
  in
  let m = length as0 in
  let n = length cs in
  let step = fun i x y ->
    let y1 =
      if (||) (beq_nat i (minus m (S O)))
           (beq_nat i (minus (plus m n) (S O)))
      then right_trunc_pad_to (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S
             O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
             y
      else y
    in
    gf128_mul (xor x y1) h0
  in
  let x =
    fold_left_i step (app as0 cs)
      (zeros (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      O
  in
  gf128_mul (xor x (app (len a) (len c))) h0

type iV_t = bitvec

type a_t = bitvec

(** val h : (key_t -> b128 -> b128) -> key_t -> b128 **)

let h e k =
  apply (e k)
    (zeros (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S
      O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val msb_unsign_plus : bitvec -> bitvec -> bitvec **)

let msb_unsign_plus a b =
  msb_of_N (length a) (N.add (msb_to_N a) (msb_to_N b))

(** val incr : bool list -> bool list **)

let incr v =
  let f_len =
    minus (length v) (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S
      O))))))))))))))))))))))))))))))))
  in
  let f = firstn f_len v in
  let i = skipn f_len v in
  app f
    (msb_unsign_plus i
      (msb_of_nat (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))))
        (S O)))

(** val y0 : (key_t -> b128 -> b128) -> key_t -> iV_t -> b128 **)

let y0 e k iV =
  if beq_nat (length iV) (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
       (S (S (S (S (S (S (S (S (S (S
       O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
  then app iV
         (app
           (zeros (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S
             O)))))))))))))))))))))))))))))))) (bitvec_of_bin_str ('1'::[])))
  else gHASH (h e k) [] iV

(** val encrypt0 :
    (key_t -> b128 -> b128) -> key_t -> iV_t -> bitvec -> bitvec **)

let encrypt0 e k iV p = match p with
| [] -> []
| b :: l ->
  let ps =
    slice (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S (S (S (S (S (S
      O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      p
  in
  let pi = removelast ps in
  let pn =
    last ps
      (zeros (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
  in
  let (ci, yn) =
    stateful_map incr (incr (y0 e k iV)) (fun pi0 yi -> xor pi0 (e k yi)) pi
  in
  let cn = xor pn (firstn (length pn) (e k yn)) in app (flat ci) cn

(** val hash :
    (key_t -> b128 -> b128) -> key_t -> iV_t -> a_t -> nat -> bitvec -> bool
    list **)

let hash e k iV a t0 c =
  apply (firstn t0) (xor (gHASH (h e k) a c) (e k (y0 e k iV)))

(** val encrypt1 :
    (key_t -> b128 -> b128) -> key_t -> iV_t -> bitvec -> a_t -> nat ->
    bitvec * bool list **)

let encrypt1 e k iV p a k0 =
  let c = encrypt0 e k iV p in let t0 = hash e k iV a k0 c in (c, t0)

(** val decrypt :
    (key_t -> b128 -> b128) -> key_t -> iV_t -> bitvec -> a_t -> bitvec ->
    bitvec option **)

let decrypt e k iV c a t0 =
  let k0 = length t0 in
  let t' = hash e k iV a k0 c in
  if bitvec_eqb t' t0 then let p = encrypt0 e k iV c in Some p else None

module type EncryptionDataTypes = 
 sig 
  type rawDataT 
  
  type masterKeyT 
  
  type encryptedDataT 
  
  type systemRandomnessT 
  
  type systemRandomnessHintT 
 end

module EncryptionStringDataTypes = 
 struct 
  type rawDataT = char list
  
  type masterKeyT = char list
  
  type encryptedDataT = char list
  
  type systemRandomnessT = char list
  
  type systemRandomnessHintT = nat
 end

type ('systemRandomnessHintT, 'systemRandomnessT) encryptionError =
| NotEnoughRandomness of 'systemRandomnessHintT * 'systemRandomnessT

module AESGCM = 
 struct 
  (** val isValidMasterKey : EncryptionStringDataTypes.masterKeyT -> bool **)
  
  let isValidMasterKey key0 =
    beq_nat (length0 key0) (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
      O))))))))))))))))
  
  (** val randomnessHint :
      EncryptionStringDataTypes.rawDataT ->
      EncryptionStringDataTypes.systemRandomnessHintT **)
  
  let randomnessHint rawData =
    S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))
  
  (** val encrypt :
      EncryptionStringDataTypes.systemRandomnessT ->
      EncryptionStringDataTypes.masterKeyT ->
      EncryptionStringDataTypes.rawDataT ->
      (EncryptionStringDataTypes.encryptedDataT,
      (EncryptionStringDataTypes.systemRandomnessHintT,
      EncryptionStringDataTypes.systemRandomnessT) encryptionError) sum **)
  
  let encrypt randomness masterKey0 rawData =
    let iV = str_to_bitvec randomness in
    let iV_len = length iV in
    if ltb0 iV_len (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
         (S (S (S (S (S (S (S (S
         O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
    then apply (fun x -> Inr x) (NotEnoughRandomness ((S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
           randomness))
    else let iV0 =
           firstn (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S
             O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
             iV
         in
         let (c, t0) =
           encrypt1 encrypt (str_to_bitvec masterKey0) iV0
             (str_to_bitvec rawData) [] (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S
             O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         in
         apply (fun x -> Inl x) (apply bitvec_to_str (app iV0 (app t0 c)))
  
  (** val decrypt :
      EncryptionStringDataTypes.masterKeyT ->
      EncryptionStringDataTypes.encryptedDataT ->
      (EncryptionStringDataTypes.rawDataT, __) sum **)
  
  let decrypt masterKey0 encryptedData =
    let err = apply (fun x -> Inr x) __ in
    let c = str_to_bitvec encryptedData in
    if ltb0 (length c)
         (plus (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S
           O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
           O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
    then err
    else let (iV, c0) =
           splitn (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S
             O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
             c
         in
         let (t0, c1) =
           splitn (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
             (S (S (S
             O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
             c0
         in
         (match decrypt Coq__1.encrypt (str_to_bitvec masterKey0) iV c1 [] t0 with
          | Some p -> apply (fun x -> Inl x) (apply bitvec_to_str p)
          | None -> err)
  
  (** val doit :
      (EncryptionStringDataTypes.encryptedDataT,
      (EncryptionStringDataTypes.systemRandomnessHintT,
      EncryptionStringDataTypes.systemRandomnessT) encryptionError) sum ->
      EncryptionStringDataTypes.encryptedDataT **)
  
  let doit = function
  | Inl s -> s
  | Inr e -> []
  
  (** val check :
      (EncryptionStringDataTypes.rawDataT, __) sum ->
      EncryptionStringDataTypes.rawDataT option **)
  
  let check = function
  | Inl s -> Some s
  | Inr _ -> None
  
  module Coq_test1 = 
   struct 
    (** val coq_K : char list **)
    
    let coq_K =
      '2'::('k'::('l'::('l'::('a'::('j'::('s'::('f'::('3'::('j'::('r'::('l'::(';'::('k'::('a'::('j'::[])))))))))))))))
    
    (** val coq_R : char list **)
    
    let coq_R =
      '9'::('u'::('8'::('j'::('g'::('3'::('q'::('8'::('4'::('-'::('u'::('8'::[])))))))))))
    
    (** val coq_P : char list **)
    
    let coq_P =
      '8'::('a'::('I'::('O'::('w'::(';'::('f'::('j'::('8'::('d'::('f'::('u'::('['::('j'::('q'::('o'::('i'::('r'::('2'::('w'::('f'::('['::('u'::('s'::('j'::('a'::('i'::('o'::('v'::('u'::('9'::('r'::('['::('2'::('i'::('o'::('j'::('d'::('0'::('f'::('a'::('w'::('f'::('s'::('2'::('9'::('3'::('j'::('f'::('E'::[])))))))))))))))))))))))))))))))))))))))))))))))))
    
    (** val coq_C : EncryptionStringDataTypes.encryptedDataT **)
    
    let coq_C =
      apply doit (encrypt coq_R coq_K coq_P)
    
    (** val bad1 : char list **)
    
    let bad1 =
      apply list_to_str (apply tl (apply str_to_list coq_C))
    
    (** val bad2 : char list **)
    
    let bad2 =
      apply list_to_str (apply removelast (apply str_to_list coq_C))
    
    (** val replace3 : char list **)
    
    let replace3 =
      str_to_list
        ('l'::('a'::('j'::('s'::('f'::('a'::('k'::('l'::('s'::[])))))))))
    
    (** val bad3 : char list **)
    
    let bad3 =
      apply list_to_str
        (app replace3 (skipn (length replace3) (str_to_list coq_C)))
   end
  
  module Coq_test2 = 
   struct 
    (** val coq_K : char list **)
    
    let coq_K =
      '9'::('a'::('p'::('8'::('u'::('s'::('d'::('j'::('f'::('a'::('s'::('p'::('d'::('9'::('8'::('f'::[])))))))))))))))
    
    (** val coq_R : char list **)
    
    let coq_R =
      'a'::('s'::(';'::('j'::('f'::('a'::('f'::('s'::('i'::('o'::('j'::(';'::[])))))))))))
    
    (** val coq_P : char list **)
    
    let coq_P =
      []
    
    (** val coq_C : EncryptionStringDataTypes.encryptedDataT **)
    
    let coq_C =
      apply doit (encrypt coq_R coq_K coq_P)
    
    (** val bad1 : char list **)
    
    let bad1 =
      apply list_to_str (apply tl (apply str_to_list coq_C))
    
    (** val bad2 : char list **)
    
    let bad2 =
      apply list_to_str (apply removelast (apply str_to_list coq_C))
    
    (** val replace3 : char list **)
    
    let replace3 =
      str_to_list
        ('l'::('a'::('j'::('s'::('f'::('a'::('k'::('l'::('s'::[])))))))))
    
    (** val bad3 : char list **)
    
    let bad3 =
      apply list_to_str
        (app replace3 (skipn (length replace3) (str_to_list coq_C)))
   end
 end

type 'a serializable =
  'a -> char list
  (* singleton inductive, whose constructor was Build_Serializable *)

(** val to_string : 'a1 serializable -> 'a1 -> char list **)

let to_string serializable0 =
  serializable0

type 'a deserializable =
  char list -> 'a option * char list
  (* singleton inductive, whose constructor was Build_Deserializable *)

(** val from_string :
    'a1 deserializable -> char list -> 'a1 option * char list **)

let from_string deserializable0 =
  deserializable0

type 'a prefixSerializable = { serialize : 'a serializable;
                               deserialize : 'a deserializable }

(** val serialize : 'a1 prefixSerializable -> 'a1 serializable **)

let serialize x = x.serialize

(** val deserialize : 'a1 prefixSerializable -> 'a1 deserializable **)

let deserialize x = x.deserialize

module type SerializableOrderedType = 
 sig 
  type t 
  
  val compare : t -> t -> t compare
  
  val eq_dec : t -> t -> bool
  
  val coq_PrefixSerializable_ord : t prefixSerializable
 end

(** val string_of_Npositive : Big.big_int -> char list **)

let rec string_of_Npositive n =
  Big.positive_case
    (fun n' ->
    append (string_of_Npositive n') ('1'::[]))
    (fun n' ->
    append (string_of_Npositive n') ('0'::[]))
    (fun _ ->
    '1'::[])
    n

(** val string_of_N : Big.big_int -> char list **)

let string_of_N n =
  Big.n_case
    (fun _ ->
    '0'::(' '::[]))
    (fun n' ->
    append (string_of_Npositive n') (' '::[]))
    n

(** val n_of_string_helper :
    char list -> Big.big_int -> char list -> Big.big_int option * char list **)

let rec n_of_string_helper s so_far acc =
  match s with
  | [] -> (None, acc)
  | a::s' ->
    if (=) a ' '
    then ((Some so_far), s')
    else if (=) a '0'
         then n_of_string_helper s' (N.mul (Big.double Big.one) so_far)
                (append acc (a::[]))
         else if (=) a '1'
              then n_of_string_helper s'
                     (N.add Big.one (N.mul (Big.double Big.one) so_far))
                     (append acc (a::[]))
              else (None, (append acc (a::s')))

(** val n_of_string : char list -> Big.big_int option * char list **)

let n_of_string s =
  n_of_string_helper s Big.zero []

(** val serializable_N : Big.big_int serializable **)

let serializable_N =
  string_of_N

(** val deserializable_N : Big.big_int deserializable **)

let deserializable_N =
  n_of_string

(** val prod_map :
    ('a1 -> 'a2) -> ('a3 -> 'a4) -> ('a1 * 'a3) -> 'a2 * 'a4 **)

let prod_map f g0 xy =
  ((f (fst xy)), (g0 (snd xy)))

(** val serializable_nat : nat serializable **)

let serializable_nat x =
  to_string serializable_N (N.of_nat x)

(** val deserializable_nat : nat deserializable **)

let deserializable_nat x =
  prod_map (option_map N.to_nat) (fun x0 -> x0)
    (from_string deserializable_N x)

(** val string_drop : nat -> char list -> char list **)

let rec string_drop n s =
  match n with
  | O -> s
  | S n' ->
    (match s with
     | [] -> []
     | a::s' -> string_drop n' s')

(** val serializable_string : char list serializable **)

let serializable_string x =
  append (to_string serializable_nat (length0 x)) x

(** val deserializable_string : char list deserializable **)

let deserializable_string x =
  let nx = from_string deserializable_nat x in
  (match fst nx with
   | Some n ->
     if leb1 n (length0 (snd nx))
     then ((Some (substring O n (snd nx))), (string_drop n (snd nx)))
     else (None, x)
   | None -> (None, (snd nx)))

(** val prefixSerializable_string : __ -> char list prefixSerializable **)

let prefixSerializable_string _ =
  { serialize = serializable_string; deserialize = deserializable_string }

(** val serializable_unit : unit serializable **)

let serializable_unit x =
  []

(** val deserializable_unit : unit deserializable **)

let deserializable_unit s =
  ((Some ()), s)

(** val serializable_sum :
    'a1 serializable -> 'a2 serializable -> ('a1, 'a2) sum serializable **)

let serializable_sum h0 h1 = function
| Inl x' -> append ('L'::[]) (to_string h0 x')
| Inr x' -> append ('R'::[]) (to_string h1 x')

(** val deserializable_sum :
    'a1 deserializable -> 'a2 deserializable -> ('a1, 'a2) sum deserializable **)

let deserializable_sum h0 h1 = function
| [] -> (None, [])
| a::s' ->
  if (=) a 'L'
  then prod_map (option_map (fun x -> Inl x)) id (from_string h0 s')
  else if (=) a 'R'
       then prod_map (option_map (fun x -> Inr x)) id (from_string h1 s')
       else (None, (a::s'))

(** val serializable_option : 'a1 serializable -> 'a1 option serializable **)

let serializable_option h0 x =
  to_string (serializable_sum h0 serializable_unit)
    (match x with
     | Some x' -> Inl x'
     | None -> Inr ())

(** val deserializable_option :
    'a1 deserializable -> 'a1 option deserializable **)

let deserializable_option h0 x =
  let fs = from_string (deserializable_sum h0 deserializable_unit) x in
  ((match fst fs with
    | Some y ->
      (match y with
       | Inl s -> Some (Some s)
       | Inr y1 -> Some None)
    | None -> None), (snd fs))

(** val serializable_prod :
    'a1 serializable -> 'a2 serializable -> ('a1 * 'a2) serializable **)

let serializable_prod h0 h1 x =
  append (to_string h0 (fst x)) (to_string h1 (snd x))

(** val deserializable_prod :
    'a1 deserializable -> 'a2 deserializable -> ('a1 * 'a2) deserializable **)

let deserializable_prod h0 h1 x =
  let fs = from_string h0 x in
  let fs' = from_string h1 (snd fs) in
  (match fst fs with
   | Some a ->
     (match fst fs' with
      | Some b -> ((Some (a, b)), (snd fs'))
      | None -> (None, x))
   | None -> (None, x))

(** val list_to_string_helper : 'a1 serializable -> 'a1 list -> char list **)

let rec list_to_string_helper h0 = function
| [] -> []
| x :: xs -> append (to_string h0 x) (list_to_string_helper h0 xs)

(** val list_to_string : 'a1 serializable -> 'a1 list -> char list **)

let list_to_string h0 ls =
  append (to_string serializable_nat (length ls))
    (list_to_string_helper h0 ls)

(** val list_from_string_helper :
    'a1 deserializable -> nat -> char list -> 'a1 list option * char list **)

let rec list_from_string_helper h0 n s =
  match n with
  | O -> ((Some []), s)
  | S n' ->
    let fs = from_string h0 s in
    let fs' = list_from_string_helper h0 n' (snd fs) in
    (match fst fs with
     | Some x ->
       (match fst fs' with
        | Some xs -> ((Some (x :: xs)), (snd fs'))
        | None -> (None, s))
     | None -> (None, s))

(** val list_from_string :
    'a1 deserializable -> char list -> 'a1 list option * char list **)

let list_from_string h0 s =
  let fs = from_string deserializable_nat s in
  (match fst fs with
   | Some n -> list_from_string_helper h0 n (snd fs)
   | None -> (None, s))

(** val serializable_list : 'a1 serializable -> 'a1 list serializable **)

let serializable_list h0 x =
  list_to_string h0 x

(** val deserializable_list :
    'a1 deserializable -> 'a1 list deserializable **)

let deserializable_list h0 x =
  list_from_string h0 x

module MakeSerializableMergableMap = 
 functor (E:SerializableOrderedType) ->
 functor (M:sig 
  type key = E.t
  
  type 'x t 
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val find : key -> 'a1 t -> 'a1 option
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end) ->
 struct 
  type key = M.key
  
  type 'elt t = (nat * 'elt option) M.t
  
  (** val empty : (nat * 'a1 option) M.t **)
  
  let empty =
    M.empty
  
  (** val is_empty : 'a1 t -> bool **)
  
  let is_empty m =
    M.fold (fun k v b ->
      (&&) b
        (match snd v with
         | Some y -> false
         | None -> true)) m true
  
  (** val add : key -> 'a1 -> 'a1 t -> 'a1 t **)
  
  let add k v m =
    M.add k
      ((match M.find k m with
        | Some p -> let (gen, v0) = p in S gen
        | None -> O), (Some v)) m
  
  (** val find : key -> 'a1 t -> 'a1 option **)
  
  let find k m =
    match M.find k m with
    | Some p -> let (n, o) = p in o
    | None -> None
  
  (** val remove : key -> 'a1 t -> 'a1 t **)
  
  let remove k m =
    match M.find k m with
    | Some p -> let (gen, v0) = p in M.add k ((S gen), None) m
    | None -> m
  
  (** val mem : key -> 'a1 t -> bool **)
  
  let mem k m =
    match M.find k m with
    | Some p ->
      let (n, o) = p in
      (match o with
       | Some e -> true
       | None -> false)
    | None -> false
  
  (** val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t **)
  
  let map f m =
    M.map (fun v -> ((fst v), (option_map f (snd v)))) m
  
  (** val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t **)
  
  let mapi f m =
    M.mapi (fun k v -> ((fst v), (option_map (f k) (snd v)))) m
  
  (** val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t **)
  
  let map2 f m m' =
    M.map2 (fun v1 v2 ->
      match v1 with
      | Some y ->
        let (gen1, v1') = y in
        (match v1' with
         | Some y1 ->
           (match v2 with
            | Some y2 ->
              let (gen2, v2') = y2 in Some ((max gen1 gen2), (f v1' v2'))
            | None -> Some (gen1, (f v1' None)))
         | None ->
           (match v2 with
            | Some y1 ->
              let (gen2, v2') = y1 in
              (match v2' with
               | Some e -> Some ((max gen1 gen2), (f v1' v2'))
               | None -> Some ((max gen1 gen2), None))
            | None -> Some (gen1, None)))
      | None ->
        (match v2 with
         | Some y ->
           let (gen2, v2') = y in
           (match v2' with
            | Some e -> Some (gen2, (f None v2'))
            | None -> Some (gen2, None))
         | None -> None)) m m'
  
  (** val garbage_collect : 'a1 t -> 'a1 t **)
  
  let garbage_collect m =
    M.map2 (fun v1 x ->
      match v1 with
      | Some y ->
        let (y1, y2) = y in
        (match y2 with
         | Some v -> Some (O, (Some v))
         | None -> None)
      | None -> None) m m
  
  (** val filter_some :
      ('a1 * 'a2
      option)
      list
      ->
      ('a1 * 'a2)
      list **)
  
  let rec filter_some = function
  | [] ->
    []
  | p :: ls' ->
    let (a,
         o) =
      p
    in
    (match o with
     | Some b ->
       (a,
         b) :: (filter_some
                 ls')
     | None ->
       filter_some
         ls')
  
  (** val elements :
      'a1
      t
      ->
      (key * 'a1)
      list **)
  
  let elements m =
    filter_some
      (Coq__2.map
        (fun kv ->
        ((fst
           kv),
        (snd
          (snd
            kv))))
        (M.elements
          m))
  
  (** val cardinal :
      'a1
      t
      ->
      nat **)
  
  let cardinal m =
    length
      (elements
        m)
  
  (** val fold :
      (key
      ->
      'a1
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      t
      ->
      'a2
      ->
      'a2 **)
  
  let fold f m init =
    fold_left
      (fun acc kv ->
      f
        (fst
          kv)
        (snd
          kv)
        acc)
      (elements
        m)
      init
  
  (** val equal :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      'a1
      t
      ->
      'a1
      t
      ->
      bool **)
  
  let equal eq m1 m2 =
    M.equal
      (fun v1 v2 ->
      match snd
              v1 with
      | Some v1' ->
        (match snd
                 v2 with
         | Some v2' ->
           eq
             v1'
             v2'
         | None ->
           false)
      | None ->
        (match snd
                 v2 with
         | Some y ->
           false
         | None ->
           true))
      (garbage_collect
        m1)
      (garbage_collect
        m2)
  
  (** val merge :
      'a1
      t
      ->
      'a1
      t
      ->
      'a1
      t **)
  
  let merge m1 m2 =
    M.map2
      (fun a b ->
      match a with
      | Some gv ->
        let (gen0,
             v0) =
          gv
        in
        (match b with
         | Some y ->
           let (gen1,
                v1) =
             y
           in
           Some
           (if leb0
                 gen0
                 gen1
            then (gen1,
                   v1)
            else (gen0,
                   v0))
         | None ->
           Some
             gv)
      | None ->
        b)
      m1
      m2
  
  (** val from_internal_elements :
      (M.key * (nat * 'a1
      option))
      list
      ->
      'a1
      t **)
  
  let from_internal_elements elements0 =
    fold_right
      (fun kv acc ->
      M.add
        (fst
          kv)
        (snd
          kv)
        acc)
      M.empty
      elements0
  
  (** val is_sorted :
      (M.key * (nat * 'a1
      option))
      list
      ->
      bool **)
  
  let rec is_sorted = function
  | [] ->
    true
  | x :: xs ->
    (match xs with
     | [] ->
       true
     | y :: ys ->
       (match E.compare
                (fst
                  x)
                (fst
                  y) with
        | LT ->
          is_sorted
            xs
        | _ ->
          false))
  
  (** val sorted_from_internal_elements :
      (M.key * (nat * 'a1
      option))
      list
      option
      ->
      'a1
      t
      option **)
  
  let sorted_from_internal_elements = function
  | Some ls' ->
    if is_sorted
         ls'
    then Some
           (from_internal_elements
             ls')
    else None
  | None ->
    None
  
  (** val coq_Serializable_map :
      'a1
      serializable
      ->
      'a1
      t
      serializable **)
  
  let coq_Serializable_map h0 x =
    to_string
      (serializable_list
        (serializable_prod
          E.coq_PrefixSerializable_ord.serialize
          (serializable_prod
            serializable_nat
            (serializable_option
              h0))))
      (M.elements
        x)
  
  (** val coq_Deserializable_map :
      'a1
      deserializable
      ->
      'a1
      t
      deserializable **)
  
  let coq_Deserializable_map h0 s =
    prod_map
      sorted_from_internal_elements
      id
      (from_string
        (deserializable_list
          (deserializable_prod
            E.coq_PrefixSerializable_ord.deserialize
            (deserializable_prod
              deserializable_nat
              (deserializable_option
                h0))))
        s)
  
  (** val coq_PrefixSerializable_map :
      'a1
      prefixSerializable
      ->
      'a1
      t
      prefixSerializable **)
  
  let coq_PrefixSerializable_map h0 =
    { serialize =
      (coq_Serializable_map
        h0.serialize);
      deserialize =
      (coq_Deserializable_map
        h0.deserialize) }
 end

(** val string_lt :
    char list
    ->
    char list
    ->
    bool **)

let rec string_lt s1 s2 =
  match s1 with
  | [] ->
    (match s2 with
     | [] ->
       false
     | a::s ->
       true)
  | a1::s1' ->
    (match s2 with
     | [] ->
       false
     | a2::s2' ->
       (match N.compare
                (n_of_ascii
                  a1)
                (n_of_ascii
                  a2) with
        | Eq ->
          string_lt
            s1'
            s2'
        | Lt ->
          true
        | Gt ->
          false))

module String_as_SOT = 
 struct 
  type t
    =
    char list
  
  (** val compare' :
      t
      ->
      t
      ->
      comparison **)
  
  let compare' x y =
    if string_lt
         x
         y
    then Lt
    else if string_dec
              x
              y
         then Eq
         else Gt
  
  (** val compare :
      t
      ->
      t
      ->
      t
      compare **)
  
  let compare x y =
    match compare'
            x
            y with
    | Eq ->
      EQ
    | Lt ->
      LT
    | Gt ->
      GT
  
  (** val eq_dec :
      t
      ->
      t
      ->
      bool **)
  
  let eq_dec x y =
    string_dec
      x
      y
  
  (** val coq_PrefixSerializable_ord :
      t
      prefixSerializable **)
  
  let coq_PrefixSerializable_ord =
    prefixSerializable_string
      __
 end

module PwMgrUI = 
 functor (KVStore:sig 
  type key
    =
    char list
  
  type 'x t 
  
  val empty :
    'a1
    t
  
  val is_empty :
    'a1
    t
    ->
    bool
  
  val add :
    key
    ->
    'a1
    ->
    'a1
    t
    ->
    'a1
    t
  
  val find :
    key
    ->
    'a1
    t
    ->
    'a1
    option
  
  val remove :
    key
    ->
    'a1
    t
    ->
    'a1
    t
  
  val mem :
    key
    ->
    'a1
    t
    ->
    bool
  
  val map :
    ('a1
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    t
  
  val mapi :
    (key
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    t
  
  val map2 :
    ('a1
    option
    ->
    'a2
    option
    ->
    'a3
    option)
    ->
    'a1
    t
    ->
    'a2
    t
    ->
    'a3
    t
  
  val elements :
    'a1
    t
    ->
    (key * 'a1)
    list
  
  val cardinal :
    'a1
    t
    ->
    nat
  
  val fold :
    (key
    ->
    'a1
    ->
    'a2
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    ->
    'a2
  
  val equal :
    ('a1
    ->
    'a1
    ->
    bool)
    ->
    'a1
    t
    ->
    'a1
    t
    ->
    bool
  
  val coq_Serializable_map :
    'a1
    serializable
    ->
    'a1
    t
    serializable
  
  val coq_Deserializable_map :
    'a1
    deserializable
    ->
    'a1
    t
    deserializable
  
  val coq_PrefixSerializable_map :
    'a1
    prefixSerializable
    ->
    'a1
    t
    prefixSerializable
  
  val merge :
    'a1
    t
    ->
    'a1
    t
    ->
    'a1
    t
 end) ->
 struct 
  type uiInput =
  | Coq_uiConsoleIn of char list
  | Coq_uiGotUpdate of char list
  
  (** val uiInput_rect :
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiInput
      ->
      'a1 **)
  
  let uiInput_rect f f0 = function
  | Coq_uiConsoleIn x ->
    f
      x
  | Coq_uiGotUpdate x ->
    f0
      x
  
  (** val uiInput_rec :
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiInput
      ->
      'a1 **)
  
  let uiInput_rec f f0 = function
  | Coq_uiConsoleIn x ->
    f
      x
  | Coq_uiGotUpdate x ->
    f0
      x
  
  type uiOutput =
  | Coq_uiGetUpdate
  | Coq_uiSetData of char list
  | Coq_uiConsoleOut of char list
  
  (** val uiOutput_rect :
      'a1
      ->
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiOutput
      ->
      'a1 **)
  
  let uiOutput_rect f f0 f1 = function
  | Coq_uiGetUpdate ->
    f
  | Coq_uiSetData x ->
    f0
      x
  | Coq_uiConsoleOut x ->
    f1
      x
  
  (** val uiOutput_rec :
      'a1
      ->
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiOutput
      ->
      'a1 **)
  
  let uiOutput_rec f f0 f1 = function
  | Coq_uiGetUpdate ->
    f
  | Coq_uiSetData x ->
    f0
      x
  | Coq_uiConsoleOut x ->
    f1
      x
  
  (** val split :
      char
      ->
      char list
      ->
      char list
      list **)
  
  let rec split sep = function
  | [] ->
    []
  | c::s' ->
    if (=)
         c
         sep
    then [] :: (split
                 sep
                 s')
    else (match split
                  sep
                  s' with
          | [] ->
            (c::[]) :: []
          | w :: ws ->
            (c::w) :: ws)
  
  (** val newline :
      char **)
  
  let newline =
    '\n'
  
  (** val dump :
      (char list * char list)
      list
      ->
      char list **)
  
  let dump pws =
    fold_right
      append
      []
      (map
        (fun p ->
        append
          (fst
            p)
          (append
            (' '::[])
            (append
              (snd
                p)
              (newline::[]))))
        pws)
  
  (** val load :
      char list
      ->
      (char list * char list)
      list **)
  
  let rec load s =
    flat_map
      (fun l ->
      match split
              ' '
              l with
      | [] ->
        []
      | account :: l0 ->
        (match l0 with
         | [] ->
           []
         | password :: l1 ->
           (match l1 with
            | [] ->
              (account,
                password) :: []
            | s0 :: l2 ->
              [])))
      (split
        newline
        s)
  
  (** val list_dec :
      'a1
      list
      ->
      ('a1 * 'a1
      list)
      option **)
  
  let list_dec = function
  | [] ->
    None
  | a :: ls0 ->
    Some
      (a,
      ls0)
  
  (** val uiLoopBody :
      (uiOutput
      ->
      'a1
      action)
      ->
      (char list
      KVStore.t
      ->
      (uiInput,
      'a1)
      process)
      ->
      char list
      KVStore.t
      ->
      uiInput
      ->
      'a1
      action * (uiInput,
      'a1)
      process **)
  
  let uiLoopBody handle uiLoop0 pws = function
  | Coq_uiConsoleIn s ->
    (match split
             ' '
             s with
     | [] ->
       ((handle
          (Coq_uiConsoleOut
          ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
         (uiLoop0
           pws))
     | comm :: ls ->
       if string_dec
            comm
            ('g'::('e'::('t'::[])))
       then (match ls with
             | [] ->
               if string_dec
                    comm
                    ('s'::('e'::('t'::[])))
               then (match ls with
                     | [] ->
                       ((handle
                          (Coq_uiConsoleOut
                          ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                         (uiLoop0
                           pws))
                     | account :: l ->
                       (match l with
                        | [] ->
                          ((handle
                             (Coq_uiConsoleOut
                             ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                            (uiLoop0
                              pws))
                        | password :: l0 ->
                          (match l0 with
                           | [] ->
                             let pws' =
                               KVStore.add
                                 account
                                 password
                                 pws
                             in
                             ((handle
                                (Coq_uiSetData
                                (to_string
                                  (KVStore.coq_Serializable_map
                                    serializable_string)
                                  pws'))),
                             (uiLoop0
                               pws'))
                           | s0 :: l1 ->
                             ((handle
                                (Coq_uiConsoleOut
                                ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                               (uiLoop0
                                 pws)))))
               else ((handle
                       (Coq_uiConsoleOut
                       ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                      (uiLoop0
                        pws))
             | account :: l ->
               (match l with
                | [] ->
                  (match KVStore.find
                           account
                           pws with
                   | Some password ->
                     ((handle
                        (Coq_uiConsoleOut
                        password)),
                       (uiLoop0
                         pws))
                   | None ->
                     ((handle
                        (Coq_uiConsoleOut
                        ('a'::('c'::('c'::('o'::('u'::('n'::('t'::(' '::('n'::('o'::('t'::(' '::('f'::('o'::('u'::('n'::('d'::[]))))))))))))))))))),
                       (uiLoop0
                         pws)))
                | s0 :: l0 ->
                  if string_dec
                       comm
                       ('s'::('e'::('t'::[])))
                  then (match ls with
                        | [] ->
                          ((handle
                             (Coq_uiConsoleOut
                             ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                            (uiLoop0
                              pws))
                        | account0 :: l1 ->
                          (match l1 with
                           | [] ->
                             ((handle
                                (Coq_uiConsoleOut
                                ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                               (uiLoop0
                                 pws))
                           | password :: l2 ->
                             (match l2 with
                              | [] ->
                                let pws' =
                                  KVStore.add
                                    account0
                                    password
                                    pws
                                in
                                ((handle
                                   (Coq_uiSetData
                                   (to_string
                                     (KVStore.coq_Serializable_map
                                       serializable_string)
                                     pws'))),
                                (uiLoop0
                                  pws'))
                              | s1 :: l3 ->
                                ((handle
                                   (Coq_uiConsoleOut
                                   ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                                  (uiLoop0
                                    pws)))))
                  else ((handle
                          (Coq_uiConsoleOut
                          ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                         (uiLoop0
                           pws))))
       else if string_dec
                 comm
                 ('s'::('e'::('t'::[])))
            then (match ls with
                  | [] ->
                    ((handle
                       (Coq_uiConsoleOut
                       ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                      (uiLoop0
                        pws))
                  | account :: l ->
                    (match l with
                     | [] ->
                       ((handle
                          (Coq_uiConsoleOut
                          ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                         (uiLoop0
                           pws))
                     | password :: l0 ->
                       (match l0 with
                        | [] ->
                          let pws' =
                            KVStore.add
                              account
                              password
                              pws
                          in
                          ((handle
                             (Coq_uiSetData
                             (to_string
                               (KVStore.coq_Serializable_map
                                 serializable_string)
                               pws'))),
                          (uiLoop0
                            pws'))
                        | s0 :: l1 ->
                          ((handle
                             (Coq_uiConsoleOut
                             ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                            (uiLoop0
                              pws)))))
            else ((handle
                    (Coq_uiConsoleOut
                    ('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::[])))))))))))))))))))))),
                   (uiLoop0
                     pws)))
  | Coq_uiGotUpdate s ->
    let left_over =
      snd
        (from_string
          (KVStore.coq_Deserializable_map
            deserializable_string)
          s)
    in
    let action0 =
      if string_dec
           left_over
           []
      then id
      else handle
             (Coq_uiConsoleOut
             (append
               ('e'::('x'::('t'::('r'::('a'::(' '::('d'::('e'::('s'::('e'::('r'::('i'::('a'::('l'::('i'::('z'::('a'::('t'::('i'::('o'::('n'::(' '::('g'::('a'::('r'::('b'::('a'::('g'::('e'::(':'::(' '::('\''::[]))))))))))))))))))))))))))))))))
               (append
                 left_over
                 ('\''::[]))))
    in
    (match fst
             (from_string
               (KVStore.coq_Deserializable_map
                 deserializable_string)
               s) with
     | Some new_pws ->
       let pws' =
         KVStore.merge
           pws
           new_pws
       in
       ((if KVStore.equal
              (fun s1 s2 ->
              if string_dec
                   s1
                   s2
              then true
              else false)
              new_pws
              pws'
         then action0
         else compose
                action0
                (handle
                  (Coq_uiSetData
                  (to_string
                    (KVStore.coq_Serializable_map
                      serializable_string)
                    pws')))),
       (uiLoop0
         pws'))
     | None ->
       ((compose
          (handle
            (Coq_uiConsoleOut
            (append
              ('n'::('o'::('n'::('-'::('d'::('e'::('s'::('e'::('r'::('i'::('a'::('l'::('i'::('z'::('a'::('b'::('l'::('e'::(' '::('n'::('e'::('t'::('w'::('o'::('r'::('k'::(' '::('r'::('e'::('s'::('p'::('o'::('n'::('s'::('e'::(':'::(' '::('\''::[]))))))))))))))))))))))))))))))))))))))
              (append
                s
                ('\''::[])))))
          (handle
            (Coq_uiSetData
            (to_string
              (KVStore.coq_Serializable_map
                serializable_string)
              pws)))),
         (uiLoop0
           pws)))
  
  (** val uiLoop :
      (uiOutput
      ->
      'a1
      action)
      ->
      char list
      KVStore.t
      ->
      (uiInput,
      'a1)
      process **)
  
  let rec uiLoop handle pws =
    lazy (Step (uiLoopBody
                 handle
                 (uiLoop
                   handle)
                 pws))
  
  (** val ui :
      (uiOutput
      ->
      'a1
      action)
      ->
      (uiInput,
      'a1)
      process **)
  
  let ui handle =
    uiLoop
      handle
      KVStore.empty
 end

type publishDurationT =
| DurationOf of Big.big_int
| Inf

(** val duration_leb :
    Big.big_int
    ->
    publishDurationT
    ->
    bool **)

let duration_leb x = function
| DurationOf y' ->
  N.leb
    x
    y'
| Inf ->
  true

type 'dataT tickBoxPreState =
| NoData of Big.big_int
| InitiallyWaitingOnData of Big.big_int
| HaveData of Big.big_int
   * 'dataT
   * Big.big_int
     option
| WaitingOnData of Big.big_int
   * Big.big_int
     option
| WaitingOnTicks of Big.big_int
   * Big.big_int
     option

type 'dataT tickBoxState = { curData : 'dataT
                                       tickBoxPreState;
                             publishInterval : Big.big_int;
                             publishDuration : publishDurationT;
                             waitBeforeUpdateInterval : Big.big_int;
                             publishPrecision : Big.big_int }

(** val curData :
    'a1
    tickBoxState
    ->
    'a1
    tickBoxPreState **)

let curData x = x.curData

(** val publishInterval :
    'a1
    tickBoxState
    ->
    Big.big_int **)

let publishInterval x = x.publishInterval

(** val publishDuration :
    'a1
    tickBoxState
    ->
    publishDurationT **)

let publishDuration x = x.publishDuration

(** val waitBeforeUpdateInterval :
    'a1
    tickBoxState
    ->
    Big.big_int **)

let waitBeforeUpdateInterval x = x.waitBeforeUpdateInterval

(** val publishPrecision :
    'a1
    tickBoxState
    ->
    Big.big_int **)

let publishPrecision x = x.publishPrecision

(** val set_curData :
    'a1
    tickBoxState
    ->
    'a1
    tickBoxPreState
    ->
    'a1
    tickBoxState **)

let set_curData st v =
  { curData =
    v;
    publishInterval =
    st.publishInterval;
    publishDuration =
    st.publishDuration;
    waitBeforeUpdateInterval =
    st.waitBeforeUpdateInterval;
    publishPrecision =
    st.publishPrecision }

(** val set_publishInterval :
    'a1
    tickBoxState
    ->
    Big.big_int
    ->
    'a1
    tickBoxState **)

let set_publishInterval st v =
  { curData =
    st.curData;
    publishInterval =
    v;
    publishDuration =
    st.publishDuration;
    waitBeforeUpdateInterval =
    st.waitBeforeUpdateInterval;
    publishPrecision =
    st.publishPrecision }

(** val set_publishDuration :
    'a1
    tickBoxState
    ->
    publishDurationT
    ->
    'a1
    tickBoxState **)

let set_publishDuration st v =
  { curData =
    st.curData;
    publishInterval =
    st.publishInterval;
    publishDuration =
    v;
    waitBeforeUpdateInterval =
    st.waitBeforeUpdateInterval;
    publishPrecision =
    st.publishPrecision }

(** val set_waitBeforeUpdateInterval :
    'a1
    tickBoxState
    ->
    Big.big_int
    ->
    'a1
    tickBoxState **)

let set_waitBeforeUpdateInterval st v =
  { curData =
    st.curData;
    publishInterval =
    st.publishInterval;
    publishDuration =
    st.publishDuration;
    waitBeforeUpdateInterval =
    v;
    publishPrecision =
    st.publishPrecision }

(** val set_publishPrecision :
    'a1
    tickBoxState
    ->
    Big.big_int
    ->
    'a1
    tickBoxState **)

let set_publishPrecision st v =
  { curData =
    st.curData;
    publishInterval =
    st.publishInterval;
    publishDuration =
    st.publishDuration;
    waitBeforeUpdateInterval =
    st.waitBeforeUpdateInterval;
    publishPrecision =
    v }

type tbConfigInput =
| TbSetPublishInterval of Big.big_int
| TbSetPublishDuration of publishDurationT
| TbSetWaitBeforeUpdateInterval of Big.big_int
| TbSetPublishPrecision of Big.big_int

type 'dataT tbEventInput =
| TbNotifyChange
| TbTick of Big.big_int
| TbValueReady of 'dataT

type 'dataT tbInput
  =
  (tbConfigInput,
  'dataT
  tbEventInput)
  sum

type 'dataT tbWarningOutput =
| TbWarnNoDataReady
| TbWarnTicksTooInfrequent of Big.big_int
| TbWarnInvalidWaitBeforeUpdateInterval of Big.big_int
| TbWarnInvalidEvent of 'dataT
                        tickBoxPreState
   * 'dataT
     tbEventInput
| TbDebugStateTransition of 'dataT
                            tickBoxPreState
   * 'dataT
     tickBoxPreState
   * 'dataT
     tbInput

type 'dataT tbEventOutput =
| TbRequestDataUpdate
| TbPublishUpdate of 'dataT
| TbSleepFor of Big.big_int

type 'dataT tbOutput
  =
  ('dataT
  tbWarningOutput,
  'dataT
  tbEventOutput)
  sum

(** val initState :
    'a1
    tickBoxState **)

let initState =
  { curData =
    (NoData
    Big.zero);
    publishInterval =
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.double
    Big.one))))))))))))))))))))))))))))))));
    publishDuration =
    Inf;
    waitBeforeUpdateInterval =
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    Big.one)))))))))))))))))))))))))))))));
    publishPrecision =
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.double
    Big.one))))))))))))))))))))) }

(** val ticksToTransmit :
    Big.big_int
    ->
    'a1
    tickBoxState
    ->
    Big.big_int **)

let ticksToTransmit ticks st =
  N.sub
    st.publishInterval
    ticks

(** val ticksToGetUpdate :
    Big.big_int
    ->
    'a1
    tickBoxState
    ->
    Big.big_int **)

let ticksToGetUpdate ticks st =
  N.sub
    st.waitBeforeUpdateInterval
    ticks

(** val invalidWaitBeforeUpdateInterval :
    Big.big_int
    ->
    'a1
    tickBoxState
    ->
    bool **)

let invalidWaitBeforeUpdateInterval val0 st =
  duration_leb
    st.publishInterval
    (DurationOf
    val0)

(** val ticksTooCoarse :
    Big.big_int
    ->
    'a1
    tickBoxState
    ->
    bool **)

let ticksTooCoarse ticks st =
  N.ltb
    (N.add
      st.publishPrecision
      Big.one)
    (N.sub
      ticks
      st.publishInterval)

(** val ticksTooCoarseWaitingOnTicks :
    Big.big_int
    ->
    'a1
    tickBoxState
    ->
    bool **)

let ticksTooCoarseWaitingOnTicks ticks st =
  N.ltb
    (N.add
      st.publishPrecision
      Big.one)
    (N.sub
      ticks
      st.waitBeforeUpdateInterval)

(** val enoughTransmissions :
    Big.big_int
    ->
    'a1
    tickBoxState
    ->
    bool **)

let enoughTransmissions publishesSinceLastChange st =
  negb
    (duration_leb
      publishesSinceLastChange
      st.publishDuration)

(** val ticksMod :
    Big.big_int
    ->
    'a1
    tickBoxState
    ->
    Big.big_int **)

let ticksMod ticks st =
  N.modulo
    ticks
    st.publishInterval

(** val tickBoxLoopPreBody' :
    'a1
    tickBoxState
    ->
    'a1
    tbInput
    ->
    'a1
    tbOutput
    list * 'a1
    tickBoxState **)

let tickBoxLoopPreBody' st = function
| Inl t0 ->
  (match t0 with
   | TbSetPublishInterval val0 ->
     ([],
       (set_publishInterval
         st
         val0))
   | TbSetPublishDuration val0 ->
     ([],
       (set_publishDuration
         st
         val0))
   | TbSetWaitBeforeUpdateInterval val0 ->
     if invalidWaitBeforeUpdateInterval
          val0
          st
     then (((Inl
            (TbWarnInvalidWaitBeforeUpdateInterval
            val0)) :: []),
            st)
     else ([],
            (set_waitBeforeUpdateInterval
              st
              val0))
   | TbSetPublishPrecision val0 ->
     ([],
       (set_publishPrecision
         st
         val0)))
| Inr t0 ->
  (match t0 with
   | TbNotifyChange ->
     (match st.curData with
      | NoData ticks ->
        (((Inr
          TbRequestDataUpdate) :: []),
          (set_curData
            st
            (InitiallyWaitingOnData
            ticks)))
      | InitiallyWaitingOnData ticks ->
        ([],
          st)
      | HaveData (ticks,
                  data,
                  publishesSinceLastChange) ->
        ([],
          (set_curData
            st
            (HaveData
            (ticks,
            data,
            None))))
      | WaitingOnData (ticks,
                       publishesSinceLastChange) ->
        ([],
          (set_curData
            st
            (WaitingOnData
            (ticks,
            None))))
      | WaitingOnTicks (ticks,
                        publishesSinceLastChange) ->
        ([],
          (set_curData
            st
            (WaitingOnTicks
            (ticks,
            None)))))
   | TbTick ticksSinceLastTick ->
     (match st.curData with
      | NoData ticks ->
        ([],
          (set_curData
            st
            (NoData
            (ticksMod
              (N.add
                ticks
                ticksSinceLastTick)
              st))))
      | InitiallyWaitingOnData ticks ->
        ([],
          (set_curData
            st
            (InitiallyWaitingOnData
            (ticksMod
              (N.add
                ticks
                ticksSinceLastTick)
              st))))
      | HaveData (ticks,
                  data,
                  publishesSinceLastChange) ->
        let ticks' =
          N.add
            ticksSinceLastTick
            ticks
        in
        let st' =
          set_curData
            st
            (HaveData
            (ticks',
            data,
            publishesSinceLastChange))
        in
        let cur_ticksToTransmit =
          ticksToTransmit
            ticks'
            st'
        in
        if N.ltb
             Big.zero
             cur_ticksToTransmit
        then (((Inr
               (TbSleepFor
               cur_ticksToTransmit)) :: []),
               st')
        else let publishesSinceLastChange' =
               match publishesSinceLastChange with
               | Some n ->
                 N.add
                   n
                   Big.one
               | None ->
                 Big.zero
             in
             let actions =
               (Inr
               (TbPublishUpdate
               data)) :: []
             in
             let actions0 =
               if ticksTooCoarse
                    ticks'
                    st'
               then (Inl
                      (TbWarnTicksTooInfrequent
                      (N.sub
                        ticks'
                        st'.publishInterval))) :: actions
               else actions
             in
             let ticks'' =
               ticksMod
                 ticks'
                 st'
             in
             if enoughTransmissions
                  publishesSinceLastChange'
                  st'
             then (actions0,
                    (set_curData
                      st'
                      (NoData
                      ticks'')))
             else (((Inr
                    (TbSleepFor
                    (ticksToGetUpdate
                      ticks''
                      st'))) :: actions0),
                    (set_curData
                      st'
                      (WaitingOnTicks
                      (ticks'',
                      (Some
                      publishesSinceLastChange')))))
      | WaitingOnData (ticks,
                       publishesSinceLastChange) ->
        let ticks' =
          N.add
            ticks
            ticksSinceLastTick
        in
        ((if N.eqb
               (ticksToTransmit
                 ticks'
                 st)
               Big.zero
          then (Inl
                 TbWarnNoDataReady) :: []
          else []),
        (set_curData
          st
          (WaitingOnData
          (ticks',
          publishesSinceLastChange))))
      | WaitingOnTicks (ticks,
                        publishesSinceLastChange) ->
        let ticks' =
          N.add
            ticksSinceLastTick
            ticks
        in
        let st_request =
          set_curData
            st
            (WaitingOnData
            (ticks',
            publishesSinceLastChange))
        in
        let st_waiting =
          set_curData
            st
            (WaitingOnTicks
            (ticks',
            publishesSinceLastChange))
        in
        let actions =
          if ticksTooCoarseWaitingOnTicks
               ticks'
               st
          then (Inl
                 (TbWarnTicksTooInfrequent
                 (N.sub
                   ticks'
                   st.waitBeforeUpdateInterval))) :: []
          else []
        in
        let cur_ticksToGetUpdate =
          ticksToGetUpdate
            ticks'
            st
        in
        if N.ltb
             Big.zero
             cur_ticksToGetUpdate
        then (((Inr
               (TbSleepFor
               cur_ticksToGetUpdate)) :: actions),
               st_waiting)
        else (((Inr
               TbRequestDataUpdate) :: actions),
               st_request))
   | TbValueReady data ->
     (match st.curData with
      | InitiallyWaitingOnData ticks ->
        (((Inr
          (TbSleepFor
          (ticksToTransmit
            ticks
            st))) :: []),
          (set_curData
            st
            (HaveData
            (ticks,
            data,
            (Some
            Big.zero)))))
      | WaitingOnData (ticks,
                       publishesSinceLastChange) ->
        (((Inr
          (TbSleepFor
          (ticksToTransmit
            ticks
            st))) :: []),
          (set_curData
            st
            (HaveData
            (ticks,
            data,
            publishesSinceLastChange))))
      | _ ->
        (((Inl
          (TbWarnInvalidEvent
          (st.curData,
          (TbValueReady
          data)))) :: []),
          st)))

(** val tickBoxLoopPreBody :
    'a1
    tickBoxState
    ->
    'a1
    tbInput
    ->
    'a1
    tbOutput
    list * 'a1
    tickBoxState **)

let tickBoxLoopPreBody st i =
  let (a,
       st') =
    tickBoxLoopPreBody'
      st
      i
  in
  (((Inl
  (TbDebugStateTransition
  (st.curData,
  st'.curData,
  i))) :: a),
  st')

module TrustedEncryptBox = 
 functor (DataTypes:EncryptionDataTypes) ->
 functor (Algorithm:sig 
  val isValidMasterKey :
    DataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    DataTypes.rawDataT
    ->
    DataTypes.systemRandomnessHintT
  
  val encrypt :
    DataTypes.systemRandomnessT
    ->
    DataTypes.masterKeyT
    ->
    DataTypes.rawDataT
    ->
    (DataTypes.encryptedDataT,
    (DataTypes.systemRandomnessHintT,
    DataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    DataTypes.masterKeyT
    ->
    DataTypes.encryptedDataT
    ->
    (DataTypes.rawDataT,
    __)
    sum
 end) ->
 struct 
  type coq_EncryptBoxState =
    DataTypes.masterKeyT
    option
    (* singleton inductive, whose constructor was Build_EncryptBoxState *)
  
  (** val coq_EncryptBoxState_rect :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_EncryptBoxState
      ->
      'a1 **)
  
  let coq_EncryptBoxState_rect f e =
    f
      e
  
  (** val coq_EncryptBoxState_rec :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_EncryptBoxState
      ->
      'a1 **)
  
  let coq_EncryptBoxState_rec f e =
    f
      e
  
  (** val masterKey :
      coq_EncryptBoxState
      ->
      DataTypes.masterKeyT
      option **)
  
  let masterKey e =
    e
  
  type 'dataTagT ebInput =
  | Coq_ebSetMasterKey of DataTypes.masterKeyT
  | Coq_ebSystemRandomness of DataTypes.systemRandomnessT
     * (DataTypes.rawDataT * 'dataTagT)
  | Coq_ebEncrypt of DataTypes.rawDataT
     * 'dataTagT
  
  (** val ebInput_rect :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.systemRandomnessT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebInput
      ->
      'a2 **)
  
  let ebInput_rect f f0 f1 = function
  | Coq_ebSetMasterKey x ->
    f
      x
  | Coq_ebSystemRandomness (x,
                            x0) ->
    f0
      x
      x0
  | Coq_ebEncrypt (x,
                   x0) ->
    f1
      x
      x0
  
  (** val ebInput_rec :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.systemRandomnessT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebInput
      ->
      'a2 **)
  
  let ebInput_rec f f0 f1 = function
  | Coq_ebSetMasterKey x ->
    f
      x
  | Coq_ebSystemRandomness (x,
                            x0) ->
    f0
      x
      x0
  | Coq_ebEncrypt (x,
                   x0) ->
    f1
      x
      x0
  
  type ebErrorOutput =
  | Coq_ebErrorNotEnoughRandomness of DataTypes.systemRandomnessHintT
     * DataTypes.systemRandomnessT
  | Coq_ebErrorInvalidMasterKey of DataTypes.masterKeyT
  | Coq_ebErrorNoMasterKey
  
  (** val ebErrorOutput_rect :
      (DataTypes.systemRandomnessHintT
      ->
      DataTypes.systemRandomnessT
      ->
      'a1)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a1)
      ->
      'a1
      ->
      ebErrorOutput
      ->
      'a1 **)
  
  let ebErrorOutput_rect f f0 f1 = function
  | Coq_ebErrorNotEnoughRandomness (x,
                                    x0) ->
    f
      x
      x0
  | Coq_ebErrorInvalidMasterKey x ->
    f0
      x
      __
  | Coq_ebErrorNoMasterKey ->
    f1
  
  (** val ebErrorOutput_rec :
      (DataTypes.systemRandomnessHintT
      ->
      DataTypes.systemRandomnessT
      ->
      'a1)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a1)
      ->
      'a1
      ->
      ebErrorOutput
      ->
      'a1 **)
  
  let ebErrorOutput_rec f f0 f1 = function
  | Coq_ebErrorNotEnoughRandomness (x,
                                    x0) ->
    f
      x
      x0
  | Coq_ebErrorInvalidMasterKey x ->
    f0
      x
      __
  | Coq_ebErrorNoMasterKey ->
    f1
  
  type 'dataTagT ebEventOutput =
  | Coq_ebRequestSystemRandomness of DataTypes.systemRandomnessHintT
     * (DataTypes.rawDataT * 'dataTagT)
  | Coq_ebEncrypted of DataTypes.encryptedDataT
     * 'dataTagT
  
  (** val ebEventOutput_rect :
      (DataTypes.systemRandomnessHintT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebEventOutput
      ->
      'a2 **)
  
  let ebEventOutput_rect f f0 = function
  | Coq_ebRequestSystemRandomness (x,
                                   x0) ->
    f
      x
      x0
  | Coq_ebEncrypted (x,
                     x0) ->
    f0
      x
      x0
  
  (** val ebEventOutput_rec :
      (DataTypes.systemRandomnessHintT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebEventOutput
      ->
      'a2 **)
  
  let ebEventOutput_rec f f0 = function
  | Coq_ebRequestSystemRandomness (x,
                                   x0) ->
    f
      x
      x0
  | Coq_ebEncrypted (x,
                     x0) ->
    f0
      x
      x0
  
  type 'dataTagT ebOutput
    =
    (ebErrorOutput,
    'dataTagT
    ebEventOutput)
    sum
  
  (** val initState :
      coq_EncryptBoxState **)
  
  let initState =
    None
  
  (** val encryptBoxLoopPreBody :
      coq_EncryptBoxState
      ->
      'a1
      ebInput
      ->
      'a1
      ebOutput
      option * coq_EncryptBoxState **)
  
  let encryptBoxLoopPreBody st = function
  | Coq_ebSetMasterKey key0 ->
    if sumbool_of_bool
         (Algorithm.isValidMasterKey
           key0)
    then (None,
           (Some
           key0))
    else ((Some
           (Inl
           (Coq_ebErrorInvalidMasterKey
           key0))),
           None)
  | Coq_ebSystemRandomness (randomness,
                            tag0) ->
    let (rawData,
         tag) =
      tag0
    in
    ((match masterKey
              st with
      | Some s ->
        (match Algorithm.encrypt
                 randomness
                 s
                 rawData with
         | Inl enc ->
           Some
             (Inr
             (Coq_ebEncrypted
             (enc,
             tag)))
         | Inr e ->
           let NotEnoughRandomness (howMuchWanted,
                                    randomnessGiven) =
             e
           in
           Some
           (Inl
           (Coq_ebErrorNotEnoughRandomness
           (howMuchWanted,
           randomnessGiven))))
      | None ->
        Some
          (Inl
          Coq_ebErrorNoMasterKey)),
    st)
  | Coq_ebEncrypt (rawData,
                   tag) ->
    let hint =
      Algorithm.randomnessHint
        rawData
    in
    ((Some
    (Inr
    (Coq_ebRequestSystemRandomness
    (hint,
    (rawData,
    tag))))),
    st)
  
  (** val encryptBoxLoopBody :
      ('a1
      ebOutput
      ->
      'a2
      action)
      ->
      (coq_EncryptBoxState
      ->
      'a3)
      ->
      coq_EncryptBoxState
      ->
      'a1
      ebInput
      ->
      'a2
      action * 'a3 **)
  
  let encryptBoxLoopBody handle encryptBoxLoop0 st i =
    let outs =
      fst
        (encryptBoxLoopPreBody
          st
          i)
    in
    ((match outs with
      | Some out ->
        handle
          out
      | None ->
        id),
    (encryptBoxLoop0
      (snd
        (encryptBoxLoopPreBody
          st
          i))))
  
  (** val encryptBoxLoop :
      ('a1
      ebOutput
      ->
      'a2
      action)
      ->
      coq_EncryptBoxState
      ->
      ('a1
      ebInput,
      'a2)
      process **)
  
  let rec encryptBoxLoop handle st =
    lazy (Step (encryptBoxLoopBody
                 handle
                 (encryptBoxLoop
                   handle)
                 st))
  
  (** val encryptBox :
      ('a1
      ebOutput
      ->
      'a2
      action)
      ->
      ('a1
      ebInput,
      'a2)
      process **)
  
  let encryptBox handle =
    encryptBoxLoop
      handle
      initState
 end

module TrustedDecryptBox = 
 functor (DataTypes:EncryptionDataTypes) ->
 functor (Algorithm:sig 
  val isValidMasterKey :
    DataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    DataTypes.rawDataT
    ->
    DataTypes.systemRandomnessHintT
  
  val encrypt :
    DataTypes.systemRandomnessT
    ->
    DataTypes.masterKeyT
    ->
    DataTypes.rawDataT
    ->
    (DataTypes.encryptedDataT,
    (DataTypes.systemRandomnessHintT,
    DataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    DataTypes.masterKeyT
    ->
    DataTypes.encryptedDataT
    ->
    (DataTypes.rawDataT,
    __)
    sum
 end) ->
 struct 
  type coq_DecryptBoxState =
    DataTypes.masterKeyT
    option
    (* singleton inductive, whose constructor was Build_DecryptBoxState *)
  
  (** val coq_DecryptBoxState_rect :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_DecryptBoxState
      ->
      'a1 **)
  
  let coq_DecryptBoxState_rect f d =
    f
      d
  
  (** val coq_DecryptBoxState_rec :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_DecryptBoxState
      ->
      'a1 **)
  
  let coq_DecryptBoxState_rec f d =
    f
      d
  
  (** val masterKey :
      coq_DecryptBoxState
      ->
      DataTypes.masterKeyT
      option **)
  
  let masterKey d =
    d
  
  type 'dataTagT dbInput =
  | Coq_dbSetMasterKey of DataTypes.masterKeyT
  | Coq_dbDecrypt of DataTypes.encryptedDataT
     * 'dataTagT
  
  (** val dbInput_rect :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbInput
      ->
      'a2 **)
  
  let dbInput_rect f f0 = function
  | Coq_dbSetMasterKey x ->
    f
      x
  | Coq_dbDecrypt (x,
                   x0) ->
    f0
      x
      x0
  
  (** val dbInput_rec :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbInput
      ->
      'a2 **)
  
  let dbInput_rec f f0 = function
  | Coq_dbSetMasterKey x ->
    f
      x
  | Coq_dbDecrypt (x,
                   x0) ->
    f0
      x
      x0
  
  type 'dataTagT dbErrorOutput =
  | Coq_dbErrorInvalidData of DataTypes.encryptedDataT
     * 'dataTagT
  | Coq_dbErrorInvalidMasterKey of DataTypes.masterKeyT
  | Coq_dbErrorNoMasterKey
  
  (** val dbErrorOutput_rect :
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a2)
      ->
      'a2
      ->
      'a1
      dbErrorOutput
      ->
      'a2 **)
  
  let dbErrorOutput_rect f f0 f1 = function
  | Coq_dbErrorInvalidData (x,
                            x0) ->
    f
      x
      x0
  | Coq_dbErrorInvalidMasterKey x ->
    f0
      x
      __
  | Coq_dbErrorNoMasterKey ->
    f1
  
  (** val dbErrorOutput_rec :
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a2)
      ->
      'a2
      ->
      'a1
      dbErrorOutput
      ->
      'a2 **)
  
  let dbErrorOutput_rec f f0 f1 = function
  | Coq_dbErrorInvalidData (x,
                            x0) ->
    f
      x
      x0
  | Coq_dbErrorInvalidMasterKey x ->
    f0
      x
      __
  | Coq_dbErrorNoMasterKey ->
    f1
  
  type 'dataTagT dbEventOutput =
  | Coq_dbDecrypted of DataTypes.rawDataT
     * 'dataTagT
  
  (** val dbEventOutput_rect :
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbEventOutput
      ->
      'a2 **)
  
  let dbEventOutput_rect f = function
  | Coq_dbDecrypted (x,
                     x0) ->
    f
      x
      x0
  
  (** val dbEventOutput_rec :
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbEventOutput
      ->
      'a2 **)
  
  let dbEventOutput_rec f = function
  | Coq_dbDecrypted (x,
                     x0) ->
    f
      x
      x0
  
  type 'dataTagT dbOutput
    =
    ('dataTagT
    dbErrorOutput,
    'dataTagT
    dbEventOutput)
    sum
  
  (** val initState :
      coq_DecryptBoxState **)
  
  let initState =
    None
  
  (** val decryptBoxLoopPreBody :
      coq_DecryptBoxState
      ->
      'a1
      dbInput
      ->
      'a1
      dbOutput
      option * coq_DecryptBoxState **)
  
  let decryptBoxLoopPreBody st = function
  | Coq_dbSetMasterKey key0 ->
    if sumbool_of_bool
         (Algorithm.isValidMasterKey
           key0)
    then (None,
           (Some
           key0))
    else ((Some
           (Inl
           (Coq_dbErrorInvalidMasterKey
           key0))),
           None)
  | Coq_dbDecrypt (data,
                   tag) ->
    ((match masterKey
              st with
      | Some s ->
        (match Algorithm.decrypt
                 s
                 data with
         | Inl rawData ->
           Some
             (Inr
             (Coq_dbDecrypted
             (rawData,
             tag)))
         | Inr _ ->
           Some
             (Inl
             (Coq_dbErrorInvalidData
             (data,
             tag))))
      | None ->
        Some
          (Inl
          Coq_dbErrorNoMasterKey)),
      st)
  
  (** val decryptBoxLoopBody :
      ('a1
      dbOutput
      ->
      'a2
      action)
      ->
      (coq_DecryptBoxState
      ->
      'a3)
      ->
      coq_DecryptBoxState
      ->
      'a1
      dbInput
      ->
      'a2
      action * 'a3 **)
  
  let decryptBoxLoopBody handle decryptBoxLoop0 st i =
    let outs =
      fst
        (decryptBoxLoopPreBody
          st
          i)
    in
    ((match outs with
      | Some out ->
        handle
          out
      | None ->
        id),
    (decryptBoxLoop0
      (snd
        (decryptBoxLoopPreBody
          st
          i))))
  
  (** val decryptBoxLoop :
      ('a1
      dbOutput
      ->
      'a2
      action)
      ->
      coq_DecryptBoxState
      ->
      ('a1
      dbInput,
      'a2)
      process **)
  
  let rec decryptBoxLoop handle st =
    lazy (Step (decryptBoxLoopBody
                 handle
                 (decryptBoxLoop
                   handle)
                 st))
  
  (** val decryptBox :
      ('a1
      dbOutput
      ->
      'a2
      action)
      ->
      ('a1
      dbInput,
      'a2)
      process **)
  
  let decryptBox handle =
    decryptBoxLoop
      handle
      initState
 end

module TrustedServerSyncBox = 
 functor (DataTypes:EncryptionDataTypes) ->
 functor (Algorithm:sig 
  val isValidMasterKey :
    DataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    DataTypes.rawDataT
    ->
    DataTypes.systemRandomnessHintT
  
  val encrypt :
    DataTypes.systemRandomnessT
    ->
    DataTypes.masterKeyT
    ->
    DataTypes.rawDataT
    ->
    (DataTypes.encryptedDataT,
    (DataTypes.systemRandomnessHintT,
    DataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    DataTypes.masterKeyT
    ->
    DataTypes.encryptedDataT
    ->
    (DataTypes.rawDataT,
    __)
    sum
 end) ->
 struct 
  module TEB = TrustedEncryptBox(DataTypes)(Algorithm)
  
  module TDB = TrustedDecryptBox(DataTypes)(Algorithm)
  
  type coq_ServerSyncBoxPreState = { localStateD : DataTypes.rawDataT;
                                     remoteStateE : DataTypes.encryptedDataT
                                                    option }
  
  (** val coq_ServerSyncBoxPreState_rect :
      (DataTypes.rawDataT
      ->
      DataTypes.encryptedDataT
      option
      ->
      'a1)
      ->
      coq_ServerSyncBoxPreState
      ->
      'a1 **)
  
  let coq_ServerSyncBoxPreState_rect f s =
    let { localStateD =
      x;
      remoteStateE =
      x0 } =
      s
    in
    f
      x
      x0
  
  (** val coq_ServerSyncBoxPreState_rec :
      (DataTypes.rawDataT
      ->
      DataTypes.encryptedDataT
      option
      ->
      'a1)
      ->
      coq_ServerSyncBoxPreState
      ->
      'a1 **)
  
  let coq_ServerSyncBoxPreState_rec f s =
    let { localStateD =
      x;
      remoteStateE =
      x0 } =
      s
    in
    f
      x
      x0
  
  (** val localStateD :
      coq_ServerSyncBoxPreState
      ->
      DataTypes.rawDataT **)
  
  let localStateD s =
    s.localStateD
  
  (** val remoteStateE :
      coq_ServerSyncBoxPreState
      ->
      DataTypes.encryptedDataT
      option **)
  
  let remoteStateE s =
    s.remoteStateE
  
  type coq_ServerSyncBoxState = { ssbState : coq_ServerSyncBoxPreState;
                                  ssbGetUpdateState : unit
                                                      tickBoxState;
                                  ssbCASState : DataTypes.encryptedDataT
                                                tickBoxState;
                                  ssbEncryptState : TEB.coq_EncryptBoxState;
                                  ssbDecryptState : TDB.coq_DecryptBoxState }
  
  (** val coq_ServerSyncBoxState_rect :
      (coq_ServerSyncBoxPreState
      ->
      unit
      tickBoxState
      ->
      DataTypes.encryptedDataT
      tickBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      'a1)
      ->
      coq_ServerSyncBoxState
      ->
      'a1 **)
  
  let coq_ServerSyncBoxState_rect f s =
    let { ssbState =
      x;
      ssbGetUpdateState =
      x0;
      ssbCASState =
      x1;
      ssbEncryptState =
      x2;
      ssbDecryptState =
      x3 } =
      s
    in
    f
      x
      x0
      x1
      x2
      x3
  
  (** val coq_ServerSyncBoxState_rec :
      (coq_ServerSyncBoxPreState
      ->
      unit
      tickBoxState
      ->
      DataTypes.encryptedDataT
      tickBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      'a1)
      ->
      coq_ServerSyncBoxState
      ->
      'a1 **)
  
  let coq_ServerSyncBoxState_rec f s =
    let { ssbState =
      x;
      ssbGetUpdateState =
      x0;
      ssbCASState =
      x1;
      ssbEncryptState =
      x2;
      ssbDecryptState =
      x3 } =
      s
    in
    f
      x
      x0
      x1
      x2
      x3
  
  (** val ssbState :
      coq_ServerSyncBoxState
      ->
      coq_ServerSyncBoxPreState **)
  
  let ssbState s =
    s.ssbState
  
  (** val ssbGetUpdateState :
      coq_ServerSyncBoxState
      ->
      unit
      tickBoxState **)
  
  let ssbGetUpdateState s =
    s.ssbGetUpdateState
  
  (** val ssbCASState :
      coq_ServerSyncBoxState
      ->
      DataTypes.encryptedDataT
      tickBoxState **)
  
  let ssbCASState s =
    s.ssbCASState
  
  (** val ssbEncryptState :
      coq_ServerSyncBoxState
      ->
      TEB.coq_EncryptBoxState **)
  
  let ssbEncryptState s =
    s.ssbEncryptState
  
  (** val ssbDecryptState :
      coq_ServerSyncBoxState
      ->
      TDB.coq_DecryptBoxState **)
  
  let ssbDecryptState s =
    s.ssbDecryptState
  
  (** val set_ssbState :
      coq_ServerSyncBoxState
      ->
      coq_ServerSyncBoxPreState
      ->
      coq_ServerSyncBoxState **)
  
  let set_ssbState st v =
    { ssbState =
      v;
      ssbGetUpdateState =
      (ssbGetUpdateState
        st);
      ssbCASState =
      (ssbCASState
        st);
      ssbEncryptState =
      (ssbEncryptState
        st);
      ssbDecryptState =
      (ssbDecryptState
        st) }
  
  (** val set_ssbGetUpdateState :
      coq_ServerSyncBoxState
      ->
      unit
      tickBoxState
      ->
      coq_ServerSyncBoxState **)
  
  let set_ssbGetUpdateState st v =
    { ssbState =
      (ssbState
        st);
      ssbGetUpdateState =
      v;
      ssbCASState =
      (ssbCASState
        st);
      ssbEncryptState =
      (ssbEncryptState
        st);
      ssbDecryptState =
      (ssbDecryptState
        st) }
  
  (** val set_ssbCASState :
      coq_ServerSyncBoxState
      ->
      DataTypes.encryptedDataT
      tickBoxState
      ->
      coq_ServerSyncBoxState **)
  
  let set_ssbCASState st v =
    { ssbState =
      (ssbState
        st);
      ssbGetUpdateState =
      (ssbGetUpdateState
        st);
      ssbCASState =
      v;
      ssbEncryptState =
      (ssbEncryptState
        st);
      ssbDecryptState =
      (ssbDecryptState
        st) }
  
  (** val set_ssbEncryptState :
      coq_ServerSyncBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      coq_ServerSyncBoxState **)
  
  let set_ssbEncryptState st v =
    { ssbState =
      (ssbState
        st);
      ssbGetUpdateState =
      (ssbGetUpdateState
        st);
      ssbCASState =
      (ssbCASState
        st);
      ssbEncryptState =
      v;
      ssbDecryptState =
      (ssbDecryptState
        st) }
  
  (** val set_ssbDecryptState :
      coq_ServerSyncBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      coq_ServerSyncBoxState **)
  
  let set_ssbDecryptState st v =
    { ssbState =
      (ssbState
        st);
      ssbGetUpdateState =
      (ssbGetUpdateState
        st);
      ssbCASState =
      (ssbCASState
        st);
      ssbEncryptState =
      (ssbEncryptState
        st);
      ssbDecryptState =
      v }
  
  type ssbConfigInput =
  | Coq_ssbGetUpdateConfig of tbConfigInput
  | Coq_ssbCASConfig of tbConfigInput
  | Coq_ssbSetMasterKey of DataTypes.masterKeyT
  
  (** val ssbConfigInput_rect :
      (tbConfigInput
      ->
      'a1)
      ->
      (tbConfigInput
      ->
      'a1)
      ->
      (DataTypes.masterKeyT
      ->
      'a1)
      ->
      ssbConfigInput
      ->
      'a1 **)
  
  let ssbConfigInput_rect f f0 f1 = function
  | Coq_ssbGetUpdateConfig x ->
    f
      x
  | Coq_ssbCASConfig x ->
    f0
      x
  | Coq_ssbSetMasterKey x ->
    f1
      x
  
  (** val ssbConfigInput_rec :
      (tbConfigInput
      ->
      'a1)
      ->
      (tbConfigInput
      ->
      'a1)
      ->
      (DataTypes.masterKeyT
      ->
      'a1)
      ->
      ssbConfigInput
      ->
      'a1 **)
  
  let ssbConfigInput_rec f f0 f1 = function
  | Coq_ssbGetUpdateConfig x ->
    f
      x
  | Coq_ssbCASConfig x ->
    f0
      x
  | Coq_ssbSetMasterKey x ->
    f1
      x
  
  type ssbEventInput =
  | Coq_ssbClientGetUpdate
  | Coq_ssbClientSet of DataTypes.rawDataT
  | Coq_ssbServerGotUpdate of DataTypes.encryptedDataT
  | Coq_ssbSystemRandomness of DataTypes.systemRandomnessT
     * DataTypes.rawDataT
  | Coq_ssbTick of Big.big_int
  
  (** val ssbEventInput_rect :
      'a1
      ->
      (DataTypes.rawDataT
      ->
      'a1)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1)
      ->
      (DataTypes.systemRandomnessT
      ->
      DataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventInput
      ->
      'a1 **)
  
  let ssbEventInput_rect f f0 f1 f2 f3 = function
  | Coq_ssbClientGetUpdate ->
    f
  | Coq_ssbClientSet x ->
    f0
      x
  | Coq_ssbServerGotUpdate x ->
    f1
      x
  | Coq_ssbSystemRandomness (x,
                             x0) ->
    f2
      x
      x0
  | Coq_ssbTick x ->
    f3
      x
  
  (** val ssbEventInput_rec :
      'a1
      ->
      (DataTypes.rawDataT
      ->
      'a1)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1)
      ->
      (DataTypes.systemRandomnessT
      ->
      DataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventInput
      ->
      'a1 **)
  
  let ssbEventInput_rec f f0 f1 f2 f3 = function
  | Coq_ssbClientGetUpdate ->
    f
  | Coq_ssbClientSet x ->
    f0
      x
  | Coq_ssbServerGotUpdate x ->
    f1
      x
  | Coq_ssbSystemRandomness (x,
                             x0) ->
    f2
      x
      x0
  | Coq_ssbTick x ->
    f3
      x
  
  type ssbInput
    =
    (ssbConfigInput,
    ssbEventInput)
    sum
  
  type ssbWarningOutput =
  | Coq_ssbGetUpdateWarning of unit
                               tbWarningOutput
  | Coq_ssbCASWarning of DataTypes.encryptedDataT
                         tbWarningOutput
  | Coq_ssbEncryptError of TEB.ebErrorOutput
  | Coq_ssbDecryptError of unit
                           TDB.dbErrorOutput
  | Coq_ssbWarningInvalidTransition of ssbInput
     * coq_ServerSyncBoxState
  | Coq_ssbWarningPushBeforePull
  
  (** val ssbWarningOutput_rect :
      (unit
      tbWarningOutput
      ->
      'a1)
      ->
      (DataTypes.encryptedDataT
      tbWarningOutput
      ->
      'a1)
      ->
      (TEB.ebErrorOutput
      ->
      'a1)
      ->
      (unit
      TDB.dbErrorOutput
      ->
      'a1)
      ->
      (ssbInput
      ->
      coq_ServerSyncBoxState
      ->
      'a1)
      ->
      'a1
      ->
      ssbWarningOutput
      ->
      'a1 **)
  
  let ssbWarningOutput_rect f f0 f1 f2 f3 f4 = function
  | Coq_ssbGetUpdateWarning x ->
    f
      x
  | Coq_ssbCASWarning x ->
    f0
      x
  | Coq_ssbEncryptError x ->
    f1
      x
  | Coq_ssbDecryptError x ->
    f2
      x
  | Coq_ssbWarningInvalidTransition (x,
                                     x0) ->
    f3
      x
      x0
  | Coq_ssbWarningPushBeforePull ->
    f4
  
  (** val ssbWarningOutput_rec :
      (unit
      tbWarningOutput
      ->
      'a1)
      ->
      (DataTypes.encryptedDataT
      tbWarningOutput
      ->
      'a1)
      ->
      (TEB.ebErrorOutput
      ->
      'a1)
      ->
      (unit
      TDB.dbErrorOutput
      ->
      'a1)
      ->
      (ssbInput
      ->
      coq_ServerSyncBoxState
      ->
      'a1)
      ->
      'a1
      ->
      ssbWarningOutput
      ->
      'a1 **)
  
  let ssbWarningOutput_rec f f0 f1 f2 f3 f4 = function
  | Coq_ssbGetUpdateWarning x ->
    f
      x
  | Coq_ssbCASWarning x ->
    f0
      x
  | Coq_ssbEncryptError x ->
    f1
      x
  | Coq_ssbDecryptError x ->
    f2
      x
  | Coq_ssbWarningInvalidTransition (x,
                                     x0) ->
    f3
      x
      x0
  | Coq_ssbWarningPushBeforePull ->
    f4
  
  type ssbEventOutput =
  | Coq_ssbClientGotUpdate of DataTypes.rawDataT
  | Coq_ssbServerGetUpdate
  | Coq_ssbServerCAS of DataTypes.encryptedDataT
     * DataTypes.encryptedDataT
  | Coq_ssbRequestSystemRandomness of DataTypes.systemRandomnessHintT
     * DataTypes.rawDataT
  | Coq_ssbSleepFor of Big.big_int
  
  (** val ssbEventOutput_rect :
      (DataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (DataTypes.encryptedDataT
      ->
      DataTypes.encryptedDataT
      ->
      'a1)
      ->
      (DataTypes.systemRandomnessHintT
      ->
      DataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1 **)
  
  let ssbEventOutput_rect f f0 f1 f2 f3 = function
  | Coq_ssbClientGotUpdate x ->
    f
      x
  | Coq_ssbServerGetUpdate ->
    f0
  | Coq_ssbServerCAS (x,
                      x0) ->
    f1
      x
      x0
  | Coq_ssbRequestSystemRandomness (x,
                                    x0) ->
    f2
      x
      x0
  | Coq_ssbSleepFor x ->
    f3
      x
  
  (** val ssbEventOutput_rec :
      (DataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (DataTypes.encryptedDataT
      ->
      DataTypes.encryptedDataT
      ->
      'a1)
      ->
      (DataTypes.systemRandomnessHintT
      ->
      DataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1 **)
  
  let ssbEventOutput_rec f f0 f1 f2 f3 = function
  | Coq_ssbClientGotUpdate x ->
    f
      x
  | Coq_ssbServerGetUpdate ->
    f0
  | Coq_ssbServerCAS (x,
                      x0) ->
    f1
      x
      x0
  | Coq_ssbRequestSystemRandomness (x,
                                    x0) ->
    f2
      x
      x0
  | Coq_ssbSleepFor x ->
    f3
      x
  
  type ssbOutput
    =
    (ssbWarningOutput,
    ssbEventOutput)
    sum
  
  (** val initState :
      DataTypes.rawDataT
      ->
      coq_ServerSyncBoxState **)
  
  let initState initRawData =
    { ssbState =
      { localStateD =
      initRawData;
      remoteStateE =
      None };
      ssbGetUpdateState =
      initState;
      ssbCASState =
      initState;
      ssbEncryptState =
      TEB.initState;
      ssbDecryptState =
      TDB.initState }
  
  (** val isTickBoxSimpleResult :
      'a1
      tbOutput
      list
      ->
      bool **)
  
  let rec isTickBoxSimpleResult = function
  | [] ->
    true
  | t0 :: res' ->
    (match t0 with
     | Inl t1 ->
       isTickBoxSimpleResult
         res'
     | Inr t1 ->
       (match t1 with
        | TbSleepFor ticks ->
          isTickBoxSimpleResult
            res'
        | _ ->
          false))
  
  (** val handle_simpleTickBox :
      ('a1
      tbWarningOutput
      ->
      ssbWarningOutput)
      ->
      'a1
      tbOutput
      list
      ->
      ssbOutput
      list **)
  
  let rec handle_simpleTickBox warn = function
  | [] ->
    []
  | t0 :: res' ->
    (match t0 with
     | Inl warning ->
       (Inl
         (warn
           warning)) :: (handle_simpleTickBox
                          warn
                          res')
     | Inr t1 ->
       (match t1 with
        | TbSleepFor ticks ->
          (Inr
            (Coq_ssbSleepFor
            ticks)) :: (handle_simpleTickBox
                         warn
                         res')
        | _ ->
          assert false
            (* absurd case *)))
  
  (** val handle_ssbGetUpdate' :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let handle_ssbGetUpdate' st i =
    ((match fst
              i with
      | Inl warning ->
        (Inl
          (Coq_ssbGetUpdateWarning
          warning)) :: []
      | Inr t0 ->
        (match t0 with
         | TbRequestDataUpdate ->
           let upd =
             tickBoxLoopPreBody
               (ssbGetUpdateState
                 st)
               (Inr
               (TbValueReady
               ()))
           in
           handle_simpleTickBox
             (fun x ->
             Coq_ssbGetUpdateWarning
             x)
             (fst
               upd)
         | TbPublishUpdate val0 ->
           (Inr
             Coq_ssbServerGetUpdate) :: []
         | TbSleepFor ticks ->
           (Inr
             (Coq_ssbSleepFor
             ticks)) :: [])),
      (set_ssbGetUpdateState
        st
        (snd
          i)))
  
  (** val fold_handler :
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2
      ->
      coq_ServerSyncBoxState)
      ->
      (coq_ServerSyncBoxState
      ->
      ('a1 * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState)
      ->
      coq_ServerSyncBoxState
      ->
      ('a1
      list * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let fold_handler get0 set0 handle st outs_st =
    fold_left
      (fun ls_st out ->
      let ls'_st' =
        handle
          (snd
            ls_st)
          (out,
          (get0
            (snd
              ls_st)))
      in
      ((app
         (fst
           ls_st)
         (fst
           ls'_st')),
      (snd
        ls'_st')))
      (fst
        outs_st)
      ([],
      (set0
        st
        (snd
          outs_st)))
  
  (** val handle_ssbGetUpdate :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput
      list * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let handle_ssbGetUpdate =
    fold_handler
      ssbGetUpdateState
      set_ssbGetUpdateState
      handle_ssbGetUpdate'
  
  (** val handle_ssbEncrypt :
      coq_ServerSyncBoxState
      ->
      (unit
      TEB.ebOutput
      option * TEB.coq_EncryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let handle_ssbEncrypt st i =
    let st' =
      set_ssbEncryptState
        st
        (snd
          i)
    in
    (match fst
             i with
     | Some e ->
       (match e with
        | Inl warning ->
          (((Inl
            (Coq_ssbEncryptError
            warning)) :: []),
            st')
        | Inr e0 ->
          (match e0 with
           | TEB.Coq_ebRequestSystemRandomness (howMuch,
                                                tag) ->
             (((Inr
               (Coq_ssbRequestSystemRandomness
               (howMuch,
               (fst
                 tag)))) :: []),
               st')
           | TEB.Coq_ebEncrypted (newE,
                                  tag) ->
             let upd =
               tickBoxLoopPreBody
                 (ssbCASState
                   st')
                 (Inr
                 (TbValueReady
                 newE))
             in
             ((handle_simpleTickBox
                (fun x ->
                Coq_ssbCASWarning
                x)
                (fst
                  upd)),
             (set_ssbCASState
               st'
               (snd
                 upd)))))
     | None ->
       ([],
         st'))
  
  (** val handle_ssbCAS' :
      coq_ServerSyncBoxState
      ->
      (DataTypes.encryptedDataT
      tbOutput * DataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let handle_ssbCAS' st i =
    let st' =
      set_ssbCASState
        st
        (snd
          i)
    in
    (match fst
             i with
     | Inl warning ->
       (((Inl
         (Coq_ssbCASWarning
         warning)) :: []),
         st')
     | Inr t0 ->
       (match t0 with
        | TbRequestDataUpdate ->
          let encResult =
            TEB.encryptBoxLoopPreBody
              (ssbEncryptState
                st')
              (TEB.Coq_ebEncrypt
              ((localStateD
                 (ssbState
                   st')),
              ()))
          in
          handle_ssbEncrypt
            st'
            encResult
        | TbPublishUpdate val0 ->
          (((match remoteStateE
                     (ssbState
                       st') with
             | Some curE ->
               Inr
                 (Coq_ssbServerCAS
                 (curE,
                 val0))
             | None ->
               Inl
                 Coq_ssbWarningPushBeforePull) :: []),
            st')
        | TbSleepFor ticks ->
          (((Inr
            (Coq_ssbSleepFor
            ticks)) :: []),
            st')))
  
  (** val handle_ssbCAS :
      coq_ServerSyncBoxState
      ->
      (DataTypes.encryptedDataT
      tbOutput
      list * DataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let handle_ssbCAS =
    fold_handler
      ssbCASState
      set_ssbCASState
      handle_ssbCAS'
  
  (** val handle_ssbDecrypt :
      (DataTypes.rawDataT
      ->
      DataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      (unit
      TDB.dbOutput
      option * TDB.coq_DecryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let handle_ssbDecrypt d_eqb st i =
    let st' =
      set_ssbDecryptState
        st
        (snd
          i)
    in
    (match fst
             i with
     | Some d ->
       (match d with
        | Inl warning ->
          (((Inl
            (Coq_ssbDecryptError
            warning)) :: []),
            st')
        | Inr d0 ->
          let TDB.Coq_dbDecrypted (dataD,
                                   tag) =
            d0
          in
          ((if d_eqb
                 dataD
                 (localStateD
                   (ssbState
                     st'))
            then []
            else (Inr
                   (Coq_ssbClientGotUpdate
                   dataD)) :: []),
          (set_ssbState
            st'
            { localStateD =
            dataD;
            remoteStateE =
            (remoteStateE
              (ssbState
                st')) })))
     | None ->
       ([],
         st'))
  
  (** val serverSyncBoxLoopPreBody :
      (DataTypes.rawDataT
      ->
      DataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      ssbOutput
      list * coq_ServerSyncBoxState **)
  
  let serverSyncBoxLoopPreBody d_eqb st = function
  | Inl s ->
    (match s with
     | Coq_ssbGetUpdateConfig i' ->
       handle_ssbGetUpdate
         st
         (tickBoxLoopPreBody
           (ssbGetUpdateState
             st)
           (Inl
           i'))
     | Coq_ssbCASConfig i' ->
       handle_ssbCAS
         st
         (tickBoxLoopPreBody
           (ssbCASState
             st)
           (Inl
           i'))
     | Coq_ssbSetMasterKey newKey ->
       let (ls0,
            st0) =
         handle_ssbEncrypt
           st
           (TEB.encryptBoxLoopPreBody
             (ssbEncryptState
               st)
             (TEB.Coq_ebSetMasterKey
             newKey))
       in
       let (ls1,
            st1) =
         handle_ssbDecrypt
           d_eqb
           st0
           (TDB.decryptBoxLoopPreBody
             (ssbDecryptState
               st)
             (TDB.Coq_dbSetMasterKey
             newKey))
       in
       ((app
          ls0
          ls1),
       st1))
  | Inr s ->
    (match s with
     | Coq_ssbClientGetUpdate ->
       handle_ssbGetUpdate
         st
         (tickBoxLoopPreBody
           (ssbGetUpdateState
             st)
           (Inr
           TbNotifyChange))
     | Coq_ssbClientSet newD ->
       let st' =
         set_ssbState
           st
           { localStateD =
           newD;
           remoteStateE =
           (remoteStateE
             (ssbState
               st)) }
       in
       handle_ssbCAS
         st'
         (tickBoxLoopPreBody
           (ssbCASState
             st')
           (Inr
           TbNotifyChange))
     | Coq_ssbServerGotUpdate dataE ->
       let st' =
         set_ssbState
           st
           { localStateD =
           (localStateD
             (ssbState
               st));
           remoteStateE =
           (Some
           dataE) }
       in
       handle_ssbDecrypt
         d_eqb
         st'
         (TDB.decryptBoxLoopPreBody
           (ssbDecryptState
             st')
           (TDB.Coq_dbDecrypt
           (dataE,
           ())))
     | Coq_ssbSystemRandomness (randomness,
                                tag) ->
       handle_ssbEncrypt
         st
         (TEB.encryptBoxLoopPreBody
           (ssbEncryptState
             st)
           (TEB.Coq_ebSystemRandomness
           (randomness,
           (tag,
           ()))))
     | Coq_ssbTick n ->
       let (ls0,
            st0) =
         handle_ssbGetUpdate
           st
           (tickBoxLoopPreBody
             (ssbGetUpdateState
               st)
             (Inr
             (TbTick
             n)))
       in
       let (ls1,
            st1) =
         handle_ssbCAS
           st0
           (tickBoxLoopPreBody
             (ssbCASState
               st0)
             (Inr
             (TbTick
             n)))
       in
       ((app
          ls0
          ls1),
       st1))
  
  (** val serverSyncBoxLoopBody :
      (DataTypes.rawDataT
      ->
      DataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      'a1
      action * 'a2 **)
  
  let serverSyncBoxLoopBody d_eqb handle serverSyncBoxLoop0 st i =
    let outs =
      fst
        (serverSyncBoxLoopPreBody
          d_eqb
          st
          i)
    in
    ((fold_left
       compose
       (map
         handle
         outs)
       id),
    (serverSyncBoxLoop0
      (snd
        (serverSyncBoxLoopPreBody
          d_eqb
          st
          i))))
  
  (** val serverSyncBoxLoop :
      (DataTypes.rawDataT
      ->
      DataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      coq_ServerSyncBoxState
      ->
      (ssbInput,
      'a1)
      process **)
  
  let rec serverSyncBoxLoop d_eqb handle st =
    lazy (Step (serverSyncBoxLoopBody
                 d_eqb
                 handle
                 (serverSyncBoxLoop
                   d_eqb
                   handle)
                 st))
  
  (** val serverSyncBox :
      (DataTypes.rawDataT
      ->
      DataTypes.rawDataT
      ->
      bool)
      ->
      DataTypes.rawDataT
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (ssbInput,
      'a1)
      process **)
  
  let serverSyncBox d_eqb initRawData handle =
    serverSyncBoxLoop
      d_eqb
      handle
      (initState
        initRawData)
 end

type tickGInput =
| TGWakeUp
| TGClocksGot of Big.big_int
| TGWantWakeupIn of Big.big_int

(** val nanos_per_tick :
    Big.big_int **)

let nanos_per_tick =
  Big.one

type gatewayPreState =
| Init
| WaitingToWake
| WaitingToSleep

type gatewayState = { systemTime : Big.big_int
                                   option;
                      nextWakeUpTime : Big.big_int
                                       option;
                      waitingOn : gatewayPreState }

(** val systemTime :
    gatewayState
    ->
    Big.big_int
    option **)

let systemTime x = x.systemTime

(** val nextWakeUpTime :
    gatewayState
    ->
    Big.big_int
    option **)

let nextWakeUpTime x = x.nextWakeUpTime

(** val waitingOn :
    gatewayState
    ->
    gatewayPreState **)

let waitingOn x = x.waitingOn

(** val set_waitingOn :
    gatewayState
    ->
    gatewayPreState
    ->
    gatewayState **)

let set_waitingOn st v =
  { systemTime =
    st.systemTime;
    nextWakeUpTime =
    st.nextWakeUpTime;
    waitingOn =
    v }

type tickGWarningOutput =
| TGDebugStateTransition of gatewayState
   * gatewayState
   * tickGInput

type tickGEventOutput =
| TGGetNanosecs
| TGTick of Big.big_int
| TGSystemSleep of Big.big_int

type tickGOutput
  =
  (tickGWarningOutput,
  tickGEventOutput)
  sum

(** val tickStarvationBoundary :
    Big.big_int **)

let tickStarvationBoundary =
  (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.double
    (Big.double
    (Big.double
    (Big.doubleplusone
    (Big.double
    (Big.doubleplusone
    (Big.doubleplusone
    (Big.doubleplusone
    Big.one))))))))))))))))))

(** val tickGLoopPreBody' :
    gatewayState
    ->
    tickGInput
    ->
    tickGOutput
    list * gatewayState **)

let tickGLoopPreBody' st = function
| TGWakeUp ->
  (((Inr
    TGGetNanosecs) :: []),
    (set_waitingOn
      st
      WaitingToWake))
| TGClocksGot new0 ->
  (match st.waitingOn with
   | Init ->
     ([],
       { systemTime =
       (Some
       new0);
       nextWakeUpTime =
       st.nextWakeUpTime;
       waitingOn =
       Init })
   | WaitingToWake ->
     let actions =
       match st.systemTime with
       | Some prev ->
         let ticks =
           N.div
             (N.sub
               new0
               prev)
             nanos_per_tick
         in
         (Inr
         (TGTick
         ticks)) :: []
       | None ->
         []
     in
     (actions,
     { systemTime =
     (Some
     new0);
     nextWakeUpTime =
     None;
     waitingOn =
     Init })
   | WaitingToSleep ->
     (match st.systemTime with
      | Some prev ->
        (match st.nextWakeUpTime with
         | Some nanos ->
           let diff =
             N.sub
               new0
               prev
           in
           let new_nanos =
             N.sub
               nanos
               diff
           in
           if N.eqb
                new_nanos
                Big.zero
           then (((Inr
                  (TGTick
                  (N.div
                    diff
                    nanos_per_tick))) :: []),
                  { systemTime =
                  (Some
                  new0);
                  nextWakeUpTime =
                  None;
                  waitingOn =
                  Init })
           else (((Inr
                  (TGSystemSleep
                  new_nanos)) :: []),
                  { systemTime =
                  (Some
                  new0);
                  nextWakeUpTime =
                  (Some
                  new_nanos);
                  waitingOn =
                  Init })
         | None ->
           (((Inr
             (TGSystemSleep
             Big.zero)) :: []),
             { systemTime =
             (Some
             new0);
             nextWakeUpTime =
             (Some
             Big.zero);
             waitingOn =
             Init }))
      | None ->
        (((Inr
          (TGSystemSleep
          Big.zero)) :: []),
          { systemTime =
          (Some
          new0);
          nextWakeUpTime =
          (Some
          Big.zero);
          waitingOn =
          Init })))
| TGWantWakeupIn ticks ->
  let nanos =
    N.mul
      ticks
      nanos_per_tick
  in
  if N.ltb
       nanos
       tickStarvationBoundary
  then (((Inr
         (TGSystemSleep
         Big.one)) :: []),
         st)
  else (match st.nextWakeUpTime with
        | Some nextWake ->
          if N.ltb
               nanos
               nextWake
          then (((Inr
                 TGGetNanosecs) :: []),
                 { systemTime =
                 st.systemTime;
                 nextWakeUpTime =
                 (Some
                 nanos);
                 waitingOn =
                 WaitingToSleep })
          else ([],
                 st)
        | None ->
          (((Inr
            TGGetNanosecs) :: []),
            { systemTime =
            st.systemTime;
            nextWakeUpTime =
            (Some
            nanos);
            waitingOn =
            WaitingToSleep }))

(** val tickGLoopPreBody :
    gatewayState
    ->
    tickGInput
    ->
    tickGOutput
    list * gatewayState **)

let tickGLoopPreBody st i =
  let (a,
       st') =
    tickGLoopPreBody'
      st
      i
  in
  (((Inl
  (TGDebugStateTransition
  (st,
  st',
  i))) :: a),
  st')

(** val tickGLoopBody :
    (tickGOutput
    ->
    'a1
    action)
    ->
    (gatewayState
    ->
    'a2)
    ->
    gatewayState
    ->
    tickGInput
    ->
    'a1
    action * 'a2 **)

let tickGLoopBody handle loop st i =
  let outputs =
    fst
      (tickGLoopPreBody
        st
        i)
  in
  let st' =
    snd
      (tickGLoopPreBody
        st
        i)
  in
  ((fold_left
     compose
     (map
       handle
       outputs)
     id),
  (loop
    st'))

(** val tickGLoop :
    (tickGOutput
    ->
    'a1
    action)
    ->
    gatewayState
    ->
    (tickGInput,
    'a1)
    process **)

let rec tickGLoop handle st =
  lazy (Step (tickGLoopBody
               handle
               (tickGLoop
                 handle)
               st))

(** val tickGInitState :
    gatewayState **)

let tickGInitState =
  { systemTime = None; nextWakeUpTime = None; waitingOn = Init }

(** val tickG : (tickGOutput -> 'a1 action) -> (tickGInput, 'a1) process **)

let tickG handle =
  tickGLoop handle tickGInitState

(** val tickBoxState_Serializable :
    'a1 serializable -> 'a1 tickBoxPreState serializable **)

let tickBoxState_Serializable h0 = function
| NoData ticks ->
  append ('N'::('o'::('D'::('a'::('t'::('a'::(' '::[])))))))
    (to_string serializable_N ticks)
| InitiallyWaitingOnData ticks ->
  append
    ('I'::('n'::('i'::('t'::('i'::('a'::('l'::('l'::('y'::('W'::('a'::('i'::('t'::('i'::('n'::('g'::('O'::('n'::('D'::('a'::('t'::('a'::(' '::[])))))))))))))))))))))))
    (to_string serializable_N ticks)
| HaveData (ticks, data, publishesSinceLastChange) ->
  append ('H'::('a'::('v'::('e'::('D'::('a'::('t'::('a'::(' '::[])))))))))
    (append (to_string serializable_N ticks)
      (append (' '::[])
        (append
          ('d'::('u'::('m'::('m'::('y'::(' '::('d'::('a'::('t'::('a'::[]))))))))))
          (append (' '::[])
            (to_string (serializable_option serializable_N)
              publishesSinceLastChange)))))
| WaitingOnData (ticks, publishesSinceLastChange) ->
  append
    ('W'::('a'::('i'::('t'::('i'::('n'::('g'::('O'::('n'::('D'::('a'::('t'::('a'::(' '::[]))))))))))))))
    (append (to_string serializable_N ticks)
      (append (' '::[])
        (to_string (serializable_option serializable_N)
          publishesSinceLastChange)))
| WaitingOnTicks (ticks, publishesSinceLastChange) ->
  append
    ('W'::('a'::('i'::('t'::('i'::('n'::('g'::('O'::('n'::('T'::('i'::('c'::('k'::('s'::(' '::[])))))))))))))))
    (append (to_string serializable_N ticks)
      (append (' '::[])
        (to_string (serializable_option serializable_N)
          publishesSinceLastChange)))

(** val publishDurationT_Serializable : publishDurationT serializable **)

let publishDurationT_Serializable = function
| DurationOf n0 -> to_string serializable_N n0
| Inf -> ''::('\136'::(''::[]))

(** val tbConfigInput_Serializable : tbConfigInput serializable **)

let tbConfigInput_Serializable = function
| TbSetPublishInterval n ->
  append
    ('t'::('b'::('S'::('e'::('t'::('P'::('u'::('b'::('l'::('i'::('s'::('h'::('I'::('n'::('t'::('e'::('r'::('v'::('a'::('l'::(' '::[])))))))))))))))))))))
    (to_string serializable_N n)
| TbSetPublishDuration n ->
  append
    ('t'::('b'::('S'::('e'::('t'::('P'::('u'::('b'::('l'::('i'::('s'::('h'::('D'::('u'::('r'::('a'::('t'::('i'::('o'::('n'::(' '::[])))))))))))))))))))))
    (to_string publishDurationT_Serializable n)
| TbSetWaitBeforeUpdateInterval n ->
  append
    ('t'::('b'::('S'::('e'::('t'::('W'::('a'::('i'::('t'::('B'::('e'::('f'::('o'::('r'::('e'::('U'::('p'::('d'::('a'::('t'::('e'::('I'::('n'::('t'::('e'::('r'::('v'::('a'::('l'::(' '::[]))))))))))))))))))))))))))))))
    (to_string serializable_N n)
| TbSetPublishPrecision n ->
  append
    ('t'::('b'::('S'::('e'::('t'::('P'::('u'::('b'::('l'::('i'::('s'::('h'::('P'::('r'::('e'::('c'::('i'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))
    (to_string serializable_N n)

(** val tbEventInput_Serializable :
    'a1 serializable -> 'a1 tbEventInput serializable **)

let tbEventInput_Serializable h0 = function
| TbNotifyChange ->
  't'::('b'::('N'::('o'::('t'::('i'::('f'::('y'::('C'::('h'::('a'::('n'::('g'::('e'::[])))))))))))))
| TbTick addedTickCount ->
  append ('t'::('b'::('T'::('i'::('c'::('k'::(' '::[])))))))
    (to_string serializable_N addedTickCount)
| TbValueReady val0 ->
  append
    ('t'::('b'::('V'::('a'::('l'::('u'::('e'::('R'::('e'::('a'::('d'::('y'::(' '::[])))))))))))))
    (to_string h0 val0)

(** val gatewayPreState_Serializable : gatewayPreState serializable **)

let gatewayPreState_Serializable = function
| Init -> 'I'::('n'::('i'::('t'::[])))
| WaitingToWake ->
  'W'::('a'::('i'::('t'::('i'::('n'::('g'::('T'::('o'::('W'::('a'::('k'::('e'::('U'::('p'::[]))))))))))))))
| WaitingToSleep ->
  'W'::('a'::('i'::('t'::('i'::('n'::('g'::('T'::('o'::('S'::('l'::('e'::('e'::('p'::[])))))))))))))

(** val gatewayState_Serializable : gatewayState serializable **)

let gatewayState_Serializable st =
  append
    ('s'::('y'::('s'::('t'::('e'::('m'::('T'::('i'::('m'::('e'::(' '::[])))))))))))
    (append (to_string (serializable_option serializable_N) st.systemTime)
      (append
        (' '::('n'::('e'::('x'::('t'::('W'::('a'::('k'::('e'::('U'::('p'::('T'::('i'::('m'::('e'::(' '::[]))))))))))))))))
        (append
          (to_string (serializable_option serializable_N) st.nextWakeUpTime)
          (append
            (' '::('w'::('a'::('i'::('t'::('i'::('n'::('g'::('O'::('n'::(' '::[])))))))))))
            (to_string gatewayPreState_Serializable st.waitingOn)))))

(** val tickGInput_Serializable : tickGInput serializable **)

let tickGInput_Serializable = function
| TGWakeUp -> 'T'::('G'::('W'::('a'::('k'::('e'::('U'::('p'::[])))))))
| TGClocksGot nanoseconds ->
  append
    ('T'::('G'::('C'::('l'::('o'::('c'::('k'::('s'::('G'::('o'::('t'::(' '::[]))))))))))))
    (to_string serializable_N nanoseconds)
| TGWantWakeupIn ticks ->
  append
    ('T'::('G'::('W'::('a'::('n'::('t'::('W'::('a'::('k'::('e'::('u'::('p'::('I'::('n'::(' '::[])))))))))))))))
    (to_string serializable_N ticks)

module PwMgrWarningBox = 
 functor (Algorithm:sig 
  val isValidMasterKey : EncryptionStringDataTypes.masterKeyT -> bool
  
  val randomnessHint :
    EncryptionStringDataTypes.rawDataT ->
    EncryptionStringDataTypes.systemRandomnessHintT
  
  val encrypt :
    EncryptionStringDataTypes.systemRandomnessT ->
    EncryptionStringDataTypes.masterKeyT ->
    EncryptionStringDataTypes.rawDataT ->
    (EncryptionStringDataTypes.encryptedDataT,
    (EncryptionStringDataTypes.systemRandomnessHintT,
    EncryptionStringDataTypes.systemRandomnessT) encryptionError) sum
  
  val decrypt :
    EncryptionStringDataTypes.masterKeyT ->
    EncryptionStringDataTypes.encryptedDataT ->
    (EncryptionStringDataTypes.rawDataT, __) sum
 end) ->
 struct 
  module SSB = TrustedServerSyncBox(EncryptionStringDataTypes)(Algorithm)
  
  type wInput = (SSB.ssbWarningOutput, tickGWarningOutput) sum
  
  module Coercions = 
   struct 
    (** val wInput_of_ssb : SSB.ssbWarningOutput -> wInput **)
    
    let wInput_of_ssb x =
      Inl x
    
    (** val wInput_of_tg : tickGWarningOutput -> wInput **)
    
    let wInput_of_tg x =
      Inr x
   end
  
  type wOutput =
  | Coq_wConsoleErr of char list
  | Coq_wFatalError of char list
  | Coq_wBad of char list
  
  (** val wOutput_rect :
      (char list -> 'a1) -> (char list -> 'a1) -> (char list -> 'a1) ->
      wOutput -> 'a1 **)
  
  let wOutput_rect f f0 f1 = function
  | Coq_wConsoleErr x -> f x
  | Coq_wFatalError x -> f0 x
  | Coq_wBad x -> f1 x
  
  (** val wOutput_rec :
      (char list -> 'a1) -> (char list -> 'a1) -> (char list -> 'a1) ->
      wOutput -> 'a1 **)
  
  let wOutput_rec f f0 f1 = function
  | Coq_wConsoleErr x -> f x
  | Coq_wFatalError x -> f0 x
  | Coq_wBad x -> f1 x
  
  (** val newline : char **)
  
  let newline =
    '\n'
  
  (** val newlineS : char list **)
  
  let newlineS =
    newline::[]
  
  (** val emit : (wOutput -> 'a1 action) -> char list -> 'a1 action **)
  
  let emit handle body =
    handle (Coq_wConsoleErr
      (append
        ('W'::('A'::('R'::('N'::('I'::('N'::('G'::(':'::(' '::[])))))))))
        body))
  
  (** val debugMsg :
      (wOutput -> 'a1 action) -> Big.big_int -> char list -> char list ->
      Big.big_int -> 'a1 action **)
  
  let debugMsg handle debug component body level =
    if N.leb level debug
    then handle (Coq_wConsoleErr
           (append ('D'::('E'::('B'::('U'::('G'::(' '::('('::[])))))))
             (append component (append (')'::(':'::(' '::[]))) body))))
    else id
  
  (** val labelTBStateTransition :
      'a1 serializable -> 'a1 tickBoxPreState -> 'a1 tickBoxPreState -> 'a1
      tbInput -> char list **)
  
  let labelTBStateTransition h0 old new0 ev =
    append ('f'::('r'::('o'::('m'::[]))))
      (append newlineS
        (append (' '::(' '::[]))
          (append (to_string (tickBoxState_Serializable h0) old)
            (append newlineS
              (append ('t'::('o'::(' '::('('::[]))))
                (append
                  (to_string
                    (serializable_sum tbConfigInput_Serializable
                      (tbEventInput_Serializable h0)) ev)
                  (append (')'::[])
                    (append newlineS
                      (append (' '::(' '::[]))
                        (to_string (tickBoxState_Serializable h0) new0))))))))))
  
  (** val labelTGBStateTransition :
      gatewayState -> gatewayState -> tickGInput -> char list **)
  
  let labelTGBStateTransition old new0 ev =
    append ('f'::('r'::('o'::('m'::[]))))
      (append newlineS
        (append (' '::(' '::[]))
          (append (to_string gatewayState_Serializable old)
            (append newlineS
              (append ('t'::('o'::(' '::('('::[]))))
                (append (to_string tickGInput_Serializable ev)
                  (append (')'::[])
                    (append newlineS
                      (append (' '::(' '::[]))
                        (to_string gatewayState_Serializable new0))))))))))
  
  (** val emitTB :
      (wOutput -> 'a1 action) -> 'a2 serializable -> Big.big_int -> 'a2
      tbWarningOutput -> char list -> 'a1 action **)
  
  let emitTB handle h0 debug ev component =
    let pre =
      append
        ('I'::('n'::(' '::('c'::('o'::('m'::('p'::('o'::('n'::('e'::('n'::('t'::(' '::('\''::[]))))))))))))))
        (append component ('\''::(','::(' '::[]))))
    in
    (match ev with
     | TbWarnNoDataReady ->
       handle (Coq_wBad
         (append pre
           ('d'::('a'::('t'::('a'::(' '::('w'::('a'::('s'::(' '::('n'::('o'::('t'::(' '::('r'::('e'::('a'::('d'::('y'::(' '::('t'::('o'::(' '::('s'::('e'::('n'::('d'::[]))))))))))))))))))))))))))))
     | TbWarnTicksTooInfrequent ticks ->
       emit handle
         (append pre
           (append
             ('t'::('i'::('c'::('k'::(' '::('s'::('t'::('a'::('r'::('v'::('a'::('t'::('i'::('o'::('n'::(' '::('i'::('s'::(' '::('o'::('c'::('c'::('u'::('r'::('i'::('n'::('g'::(':'::(' '::[])))))))))))))))))))))))))))))
             (to_string serializable_N ticks)))
     | TbWarnInvalidWaitBeforeUpdateInterval n ->
       handle (Coq_wBad
         (append pre
           ('i'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('w'::('a'::('i'::('t'::[]))))))))))))))
     | TbWarnInvalidEvent (st, ev') ->
       handle (Coq_wBad
         (append pre
           ('i'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('e'::('v'::('e'::('n'::('t'::[])))))))))))))))
     | TbDebugStateTransition (old, new0, ev') ->
       debugMsg handle debug component
         (labelTBStateTransition h0 old new0 ev') (Big.doubleplusone Big.one))
  
  (** val wLoopBody :
      (wOutput -> 'a1 action) -> (Big.big_int -> (wInput, 'a1) process) ->
      Big.big_int -> wInput -> 'a1 action * (wInput, 'a1) process **)
  
  let wLoopBody handle wLoop debug = function
  | Inl s ->
    (match s with
     | SSB.Coq_ssbGetUpdateWarning ev ->
       ((emitTB handle serializable_unit debug ev
          ('G'::('e'::('t'::(' '::('U'::('p'::('d'::('a'::('t'::('e'::(' '::('B'::('o'::('x'::[]))))))))))))))),
         (wLoop debug))
     | SSB.Coq_ssbCASWarning ev ->
       ((emitTB handle serializable_string debug ev
          ('C'::('o'::('m'::('p'::('a'::('r'::('e'::(' '::('A'::('n'::('d'::(' '::('S'::('e'::('t'::(' '::('B'::('o'::('x'::[])))))))))))))))))))),
         (wLoop debug))
     | SSB.Coq_ssbEncryptError e ->
       (match e with
        | SSB.TEB.Coq_ebErrorNotEnoughRandomness (howMuch, given) ->
          ((handle (Coq_wConsoleErr
             (append
               ('N'::('o'::('t'::(' '::('e'::('n'::('o'::('u'::('g'::('h'::(' '::('r'::('a'::('n'::('d'::('o'::('m'::('n'::('e'::('s'::('s'::(':'::(' '::('w'::('a'::('n'::('t'::('e'::('d'::(' '::[]))))))))))))))))))))))))))))))
               (append (to_string serializable_nat howMuch)
                 (append
                   (','::(' '::('b'::('u'::('t'::(' '::('g'::('o'::('t'::(' '::('t'::('h'::('e'::(' '::('s'::('t'::('r'::('i'::('n'::('g'::(':'::(' '::('\''::[])))))))))))))))))))))))
                   (append given ('\''::[]))))))), (wLoop debug))
        | SSB.TEB.Coq_ebErrorInvalidMasterKey key0 ->
          ((handle (Coq_wFatalError
             (append
               ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('M'::('a'::('s'::('t'::('e'::('r'::(' '::('K'::('e'::('y'::(':'::(' '::[]))))))))))))))))))))
               key0))), (wLoop debug))
        | SSB.TEB.Coq_ebErrorNoMasterKey ->
          ((handle (Coq_wBad
             ('N'::('o'::(' '::('M'::('a'::('s'::('t'::('e'::('r'::(' '::('K'::('e'::('y'::(' '::('i'::('n'::(' '::('e'::('n'::('c'::('r'::('y'::('p'::('t'::('i'::('o'::('n'::(' '::('b'::('o'::('x'::[]))))))))))))))))))))))))))))))))),
            (wLoop debug)))
     | SSB.Coq_ssbDecryptError d ->
       (match d with
        | SSB.TDB.Coq_dbErrorInvalidData (data, tag) ->
          ((handle (Coq_wConsoleErr
             (append
               ('S'::('e'::('r'::('v'::('e'::('r'::(' '::('g'::('o'::('t'::(' '::('c'::('o'::('r'::('r'::('u'::('p'::('t'::('e'::('d'::(' '::('-'::(' '::('e'::('n'::('c'::('r'::('y'::('p'::('t'::('e'::('d'::(' '::('d'::('a'::('t'::('a'::(' '::('r'::('e'::('c'::('i'::('e'::('v'::('e'::('d'::(' '::('i'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))
               data))), (wLoop debug))
        | SSB.TDB.Coq_dbErrorInvalidMasterKey key0 ->
          ((handle (Coq_wFatalError
             (append
               ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('M'::('a'::('s'::('t'::('e'::('r'::(' '::('K'::('e'::('y'::(':'::(' '::[]))))))))))))))))))))
               key0))), (wLoop debug))
        | SSB.TDB.Coq_dbErrorNoMasterKey ->
          ((handle (Coq_wBad
             ('N'::('o'::(' '::('M'::('a'::('s'::('t'::('e'::('r'::(' '::('K'::('e'::('y'::(' '::('i'::('n'::(' '::('d'::('e'::('c'::('r'::('y'::('p'::('t'::('i'::('o'::('n'::(' '::('b'::('o'::('x'::[]))))))))))))))))))))))))))))))))),
            (wLoop debug)))
     | SSB.Coq_ssbWarningInvalidTransition (ev', st') ->
       ((handle (Coq_wBad
          ('S'::('e'::('r'::('v'::('e'::('r'::(' '::('S'::('y'::('n'::('c'::(' '::('B'::('o'::('x'::(' '::('i'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('r'::('a'::('n'::('s'::('i'::('t'::('i'::('o'::('n'::[])))))))))))))))))))))))))))))))))))),
         (wLoop debug))
     | SSB.Coq_ssbWarningPushBeforePull ->
       ((emit handle
          ('C'::('a'::('n'::('n'::('o'::('t'::(' '::('d'::('o'::(' '::('a'::(' '::('s'::('e'::('r'::('v'::('e'::('r'::('-'::('c'::('o'::('m'::('p'::('a'::('r'::('e'::('-'::('a'::('n'::('d'::('-'::('s'::('w'::('a'::('p'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('o'::('b'::('t'::('a'::('i'::('n'::('i'::('n'::('g'::(' '::('s'::('e'::('r'::('v'::('e'::('r'::('\''::('s'::(' '::('c'::('u'::('r'::('r'::('e'::('n'::('t'::(' '::('s'::('t'::('a'::('t'::('e'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
         (wLoop debug)))
  | Inr t0 ->
    let TGDebugStateTransition (old, new0, ev') = t0 in
    ((debugMsg handle debug
       ('T'::('i'::('c'::('k'::(' '::('G'::('e'::('n'::('e'::('r'::('a'::('t'::('o'::('r'::[]))))))))))))))
       (labelTGBStateTransition old new0 ev') (Big.double Big.one)),
    (wLoop debug))
  
  (** val warningBox :
      (wOutput -> 'a1 action) -> Big.big_int -> (wInput, 'a1) process **)
  
  let rec warningBox handle debug =
    lazy (Step (wLoopBody handle (warningBox handle) debug))
 end

(** val storageURI : char list **)

let storageURI =
  'h'::('t'::('t'::('p'::('s'::(':'::('/'::('/'::('a'::('n'::('d'::('e'::('r'::('s'::('k'::('.'::('s'::('c'::('r'::('i'::('p'::('t'::('s'::('.'::('m'::('i'::('t'::('.'::('e'::('d'::('u'::('/'::('p'::('w'::('m'::('g'::('r'::('/'::('s'::('t'::('o'::('r'::('a'::('g'::('e'::[]))))))))))))))))))))))))))))))))))))))))))))

(** val storageGet :
    (char list -> (char list * char list) list -> (('a1, httpResponse)
    abortable -> 'a3) -> 'a2 action) -> char list -> (('a1, (char list,
    httpResponse) sum) abortable -> 'a3) -> 'a2 action **)

let storageGet httpPOST0 id0 cb =
  httpPOST0 (append storageURI ('/'::('g'::('e'::('t'::[])))))
    ((('i'::('d'::[])), id0) :: []) (fun ra ->
    match ra with
    | Started abort0 -> cb (Started abort0)
    | Done r ->
      (match r.httpResponseStatus with
       | HttpOk -> cb (Done (Inl r.httpResponseBody))
       | HttpPreconditionFailed -> cb (Done (Inr r))
       | HttpUnrecognizedCode -> cb (Done (Inr r))))

(** val storageSet :
    (char list -> (char list * char list) list -> (('a1, httpResponse)
    abortable -> 'a3) -> 'a2 action) -> char list -> char list -> char list
    -> (('a1, (char list option, httpResponse) sum) abortable -> 'a3) -> 'a2
    action **)

let storageSet httpPOST0 id0 old new0 cb =
  httpPOST0 (append storageURI ('/'::('s'::('e'::('t'::[])))))
    ((('i'::('d'::[])), id0) :: ((('o'::('l'::('d'::[]))),
    old) :: ((('n'::('e'::('w'::[]))), new0) :: []))) (fun ra ->
    match ra with
    | Started abort0 -> cb (Started abort0)
    | Done r ->
      (match r.httpResponseStatus with
       | HttpOk -> cb (Done (Inl None))
       | HttpPreconditionFailed -> cb (Done (Inl (Some r.httpResponseBody)))
       | HttpUnrecognizedCode -> cb (Done (Inr r))))

(** val storagePoll :
    (char list -> (char list * char list) list -> (('a1, httpResponse)
    abortable -> 'a3) -> 'a2 action) -> char list -> char list -> (('a1,
    (char list, httpResponse) sum) abortable -> 'a3) -> 'a2 action **)

let storagePoll httpPOST0 id0 old cb =
  httpPOST0 (append storageURI ('/'::('p'::('o'::('l'::('l'::[]))))))
    ((('i'::('d'::[])), id0) :: ((('o'::('l'::('d'::[]))), old) :: []))
    (fun ra ->
    match ra with
    | Started abort0 -> cb (Started abort0)
    | Done r ->
      (match r.httpResponseStatus with
       | HttpOk -> cb (Done (Inl r.httpResponseBody))
       | HttpPreconditionFailed -> cb (Done (Inr r))
       | HttpUnrecognizedCode -> cb (Done (Inr r))))

type 'world0 netInput =
| NetStarted of 'world0 action
| NetGetUpdate
| NetCAS of char list * char list
| NetSendGotUpdate of char list
| NetHttpError of httpResponse

type 'world0 netOutput =
| NetLift of 'world0 action
| NetGotUpdate of char list
| NetHttpPOST of char list * (char list * char list) list
   * (('world0, httpResponse) abortable -> 'world0 netInput)

(** val sendHttpPOST :
    ('a1 netOutput -> 'a2 action) -> char list -> (char list * char list)
    list -> (('a1, httpResponse) abortable -> 'a1 netInput) -> 'a2 action **)

let sendHttpPOST send uri data cb =
  send (NetHttpPOST (uri, data, cb))

(** val netGetUpdateCallback :
    ('a1, (char list, httpResponse) sum) abortable -> 'a1 netInput **)

let netGetUpdateCallback = function
| Started abort0 -> NetStarted abort0
| Done y ->
  (match y with
   | Inl new0 -> NetSendGotUpdate new0
   | Inr r -> NetHttpError r)

(** val netCASCallback :
    char list -> ('a1, (char list option, httpResponse) sum) abortable -> 'a1
    netInput **)

let netCASCallback new0 = function
| Started abort0 -> NetStarted abort0
| Done y ->
  (match y with
   | Inl y1 ->
     (match y1 with
      | Some other -> NetSendGotUpdate other
      | None -> NetSendGotUpdate new0)
   | Inr r -> NetHttpError r)

(** val netLoop :
    ('a1 netOutput -> 'a2 action) -> char list -> 'a1 action -> ('a1
    netInput, 'a2) process **)

let rec netLoop send storageId0 abort0 =
  lazy (Step (fun i ->
    match i with
    | NetStarted abort' -> (id, (netLoop send storageId0 abort'))
    | NetGetUpdate ->
      ((compose (send (NetLift abort0))
         (storageGet (sendHttpPOST send) storageId0 netGetUpdateCallback)),
        (netLoop send storageId0 id))
    | NetCAS (old, new0) ->
      ((compose (send (NetLift abort0))
         (storageSet (sendHttpPOST send) storageId0 old new0
           (netCASCallback new0))), (netLoop send storageId0 id))
    | NetSendGotUpdate new0 ->
      ((compose (send (NetGotUpdate new0))
         (storagePoll (sendHttpPOST send) storageId0 new0
           netGetUpdateCallback)), (netLoop send storageId0 id))
    | NetHttpError r -> (id, (netLoop send storageId0 id))))

(** val net :
    ('a1 netOutput -> 'a2 action) -> char list -> ('a1 netInput, 'a2) process **)

let net send storageId0 =
  netLoop send storageId0 id

(** val getStep :
    ('a1, 'a2) process -> 'a1 -> 'a2 action * ('a1, 'a2) process **)

let getStep p =
  let Step f = Lazy.force p in f

module MakePwMgr = 
 functor (KVStore:sig 
  type key = char list
  
  type 'x t 
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val find : key -> 'a1 t -> 'a1 option
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
  
  val coq_Serializable_map : 'a1 serializable -> 'a1 t serializable
  
  val coq_Deserializable_map : 'a1 deserializable -> 'a1 t deserializable
  
  val coq_PrefixSerializable_map :
    'a1 prefixSerializable -> 'a1 t prefixSerializable
  
  val merge : 'a1 t -> 'a1 t -> 'a1 t
 end) ->
 functor (Algorithm:sig 
  val isValidMasterKey : EncryptionStringDataTypes.masterKeyT -> bool
  
  val randomnessHint :
    EncryptionStringDataTypes.rawDataT ->
    EncryptionStringDataTypes.systemRandomnessHintT
  
  val encrypt :
    EncryptionStringDataTypes.systemRandomnessT ->
    EncryptionStringDataTypes.masterKeyT ->
    EncryptionStringDataTypes.rawDataT ->
    (EncryptionStringDataTypes.encryptedDataT,
    (EncryptionStringDataTypes.systemRandomnessHintT,
    EncryptionStringDataTypes.systemRandomnessT) encryptionError) sum
  
  val decrypt :
    EncryptionStringDataTypes.masterKeyT ->
    EncryptionStringDataTypes.encryptedDataT ->
    (EncryptionStringDataTypes.rawDataT, __) sum
 end) ->
 struct 
  module SSB = TrustedServerSyncBox(EncryptionStringDataTypes)(Algorithm)
  
  module WB = PwMgrWarningBox(Algorithm)
  
  module UI = PwMgrUI(KVStore)
  
  (** val eta_ebError : SSB.TEB.ebErrorOutput -> WB.SSB.TEB.ebErrorOutput **)
  
  let eta_ebError = function
  | SSB.TEB.Coq_ebErrorNotEnoughRandomness (howMuchWanted, randomnessGiven) ->
    WB.SSB.TEB.Coq_ebErrorNotEnoughRandomness (howMuchWanted,
      randomnessGiven)
  | SSB.TEB.Coq_ebErrorInvalidMasterKey key0 ->
    WB.SSB.TEB.Coq_ebErrorInvalidMasterKey key0
  | SSB.TEB.Coq_ebErrorNoMasterKey -> WB.SSB.TEB.Coq_ebErrorNoMasterKey
  
  (** val eta_dbError :
      'a1 SSB.TDB.dbErrorOutput -> 'a1 WB.SSB.TDB.dbErrorOutput **)
  
  let eta_dbError = function
  | SSB.TDB.Coq_dbErrorInvalidData (data, tag) ->
    WB.SSB.TDB.Coq_dbErrorInvalidData (data, tag)
  | SSB.TDB.Coq_dbErrorInvalidMasterKey key0 ->
    WB.SSB.TDB.Coq_dbErrorInvalidMasterKey key0
  | SSB.TDB.Coq_dbErrorNoMasterKey -> WB.SSB.TDB.Coq_dbErrorNoMasterKey
  
  (** val eta_ssbConfigInput :
      SSB.ssbConfigInput -> WB.SSB.ssbConfigInput **)
  
  let eta_ssbConfigInput = function
  | SSB.Coq_ssbGetUpdateConfig b -> WB.SSB.Coq_ssbGetUpdateConfig b
  | SSB.Coq_ssbCASConfig b -> WB.SSB.Coq_ssbCASConfig b
  | SSB.Coq_ssbSetMasterKey key0 -> WB.SSB.Coq_ssbSetMasterKey key0
  
  (** val eta_ssbEventInput : SSB.ssbEventInput -> WB.SSB.ssbEventInput **)
  
  let eta_ssbEventInput = function
  | SSB.Coq_ssbClientGetUpdate -> WB.SSB.Coq_ssbClientGetUpdate
  | SSB.Coq_ssbClientSet newD -> WB.SSB.Coq_ssbClientSet newD
  | SSB.Coq_ssbServerGotUpdate newE -> WB.SSB.Coq_ssbServerGotUpdate newE
  | SSB.Coq_ssbSystemRandomness (randomness, tag) ->
    WB.SSB.Coq_ssbSystemRandomness (randomness, tag)
  | SSB.Coq_ssbTick n -> WB.SSB.Coq_ssbTick n
  
  (** val eta_ssbInput : SSB.ssbInput -> WB.SSB.ssbInput **)
  
  let eta_ssbInput = function
  | Inl x -> Inl (eta_ssbConfigInput x)
  | Inr x -> Inr (eta_ssbEventInput x)
  
  (** val eta_EncryptBoxState :
      SSB.TEB.coq_EncryptBoxState -> WB.SSB.TEB.coq_EncryptBoxState **)
  
  let eta_EncryptBoxState a =
    SSB.TEB.masterKey a
  
  (** val eta_DecryptBoxState :
      SSB.TDB.coq_DecryptBoxState -> WB.SSB.TDB.coq_DecryptBoxState **)
  
  let eta_DecryptBoxState a =
    SSB.TDB.masterKey a
  
  (** val eta_ServerSyncBoxPreState :
      SSB.coq_ServerSyncBoxPreState -> WB.SSB.coq_ServerSyncBoxPreState **)
  
  let eta_ServerSyncBoxPreState a =
    { WB.SSB.localStateD = (SSB.localStateD a); WB.SSB.remoteStateE =
      (SSB.remoteStateE a) }
  
  (** val eta_ServerSyncBoxState :
      SSB.coq_ServerSyncBoxState -> WB.SSB.coq_ServerSyncBoxState **)
  
  let eta_ServerSyncBoxState a =
    { WB.SSB.ssbState = (eta_ServerSyncBoxPreState (SSB.ssbState a));
      WB.SSB.ssbGetUpdateState = (SSB.ssbGetUpdateState a);
      WB.SSB.ssbCASState = (SSB.ssbCASState a); WB.SSB.ssbEncryptState =
      (eta_EncryptBoxState (SSB.ssbEncryptState a)); WB.SSB.ssbDecryptState =
      (eta_DecryptBoxState (SSB.ssbDecryptState a)) }
  
  (** val eta_ssbWarning :
      SSB.ssbWarningOutput -> WB.SSB.ssbWarningOutput **)
  
  let eta_ssbWarning = function
  | SSB.Coq_ssbGetUpdateWarning b -> WB.SSB.Coq_ssbGetUpdateWarning b
  | SSB.Coq_ssbCASWarning b -> WB.SSB.Coq_ssbCASWarning b
  | SSB.Coq_ssbEncryptError b -> WB.SSB.Coq_ssbEncryptError (eta_ebError b)
  | SSB.Coq_ssbDecryptError b -> WB.SSB.Coq_ssbDecryptError (eta_dbError b)
  | SSB.Coq_ssbWarningInvalidTransition (ev, st) ->
    WB.SSB.Coq_ssbWarningInvalidTransition ((eta_ssbInput ev),
      (eta_ServerSyncBoxState st))
  | SSB.Coq_ssbWarningPushBeforePull -> WB.SSB.Coq_ssbWarningPushBeforePull
  
  type 'world input =
  | Coq_pwMgrFatal of char list
  | Coq_pwMgrConfigure of Big.big_int
  | Coq_pwMgrInit of char list
  | Coq_pwMgrConsoleIn of char list
  | Coq_pwUI of UI.uiInput
  | Coq_pwW of WB.wInput
  | Coq_pwSSB of SSB.ssbInput
  | Coq_pwNET of 'world netInput
  | Coq_pwTG of tickGInput
  
  (** val input_rect :
      (char list -> 'a2) -> (Big.big_int -> 'a2) -> (char list -> 'a2) ->
      (char list -> 'a2) -> (UI.uiInput -> 'a2) -> (WB.wInput -> 'a2) ->
      (SSB.ssbInput -> 'a2) -> ('a1 netInput -> 'a2) -> (tickGInput -> 'a2)
      -> 'a1 input -> 'a2 **)
  
  let input_rect f f0 f1 f2 f3 f4 f5 f6 f7 = function
  | Coq_pwMgrFatal x -> f x
  | Coq_pwMgrConfigure x -> f0 x
  | Coq_pwMgrInit x -> f1 x
  | Coq_pwMgrConsoleIn x -> f2 x
  | Coq_pwUI x -> f3 x
  | Coq_pwW x -> f4 x
  | Coq_pwSSB x -> f5 x
  | Coq_pwNET x -> f6 x
  | Coq_pwTG x -> f7 x
  
  (** val input_rec :
      (char list -> 'a2) -> (Big.big_int -> 'a2) -> (char list -> 'a2) ->
      (char list -> 'a2) -> (UI.uiInput -> 'a2) -> (WB.wInput -> 'a2) ->
      (SSB.ssbInput -> 'a2) -> ('a1 netInput -> 'a2) -> (tickGInput -> 'a2)
      -> 'a1 input -> 'a2 **)
  
  let input_rec f f0 f1 f2 f3 f4 f5 f6 f7 = function
  | Coq_pwMgrFatal x -> f x
  | Coq_pwMgrConfigure x -> f0 x
  | Coq_pwMgrInit x -> f1 x
  | Coq_pwMgrConsoleIn x -> f2 x
  | Coq_pwUI x -> f3 x
  | Coq_pwW x -> f4 x
  | Coq_pwSSB x -> f5 x
  | Coq_pwNET x -> f6 x
  | Coq_pwTG x -> f7 x
  
  (** val one_second : Big.big_int **)
  
  let one_second =
    (Big.double (Big.double (Big.double (Big.double (Big.double (Big.double
      (Big.double (Big.double (Big.double (Big.doubleplusone (Big.double
      (Big.doubleplusone (Big.double (Big.double (Big.doubleplusone
      (Big.doubleplusone (Big.double (Big.doubleplusone (Big.double
      (Big.doubleplusone (Big.doubleplusone (Big.double (Big.double
      (Big.doubleplusone (Big.doubleplusone (Big.doubleplusone (Big.double
      (Big.doubleplusone (Big.doubleplusone
      Big.one)))))))))))))))))))))))))))))
  
  (** val abort :
      ('a1 input, 'a1) systemActions -> char list -> 'a1 -> 'a1 **)
  
  let abort sys msg =
    compose (sys.consoleErr msg)
      (sys.exit (Big.doubleplusone (Big.doubleplusone (Big.doubleplusone
        (Big.doubleplusone (Big.doubleplusone (Big.doubleplusone
        (Big.doubleplusone Big.one))))))))
  
  (** val hang : ('a1, 'a2) process **)
  
  let rec hang =
    lazy (Step (fun x -> (id, hang)))
  
  (** val pwMgrLoopBody :
      ('a1 input, 'a1) systemActions -> ((SSB.ssbInput, ('a1 input, 'a1)
      stackWorld) process -> (WB.wInput, ('a1 input, 'a1) stackWorld) process
      -> (UI.uiInput, ('a1 input, 'a1) stackWorld) process -> ('a1 netInput,
      ('a1 input, 'a1) stackWorld) process -> (tickGInput, ('a1 input, 'a1)
      stackWorld) process -> ('a1 input, 'a1) stackProcess) -> (SSB.ssbInput,
      ('a1 input, 'a1) stackWorld) process -> (WB.wInput, ('a1 input, 'a1)
      stackWorld) process -> (UI.uiInput, ('a1 input, 'a1) stackWorld)
      process -> ('a1 netInput, ('a1 input, 'a1) stackWorld) process ->
      (tickGInput, ('a1 input, 'a1) stackWorld) process -> 'a1 input -> ('a1
      input, 'a1) stackWorld action * ('a1 input, 'a1) stackProcess **)
  
  let pwMgrLoopBody sys pwMgrLoop0 ssb wb ui0 net0 tickG0 = function
  | Coq_pwMgrFatal msg -> ((fun x -> StackLift ((abort sys msg), x)), hang)
  | Coq_pwMgrConfigure debug ->
    ((fun x -> StackLift
      ((abort sys
         ('U'::('N'::('E'::('X'::('P'::('E'::('C'::('T'::('E'::('D'::(' '::('I'::('N'::('P'::('U'::('T'::[]))))))))))))))))),
      x)), hang)
  | Coq_pwMgrInit key0 ->
    ((compose
       (compose (fun x -> StackPush ((Coq_pwSSB (Inl (SSB.Coq_ssbSetMasterKey
         key0))), x)) (fun x -> StackPush ((Coq_pwNET NetGetUpdate), x)))
       (fun x -> StackLift
       ((sys.sleepNanosecs one_second (Coq_pwTG TGWakeUp)), x))),
      (pwMgrLoop0 ssb wb ui0 net0 tickG0))
  | Coq_pwMgrConsoleIn s ->
    ((compose (fun x -> StackPush ((Coq_pwUI (UI.Coq_uiConsoleIn s)), x))
       (fun x -> StackLift
       ((sys.consoleIn (fun x0 -> Coq_pwMgrConsoleIn x0)), x))),
      (pwMgrLoop0 ssb wb ui0 net0 tickG0))
  | Coq_pwUI ev ->
    let (a, ui') = getStep ui0 ev in (a, (pwMgrLoop0 ssb wb ui' net0 tickG0))
  | Coq_pwW ev ->
    let (a, wb') = getStep wb ev in (a, (pwMgrLoop0 ssb wb' ui0 net0 tickG0))
  | Coq_pwSSB ev ->
    let (a, ssb') = getStep ssb ev in
    (a, (pwMgrLoop0 ssb' wb ui0 net0 tickG0))
  | Coq_pwNET ev ->
    let (a, net') = getStep net0 ev in
    (a, (pwMgrLoop0 ssb wb ui0 net' tickG0))
  | Coq_pwTG ev ->
    let (a, tickG') = getStep tickG0 ev in
    (a, (pwMgrLoop0 ssb wb ui0 net0 tickG'))
  
  (** val pwMgrLoop :
      ('a1 input, 'a1) systemActions -> (SSB.ssbInput, ('a1 input, 'a1)
      stackWorld) process -> (WB.wInput, ('a1 input, 'a1) stackWorld) process
      -> (UI.uiInput, ('a1 input, 'a1) stackWorld) process -> ('a1 netInput,
      ('a1 input, 'a1) stackWorld) process -> (tickGInput, ('a1 input, 'a1)
      stackWorld) process -> ('a1 input, 'a1) stackProcess **)
  
  let rec pwMgrLoop sys ssb wb ui0 net0 tickG0 =
    lazy (Step (pwMgrLoopBody sys (pwMgrLoop sys) ssb wb ui0 net0 tickG0))
  
  (** val wrap_ui :
      ('a1 input, 'a1) systemActions -> (__ -> (UI.uiOutput -> __ action) ->
      (UI.uiInput, __) process) -> (UI.uiInput, ('a1 input, 'a1) stackWorld)
      process **)
  
  let wrap_ui sys ui0 =
    Obj.magic ui0 __ (fun i x ->
      match i with
      | UI.Coq_uiGetUpdate ->
        StackPush ((Coq_pwSSB (Inr SSB.Coq_ssbClientGetUpdate)), x)
      | UI.Coq_uiSetData data ->
        StackPush ((Coq_pwSSB (Inr (SSB.Coq_ssbClientSet data))), x)
      | UI.Coq_uiConsoleOut data -> StackLift ((sys.consoleOut data), x))
  
  (** val wrap_wb :
      ('a1 input, 'a1) systemActions -> (__ -> (WB.wOutput -> __ action) ->
      (WB.wInput, __) process) -> (WB.wInput, ('a1 input, 'a1) stackWorld)
      process **)
  
  let wrap_wb sys wb =
    Obj.magic wb __ (fun i x ->
      match i with
      | WB.Coq_wConsoleErr lines -> StackLift ((sys.consoleErr lines), x)
      | WB.Coq_wFatalError msg -> StackLift ((abort sys msg), x)
      | WB.Coq_wBad msg -> StackLift ((abort sys msg), x))
  
  (** val wrap_ssb :
      ('a1 input, 'a1) systemActions -> (__ -> (SSB.ssbOutput -> __ action)
      -> (SSB.ssbInput, __) process) -> (SSB.ssbInput, ('a1 input, 'a1)
      stackWorld) process **)
  
  let wrap_ssb sys ssb =
    Obj.magic ssb __ (fun i x ->
      match i with
      | Inl warning ->
        StackPush ((Coq_pwW
          (WB.Coercions.wInput_of_ssb (eta_ssbWarning warning))), x)
      | Inr s ->
        (match s with
         | SSB.Coq_ssbClientGotUpdate data ->
           StackPush ((Coq_pwUI (UI.Coq_uiGotUpdate data)), x)
         | SSB.Coq_ssbServerGetUpdate ->
           StackPush ((Coq_pwNET NetGetUpdate), x)
         | SSB.Coq_ssbServerCAS (cur, new0) ->
           StackPush ((Coq_pwNET (NetCAS (cur, new0))), x)
         | SSB.Coq_ssbRequestSystemRandomness (howMuch, tag) ->
           StackLift
             ((sys.getRandomness (N.of_nat howMuch)
                (compose
                  (compose (fun x0 -> Coq_pwSSB x0) (fun x0 -> Inr x0))
                  (flip (fun x0 x1 -> SSB.Coq_ssbSystemRandomness (x0, x1))
                    tag))), x)
         | SSB.Coq_ssbSleepFor ticks ->
           StackPush ((Coq_pwTG (TGWantWakeupIn ticks)), x)))
  
  (** val wrap_net :
      ('a1 input, 'a1) systemActions -> (__ -> __ -> (__ netOutput -> __
      action) -> (__ netInput, __) process) -> ('a1 netInput, ('a1 input,
      'a1) stackWorld) process **)
  
  let wrap_net sys net0 =
    Obj.magic net0 __ __ (fun i x ->
      match i with
      | NetLift a -> StackLift (a, x)
      | NetGotUpdate new0 ->
        StackPush ((Coq_pwSSB (Inr (SSB.Coq_ssbServerGotUpdate new0))), x)
      | NetHttpPOST (uri, data, cb) ->
        StackLift ((sys.httpPOST uri data (fun r -> Coq_pwNET (cb r))), x))
  
  (** val wrap_tickG :
      ('a1 input, 'a1) systemActions -> (__ -> (tickGOutput -> __ action) ->
      (tickGInput, __) process) -> (tickGInput, ('a1 input, 'a1) stackWorld)
      process **)
  
  let wrap_tickG sys tickG0 =
    Obj.magic tickG0 __ (fun i x ->
      match i with
      | Inl warning ->
        StackPush ((Coq_pwW (WB.Coercions.wInput_of_tg warning)), x)
      | Inr t0 ->
        (match t0 with
         | TGGetNanosecs ->
           StackLift
             ((sys.getNanosecs
                (compose (fun x0 -> Coq_pwTG x0) (fun x0 -> TGClocksGot x0))),
             x)
         | TGTick n -> StackPush ((Coq_pwSSB (Inr (SSB.Coq_ssbTick n))), x)
         | TGSystemSleep n ->
           StackLift ((sys.sleepNanosecs n (Coq_pwTG TGWakeUp)), x)))
  
  (** val mkPwMgrStack :
      ('a1 input, 'a1) systemActions -> (__ -> (SSB.ssbOutput -> __ action)
      -> (SSB.ssbInput, __) process) -> (__ -> (WB.wOutput -> __ action) ->
      (WB.wInput, __) process) -> (__ -> (UI.uiOutput -> __ action) ->
      (UI.uiInput, __) process) -> (__ -> __ -> (__ netOutput -> __ action)
      -> (__ netInput, __) process) -> (__ -> (tickGOutput -> __ action) ->
      (tickGInput, __) process) -> ('a1 input, 'a1) stackProcess **)
  
  let mkPwMgrStack sys ssb wb ui0 net0 tickG0 =
    pwMgrLoop sys (wrap_ssb sys ssb) (wrap_wb sys wb) (wrap_ui sys ui0)
      (wrap_net sys net0) (wrap_tickG sys tickG0)
  
  (** val pwMgrStack :
      ('a1 input, 'a1) systemActions -> EncryptionStringDataTypes.rawDataT ->
      char list -> Big.big_int -> (__ -> (tickGOutput -> __ action) ->
      (tickGInput, __) process) -> ('a1 input, 'a1) stackProcess **)
  
  let pwMgrStack sys initStore0 storageId0 debug =
    mkPwMgrStack sys (fun _ ->
      SSB.serverSyncBox (fun s1 s2 ->
        if string_dec s1 s2 then true else false) initStore0)
      (fun _ handle -> WB.warningBox handle debug) (fun _ -> UI.ui)
      (fun _ _ handle -> net handle storageId0)
  
  (** val initStore : char list **)
  
  let initStore =
    []
  
  (** val storageId : char list **)
  
  let storageId =
    'f'::('o'::('o'::[]))
  
  (** val getMasterKeyLoop :
      ('a1 input, 'a1) systemActions -> Big.big_int -> ('a1 input, 'a1)
      process **)
  
  let getMasterKeyLoop sys debug =
    lazy (Step (fun i ->
      match i with
      | Coq_pwMgrConsoleIn key0 ->
        let Step f = Lazy.force
          (runStackProcess
            (pwMgrStack sys initStore storageId debug (fun _ -> tickG)))
        in
        let (a, p) = f (Coq_pwMgrInit key0) in
        ((compose (sys.consoleIn (fun x -> Coq_pwMgrConsoleIn x)) a), p)
      | _ ->
        ((abort sys
           ('U'::('N'::('E'::('X'::('P'::('E'::('C'::('T'::('E'::('D'::(' '::('I'::('N'::('P'::('U'::('T'::[]))))))))))))))))),
          hang)))
  
  (** val getMasterKey :
      ('a1 input, 'a1) systemActions -> Big.big_int -> ('a1 -> 'a1) * ('a1
      input, 'a1) process **)
  
  let getMasterKey sys debug =
    ((compose
       (compose (sys.setDebug debug)
         (sys.consoleOut
           ('E'::('n'::('t'::('e'::('r'::(' '::('y'::('o'::('u'::('r'::(' '::('m'::('a'::('s'::('t'::('e'::('r'::(' '::('k'::('e'::('y'::(':'::[]))))))))))))))))))))))))
       (sys.consoleIn (fun x -> Coq_pwMgrConsoleIn x))),
      (getMasterKeyLoop sys debug))
  
  (** val parseFlag :
      char list -> Big.big_int -> char list -> (Big.big_int -> 'a1 input) ->
      'a1 input **)
  
  let rec parseFlag argv0 debug flag next =
    match flag with
    | [] -> next debug
    | a::flag' ->
      (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
        (fun b b0 b1 b2 b3 b4 b5 b6 ->
        if b
        then Coq_pwMgrFatal
               (append ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                 argv0)
        else if b0
             then Coq_pwMgrFatal
                    (append
                      ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                      argv0)
             else if b1
                  then if b2
                       then Coq_pwMgrFatal
                              (append
                                ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                argv0)
                       else if b3
                            then Coq_pwMgrFatal
                                   (append
                                     ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                     argv0)
                            else if b4
                                 then if b5
                                      then if b6
                                           then Coq_pwMgrFatal
                                                  (append
                                                    ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                                    argv0)
                                           else parseFlag argv0
                                                  (N.add debug Big.one) flag'
                                                  next
                                      else Coq_pwMgrFatal
                                             (append
                                               ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                               argv0)
                                 else Coq_pwMgrFatal
                                        (append
                                          ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                          argv0)
                  else Coq_pwMgrFatal
                         (append
                           ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                           argv0))
        a
  
  (** val parseArgv' :
      char list -> char list list -> Big.big_int -> 'a1 input **)
  
  let rec parseArgv' argv0 argv debug =
    match argv with
    | [] -> Coq_pwMgrConfigure debug
    | y :: argv' ->
      (match y with
       | [] ->
         Coq_pwMgrFatal
           (append ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
             (append argv0
               (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
       | a::flag ->
         (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
           (fun b b0 b1 b2 b3 b4 b5 b6 ->
           if b
           then if b0
                then Coq_pwMgrFatal
                       (append
                         ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                         (append argv0
                           (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
                else if b1
                     then if b2
                          then if b3
                               then Coq_pwMgrFatal
                                      (append
                                        ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                        (append argv0
                                          (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
                               else if b4
                                    then if b5
                                         then Coq_pwMgrFatal
                                                (append
                                                  ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                                  (append argv0
                                                    (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
                                         else if b6
                                              then Coq_pwMgrFatal
                                                     (append
                                                       ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                                       (append argv0
                                                         (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
                                              else parseFlag argv0 debug flag
                                                     (parseArgv' argv0 argv')
                                    else Coq_pwMgrFatal
                                           (append
                                             ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                             (append argv0
                                               (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
                          else Coq_pwMgrFatal
                                 (append
                                   ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                                   (append argv0
                                     (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
                     else Coq_pwMgrFatal
                            (append
                              ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                              (append argv0
                                (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[]))))))))))
           else Coq_pwMgrFatal
                  (append ('u'::('s'::('a'::('g'::('e'::(':'::(' '::[])))))))
                    (append argv0
                      (' '::('['::('-'::('d'::('.'::('.'::('.'::(']'::[])))))))))))
           a)
  
  (** val parseArgv : Big.big_int -> char list list -> 'a1 input **)
  
  let parseArgv debug = function
  | [] ->
    Coq_pwMgrFatal
      ('E'::('M'::('P'::('T'::('Y'::(' '::('A'::('R'::('G'::('V'::[]))))))))))
  | argv0 :: argv' -> parseArgv' argv0 argv' debug
  
  (** val proc :
      ('a1 input, 'a1) systemActions -> 'a1 action * ('a1 input, 'a1) process **)
  
  let proc sys =
    ((sys.getArgv (parseArgv Big.zero)), (lazy (Step (fun i ->
      match i with
      | Coq_pwMgrFatal msg -> ((abort sys msg), hang)
      | Coq_pwMgrConfigure debug -> getMasterKey sys debug
      | _ ->
        ((abort sys
           ('U'::('N'::('E'::('X'::('P'::('E'::('C'::('T'::('E'::('D'::(' '::('I'::('N'::('P'::('U'::('T'::[]))))))))))))))))),
          hang)))))
 end

module PreKVStore = Make(String_as_SOT)

module KVStore = MakeSerializableMergableMap(String_as_SOT)(PreKVStore)

module PwMgr = MakePwMgr(KVStore)(AESGCM)

