type __ = Obj.t

val negb : bool -> bool

type nat =
| O
| S of nat

val option_map : ('a1 -> 'a2) -> 'a1 option -> 'a2 option

type ('a, 'b) sum =
| Inl of 'a
| Inr of 'b

val fst : ('a1 * 'a2) -> 'a1

val snd : ('a1 * 'a2) -> 'a2

val length : 'a1 list -> nat

val app : 'a1 list -> 'a1 list -> 'a1 list

type comparison =
| Eq
| Lt
| Gt

type compareSpecT =
| CompEqT
| CompLtT
| CompGtT

val compareSpec2Type : comparison -> compareSpecT

type 'a compSpecT = compareSpecT

val compSpec2Type : 'a1 -> 'a1 -> comparison -> 'a1 compSpecT

val id : 'a1 -> 'a1

type 'a sig0 =
  'a
  (* singleton inductive, whose constructor was exist *)

val plus : nat -> nat -> nat

val mult : nat -> nat -> nat

val minus : nat -> nat -> nat

val max : nat -> nat -> nat

val nat_iter : nat -> ('a1 -> 'a1) -> 'a1 -> 'a1

val eqb : bool -> bool -> bool

type reflect =
| ReflectT
| ReflectF

val iff_reflect : bool -> reflect

val compose : ('a2 -> 'a3) -> ('a1 -> 'a2) -> 'a1 -> 'a3

val flip : ('a1 -> 'a2 -> 'a3) -> 'a2 -> 'a1 -> 'a3

val tl : 'a1 list -> 'a1 list

val nth : nat -> 'a1 list -> 'a1 -> 'a1

val last : 'a1 list -> 'a1 -> 'a1

val removelast : 'a1 list -> 'a1 list

val rev : 'a1 list -> 'a1 list

val map : ('a1 -> 'a2) -> 'a1 list -> 'a2 list

val flat_map : ('a1 -> 'a2 list) -> 'a1 list -> 'a2 list

val fold_left : ('a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> 'a1

val fold_right : ('a2 -> 'a1 -> 'a1) -> 'a1 -> 'a2 list -> 'a1

val filter : ('a1 -> bool) -> 'a1 list -> 'a1 list

val firstn : nat -> 'a1 list -> 'a1 list

val skipn : nat -> 'a1 list -> 'a1 list

module type EqLtLe = 
 sig 
  type t 
 end

module MakeOrderTac : 
 functor (O:EqLtLe) ->
 functor (P:sig 
  
 end) ->
 sig 
  
 end

type 'x compare =
| LT
| EQ
| GT

module type OrderedType = 
 sig 
  type t 
  
  val compare : t -> t -> t compare
  
  val eq_dec : t -> t -> bool
 end

module OrderedTypeFacts : 
 functor (O:OrderedType) ->
 sig 
  module TO : 
   sig 
    type t = O.t
   end
  
  module IsTO : 
   sig 
    
   end
  
  module OrderTac : 
   sig 
    
   end
  
  val eq_dec : O.t -> O.t -> bool
  
  val lt_dec : O.t -> O.t -> bool
  
  val eqb : O.t -> O.t -> bool
 end

module KeyOrderedType : 
 functor (O:OrderedType) ->
 sig 
  module MO : 
   sig 
    module TO : 
     sig 
      type t = O.t
     end
    
    module IsTO : 
     sig 
      
     end
    
    module OrderTac : 
     sig 
      
     end
    
    val eq_dec : O.t -> O.t -> bool
    
    val lt_dec : O.t -> O.t -> bool
    
    val eqb : O.t -> O.t -> bool
   end
 end

module Raw : 
 functor (X:OrderedType) ->
 sig 
  module MX : 
   sig 
    module TO : 
     sig 
      type t = X.t
     end
    
    module IsTO : 
     sig 
      
     end
    
    module OrderTac : 
     sig 
      
     end
    
    val eq_dec : X.t -> X.t -> bool
    
    val lt_dec : X.t -> X.t -> bool
    
    val eqb : X.t -> X.t -> bool
   end
  
  module PX : 
   sig 
    module MO : 
     sig 
      module TO : 
       sig 
        type t = X.t
       end
      
      module IsTO : 
       sig 
        
       end
      
      module OrderTac : 
       sig 
        
       end
      
      val eq_dec : X.t -> X.t -> bool
      
      val lt_dec : X.t -> X.t -> bool
      
      val eqb : X.t -> X.t -> bool
     end
   end
  
  type key = X.t
  
  type 'elt t = (X.t * 'elt) list
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val mem : key -> 'a1 t -> bool
  
  type 'elt coq_R_mem =
  | R_mem_0 of 'elt t
  | R_mem_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_mem_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_mem_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * bool
     * 'elt coq_R_mem
  
  val coq_R_mem_rect :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 t -> bool ->
    'a1 coq_R_mem -> 'a2
  
  val coq_R_mem_rec :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 t -> bool ->
    'a1 coq_R_mem -> 'a2
  
  val mem_rect :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val mem_rec :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val coq_R_mem_correct : key -> 'a1 t -> bool -> 'a1 coq_R_mem
  
  val find : key -> 'a1 t -> 'a1 option
  
  type 'elt coq_R_find =
  | R_find_0 of 'elt t
  | R_find_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_find_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_find_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt option
     * 'elt coq_R_find
  
  val coq_R_find_rect :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 t ->
    'a1 option -> 'a1 coq_R_find -> 'a2
  
  val coq_R_find_rec :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 t ->
    'a1 option -> 'a1 coq_R_find -> 'a2
  
  val find_rect :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val find_rec :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val coq_R_find_correct : key -> 'a1 t -> 'a1 option -> 'a1 coq_R_find
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  type 'elt coq_R_add =
  | R_add_0 of 'elt t
  | R_add_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_add_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_add_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt t
     * 'elt coq_R_add
  
  val coq_R_add_rect :
    key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 t
    -> 'a1 t -> 'a1 coq_R_add -> 'a2
  
  val coq_R_add_rec :
    key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 t
    -> 'a1 t -> 'a1 coq_R_add -> 'a2
  
  val add_rect :
    key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val add_rec :
    key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
    list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val coq_R_add_correct : key -> 'a1 -> 'a1 t -> 'a1 t -> 'a1 coq_R_add
  
  val remove : key -> 'a1 t -> 'a1 t
  
  type 'elt coq_R_remove =
  | R_remove_0 of 'elt t
  | R_remove_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_remove_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
  | R_remove_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt t
     * 'elt coq_R_remove
  
  val coq_R_remove_rect :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 t -> 'a1 t
    -> 'a1 coq_R_remove -> 'a2
  
  val coq_R_remove_rec :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 t -> 'a1 t
    -> 'a1 coq_R_remove -> 'a2
  
  val remove_rect :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val remove_rec :
    key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __
    -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
  
  val coq_R_remove_correct : key -> 'a1 t -> 'a1 t -> 'a1 coq_R_remove
  
  val elements : 'a1 t -> 'a1 t
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  type ('elt, 'a) coq_R_fold =
  | R_fold_0 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a
  | R_fold_1 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a * X.t * 'elt
     * (X.t * 'elt) list * 'a * ('elt, 'a) coq_R_fold
  
  val coq_R_fold_rect :
    (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
    (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3
    -> 'a3) -> 'a1 t -> 'a3 -> 'a3 -> ('a1, 'a3) coq_R_fold -> 'a2
  
  val coq_R_fold_rec :
    (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
    (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3
    -> 'a3) -> 'a1 t -> 'a3 -> 'a3 -> ('a1, 'a3) coq_R_fold -> 'a2
  
  val fold_rect :
    (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
    (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a2
  
  val fold_rec :
    (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__ ->
    (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 -> (X.t * 'a1) list
    -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a2
  
  val coq_R_fold_correct :
    (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 -> ('a1, 'a2)
    coq_R_fold
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
  
  type 'elt coq_R_equal =
  | R_equal_0 of 'elt t * 'elt t
  | R_equal_1 of 'elt t * 'elt t * X.t * 'elt * (X.t * 'elt) list * X.t
     * 'elt * (X.t * 'elt) list * bool * 'elt coq_R_equal
  | R_equal_2 of 'elt t * 'elt t * X.t * 'elt * (X.t * 'elt) list * X.t
     * 'elt * (X.t * 'elt) list * X.t compare
  | R_equal_3 of 'elt t * 'elt t * 'elt t * 'elt t
  
  val coq_R_equal_rect :
    ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t ->
    'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
    (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_equal -> 'a2 ->
    'a2) -> ('a1 t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t ->
    'a1 -> (X.t * 'a1) list -> __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1
    t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t
    -> bool -> 'a1 coq_R_equal -> 'a2
  
  val coq_R_equal_rec :
    ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t ->
    'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
    (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_equal -> 'a2 ->
    'a2) -> ('a1 t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t ->
    'a1 -> (X.t * 'a1) list -> __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1
    t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t
    -> bool -> 'a1 coq_R_equal -> 'a2
  
  val equal_rect :
    ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t ->
    'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
    (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> ('a1 t -> 'a1 t ->
    X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t -> __
    -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t -> 'a2
  
  val equal_rec :
    ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1 t ->
    'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
    (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> ('a1 t -> 'a1 t ->
    X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 -> (X.t * 'a1) list ->
    __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t -> __
    -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t -> 'a2
  
  val coq_R_equal_correct :
    ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val option_cons : key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list
  
  val map2_l : ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t
  
  val map2_r : ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t
  
  val fold_right_pair :
    ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3
  
  val map2_alt :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> (key * 'a3)
    list
  
  val at_least_one :
    'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option
  
  val at_least_one_then_f :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option ->
    'a3 option
 end

module Pos : 
 sig 
  type t = Big.big_int
  
  val succ : Big.big_int -> Big.big_int
  
  val add : Big.big_int -> Big.big_int -> Big.big_int
  
  val add_carry : Big.big_int -> Big.big_int -> Big.big_int
  
  val pred_double : Big.big_int -> Big.big_int
  
  val pred : Big.big_int -> Big.big_int
  
  val pred_N : Big.big_int -> Big.big_int
  
  type mask =
  | IsNul
  | IsPos of Big.big_int
  | IsNeg
  
  val mask_rect : 'a1 -> (Big.big_int -> 'a1) -> 'a1 -> mask -> 'a1
  
  val mask_rec : 'a1 -> (Big.big_int -> 'a1) -> 'a1 -> mask -> 'a1
  
  val succ_double_mask : mask -> mask
  
  val double_mask : mask -> mask
  
  val double_pred_mask : Big.big_int -> mask
  
  val pred_mask : mask -> mask
  
  val sub_mask : Big.big_int -> Big.big_int -> mask
  
  val sub_mask_carry : Big.big_int -> Big.big_int -> mask
  
  val sub : Big.big_int -> Big.big_int -> Big.big_int
  
  val mul : Big.big_int -> Big.big_int -> Big.big_int
  
  val iter : Big.big_int -> ('a1 -> 'a1) -> 'a1 -> 'a1
  
  val pow : Big.big_int -> Big.big_int -> Big.big_int
  
  val square : Big.big_int -> Big.big_int
  
  val div2 : Big.big_int -> Big.big_int
  
  val div2_up : Big.big_int -> Big.big_int
  
  val size_nat : Big.big_int -> nat
  
  val size : Big.big_int -> Big.big_int
  
  val compare_cont : Big.big_int -> Big.big_int -> comparison -> comparison
  
  val compare : Big.big_int -> Big.big_int -> comparison
  
  val min : Big.big_int -> Big.big_int -> Big.big_int
  
  val max : Big.big_int -> Big.big_int -> Big.big_int
  
  val eqb : Big.big_int -> Big.big_int -> bool
  
  val leb : Big.big_int -> Big.big_int -> bool
  
  val ltb : Big.big_int -> Big.big_int -> bool
  
  val sqrtrem_step :
    (Big.big_int -> Big.big_int) -> (Big.big_int -> Big.big_int) ->
    (Big.big_int * mask) -> Big.big_int * mask
  
  val sqrtrem : Big.big_int -> Big.big_int * mask
  
  val sqrt : Big.big_int -> Big.big_int
  
  val gcdn : nat -> Big.big_int -> Big.big_int -> Big.big_int
  
  val gcd : Big.big_int -> Big.big_int -> Big.big_int
  
  val ggcdn :
    nat -> Big.big_int -> Big.big_int ->
    Big.big_int * (Big.big_int * Big.big_int)
  
  val ggcd :
    Big.big_int -> Big.big_int -> Big.big_int * (Big.big_int * Big.big_int)
  
  val coq_Nsucc_double : Big.big_int -> Big.big_int
  
  val coq_Ndouble : Big.big_int -> Big.big_int
  
  val coq_lor : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_land : Big.big_int -> Big.big_int -> Big.big_int
  
  val ldiff : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_lxor : Big.big_int -> Big.big_int -> Big.big_int
  
  val shiftl_nat : Big.big_int -> nat -> Big.big_int
  
  val shiftr_nat : Big.big_int -> nat -> Big.big_int
  
  val shiftl : Big.big_int -> Big.big_int -> Big.big_int
  
  val shiftr : Big.big_int -> Big.big_int -> Big.big_int
  
  val testbit_nat : Big.big_int -> nat -> bool
  
  val testbit : Big.big_int -> Big.big_int -> bool
  
  val iter_op : ('a1 -> 'a1 -> 'a1) -> Big.big_int -> 'a1 -> 'a1
  
  val to_nat : Big.big_int -> nat
  
  val of_nat : nat -> Big.big_int
  
  val of_succ_nat : nat -> Big.big_int
 end

module Coq_Pos : 
 sig 
  type t = Big.big_int
  
  val succ : Big.big_int -> Big.big_int
  
  val add : Big.big_int -> Big.big_int -> Big.big_int
  
  val add_carry : Big.big_int -> Big.big_int -> Big.big_int
  
  val pred_double : Big.big_int -> Big.big_int
  
  val pred : Big.big_int -> Big.big_int
  
  val pred_N : Big.big_int -> Big.big_int
  
  type mask = Pos.mask =
  | IsNul
  | IsPos of Big.big_int
  | IsNeg
  
  val mask_rect : 'a1 -> (Big.big_int -> 'a1) -> 'a1 -> mask -> 'a1
  
  val mask_rec : 'a1 -> (Big.big_int -> 'a1) -> 'a1 -> mask -> 'a1
  
  val succ_double_mask : mask -> mask
  
  val double_mask : mask -> mask
  
  val double_pred_mask : Big.big_int -> mask
  
  val pred_mask : mask -> mask
  
  val sub_mask : Big.big_int -> Big.big_int -> mask
  
  val sub_mask_carry : Big.big_int -> Big.big_int -> mask
  
  val sub : Big.big_int -> Big.big_int -> Big.big_int
  
  val mul : Big.big_int -> Big.big_int -> Big.big_int
  
  val iter : Big.big_int -> ('a1 -> 'a1) -> 'a1 -> 'a1
  
  val pow : Big.big_int -> Big.big_int -> Big.big_int
  
  val square : Big.big_int -> Big.big_int
  
  val div2 : Big.big_int -> Big.big_int
  
  val div2_up : Big.big_int -> Big.big_int
  
  val size_nat : Big.big_int -> nat
  
  val size : Big.big_int -> Big.big_int
  
  val compare_cont : Big.big_int -> Big.big_int -> comparison -> comparison
  
  val compare : Big.big_int -> Big.big_int -> comparison
  
  val min : Big.big_int -> Big.big_int -> Big.big_int
  
  val max : Big.big_int -> Big.big_int -> Big.big_int
  
  val eqb : Big.big_int -> Big.big_int -> bool
  
  val leb : Big.big_int -> Big.big_int -> bool
  
  val ltb : Big.big_int -> Big.big_int -> bool
  
  val sqrtrem_step :
    (Big.big_int -> Big.big_int) -> (Big.big_int -> Big.big_int) ->
    (Big.big_int * mask) -> Big.big_int * mask
  
  val sqrtrem : Big.big_int -> Big.big_int * mask
  
  val sqrt : Big.big_int -> Big.big_int
  
  val gcdn : nat -> Big.big_int -> Big.big_int -> Big.big_int
  
  val gcd : Big.big_int -> Big.big_int -> Big.big_int
  
  val ggcdn :
    nat -> Big.big_int -> Big.big_int ->
    Big.big_int * (Big.big_int * Big.big_int)
  
  val ggcd :
    Big.big_int -> Big.big_int -> Big.big_int * (Big.big_int * Big.big_int)
  
  val coq_Nsucc_double : Big.big_int -> Big.big_int
  
  val coq_Ndouble : Big.big_int -> Big.big_int
  
  val coq_lor : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_land : Big.big_int -> Big.big_int -> Big.big_int
  
  val ldiff : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_lxor : Big.big_int -> Big.big_int -> Big.big_int
  
  val shiftl_nat : Big.big_int -> nat -> Big.big_int
  
  val shiftr_nat : Big.big_int -> nat -> Big.big_int
  
  val shiftl : Big.big_int -> Big.big_int -> Big.big_int
  
  val shiftr : Big.big_int -> Big.big_int -> Big.big_int
  
  val testbit_nat : Big.big_int -> nat -> bool
  
  val testbit : Big.big_int -> Big.big_int -> bool
  
  val iter_op : ('a1 -> 'a1 -> 'a1) -> Big.big_int -> 'a1 -> 'a1
  
  val to_nat : Big.big_int -> nat
  
  val of_nat : nat -> Big.big_int
  
  val of_succ_nat : nat -> Big.big_int
  
  val eq_dec : Big.big_int -> Big.big_int -> bool
  
  val peano_rect : 'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1
  
  val peano_rec : 'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1
  
  type coq_PeanoView =
  | PeanoOne
  | PeanoSucc of Big.big_int * coq_PeanoView
  
  val coq_PeanoView_rect :
    'a1 -> (Big.big_int -> coq_PeanoView -> 'a1 -> 'a1) -> Big.big_int ->
    coq_PeanoView -> 'a1
  
  val coq_PeanoView_rec :
    'a1 -> (Big.big_int -> coq_PeanoView -> 'a1 -> 'a1) -> Big.big_int ->
    coq_PeanoView -> 'a1
  
  val peanoView_xO : Big.big_int -> coq_PeanoView -> coq_PeanoView
  
  val peanoView_xI : Big.big_int -> coq_PeanoView -> coq_PeanoView
  
  val peanoView : Big.big_int -> coq_PeanoView
  
  val coq_PeanoView_iter :
    'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> coq_PeanoView -> 'a1
  
  val eqb_spec : Big.big_int -> Big.big_int -> reflect
  
  val switch_Eq : comparison -> comparison -> comparison
  
  val mask2cmp : mask -> comparison
  
  val leb_spec0 : Big.big_int -> Big.big_int -> reflect
  
  val ltb_spec0 : Big.big_int -> Big.big_int -> reflect
  
  module Private_Tac : 
   sig 
    
   end
  
  module Private_Dec : 
   sig 
    val max_case_strong :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
    
    val max_case :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> 'a1 -> 'a1 -> 'a1
    
    val max_dec : Big.big_int -> Big.big_int -> bool
    
    val min_case_strong :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
    
    val min_case :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> 'a1 -> 'a1 -> 'a1
    
    val min_dec : Big.big_int -> Big.big_int -> bool
   end
  
  val max_case_strong :
    Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
  
  val max_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1
  
  val max_dec : Big.big_int -> Big.big_int -> bool
  
  val min_case_strong :
    Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
  
  val min_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1
  
  val min_dec : Big.big_int -> Big.big_int -> bool
 end

module N : 
 sig 
  type t = Big.big_int
  
  val zero : Big.big_int
  
  val one : Big.big_int
  
  val two : Big.big_int
  
  val succ_double : Big.big_int -> Big.big_int
  
  val double : Big.big_int -> Big.big_int
  
  val succ : Big.big_int -> Big.big_int
  
  val pred : Big.big_int -> Big.big_int
  
  val succ_pos : Big.big_int -> Big.big_int
  
  val add : Big.big_int -> Big.big_int -> Big.big_int
  
  val sub : Big.big_int -> Big.big_int -> Big.big_int
  
  val mul : Big.big_int -> Big.big_int -> Big.big_int
  
  val compare : Big.big_int -> Big.big_int -> comparison
  
  val eqb : Big.big_int -> Big.big_int -> bool
  
  val leb : Big.big_int -> Big.big_int -> bool
  
  val ltb : Big.big_int -> Big.big_int -> bool
  
  val min : Big.big_int -> Big.big_int -> Big.big_int
  
  val max : Big.big_int -> Big.big_int -> Big.big_int
  
  val div2 : Big.big_int -> Big.big_int
  
  val even : Big.big_int -> bool
  
  val odd : Big.big_int -> bool
  
  val pow : Big.big_int -> Big.big_int -> Big.big_int
  
  val square : Big.big_int -> Big.big_int
  
  val log2 : Big.big_int -> Big.big_int
  
  val size : Big.big_int -> Big.big_int
  
  val size_nat : Big.big_int -> nat
  
  val pos_div_eucl : Big.big_int -> Big.big_int -> Big.big_int * Big.big_int
  
  val div_eucl : Big.big_int -> Big.big_int -> Big.big_int * Big.big_int
  
  val div : Big.big_int -> Big.big_int -> Big.big_int
  
  val modulo : Big.big_int -> Big.big_int -> Big.big_int
  
  val gcd : Big.big_int -> Big.big_int -> Big.big_int
  
  val ggcd :
    Big.big_int -> Big.big_int -> Big.big_int * (Big.big_int * Big.big_int)
  
  val sqrtrem : Big.big_int -> Big.big_int * Big.big_int
  
  val sqrt : Big.big_int -> Big.big_int
  
  val coq_lor : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_land : Big.big_int -> Big.big_int -> Big.big_int
  
  val ldiff : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_lxor : Big.big_int -> Big.big_int -> Big.big_int
  
  val shiftl_nat : Big.big_int -> nat -> Big.big_int
  
  val shiftr_nat : Big.big_int -> nat -> Big.big_int
  
  val shiftl : Big.big_int -> Big.big_int -> Big.big_int
  
  val shiftr : Big.big_int -> Big.big_int -> Big.big_int
  
  val testbit_nat : Big.big_int -> nat -> bool
  
  val testbit : Big.big_int -> Big.big_int -> bool
  
  val to_nat : Big.big_int -> nat
  
  val of_nat : nat -> Big.big_int
  
  val iter : Big.big_int -> ('a1 -> 'a1) -> 'a1 -> 'a1
  
  val eq_dec : Big.big_int -> Big.big_int -> bool
  
  val discr : Big.big_int -> Big.big_int option
  
  val binary_rect :
    'a1 -> (Big.big_int -> 'a1 -> 'a1) -> (Big.big_int -> 'a1 -> 'a1) ->
    Big.big_int -> 'a1
  
  val binary_rec :
    'a1 -> (Big.big_int -> 'a1 -> 'a1) -> (Big.big_int -> 'a1 -> 'a1) ->
    Big.big_int -> 'a1
  
  val peano_rect : 'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1
  
  val peano_rec : 'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1
  
  val leb_spec0 : Big.big_int -> Big.big_int -> reflect
  
  val ltb_spec0 : Big.big_int -> Big.big_int -> reflect
  
  module Private_BootStrap : 
   sig 
    
   end
  
  val recursion : 'a1 -> (Big.big_int -> 'a1 -> 'a1) -> Big.big_int -> 'a1
  
  module Private_OrderTac : 
   sig 
    module IsTotal : 
     sig 
      
     end
    
    module Tac : 
     sig 
      
     end
   end
  
  module Private_NZPow : 
   sig 
    
   end
  
  module Private_NZSqrt : 
   sig 
    
   end
  
  val sqrt_up : Big.big_int -> Big.big_int
  
  val log2_up : Big.big_int -> Big.big_int
  
  module Private_NZDiv : 
   sig 
    
   end
  
  val lcm : Big.big_int -> Big.big_int -> Big.big_int
  
  val eqb_spec : Big.big_int -> Big.big_int -> reflect
  
  val b2n : bool -> Big.big_int
  
  val setbit : Big.big_int -> Big.big_int -> Big.big_int
  
  val clearbit : Big.big_int -> Big.big_int -> Big.big_int
  
  val ones : Big.big_int -> Big.big_int
  
  val lnot : Big.big_int -> Big.big_int -> Big.big_int
  
  module Private_Tac : 
   sig 
    
   end
  
  module Private_Dec : 
   sig 
    val max_case_strong :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
    
    val max_case :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> 'a1 -> 'a1 -> 'a1
    
    val max_dec : Big.big_int -> Big.big_int -> bool
    
    val min_case_strong :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
    
    val min_case :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> 'a1 -> 'a1 -> 'a1
    
    val min_dec : Big.big_int -> Big.big_int -> bool
   end
  
  val max_case_strong :
    Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
  
  val max_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1
  
  val max_dec : Big.big_int -> Big.big_int -> bool
  
  val min_case_strong :
    Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
  
  val min_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1
  
  val min_dec : Big.big_int -> Big.big_int -> bool
 end

val leb0 : nat -> nat -> bool

module Z : 
 sig 
  type t = Big.big_int
  
  val zero : Big.big_int
  
  val one : Big.big_int
  
  val two : Big.big_int
  
  val double : Big.big_int -> Big.big_int
  
  val succ_double : Big.big_int -> Big.big_int
  
  val pred_double : Big.big_int -> Big.big_int
  
  val pos_sub : Big.big_int -> Big.big_int -> Big.big_int
  
  val add : Big.big_int -> Big.big_int -> Big.big_int
  
  val opp : Big.big_int -> Big.big_int
  
  val succ : Big.big_int -> Big.big_int
  
  val pred : Big.big_int -> Big.big_int
  
  val sub : Big.big_int -> Big.big_int -> Big.big_int
  
  val mul : Big.big_int -> Big.big_int -> Big.big_int
  
  val pow_pos : Big.big_int -> Big.big_int -> Big.big_int
  
  val pow : Big.big_int -> Big.big_int -> Big.big_int
  
  val square : Big.big_int -> Big.big_int
  
  val compare : Big.big_int -> Big.big_int -> comparison
  
  val sgn : Big.big_int -> Big.big_int
  
  val leb : Big.big_int -> Big.big_int -> bool
  
  val ltb : Big.big_int -> Big.big_int -> bool
  
  val geb : Big.big_int -> Big.big_int -> bool
  
  val gtb : Big.big_int -> Big.big_int -> bool
  
  val eqb : Big.big_int -> Big.big_int -> bool
  
  val max : Big.big_int -> Big.big_int -> Big.big_int
  
  val min : Big.big_int -> Big.big_int -> Big.big_int
  
  val abs : Big.big_int -> Big.big_int
  
  val abs_nat : Big.big_int -> nat
  
  val abs_N : Big.big_int -> Big.big_int
  
  val to_nat : Big.big_int -> nat
  
  val to_N : Big.big_int -> Big.big_int
  
  val of_nat : nat -> Big.big_int
  
  val of_N : Big.big_int -> Big.big_int
  
  val to_pos : Big.big_int -> Big.big_int
  
  val iter : Big.big_int -> ('a1 -> 'a1) -> 'a1 -> 'a1
  
  val pos_div_eucl : Big.big_int -> Big.big_int -> Big.big_int * Big.big_int
  
  val div_eucl : Big.big_int -> Big.big_int -> Big.big_int * Big.big_int
  
  val div : Big.big_int -> Big.big_int -> Big.big_int
  
  val modulo : Big.big_int -> Big.big_int -> Big.big_int
  
  val quotrem : Big.big_int -> Big.big_int -> Big.big_int * Big.big_int
  
  val quot : Big.big_int -> Big.big_int -> Big.big_int
  
  val rem : Big.big_int -> Big.big_int -> Big.big_int
  
  val even : Big.big_int -> bool
  
  val odd : Big.big_int -> bool
  
  val div2 : Big.big_int -> Big.big_int
  
  val quot2 : Big.big_int -> Big.big_int
  
  val log2 : Big.big_int -> Big.big_int
  
  val sqrtrem : Big.big_int -> Big.big_int * Big.big_int
  
  val sqrt : Big.big_int -> Big.big_int
  
  val gcd : Big.big_int -> Big.big_int -> Big.big_int
  
  val ggcd :
    Big.big_int -> Big.big_int -> Big.big_int * (Big.big_int * Big.big_int)
  
  val testbit : Big.big_int -> Big.big_int -> bool
  
  val shiftl : Big.big_int -> Big.big_int -> Big.big_int
  
  val shiftr : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_lor : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_land : Big.big_int -> Big.big_int -> Big.big_int
  
  val ldiff : Big.big_int -> Big.big_int -> Big.big_int
  
  val coq_lxor : Big.big_int -> Big.big_int -> Big.big_int
  
  val eq_dec : Big.big_int -> Big.big_int -> bool
  
  module Private_BootStrap : 
   sig 
    
   end
  
  val leb_spec0 : Big.big_int -> Big.big_int -> reflect
  
  val ltb_spec0 : Big.big_int -> Big.big_int -> reflect
  
  module Private_OrderTac : 
   sig 
    module IsTotal : 
     sig 
      
     end
    
    module Tac : 
     sig 
      
     end
   end
  
  val sqrt_up : Big.big_int -> Big.big_int
  
  val log2_up : Big.big_int -> Big.big_int
  
  module Private_NZDiv : 
   sig 
    
   end
  
  module Private_Div : 
   sig 
    module Quot2Div : 
     sig 
      val div : Big.big_int -> Big.big_int -> Big.big_int
      
      val modulo : Big.big_int -> Big.big_int -> Big.big_int
     end
    
    module NZQuot : 
     sig 
      
     end
   end
  
  val lcm : Big.big_int -> Big.big_int -> Big.big_int
  
  val eqb_spec : Big.big_int -> Big.big_int -> reflect
  
  val b2z : bool -> Big.big_int
  
  val setbit : Big.big_int -> Big.big_int -> Big.big_int
  
  val clearbit : Big.big_int -> Big.big_int -> Big.big_int
  
  val lnot : Big.big_int -> Big.big_int
  
  val ones : Big.big_int -> Big.big_int
  
  module Private_Tac : 
   sig 
    
   end
  
  module Private_Dec : 
   sig 
    val max_case_strong :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
    
    val max_case :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> 'a1 -> 'a1 -> 'a1
    
    val max_dec : Big.big_int -> Big.big_int -> bool
    
    val min_case_strong :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
    
    val min_case :
      Big.big_int -> Big.big_int -> (Big.big_int -> Big.big_int -> __ -> 'a1
      -> 'a1) -> 'a1 -> 'a1 -> 'a1
    
    val min_dec : Big.big_int -> Big.big_int -> bool
   end
  
  val max_case_strong :
    Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
  
  val max_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1
  
  val max_dec : Big.big_int -> Big.big_int -> bool
  
  val min_case_strong :
    Big.big_int -> Big.big_int -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1
  
  val min_case : Big.big_int -> Big.big_int -> 'a1 -> 'a1 -> 'a1
  
  val min_dec : Big.big_int -> Big.big_int -> bool
 end

val beq_nat : nat -> nat -> bool

val sumbool_of_bool : bool -> bool

val leb1 :
  nat
  ->
  nat
  ->
  bool

val ltb0 :
  nat
  ->
  nat
  ->
  bool

val divmod :
  nat
  ->
  nat
  ->
  nat
  ->
  nat
  ->
  nat * nat

val div0 :
  nat
  ->
  nat
  ->
  nat

val z_gt_dec :
  Big.big_int
  ->
  Big.big_int
  ->
  bool

val z_ge_dec :
  Big.big_int
  ->
  Big.big_int
  ->
  bool

val z_gt_le_dec :
  Big.big_int
  ->
  Big.big_int
  ->
  bool

val z_ge_lt_dec :
  Big.big_int
  ->
  Big.big_int
  ->
  bool

module type Int = 
 sig 
  type t 
  
  val i2z :
    t
    ->
    Big.big_int
  
  val _0 :
    t
  
  val _1 :
    t
  
  val _2 :
    t
  
  val _3 :
    t
  
  val plus :
    t
    ->
    t
    ->
    t
  
  val opp :
    t
    ->
    t
  
  val minus :
    t
    ->
    t
    ->
    t
  
  val mult :
    t
    ->
    t
    ->
    t
  
  val max :
    t
    ->
    t
    ->
    t
  
  val gt_le_dec :
    t
    ->
    t
    ->
    bool
  
  val ge_lt_dec :
    t
    ->
    t
    ->
    bool
  
  val eq_dec :
    t
    ->
    t
    ->
    bool
 end

module Z_as_Int : 
 sig 
  type t
    =
    Big.big_int
  
  val _0 :
    Big.big_int
  
  val _1 :
    Big.big_int
  
  val _2 :
    Big.big_int
  
  val _3 :
    Big.big_int
  
  val plus :
    Big.big_int
    ->
    Big.big_int
    ->
    Big.big_int
  
  val opp :
    Big.big_int
    ->
    Big.big_int
  
  val minus :
    Big.big_int
    ->
    Big.big_int
    ->
    Big.big_int
  
  val mult :
    Big.big_int
    ->
    Big.big_int
    ->
    Big.big_int
  
  val max :
    Big.big_int
    ->
    Big.big_int
    ->
    Big.big_int
  
  val gt_le_dec :
    Big.big_int
    ->
    Big.big_int
    ->
    bool
  
  val ge_lt_dec :
    Big.big_int
    ->
    Big.big_int
    ->
    bool
  
  val eq_dec :
    Big.big_int
    ->
    Big.big_int
    ->
    bool
  
  val i2z :
    t
    ->
    Big.big_int
 end

module Coq_Raw : 
 functor (I:Int) ->
 functor (X:OrderedType) ->
 sig 
  type key
    =
    X.t
  
  type 'elt tree =
  | Leaf
  | Node of 'elt
            tree
     * key
     * 'elt
     * 'elt
       tree
     * I.t
  
  val tree_rect :
    'a2
    ->
    ('a1
    tree
    ->
    'a2
    ->
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a2
    ->
    I.t
    ->
    'a2)
    ->
    'a1
    tree
    ->
    'a2
  
  val tree_rec :
    'a2
    ->
    ('a1
    tree
    ->
    'a2
    ->
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a2
    ->
    I.t
    ->
    'a2)
    ->
    'a1
    tree
    ->
    'a2
  
  val height :
    'a1
    tree
    ->
    I.t
  
  val cardinal :
    'a1
    tree
    ->
    nat
  
  val empty :
    'a1
    tree
  
  val is_empty :
    'a1
    tree
    ->
    bool
  
  val mem :
    X.t
    ->
    'a1
    tree
    ->
    bool
  
  val find :
    X.t
    ->
    'a1
    tree
    ->
    'a1
    option
  
  val create :
    'a1
    tree
    ->
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  val assert_false :
    'a1
    tree
    ->
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  val bal :
    'a1
    tree
    ->
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  val add :
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  val remove_min :
    'a1
    tree
    ->
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    tree * (key * 'a1)
  
  val merge :
    'a1
    tree
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  val remove :
    X.t
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  val join :
    'a1
    tree
    ->
    key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  type 'elt triple = { t_left : 'elt
                                tree;
                       t_opt : 'elt
                               option;
                       t_right : 'elt
                                 tree }
  
  val triple_rect :
    ('a1
    tree
    ->
    'a1
    option
    ->
    'a1
    tree
    ->
    'a2)
    ->
    'a1
    triple
    ->
    'a2
  
  val triple_rec :
    ('a1
    tree
    ->
    'a1
    option
    ->
    'a1
    tree
    ->
    'a2)
    ->
    'a1
    triple
    ->
    'a2
  
  val t_left :
    'a1
    triple
    ->
    'a1
    tree
  
  val t_opt :
    'a1
    triple
    ->
    'a1
    option
  
  val t_right :
    'a1
    triple
    ->
    'a1
    tree
  
  val split :
    X.t
    ->
    'a1
    tree
    ->
    'a1
    triple
  
  val concat :
    'a1
    tree
    ->
    'a1
    tree
    ->
    'a1
    tree
  
  val elements_aux :
    (key * 'a1)
    list
    ->
    'a1
    tree
    ->
    (key * 'a1)
    list
  
  val elements :
    'a1
    tree
    ->
    (key * 'a1)
    list
  
  val fold :
    (key
    ->
    'a1
    ->
    'a2
    ->
    'a2)
    ->
    'a1
    tree
    ->
    'a2
    ->
    'a2
  
  type 'elt enumeration =
  | End
  | More of key
     * 'elt
     * 'elt
       tree
     * 'elt
       enumeration
  
  val enumeration_rect :
    'a2
    ->
    (key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    enumeration
    ->
    'a2
    ->
    'a2)
    ->
    'a1
    enumeration
    ->
    'a2
  
  val enumeration_rec :
    'a2
    ->
    (key
    ->
    'a1
    ->
    'a1
    tree
    ->
    'a1
    enumeration
    ->
    'a2
    ->
    'a2)
    ->
    'a1
    enumeration
    ->
    'a2
  
  val cons :
    'a1
    tree
    ->
    'a1
    enumeration
    ->
    'a1
    enumeration
  
  val equal_more :
    ('a1
    ->
    'a1
    ->
    bool)
    ->
    X.t
    ->
    'a1
    ->
    ('a1
    enumeration
    ->
    bool)
    ->
    'a1
    enumeration
    ->
    bool
  
  val equal_cont :
    ('a1
    ->
    'a1
    ->
    bool)
    ->
    'a1
    tree
    ->
    ('a1
    enumeration
    ->
    bool)
    ->
    'a1
    enumeration
    ->
    bool
  
  val equal_end :
    'a1
    enumeration
    ->
    bool
  
  val equal :
    ('a1
    ->
    'a1
    ->
    bool)
    ->
    'a1
    tree
    ->
    'a1
    tree
    ->
    bool
  
  val map :
    ('a1
    ->
    'a2)
    ->
    'a1
    tree
    ->
    'a2
    tree
  
  val mapi :
    (key
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    tree
    ->
    'a2
    tree
  
  val map_option :
    (key
    ->
    'a1
    ->
    'a2
    option)
    ->
    'a1
    tree
    ->
    'a2
    tree
  
  val map2_opt :
    (key
    ->
    'a1
    ->
    'a2
    option
    ->
    'a3
    option)
    ->
    ('a1
    tree
    ->
    'a3
    tree)
    ->
    ('a2
    tree
    ->
    'a3
    tree)
    ->
    'a1
    tree
    ->
    'a2
    tree
    ->
    'a3
    tree
  
  val map2 :
    ('a1
    option
    ->
    'a2
    option
    ->
    'a3
    option)
    ->
    'a1
    tree
    ->
    'a2
    tree
    ->
    'a3
    tree
  
  module Proofs : 
   sig 
    module MX : 
     sig 
      module TO : 
       sig 
        type t
          =
          X.t
       end
      
      module IsTO : 
       sig 
        
       end
      
      module OrderTac : 
       sig 
        
       end
      
      val eq_dec :
        X.t
        ->
        X.t
        ->
        bool
      
      val lt_dec :
        X.t
        ->
        X.t
        ->
        bool
      
      val eqb :
        X.t
        ->
        X.t
        ->
        bool
     end
    
    module PX : 
     sig 
      module MO : 
       sig 
        module TO : 
         sig 
          type t
            =
            X.t
         end
        
        module IsTO : 
         sig 
          
         end
        
        module OrderTac : 
         sig 
          
         end
        
        val eq_dec :
          X.t
          ->
          X.t
          ->
          bool
        
        val lt_dec :
          X.t
          ->
          X.t
          ->
          bool
        
        val eqb :
          X.t
          ->
          X.t
          ->
          bool
       end
     end
    
    module L : 
     sig 
      module MX : 
       sig 
        module TO : 
         sig 
          type t
            =
            X.t
         end
        
        module IsTO : 
         sig 
          
         end
        
        module OrderTac : 
         sig 
          
         end
        
        val eq_dec :
          X.t
          ->
          X.t
          ->
          bool
        
        val lt_dec :
          X.t
          ->
          X.t
          ->
          bool
        
        val eqb :
          X.t
          ->
          X.t
          ->
          bool
       end
      
      module PX : 
       sig 
        module MO : 
         sig 
          module TO : 
           sig 
            type t
              =
              X.t
           end
          
          module IsTO : 
           sig 
            
           end
          
          module OrderTac : 
           sig 
            
           end
          
          val eq_dec :
            X.t
            ->
            X.t
            ->
            bool
          
          val lt_dec :
            X.t
            ->
            X.t
            ->
            bool
          
          val eqb :
            X.t
            ->
            X.t
            ->
            bool
         end
       end
      
      type key
        =
        X.t
      
      type 'elt t
        =
        (X.t * 'elt)
        list
      
      val empty :
        'a1
        t
      
      val is_empty :
        'a1
        t
        ->
        bool
      
      val mem :
        key
        ->
        'a1
        t
        ->
        bool
      
      type 'elt coq_R_mem =
      | R_mem_0 of 'elt
                   t
      | R_mem_1 of 'elt
                   t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_mem_2 of 'elt
                   t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_mem_3 of 'elt
                   t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * bool
         * 'elt
           coq_R_mem
      
      val coq_R_mem_rect :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
      
      val coq_R_mem_rec :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
      
      val mem_rect :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val mem_rec :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val coq_R_mem_correct :
        key
        ->
        'a1
        t
        ->
        bool
        ->
        'a1
        coq_R_mem
      
      val find :
        key
        ->
        'a1
        t
        ->
        'a1
        option
      
      type 'elt coq_R_find =
      | R_find_0 of 'elt
                    t
      | R_find_1 of 'elt
                    t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_find_2 of 'elt
                    t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_find_3 of 'elt
                    t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * 'elt
           option
         * 'elt
           coq_R_find
      
      val coq_R_find_rect :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
      
      val coq_R_find_rec :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
      
      val find_rect :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val find_rec :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val coq_R_find_correct :
        key
        ->
        'a1
        t
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
      
      val add :
        key
        ->
        'a1
        ->
        'a1
        t
        ->
        'a1
        t
      
      type 'elt coq_R_add =
      | R_add_0 of 'elt
                   t
      | R_add_1 of 'elt
                   t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_add_2 of 'elt
                   t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_add_3 of 'elt
                   t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * 'elt
           t
         * 'elt
           coq_R_add
      
      val coq_R_add_rect :
        key
        ->
        'a1
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        t
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a1
        coq_R_add
        ->
        'a2
      
      val coq_R_add_rec :
        key
        ->
        'a1
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        t
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a1
        coq_R_add
        ->
        'a2
      
      val add_rect :
        key
        ->
        'a1
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val add_rec :
        key
        ->
        'a1
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val coq_R_add_correct :
        key
        ->
        'a1
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a1
        coq_R_add
      
      val remove :
        key
        ->
        'a1
        t
        ->
        'a1
        t
      
      type 'elt coq_R_remove =
      | R_remove_0 of 'elt
                      t
      | R_remove_1 of 'elt
                      t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_remove_2 of 'elt
                      t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
      | R_remove_3 of 'elt
                      t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * 'elt
           t
         * 'elt
           coq_R_remove
      
      val coq_R_remove_rect :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        t
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a1
        coq_R_remove
        ->
        'a2
      
      val coq_R_remove_rec :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        t
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a1
        coq_R_remove
        ->
        'a2
      
      val remove_rect :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val remove_rec :
        key
        ->
        ('a1
        t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
      
      val coq_R_remove_correct :
        key
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a1
        coq_R_remove
      
      val elements :
        'a1
        t
        ->
        'a1
        t
      
      val fold :
        (key
        ->
        'a1
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
        ->
        'a2
      
      type ('elt,
            'a) coq_R_fold =
      | R_fold_0 of (key
                    ->
                    'elt
                    ->
                    'a
                    ->
                    'a)
         * 'elt
           t
         * 'a
      | R_fold_1 of (key
                    ->
                    'elt
                    ->
                    'a
                    ->
                    'a)
         * 'elt
           t
         * 'a
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * 'a
         * ('elt,
           'a)
           coq_R_fold
      
      val coq_R_fold_rect :
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        ('a1,
        __)
        coq_R_fold
        ->
        'a2
        ->
        'a2)
        ->
        (key
        ->
        'a1
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        t
        ->
        'a3
        ->
        'a3
        ->
        ('a1,
        'a3)
        coq_R_fold
        ->
        'a2
      
      val coq_R_fold_rec :
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        ('a1,
        __)
        coq_R_fold
        ->
        'a2
        ->
        'a2)
        ->
        (key
        ->
        'a1
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        t
        ->
        'a3
        ->
        'a3
        ->
        ('a1,
        'a3)
        coq_R_fold
        ->
        'a2
      
      val fold_rect :
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        (key
        ->
        'a1
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        t
        ->
        'a3
        ->
        'a2
      
      val fold_rec :
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        (__
        ->
        (key
        ->
        'a1
        ->
        __
        ->
        __)
        ->
        'a1
        t
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        (key
        ->
        'a1
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        t
        ->
        'a3
        ->
        'a2
      
      val coq_R_fold_correct :
        (key
        ->
        'a1
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
        ->
        'a2
        ->
        ('a1,
        'a2)
        coq_R_fold
      
      val equal :
        ('a1
        ->
        'a1
        ->
        bool)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        bool
      
      type 'elt coq_R_equal =
      | R_equal_0 of 'elt
                     t
         * 'elt
           t
      | R_equal_1 of 'elt
                     t
         * 'elt
           t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * bool
         * 'elt
           coq_R_equal
      | R_equal_2 of 'elt
                     t
         * 'elt
           t
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * X.t
         * 'elt
         * (X.t * 'elt)
           list
         * X.t
           compare
      | R_equal_3 of 'elt
                     t
         * 'elt
           t
         * 'elt
           t
         * 'elt
           t
      
      val coq_R_equal_rect :
        ('a1
        ->
        'a1
        ->
        bool)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_equal
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        compare
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        bool
        ->
        'a1
        coq_R_equal
        ->
        'a2
      
      val coq_R_equal_rec :
        ('a1
        ->
        'a1
        ->
        bool)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_equal
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        compare
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        bool
        ->
        'a1
        coq_R_equal
        ->
        'a2
      
      val equal_rect :
        ('a1
        ->
        'a1
        ->
        bool)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        compare
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a2
      
      val equal_rec :
        ('a1
        ->
        'a1
        ->
        bool)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        ->
        'a1
        ->
        (X.t * 'a1)
        list
        ->
        __
        ->
        X.t
        compare
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        t
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        __
        ->
        'a1
        t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        'a2
      
      val coq_R_equal_correct :
        ('a1
        ->
        'a1
        ->
        bool)
        ->
        'a1
        t
        ->
        'a1
        t
        ->
        bool
        ->
        'a1
        coq_R_equal
      
      val map :
        ('a1
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
        t
      
      val mapi :
        (key
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        t
        ->
        'a2
        t
      
      val option_cons :
        key
        ->
        'a1
        option
        ->
        (key * 'a1)
        list
        ->
        (key * 'a1)
        list
      
      val map2_l :
        ('a1
        option
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        'a1
        t
        ->
        'a3
        t
      
      val map2_r :
        ('a1
        option
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        'a2
        t
        ->
        'a3
        t
      
      val map2 :
        ('a1
        option
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        'a1
        t
        ->
        'a2
        t
        ->
        'a3
        t
      
      val combine :
        'a1
        t
        ->
        'a2
        t
        ->
        ('a1
        option * 'a2
        option)
        t
      
      val fold_right_pair :
        ('a1
        ->
        'a2
        ->
        'a3
        ->
        'a3)
        ->
        ('a1 * 'a2)
        list
        ->
        'a3
        ->
        'a3
      
      val map2_alt :
        ('a1
        option
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        'a1
        t
        ->
        'a2
        t
        ->
        (key * 'a3)
        list
      
      val at_least_one :
        'a1
        option
        ->
        'a2
        option
        ->
        ('a1
        option * 'a2
        option)
        option
      
      val at_least_one_then_f :
        ('a1
        option
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        'a1
        option
        ->
        'a2
        option
        ->
        'a3
        option
     end
    
    type 'elt coq_R_mem =
    | R_mem_0 of 'elt
                 tree
    | R_mem_1 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * bool
       * 'elt
         coq_R_mem
    | R_mem_2 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_mem_3 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * bool
       * 'elt
         coq_R_mem
    
    val coq_R_mem_rect :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      bool
      ->
      'a1
      coq_R_mem
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      bool
      ->
      'a1
      coq_R_mem
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      bool
      ->
      'a1
      coq_R_mem
      ->
      'a2
    
    val coq_R_mem_rec :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      bool
      ->
      'a1
      coq_R_mem
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      bool
      ->
      'a1
      coq_R_mem
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      bool
      ->
      'a1
      coq_R_mem
      ->
      'a2
    
    type 'elt coq_R_find =
    | R_find_0 of 'elt
                  tree
    | R_find_1 of 'elt
                  tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         option
       * 'elt
         coq_R_find
    | R_find_2 of 'elt
                  tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_find_3 of 'elt
                  tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         option
       * 'elt
         coq_R_find
    
    val coq_R_find_rect :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      option
      ->
      'a1
      coq_R_find
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      option
      ->
      'a1
      coq_R_find
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      option
      ->
      'a1
      coq_R_find
      ->
      'a2
    
    val coq_R_find_rec :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      option
      ->
      'a1
      coq_R_find
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      option
      ->
      'a1
      coq_R_find
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      option
      ->
      'a1
      coq_R_find
      ->
      'a2
    
    type 'elt coq_R_bal =
    | R_bal_0 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
    | R_bal_1 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_2 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_3 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_4 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
    | R_bal_5 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_6 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_7 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_bal_8 of 'elt
                 tree
       * key
       * 'elt
       * 'elt
         tree
    
    val coq_R_bal_rect :
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_bal
      ->
      'a2
    
    val coq_R_bal_rec :
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_bal
      ->
      'a2
    
    type 'elt coq_R_add =
    | R_add_0 of 'elt
                 tree
    | R_add_1 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_add
    | R_add_2 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_add_3 of 'elt
                 tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_add
    
    val coq_R_add_rect :
      key
      ->
      'a1
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_add
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_add
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_add
      ->
      'a2
    
    val coq_R_add_rec :
      key
      ->
      'a1
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_add
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_add
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_add
      ->
      'a2
    
    type 'elt coq_R_remove_min =
    | R_remove_min_0 of 'elt
                        tree
       * key
       * 'elt
       * 'elt
         tree
    | R_remove_min_1 of 'elt
                        tree
       * key
       * 'elt
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * ('elt
         tree * (key * 'elt))
       * 'elt
         coq_R_remove_min
       * 'elt
         tree
       * (key * 'elt)
    
    val coq_R_remove_min_rect :
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      ('a1
      tree * (key * 'a1))
      ->
      'a1
      coq_R_remove_min
      ->
      'a2
      ->
      'a1
      tree
      ->
      (key * 'a1)
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      ('a1
      tree * (key * 'a1))
      ->
      'a1
      coq_R_remove_min
      ->
      'a2
    
    val coq_R_remove_min_rec :
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      ('a1
      tree * (key * 'a1))
      ->
      'a1
      coq_R_remove_min
      ->
      'a2
      ->
      'a1
      tree
      ->
      (key * 'a1)
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      ('a1
      tree * (key * 'a1))
      ->
      'a1
      coq_R_remove_min
      ->
      'a2
    
    type 'elt coq_R_merge =
    | R_merge_0 of 'elt
                   tree
       * 'elt
         tree
    | R_merge_1 of 'elt
                   tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_merge_2 of 'elt
                   tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * (key * 'elt)
       * key
       * 'elt
    
    val coq_R_merge_rect :
      ('a1
      tree
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      (key * 'a1)
      ->
      __
      ->
      key
      ->
      'a1
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_merge
      ->
      'a2
    
    val coq_R_merge_rec :
      ('a1
      tree
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      (key * 'a1)
      ->
      __
      ->
      key
      ->
      'a1
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_merge
      ->
      'a2
    
    type 'elt coq_R_remove =
    | R_remove_0 of 'elt
                    tree
    | R_remove_1 of 'elt
                    tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_remove
    | R_remove_2 of 'elt
                    tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_remove_3 of 'elt
                    tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * 'elt
         coq_R_remove
    
    val coq_R_remove_rect :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_remove
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_remove
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_remove
      ->
      'a2
    
    val coq_R_remove_rec :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_remove
      ->
      'a2
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      tree
      ->
      'a1
      coq_R_remove
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_remove
      ->
      'a2
    
    type 'elt coq_R_concat =
    | R_concat_0 of 'elt
                    tree
       * 'elt
         tree
    | R_concat_1 of 'elt
                    tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_concat_2 of 'elt
                    tree
       * 'elt
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         tree
       * (key * 'elt)
    
    val coq_R_concat_rect :
      ('a1
      tree
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      (key * 'a1)
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_concat
      ->
      'a2
    
    val coq_R_concat_rec :
      ('a1
      tree
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a1
      tree
      ->
      (key * 'a1)
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      coq_R_concat
      ->
      'a2
    
    type 'elt coq_R_split =
    | R_split_0 of 'elt
                   tree
    | R_split_1 of 'elt
                   tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         triple
       * 'elt
         coq_R_split
       * 'elt
         tree
       * 'elt
         option
       * 'elt
         tree
    | R_split_2 of 'elt
                   tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_split_3 of 'elt
                   tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt
         triple
       * 'elt
         coq_R_split
       * 'elt
         tree
       * 'elt
         option
       * 'elt
         tree
    
    val coq_R_split_rect :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      triple
      ->
      'a1
      coq_R_split
      ->
      'a2
      ->
      'a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      triple
      ->
      'a1
      coq_R_split
      ->
      'a2
      ->
      'a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      triple
      ->
      'a1
      coq_R_split
      ->
      'a2
    
    val coq_R_split_rec :
      X.t
      ->
      ('a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      triple
      ->
      'a1
      coq_R_split
      ->
      'a2
      ->
      'a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a2)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      __
      ->
      'a1
      triple
      ->
      'a1
      coq_R_split
      ->
      'a2
      ->
      'a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      __
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a1
      triple
      ->
      'a1
      coq_R_split
      ->
      'a2
    
    type ('elt,
          'elt') coq_R_map_option =
    | R_map_option_0 of 'elt
                        tree
    | R_map_option_1 of 'elt
                        tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
    | R_map_option_2 of 'elt
                        tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
       * 'elt'
         tree
       * ('elt,
         'elt')
         coq_R_map_option
    
    val coq_R_map_option_rect :
      (key
      ->
      'a1
      ->
      'a2
      option)
      ->
      ('a1
      tree
      ->
      __
      ->
      'a3)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      ->
      __
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a3)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a3)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
    
    val coq_R_map_option_rec :
      (key
      ->
      'a1
      ->
      'a2
      option)
      ->
      ('a1
      tree
      ->
      __
      ->
      'a3)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      ->
      __
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a3)
      ->
      ('a1
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
      ->
      'a3)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      ('a1,
      'a2)
      coq_R_map_option
      ->
      'a3
    
    type ('elt,
          'elt',
          'elt'') coq_R_map2_opt =
    | R_map2_opt_0 of 'elt
                      tree
       * 'elt'
         tree
    | R_map2_opt_1 of 'elt
                      tree
       * 'elt'
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    | R_map2_opt_2 of 'elt
                      tree
       * 'elt'
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
         tree
       * key
       * 'elt'
       * 'elt'
         tree
       * I.t
       * 'elt'
         tree
       * 'elt'
         option
       * 'elt'
         tree
       * 'elt''
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
    | R_map2_opt_3 of 'elt
                      tree
       * 'elt'
         tree
       * 'elt
         tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
       * 'elt'
         tree
       * key
       * 'elt'
       * 'elt'
         tree
       * I.t
       * 'elt'
         tree
       * 'elt'
         option
       * 'elt'
         tree
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
       * 'elt''
         tree
       * ('elt,
         'elt',
         'elt'')
         coq_R_map2_opt
    
    val coq_R_map2_opt_rect :
      (key
      ->
      'a1
      ->
      'a2
      option
      ->
      'a3
      option)
      ->
      ('a1
      tree
      ->
      'a3
      tree)
      ->
      ('a2
      tree
      ->
      'a3
      tree)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      __
      ->
      'a4)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a4)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      key
      ->
      'a2
      ->
      'a2
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      'a2
      option
      ->
      'a2
      tree
      ->
      __
      ->
      'a3
      ->
      __
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a4)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      key
      ->
      'a2
      ->
      'a2
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      'a2
      option
      ->
      'a2
      tree
      ->
      __
      ->
      __
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a4)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
    
    val coq_R_map2_opt_rec :
      (key
      ->
      'a1
      ->
      'a2
      option
      ->
      'a3
      option)
      ->
      ('a1
      tree
      ->
      'a3
      tree)
      ->
      ('a2
      tree
      ->
      'a3
      tree)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      __
      ->
      'a4)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      __
      ->
      'a4)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      key
      ->
      'a2
      ->
      'a2
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      'a2
      option
      ->
      'a2
      tree
      ->
      __
      ->
      'a3
      ->
      __
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a4)
      ->
      ('a1
      tree
      ->
      'a2
      tree
      ->
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      key
      ->
      'a2
      ->
      'a2
      tree
      ->
      I.t
      ->
      __
      ->
      'a2
      tree
      ->
      'a2
      option
      ->
      'a2
      tree
      ->
      __
      ->
      __
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
      ->
      'a4)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      'a3
      tree
      ->
      ('a1,
      'a2,
      'a3)
      coq_R_map2_opt
      ->
      'a4
    
    val fold' :
      (key
      ->
      'a1
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
      ->
      'a2
    
    val flatten_e :
      'a1
      enumeration
      ->
      (key * 'a1)
      list
   end
 end

module IntMake : 
 functor (I:Int) ->
 functor (X:OrderedType) ->
 sig 
  module E : 
   sig 
    type t
      =
      X.t
    
    val compare :
      t
      ->
      t
      ->
      t
      compare
    
    val eq_dec :
      t
      ->
      t
      ->
      bool
   end
  
  module Raw : 
   sig 
    type key
      =
      X.t
    
    type 'elt tree =
    | Leaf
    | Node of 'elt
              tree
       * key
       * 'elt
       * 'elt
         tree
       * I.t
    
    val tree_rect :
      'a2
      ->
      ('a1
      tree
      ->
      'a2
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a2
      ->
      I.t
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
    
    val tree_rec :
      'a2
      ->
      ('a1
      tree
      ->
      'a2
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a2
      ->
      I.t
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
    
    val height :
      'a1
      tree
      ->
      I.t
    
    val cardinal :
      'a1
      tree
      ->
      nat
    
    val empty :
      'a1
      tree
    
    val is_empty :
      'a1
      tree
      ->
      bool
    
    val mem :
      X.t
      ->
      'a1
      tree
      ->
      bool
    
    val find :
      X.t
      ->
      'a1
      tree
      ->
      'a1
      option
    
    val create :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val assert_false :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val bal :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val add :
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val remove_min :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree * (key * 'a1)
    
    val merge :
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val remove :
      X.t
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val join :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    type 'elt triple = { t_left : 'elt
                                  tree;
                         t_opt : 'elt
                                 option;
                         t_right : 'elt
                                   tree }
    
    val triple_rect :
      ('a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      'a2)
      ->
      'a1
      triple
      ->
      'a2
    
    val triple_rec :
      ('a1
      tree
      ->
      'a1
      option
      ->
      'a1
      tree
      ->
      'a2)
      ->
      'a1
      triple
      ->
      'a2
    
    val t_left :
      'a1
      triple
      ->
      'a1
      tree
    
    val t_opt :
      'a1
      triple
      ->
      'a1
      option
    
    val t_right :
      'a1
      triple
      ->
      'a1
      tree
    
    val split :
      X.t
      ->
      'a1
      tree
      ->
      'a1
      triple
    
    val concat :
      'a1
      tree
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val elements_aux :
      (key * 'a1)
      list
      ->
      'a1
      tree
      ->
      (key * 'a1)
      list
    
    val elements :
      'a1
      tree
      ->
      (key * 'a1)
      list
    
    val fold :
      (key
      ->
      'a1
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
      ->
      'a2
    
    type 'elt enumeration =
    | End
    | More of key
       * 'elt
       * 'elt
         tree
       * 'elt
         enumeration
    
    val enumeration_rect :
      'a2
      ->
      (key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      enumeration
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      enumeration
      ->
      'a2
    
    val enumeration_rec :
      'a2
      ->
      (key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      enumeration
      ->
      'a2
      ->
      'a2)
      ->
      'a1
      enumeration
      ->
      'a2
    
    val cons :
      'a1
      tree
      ->
      'a1
      enumeration
      ->
      'a1
      enumeration
    
    val equal_more :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      X.t
      ->
      'a1
      ->
      ('a1
      enumeration
      ->
      bool)
      ->
      'a1
      enumeration
      ->
      bool
    
    val equal_cont :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      'a1
      tree
      ->
      ('a1
      enumeration
      ->
      bool)
      ->
      'a1
      enumeration
      ->
      bool
    
    val equal_end :
      'a1
      enumeration
      ->
      bool
    
    val equal :
      ('a1
      ->
      'a1
      ->
      bool)
      ->
      'a1
      tree
      ->
      'a1
      tree
      ->
      bool
    
    val map :
      ('a1
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
      tree
    
    val mapi :
      (key
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
      tree
    
    val map_option :
      (key
      ->
      'a1
      ->
      'a2
      option)
      ->
      'a1
      tree
      ->
      'a2
      tree
    
    val map2_opt :
      (key
      ->
      'a1
      ->
      'a2
      option
      ->
      'a3
      option)
      ->
      ('a1
      tree
      ->
      'a3
      tree)
      ->
      ('a2
      tree
      ->
      'a3
      tree)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      'a3
      tree
    
    val map2 :
      ('a1
      option
      ->
      'a2
      option
      ->
      'a3
      option)
      ->
      'a1
      tree
      ->
      'a2
      tree
      ->
      'a3
      tree
    
    module Proofs : 
     sig 
      module MX : 
       sig 
        module TO : 
         sig 
          type t
            =
            X.t
         end
        
        module IsTO : 
         sig 
          
         end
        
        module OrderTac : 
         sig 
          
         end
        
        val eq_dec :
          X.t
          ->
          X.t
          ->
          bool
        
        val lt_dec :
          X.t
          ->
          X.t
          ->
          bool
        
        val eqb :
          X.t
          ->
          X.t
          ->
          bool
       end
      
      module PX : 
       sig 
        module MO : 
         sig 
          module TO : 
           sig 
            type t
              =
              X.t
           end
          
          module IsTO : 
           sig 
            
           end
          
          module OrderTac : 
           sig 
            
           end
          
          val eq_dec :
            X.t
            ->
            X.t
            ->
            bool
          
          val lt_dec :
            X.t
            ->
            X.t
            ->
            bool
          
          val eqb :
            X.t
            ->
            X.t
            ->
            bool
         end
       end
      
      module L : 
       sig 
        module MX : 
         sig 
          module TO : 
           sig 
            type t
              =
              X.t
           end
          
          module IsTO : 
           sig 
            
           end
          
          module OrderTac : 
           sig 
            
           end
          
          val eq_dec :
            X.t
            ->
            X.t
            ->
            bool
          
          val lt_dec :
            X.t
            ->
            X.t
            ->
            bool
          
          val eqb :
            X.t
            ->
            X.t
            ->
            bool
         end
        
        module PX : 
         sig 
          module MO : 
           sig 
            module TO : 
             sig 
              type t
                =
                X.t
             end
            
            module IsTO : 
             sig 
              
             end
            
            module OrderTac : 
             sig 
              
             end
            
            val eq_dec :
              X.t
              ->
              X.t
              ->
              bool
            
            val lt_dec :
              X.t
              ->
              X.t
              ->
              bool
            
            val eqb :
              X.t
              ->
              X.t
              ->
              bool
           end
         end
        
        type key
          =
          X.t
        
        type 'elt t
          =
          (X.t * 'elt)
          list
        
        val empty :
          'a1
          t
        
        val is_empty :
          'a1
          t
          ->
          bool
        
        val mem :
          key
          ->
          'a1
          t
          ->
          bool
        
        type 'elt coq_R_mem =
        | R_mem_0 of 'elt
                     t
        | R_mem_1 of 'elt
                     t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_mem_2 of 'elt
                     t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_mem_3 of 'elt
                     t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * bool
           * 'elt
             coq_R_mem
        
        val coq_R_mem_rect :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          bool
          ->
          'a1
          coq_R_mem
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          bool
          ->
          'a1
          coq_R_mem
          ->
          'a2
        
        val coq_R_mem_rec :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          bool
          ->
          'a1
          coq_R_mem
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          bool
          ->
          'a1
          coq_R_mem
          ->
          'a2
        
        val mem_rect :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val mem_rec :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val coq_R_mem_correct :
          key
          ->
          'a1
          t
          ->
          bool
          ->
          'a1
          coq_R_mem
        
        val find :
          key
          ->
          'a1
          t
          ->
          'a1
          option
        
        type 'elt coq_R_find =
        | R_find_0 of 'elt
                      t
        | R_find_1 of 'elt
                      t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_find_2 of 'elt
                      t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_find_3 of 'elt
                      t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * 'elt
             option
           * 'elt
             coq_R_find
        
        val coq_R_find_rect :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a1
          option
          ->
          'a1
          coq_R_find
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          option
          ->
          'a1
          coq_R_find
          ->
          'a2
        
        val coq_R_find_rec :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a1
          option
          ->
          'a1
          coq_R_find
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          option
          ->
          'a1
          coq_R_find
          ->
          'a2
        
        val find_rect :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val find_rec :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val coq_R_find_correct :
          key
          ->
          'a1
          t
          ->
          'a1
          option
          ->
          'a1
          coq_R_find
        
        val add :
          key
          ->
          'a1
          ->
          'a1
          t
          ->
          'a1
          t
        
        type 'elt coq_R_add =
        | R_add_0 of 'elt
                     t
        | R_add_1 of 'elt
                     t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_add_2 of 'elt
                     t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_add_3 of 'elt
                     t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * 'elt
             t
           * 'elt
             coq_R_add
        
        val coq_R_add_rect :
          key
          ->
          'a1
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a1
          t
          ->
          'a1
          coq_R_add
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a1
          coq_R_add
          ->
          'a2
        
        val coq_R_add_rec :
          key
          ->
          'a1
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a1
          t
          ->
          'a1
          coq_R_add
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a1
          coq_R_add
          ->
          'a2
        
        val add_rect :
          key
          ->
          'a1
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val add_rec :
          key
          ->
          'a1
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val coq_R_add_correct :
          key
          ->
          'a1
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a1
          coq_R_add
        
        val remove :
          key
          ->
          'a1
          t
          ->
          'a1
          t
        
        type 'elt coq_R_remove =
        | R_remove_0 of 'elt
                        t
        | R_remove_1 of 'elt
                        t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_remove_2 of 'elt
                        t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
        | R_remove_3 of 'elt
                        t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * 'elt
             t
           * 'elt
             coq_R_remove
        
        val coq_R_remove_rect :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a1
          t
          ->
          'a1
          coq_R_remove
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a1
          coq_R_remove
          ->
          'a2
        
        val coq_R_remove_rec :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a1
          t
          ->
          'a1
          coq_R_remove
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a1
          coq_R_remove
          ->
          'a2
        
        val remove_rect :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val remove_rec :
          key
          ->
          ('a1
          t
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
        
        val coq_R_remove_correct :
          key
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a1
          coq_R_remove
        
        val elements :
          'a1
          t
          ->
          'a1
          t
        
        val fold :
          (key
          ->
          'a1
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
          ->
          'a2
        
        type ('elt,
              'a) coq_R_fold =
        | R_fold_0 of (key
                      ->
                      'elt
                      ->
                      'a
                      ->
                      'a)
           * 'elt
             t
           * 'a
        | R_fold_1 of (key
                      ->
                      'elt
                      ->
                      'a
                      ->
                      'a)
           * 'elt
             t
           * 'a
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * 'a
           * ('elt,
             'a)
             coq_R_fold
        
        val coq_R_fold_rect :
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          ('a1,
          __)
          coq_R_fold
          ->
          'a2
          ->
          'a2)
          ->
          (key
          ->
          'a1
          ->
          'a3
          ->
          'a3)
          ->
          'a1
          t
          ->
          'a3
          ->
          'a3
          ->
          ('a1,
          'a3)
          coq_R_fold
          ->
          'a2
        
        val coq_R_fold_rec :
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          ('a1,
          __)
          coq_R_fold
          ->
          'a2
          ->
          'a2)
          ->
          (key
          ->
          'a1
          ->
          'a3
          ->
          'a3)
          ->
          'a1
          t
          ->
          'a3
          ->
          'a3
          ->
          ('a1,
          'a3)
          coq_R_fold
          ->
          'a2
        
        val fold_rect :
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          (key
          ->
          'a1
          ->
          'a3
          ->
          'a3)
          ->
          'a1
          t
          ->
          'a3
          ->
          'a2
        
        val fold_rec :
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          (__
          ->
          (key
          ->
          'a1
          ->
          __
          ->
          __)
          ->
          'a1
          t
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          (key
          ->
          'a1
          ->
          'a3
          ->
          'a3)
          ->
          'a1
          t
          ->
          'a3
          ->
          'a2
        
        val coq_R_fold_correct :
          (key
          ->
          'a1
          ->
          'a2
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
          ->
          'a2
          ->
          ('a1,
          'a2)
          coq_R_fold
        
        val equal :
          ('a1
          ->
          'a1
          ->
          bool)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          bool
        
        type 'elt coq_R_equal =
        | R_equal_0 of 'elt
                       t
           * 'elt
             t
        | R_equal_1 of 'elt
                       t
           * 'elt
             t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * bool
           * 'elt
             coq_R_equal
        | R_equal_2 of 'elt
                       t
           * 'elt
             t
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * X.t
           * 'elt
           * (X.t * 'elt)
             list
           * X.t
             compare
        | R_equal_3 of 'elt
                       t
           * 'elt
             t
           * 'elt
             t
           * 'elt
             t
        
        val coq_R_equal_rect :
          ('a1
          ->
          'a1
          ->
          bool)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          bool
          ->
          'a1
          coq_R_equal
          ->
          'a2
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          compare
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          bool
          ->
          'a1
          coq_R_equal
          ->
          'a2
        
        val coq_R_equal_rec :
          ('a1
          ->
          'a1
          ->
          bool)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          bool
          ->
          'a1
          coq_R_equal
          ->
          'a2
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          compare
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          bool
          ->
          'a1
          coq_R_equal
          ->
          'a2
        
        val equal_rect :
          ('a1
          ->
          'a1
          ->
          bool)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          compare
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a2
        
        val equal_rec :
          ('a1
          ->
          'a1
          ->
          bool)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          __
          ->
          __
          ->
          'a2
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          ->
          'a1
          ->
          (X.t * 'a1)
          list
          ->
          __
          ->
          X.t
          compare
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          ('a1
          t
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          __
          ->
          'a1
          t
          ->
          __
          ->
          __
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          'a2
        
        val coq_R_equal_correct :
          ('a1
          ->
          'a1
          ->
          bool)
          ->
          'a1
          t
          ->
          'a1
          t
          ->
          bool
          ->
          'a1
          coq_R_equal
        
        val map :
          ('a1
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
          t
        
        val mapi :
          (key
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          t
          ->
          'a2
          t
        
        val option_cons :
          key
          ->
          'a1
          option
          ->
          (key * 'a1)
          list
          ->
          (key * 'a1)
          list
        
        val map2_l :
          ('a1
          option
          ->
          'a2
          option
          ->
          'a3
          option)
          ->
          'a1
          t
          ->
          'a3
          t
        
        val map2_r :
          ('a1
          option
          ->
          'a2
          option
          ->
          'a3
          option)
          ->
          'a2
          t
          ->
          'a3
          t
        
        val map2 :
          ('a1
          option
          ->
          'a2
          option
          ->
          'a3
          option)
          ->
          'a1
          t
          ->
          'a2
          t
          ->
          'a3
          t
        
        val combine :
          'a1
          t
          ->
          'a2
          t
          ->
          ('a1
          option * 'a2
          option)
          t
        
        val fold_right_pair :
          ('a1
          ->
          'a2
          ->
          'a3
          ->
          'a3)
          ->
          ('a1 * 'a2)
          list
          ->
          'a3
          ->
          'a3
        
        val map2_alt :
          ('a1
          option
          ->
          'a2
          option
          ->
          'a3
          option)
          ->
          'a1
          t
          ->
          'a2
          t
          ->
          (key * 'a3)
          list
        
        val at_least_one :
          'a1
          option
          ->
          'a2
          option
          ->
          ('a1
          option * 'a2
          option)
          option
        
        val at_least_one_then_f :
          ('a1
          option
          ->
          'a2
          option
          ->
          'a3
          option)
          ->
          'a1
          option
          ->
          'a2
          option
          ->
          'a3
          option
       end
      
      type 'elt coq_R_mem =
      | R_mem_0 of 'elt
                   tree
      | R_mem_1 of 'elt
                   tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * bool
         * 'elt
           coq_R_mem
      | R_mem_2 of 'elt
                   tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_mem_3 of 'elt
                   tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * bool
         * 'elt
           coq_R_mem
      
      val coq_R_mem_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
      
      val coq_R_mem_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        bool
        ->
        'a1
        coq_R_mem
        ->
        'a2
      
      type 'elt coq_R_find =
      | R_find_0 of 'elt
                    tree
      | R_find_1 of 'elt
                    tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           option
         * 'elt
           coq_R_find
      | R_find_2 of 'elt
                    tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_find_3 of 'elt
                    tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           option
         * 'elt
           coq_R_find
      
      val coq_R_find_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
      
      val coq_R_find_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        coq_R_find
        ->
        'a2
      
      type 'elt coq_R_bal =
      | R_bal_0 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
      | R_bal_1 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_bal_2 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_bal_3 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_bal_4 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
      | R_bal_5 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_bal_6 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_bal_7 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_bal_8 of 'elt
                   tree
         * key
         * 'elt
         * 'elt
           tree
      
      val coq_R_bal_rect :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_bal
        ->
        'a2
      
      val coq_R_bal_rec :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_bal
        ->
        'a2
      
      type 'elt coq_R_add =
      | R_add_0 of 'elt
                   tree
      | R_add_1 of 'elt
                   tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * 'elt
           coq_R_add
      | R_add_2 of 'elt
                   tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_add_3 of 'elt
                   tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * 'elt
           coq_R_add
      
      val coq_R_add_rect :
        key
        ->
        'a1
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
      
      val coq_R_add_rec :
        key
        ->
        'a1
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_add
        ->
        'a2
      
      type 'elt coq_R_remove_min =
      | R_remove_min_0 of 'elt
                          tree
         * key
         * 'elt
         * 'elt
           tree
      | R_remove_min_1 of 'elt
                          tree
         * key
         * 'elt
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * ('elt
           tree * (key * 'elt))
         * 'elt
           coq_R_remove_min
         * 'elt
           tree
         * (key * 'elt)
      
      val coq_R_remove_min_rect :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2
      
      val coq_R_remove_min_rec :
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        ('a1
        tree * (key * 'a1))
        ->
        'a1
        coq_R_remove_min
        ->
        'a2
      
      type 'elt coq_R_merge =
      | R_merge_0 of 'elt
                     tree
         * 'elt
           tree
      | R_merge_1 of 'elt
                     tree
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_merge_2 of 'elt
                     tree
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * (key * 'elt)
         * key
         * 'elt
      
      val coq_R_merge_rect :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        key
        ->
        'a1
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_merge
        ->
        'a2
      
      val coq_R_merge_rec :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        key
        ->
        'a1
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_merge
        ->
        'a2
      
      type 'elt coq_R_remove =
      | R_remove_0 of 'elt
                      tree
      | R_remove_1 of 'elt
                      tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * 'elt
           coq_R_remove
      | R_remove_2 of 'elt
                      tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_remove_3 of 'elt
                      tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * 'elt
           coq_R_remove
      
      val coq_R_remove_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
      
      val coq_R_remove_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_remove
        ->
        'a2
      
      type 'elt coq_R_concat =
      | R_concat_0 of 'elt
                      tree
         * 'elt
           tree
      | R_concat_1 of 'elt
                      tree
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_concat_2 of 'elt
                      tree
         * 'elt
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           tree
         * (key * 'elt)
      
      val coq_R_concat_rect :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_concat
        ->
        'a2
      
      val coq_R_concat_rec :
        ('a1
        tree
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a1
        tree
        ->
        (key * 'a1)
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        tree
        ->
        'a1
        coq_R_concat
        ->
        'a2
      
      type 'elt coq_R_split =
      | R_split_0 of 'elt
                     tree
      | R_split_1 of 'elt
                     tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           triple
         * 'elt
           coq_R_split
         * 'elt
           tree
         * 'elt
           option
         * 'elt
           tree
      | R_split_2 of 'elt
                     tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_split_3 of 'elt
                     tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt
           triple
         * 'elt
           coq_R_split
         * 'elt
           tree
         * 'elt
           option
         * 'elt
           tree
      
      val coq_R_split_rect :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
      
      val coq_R_split_rec :
        X.t
        ->
        ('a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a2)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        __
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
        ->
        'a1
        tree
        ->
        'a1
        option
        ->
        'a1
        tree
        ->
        __
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a1
        triple
        ->
        'a1
        coq_R_split
        ->
        'a2
      
      type ('elt,
            'elt') coq_R_map_option =
      | R_map_option_0 of 'elt
                          tree
      | R_map_option_1 of 'elt
                          tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt'
         * 'elt'
           tree
         * ('elt,
           'elt')
           coq_R_map_option
         * 'elt'
           tree
         * ('elt,
           'elt')
           coq_R_map_option
      | R_map_option_2 of 'elt
                          tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt'
           tree
         * ('elt,
           'elt')
           coq_R_map_option
         * 'elt'
           tree
         * ('elt,
           'elt')
           coq_R_map_option
      
      val coq_R_map_option_rect :
        (key
        ->
        'a1
        ->
        'a2
        option)
        ->
        ('a1
        tree
        ->
        __
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
      
      val coq_R_map_option_rec :
        (key
        ->
        'a1
        ->
        'a2
        option)
        ->
        ('a1
        tree
        ->
        __
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        ('a1
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
        ->
        'a3)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        ('a1,
        'a2)
        coq_R_map_option
        ->
        'a3
      
      type ('elt,
            'elt',
            'elt'') coq_R_map2_opt =
      | R_map2_opt_0 of 'elt
                        tree
         * 'elt'
           tree
      | R_map2_opt_1 of 'elt
                        tree
         * 'elt'
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
      | R_map2_opt_2 of 'elt
                        tree
         * 'elt'
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt'
           tree
         * key
         * 'elt'
         * 'elt'
           tree
         * I.t
         * 'elt'
           tree
         * 'elt'
           option
         * 'elt'
           tree
         * 'elt''
         * 'elt''
           tree
         * ('elt,
           'elt',
           'elt'')
           coq_R_map2_opt
         * 'elt''
           tree
         * ('elt,
           'elt',
           'elt'')
           coq_R_map2_opt
      | R_map2_opt_3 of 'elt
                        tree
         * 'elt'
           tree
         * 'elt
           tree
         * key
         * 'elt
         * 'elt
           tree
         * I.t
         * 'elt'
           tree
         * key
         * 'elt'
         * 'elt'
           tree
         * I.t
         * 'elt'
           tree
         * 'elt'
           option
         * 'elt'
           tree
         * 'elt''
           tree
         * ('elt,
           'elt',
           'elt'')
           coq_R_map2_opt
         * 'elt''
           tree
         * ('elt,
           'elt',
           'elt'')
           coq_R_map2_opt
      
      val coq_R_map2_opt_rect :
        (key
        ->
        'a1
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        ('a1
        tree
        ->
        'a3
        tree)
        ->
        ('a2
        tree
        ->
        'a3
        tree)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        'a3
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
      
      val coq_R_map2_opt_rec :
        (key
        ->
        'a1
        ->
        'a2
        option
        ->
        'a3
        option)
        ->
        ('a1
        tree
        ->
        'a3
        tree)
        ->
        ('a2
        tree
        ->
        'a3
        tree)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        __
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        'a3
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        ('a1
        tree
        ->
        'a2
        tree
        ->
        'a1
        tree
        ->
        key
        ->
        'a1
        ->
        'a1
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        key
        ->
        'a2
        ->
        'a2
        tree
        ->
        I.t
        ->
        __
        ->
        'a2
        tree
        ->
        'a2
        option
        ->
        'a2
        tree
        ->
        __
        ->
        __
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
        ->
        'a4)
        ->
        'a1
        tree
        ->
        'a2
        tree
        ->
        'a3
        tree
        ->
        ('a1,
        'a2,
        'a3)
        coq_R_map2_opt
        ->
        'a4
      
      val fold' :
        (key
        ->
        'a1
        ->
        'a2
        ->
        'a2)
        ->
        'a1
        tree
        ->
        'a2
        ->
        'a2
      
      val flatten_e :
        'a1
        enumeration
        ->
        (key * 'a1)
        list
     end
   end
  
  type 'elt bst =
    'elt
    Raw.tree
    (* singleton inductive, whose constructor was Bst *)
  
  val bst_rect :
    ('a1
    Raw.tree
    ->
    __
    ->
    'a2)
    ->
    'a1
    bst
    ->
    'a2
  
  val bst_rec :
    ('a1
    Raw.tree
    ->
    __
    ->
    'a2)
    ->
    'a1
    bst
    ->
    'a2
  
  val this :
    'a1
    bst
    ->
    'a1
    Raw.tree
  
  type 'elt t
    =
    'elt
    bst
  
  type key
    =
    E.t
  
  val empty :
    'a1
    t
  
  val is_empty :
    'a1
    t
    ->
    bool
  
  val add :
    key
    ->
    'a1
    ->
    'a1
    t
    ->
    'a1
    t
  
  val remove :
    key
    ->
    'a1
    t
    ->
    'a1
    t
  
  val mem :
    key
    ->
    'a1
    t
    ->
    bool
  
  val find :
    key
    ->
    'a1
    t
    ->
    'a1
    option
  
  val map :
    ('a1
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    t
  
  val mapi :
    (key
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    t
  
  val map2 :
    ('a1
    option
    ->
    'a2
    option
    ->
    'a3
    option)
    ->
    'a1
    t
    ->
    'a2
    t
    ->
    'a3
    t
  
  val elements :
    'a1
    t
    ->
    (key * 'a1)
    list
  
  val cardinal :
    'a1
    t
    ->
    nat
  
  val fold :
    (key
    ->
    'a1
    ->
    'a2
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    ->
    'a2
  
  val equal :
    ('a1
    ->
    'a1
    ->
    bool)
    ->
    'a1
    t
    ->
    'a1
    t
    ->
    bool
 end

module Make : 
 functor (X:OrderedType) ->
 sig 
  module E : 
   sig 
    type t
      =
      X.t
    
    val compare :
      t
      ->
      t
      ->
      t
      compare
    
    val eq_dec :
      t
      ->
      t
      ->
      bool
   end
  
  module Raw : 
   sig 
    type key
      =
      X.t
    
    type 'elt tree =
    | Leaf
    | Node of 'elt
              tree
       * key
       * 'elt
       * 'elt
         tree
       * Z_as_Int.t
    
    val tree_rect :
      'a2
      ->
      ('a1
      tree
      ->
      'a2
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a2
      ->
      Z_as_Int.t
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
    
    val tree_rec :
      'a2
      ->
      ('a1
      tree
      ->
      'a2
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a2
      ->
      Z_as_Int.t
      ->
      'a2)
      ->
      'a1
      tree
      ->
      'a2
    
    val height :
      'a1
      tree
      ->
      Z_as_Int.t
    
    val cardinal :
      'a1
      tree
      ->
      nat
    
    val empty :
      'a1
      tree
    
    val is_empty :
      'a1
      tree
      ->
      bool
    
    val mem :
      X.t
      ->
      'a1
      tree
      ->
      bool
    
    val find :
      X.t
      ->
      'a1
      tree
      ->
      'a1
      option
    
    val create :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val assert_false :
      'a1
      tree
      ->
      key
      ->
      'a1
      ->
      'a1
      tree
      ->
      'a1
      tree
    
    val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    val add : key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    val remove_min :
      'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1)
    
    val merge : 'a1 tree -> 'a1 tree -> 'a1 tree
    
    val remove : X.t -> 'a1 tree -> 'a1 tree
    
    val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                         t_right : 'elt tree }
    
    val triple_rect :
      ('a1 tree -> 'a1 option -> 'a1 tree -> 'a2) -> 'a1 triple -> 'a2
    
    val triple_rec :
      ('a1 tree -> 'a1 option -> 'a1 tree -> 'a2) -> 'a1 triple -> 'a2
    
    val t_left : 'a1 triple -> 'a1 tree
    
    val t_opt : 'a1 triple -> 'a1 option
    
    val t_right : 'a1 triple -> 'a1 tree
    
    val split : X.t -> 'a1 tree -> 'a1 triple
    
    val concat : 'a1 tree -> 'a1 tree -> 'a1 tree
    
    val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list
    
    val elements : 'a1 tree -> (key * 'a1) list
    
    val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
    
    type 'elt enumeration =
    | End
    | More of key * 'elt * 'elt tree * 'elt enumeration
    
    val enumeration_rect :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2
    
    val enumeration_rec :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2
    
    val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration
    
    val equal_more :
      ('a1 -> 'a1 -> bool) -> X.t -> 'a1 -> ('a1 enumeration -> bool) -> 'a1
      enumeration -> bool
    
    val equal_cont :
      ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
      enumeration -> bool
    
    val equal_end : 'a1 enumeration -> bool
    
    val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool
    
    val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree
    
    val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree
    
    val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree
    
    val map2_opt :
      (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
      ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree
    
    val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree -> 'a3
      tree
    
    module Proofs : 
     sig 
      module MX : 
       sig 
        module TO : 
         sig 
          type t = X.t
         end
        
        module IsTO : 
         sig 
          
         end
        
        module OrderTac : 
         sig 
          
         end
        
        val eq_dec : X.t -> X.t -> bool
        
        val lt_dec : X.t -> X.t -> bool
        
        val eqb : X.t -> X.t -> bool
       end
      
      module PX : 
       sig 
        module MO : 
         sig 
          module TO : 
           sig 
            type t = X.t
           end
          
          module IsTO : 
           sig 
            
           end
          
          module OrderTac : 
           sig 
            
           end
          
          val eq_dec : X.t -> X.t -> bool
          
          val lt_dec : X.t -> X.t -> bool
          
          val eqb : X.t -> X.t -> bool
         end
       end
      
      module L : 
       sig 
        module MX : 
         sig 
          module TO : 
           sig 
            type t = X.t
           end
          
          module IsTO : 
           sig 
            
           end
          
          module OrderTac : 
           sig 
            
           end
          
          val eq_dec : X.t -> X.t -> bool
          
          val lt_dec : X.t -> X.t -> bool
          
          val eqb : X.t -> X.t -> bool
         end
        
        module PX : 
         sig 
          module MO : 
           sig 
            module TO : 
             sig 
              type t = X.t
             end
            
            module IsTO : 
             sig 
              
             end
            
            module OrderTac : 
             sig 
              
             end
            
            val eq_dec : X.t -> X.t -> bool
            
            val lt_dec : X.t -> X.t -> bool
            
            val eqb : X.t -> X.t -> bool
           end
         end
        
        type key = X.t
        
        type 'elt t = (X.t * 'elt) list
        
        val empty : 'a1 t
        
        val is_empty : 'a1 t -> bool
        
        val mem : key -> 'a1 t -> bool
        
        type 'elt coq_R_mem =
        | R_mem_0 of 'elt t
        | R_mem_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_mem_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_mem_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * bool
           * 'elt coq_R_mem
        
        val coq_R_mem_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem ->
          'a2 -> 'a2) -> 'a1 t -> bool -> 'a1 coq_R_mem -> 'a2
        
        val coq_R_mem_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem ->
          'a2 -> 'a2) -> 'a1 t -> bool -> 'a1 coq_R_mem -> 'a2
        
        val mem_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t ->
          'a2
        
        val mem_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t ->
          'a2
        
        val coq_R_mem_correct : key -> 'a1 t -> bool -> 'a1 coq_R_mem
        
        val find : key -> 'a1 t -> 'a1 option
        
        type 'elt coq_R_find =
        | R_find_0 of 'elt t
        | R_find_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_find_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_find_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt option
           * 'elt coq_R_find
        
        val coq_R_find_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 option -> 'a1
          coq_R_find -> 'a2 -> 'a2) -> 'a1 t -> 'a1 option -> 'a1 coq_R_find
          -> 'a2
        
        val coq_R_find_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 option -> 'a1
          coq_R_find -> 'a2 -> 'a2) -> 'a1 t -> 'a1 option -> 'a1 coq_R_find
          -> 'a2
        
        val find_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t ->
          'a2
        
        val find_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t ->
          'a2
        
        val coq_R_find_correct : key -> 'a1 t -> 'a1 option -> 'a1 coq_R_find
        
        val add : key -> 'a1 -> 'a1 t -> 'a1 t
        
        type 'elt coq_R_add =
        | R_add_0 of 'elt t
        | R_add_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_add_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_add_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt t
           * 'elt coq_R_add
        
        val coq_R_add_rect :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t ->
          'a1 -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_add
          -> 'a2 -> 'a2) -> 'a1 t -> 'a1 t -> 'a1 coq_R_add -> 'a2
        
        val coq_R_add_rec :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t ->
          'a1 -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_add
          -> 'a2 -> 'a2) -> 'a1 t -> 'a1 t -> 'a1 coq_R_add -> 'a2
        
        val add_rect :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t ->
          'a1 -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t
          -> 'a2
        
        val add_rec :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t ->
          'a1 -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t
          -> 'a2
        
        val coq_R_add_correct : key -> 'a1 -> 'a1 t -> 'a1 t -> 'a1 coq_R_add
        
        val remove : key -> 'a1 t -> 'a1 t
        
        type 'elt coq_R_remove =
        | R_remove_0 of 'elt t
        | R_remove_1 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_remove_2 of 'elt t * X.t * 'elt * (X.t * 'elt) list
        | R_remove_3 of 'elt t * X.t * 'elt * (X.t * 'elt) list * 'elt t
           * 'elt coq_R_remove
        
        val coq_R_remove_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove
          -> 'a2 -> 'a2) -> 'a1 t -> 'a1 t -> 'a1 coq_R_remove -> 'a2
        
        val coq_R_remove_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove
          -> 'a2 -> 'a2) -> 'a1 t -> 'a1 t -> 'a1 coq_R_remove -> 'a2
        
        val remove_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t ->
          'a2
        
        val remove_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 -> (X.t * 'a1)
          list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t -> X.t -> 'a1
          -> (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t ->
          'a2
        
        val coq_R_remove_correct : key -> 'a1 t -> 'a1 t -> 'a1 coq_R_remove
        
        val elements : 'a1 t -> 'a1 t
        
        val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
        
        type ('elt, 'a) coq_R_fold =
        | R_fold_0 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a
        | R_fold_1 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a * X.t * 
           'elt * (X.t * 'elt) list * 'a * ('elt, 'a) coq_R_fold
        
        val coq_R_fold_rect :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2 -> 'a2)
          -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a3 -> ('a1, 'a3)
          coq_R_fold -> 'a2
        
        val coq_R_fold_rec :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2 -> 'a2)
          -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a3 -> ('a1, 'a3)
          coq_R_fold -> 'a2
        
        val fold_rect :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3)
          -> 'a1 t -> 'a3 -> 'a2
        
        val fold_rec :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3)
          -> 'a1 t -> 'a3 -> 'a2
        
        val coq_R_fold_correct :
          (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 -> ('a1, 'a2)
          coq_R_fold
        
        val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
        
        type 'elt coq_R_equal =
        | R_equal_0 of 'elt t * 'elt t
        | R_equal_1 of 'elt t * 'elt t * X.t * 'elt * (X.t * 'elt) list * 
           X.t * 'elt * (X.t * 'elt) list * bool * 'elt coq_R_equal
        | R_equal_2 of 'elt t * 'elt t * X.t * 'elt * (X.t * 'elt) list * 
           X.t * 'elt * (X.t * 'elt) list * X.t compare
        | R_equal_3 of 'elt t * 'elt t * 'elt t * 'elt t
        
        val coq_R_equal_rect :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_equal ->
          'a2 -> 'a2) -> ('a1 t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
          __ -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t compare -> __ ->
          __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __
          -> 'a2) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal -> 'a2
        
        val coq_R_equal_rec :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> bool -> 'a1 coq_R_equal ->
          'a2 -> 'a2) -> ('a1 t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list ->
          __ -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t compare -> __ ->
          __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __
          -> 'a2) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal -> 'a2
        
        val equal_rect :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> ('a1 t -> 'a1
          t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1 t
          -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t ->
          'a1 t -> 'a2
        
        val equal_rec :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> __ -> __ -> 'a2 -> 'a2) -> ('a1 t -> 'a1
          t -> X.t -> 'a1 -> (X.t * 'a1) list -> __ -> X.t -> 'a1 ->
          (X.t * 'a1) list -> __ -> X.t compare -> __ -> __ -> 'a2) -> ('a1 t
          -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t ->
          'a1 t -> 'a2
        
        val coq_R_equal_correct :
          ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal
        
        val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
        
        val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
        
        val option_cons :
          key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list
        
        val map2_l :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t
        
        val map2_r :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t
        
        val map2 :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
        
        val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t
        
        val fold_right_pair :
          ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3
        
        val map2_alt :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
          (key * 'a3) list
        
        val at_least_one :
          'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option
        
        val at_least_one_then_f :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2
          option -> 'a3 option
       end
      
      type 'elt coq_R_mem =
      | R_mem_0 of 'elt tree
      | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * bool * 'elt coq_R_mem
      | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * bool * 'elt coq_R_mem
      
      val coq_R_mem_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1
        coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2
      
      val coq_R_mem_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1
        coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2
      
      type 'elt coq_R_find =
      | R_find_0 of 'elt tree
      | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt option * 'elt coq_R_find
      | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt option * 'elt coq_R_find
      
      val coq_R_find_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 option -> 'a1
        coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option ->
        'a1 coq_R_find -> 'a2
      
      val coq_R_find_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 option -> 'a1
        coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option ->
        'a1 coq_R_find -> 'a2
      
      type 'elt coq_R_bal =
      | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
      | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
      | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_bal_8 of 'elt tree * key * 'elt * 'elt tree
      
      val coq_R_bal_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1
        -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree
        -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
      
      val coq_R_bal_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1
        -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree
        -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
      
      type 'elt coq_R_add =
      | R_add_0 of 'elt tree
      | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_add
      | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_add
      
      val coq_R_add_rect :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_add -> 'a2
      
      val coq_R_add_rec :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_add -> 'a2
      
      type 'elt coq_R_remove_min =
      | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
      | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree
         * key * 'elt * 'elt tree * Z_as_Int.t * ('elt tree * (key * 'elt))
         * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)
      
      val coq_R_remove_min_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2
      
      val coq_R_remove_min_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2
      
      type 'elt coq_R_merge =
      | R_merge_0 of 'elt tree * 'elt tree
      | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t
      | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * (key * 'elt) * key * 'elt
      
      val coq_R_merge_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) ->
        'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
      
      val coq_R_merge_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) ->
        'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
      
      type 'elt coq_R_remove =
      | R_remove_0 of 'elt tree
      | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_remove
      | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_remove
      
      val coq_R_remove_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
        'a1 coq_R_remove -> 'a2
      
      val coq_R_remove_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
        'a1 coq_R_remove -> 'a2
      
      type 'elt coq_R_concat =
      | R_concat_0 of 'elt tree * 'elt tree
      | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t
      | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * (key * 'elt)
      
      val coq_R_concat_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1
        tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
      
      val coq_R_concat_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1
        tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
      
      type 'elt coq_R_split =
      | R_split_0 of 'elt tree
      | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
         * 'elt option * 'elt tree
      | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
         * 'elt option * 'elt tree
      
      val coq_R_split_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
      
      val coq_R_split_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
      
      type ('elt, 'elt') coq_R_map_option =
      | R_map_option_0 of 'elt tree
      | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt' * 'elt' tree * ('elt, 'elt') coq_R_map_option
         * 'elt' tree * ('elt, 'elt') coq_R_map_option
      | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt' tree * ('elt, 'elt') coq_R_map_option
         * 'elt' tree * ('elt, 'elt') coq_R_map_option
      
      val coq_R_map_option_rect :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 -> __
        -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
        -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3
      
      val coq_R_map_option_rec :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 -> __
        -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
        -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3
      
      type ('elt, 'elt', 'elt'') coq_R_map2_opt =
      | R_map2_opt_0 of 'elt tree * 'elt' tree
      | R_map2_opt_1 of 'elt tree * 'elt' tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t
      | R_map2_opt_2 of 'elt tree * 'elt' tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt' tree * key * 'elt' * 'elt' tree
         * Z_as_Int.t * 'elt' tree * 'elt' option * 'elt' tree * 'elt''
         * 'elt'' tree * ('elt, 'elt', 'elt'') coq_R_map2_opt * 'elt'' tree
         * ('elt, 'elt', 'elt'') coq_R_map2_opt
      | R_map2_opt_3 of 'elt tree * 'elt' tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt' tree * key * 'elt' * 'elt' tree
         * Z_as_Int.t * 'elt' tree * 'elt' option * 'elt' tree * 'elt'' tree
         * ('elt, 'elt', 'elt'') coq_R_map2_opt * 'elt'' tree
         * ('elt, 'elt', 'elt'') coq_R_map2_opt
      
      val coq_R_map2_opt_rect :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
        tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __
        -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
        'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> Z_as_Int.t -> __ ->
        'a2 tree -> 'a2 option -> 'a2 tree -> __ -> __ -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3)
        coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3 tree ->
        ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4
      
      val coq_R_map2_opt_rec :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
        tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __
        -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
        'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> Z_as_Int.t -> __ ->
        'a2 tree -> 'a2 option -> 'a2 tree -> __ -> __ -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3)
        coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3 tree ->
        ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4
      
      val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
      
      val flatten_e : 'a1 enumeration -> (key * 'a1) list
     end
   end
  
  type 'elt bst =
    'elt Raw.tree
    (* singleton inductive, whose constructor was Bst *)
  
  val bst_rect : ('a1 Raw.tree -> __ -> 'a2) -> 'a1 bst -> 'a2
  
  val bst_rec : ('a1 Raw.tree -> __ -> 'a2) -> 'a1 bst -> 'a2
  
  val this : 'a1 bst -> 'a1 Raw.tree
  
  type 'elt t = 'elt bst
  
  type key = E.t
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val find : key -> 'a1 t -> 'a1 option
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end

type 'world action = 'world -> 'world

type ('input, 'world) process = ('input, 'world) __process Lazy.t
and ('input, 'world) __process =
| Step of ('input -> 'world action * ('input, 'world) process)

type ('input, 'world) stackWorld =
| StackDone
| StackPush of 'input * ('input, 'world) stackWorld
| StackLift of 'world action * ('input, 'world) stackWorld

type ('input, 'world) stackProcess =
  ('input, ('input, 'world) stackWorld) process

val stepStackProcess :
  (('a1, 'a2) stackWorld * ('a1, 'a2) stackProcess) -> 'a2 action * ('a1,
  'a2) stackProcess

val runStackProcess : ('a1, 'a2) stackProcess -> ('a1, 'a2) process

val zero0 : char

val one0 : char

val shift : bool -> char -> char

val ascii_of_pos : Big.big_int -> char

val ascii_of_N : Big.big_int -> char

val n_of_digits : bool list -> Big.big_int

val n_of_ascii : char -> Big.big_int

val string_dec : char list -> char list -> bool

val append : char list -> char list -> char list

val length0 : char list -> nat

val substring : nat -> nat -> char list -> char list

type ('world, 't) abortable =
| Started of 'world action
| Done of 't

type httpStatus =
| HttpOk
| HttpPreconditionFailed
| HttpUnrecognizedCode

type httpResponse = { httpResponseStatus : httpStatus;
                      httpResponseStatusText : char list;
                      httpResponseProtocol : char list;
                      httpResponseHeader : (char list * char list) list;
                      httpResponseBody : char list }

val httpResponseStatus : httpResponse -> httpStatus

val httpResponseBody : httpResponse -> char list

type ('input, 'world) systemActions = { consoleErr : (char list -> 'world
                                                     action);
                                        consoleIn : ((char list -> 'input) ->
                                                    'world action);
                                        consoleOut : (char list -> 'world
                                                     action);
                                        exit : (Big.big_int -> 'world action);
                                        getArgv : ((char list list -> 'input)
                                                  -> 'world action);
                                        getNanosecs : ((Big.big_int ->
                                                      'input) -> 'world
                                                      action);
                                        getRandomness : (Big.big_int ->
                                                        (char list -> 'input)
                                                        -> 'world action);
                                        httpPOST : (char list ->
                                                   (char list * char list)
                                                   list -> (('world,
                                                   httpResponse) abortable ->
                                                   'input) -> 'world action);
                                        setDebug : (Big.big_int -> 'world
                                                   action);
                                        sleepNanosecs : (Big.big_int ->
                                                        'input -> 'world
                                                        action) }

val consoleErr : ('a1, 'a2) systemActions -> char list -> 'a2 action

val consoleIn : ('a1, 'a2) systemActions -> (char list -> 'a1) -> 'a2 action

val consoleOut : ('a1, 'a2) systemActions -> char list -> 'a2 action

val exit : ('a1, 'a2) systemActions -> Big.big_int -> 'a2 action

val getArgv :
  ('a1, 'a2) systemActions -> (char list list -> 'a1) -> 'a2 action

val getNanosecs :
  ('a1, 'a2) systemActions -> (Big.big_int -> 'a1) -> 'a2 action

val getRandomness :
  ('a1, 'a2) systemActions -> Big.big_int -> (char list -> 'a1) -> 'a2 action

val httpPOST :
  ('a1, 'a2) systemActions -> char list -> (char list * char list) list ->
  (('a2, httpResponse) abortable -> 'a1) -> 'a2 action

val setDebug : ('a1, 'a2) systemActions -> Big.big_int -> 'a2 action

val sleepNanosecs :
  ('a1, 'a2) systemActions -> Big.big_int -> 'a1 -> 'a2 action

val apply : ('a1 -> 'a2) -> 'a1 -> 'a2

val flip0 : ('a1 -> 'a2 -> 'a3) -> 'a2 -> 'a1 -> 'a3

val msum : 'a1 option list -> 'a1 option

val default : 'a1 -> 'a1 option -> 'a1

val splitn : nat -> 'a1 list -> 'a1 list * 'a1 list

val flat : 'a1 list list -> 'a1 list

val sum0 : 'a1 -> ('a1 -> 'a1 -> 'a1) -> 'a1 list -> 'a1

val repeat : 'a1 -> nat -> 'a1 list

val lcshift : nat -> 'a1 list -> 'a1 list

val range : nat -> nat -> 'a1 list -> 'a1 list

val forall2 : ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool

val map0 : ('a1 -> 'a2 -> 'a3) -> 'a1 list -> 'a2 list -> 'a3 list

val mapi' : nat -> (nat -> 'a1 -> 'a2) -> 'a1 list -> 'a2 list

val mapi0 : (nat -> 'a1 -> 'a2) -> 'a1 list -> 'a2 list

val iter_range : ('a1 -> nat -> 'a1) -> nat -> nat -> 'a1 -> 'a1

val iter_range_collect_rev :
  ('a1 -> nat -> 'a1) -> nat -> nat -> 'a1 -> 'a1 list -> 'a1 list

val iter_range_collect :
  ('a1 -> nat -> 'a1) -> nat -> nat -> 'a1 -> 'a1 list -> 'a1 list

val iter_collect : ('a1 -> nat -> 'a1) -> nat -> 'a1 -> 'a1 list -> 'a1 list

val for_range : nat -> nat -> (nat -> 'a1) -> 'a1 list

val for_n : nat -> (nat -> 'a1) -> 'a1 list

val slice' : nat -> nat -> 'a1 list -> 'a1 list list

val slice : nat -> 'a1 list -> 'a1 list list

val mapi_every : nat -> (nat -> 'a1 list -> 'a1 list) -> 'a1 list -> 'a1 list

val map_every : nat -> ('a1 list -> 'a1 list) -> 'a1 list -> 'a1 list

val n_of_ascii_in : char -> char -> Big.big_int -> char -> Big.big_int option

val str_to_list : char list -> char list

val list_to_str : char list -> char list

type bitvec = bool list

type b128 = bitvec

type b352 = bitvec

type byte = bitvec

val get_slice : 'a1 list -> nat -> nat -> 'a1 list

val get : nat -> bitvec -> nat -> bool list

val set_slice : 'a1 list -> nat -> 'a1 list -> 'a1 list

val set : nat -> bitvec -> nat -> bool list -> bool list

type key_t = b128

type key_schedule_t = b352

val zeros : nat -> bool list

val of_bin_ascii : char -> bool

val bitvec_of_bin_str : char list -> bitvec

val right_trunc_pad_to : nat -> bitvec -> bitvec

val lsb_of_pos : Big.big_int -> bitvec

val lsb_of_N : Big.big_int -> byte

val lsb_to_N : bitvec -> Big.big_int

val lsb_to_nat : bitvec -> nat

val msb_to_N : bool list -> Big.big_int

val msb_to_nat : bool list -> nat

val msb_of_N : nat -> Big.big_int -> bitvec

val msb_of_nat : nat -> nat -> bitvec

val byte_of_N : Big.big_int -> byte

val byte_of_nat : nat -> byte

val byte_to_nat : byte -> nat

val n_of_hex_ascii : char -> Big.big_int

val map_byte : (byte -> byte) -> bitvec -> bitvec

val halfbyte_of_hex_ascii : char -> bool list

val remove_space : char -> bool

val bitvec_of_hex : char list -> bitvec

val left_trunc_pad_to : nat -> bool list -> bool list

val byte_of_hex : char list -> byte

val bitvec_eqb : bool list -> bool list -> bool

val bit_xor : bool -> bool -> bool

val xor : bitvec -> bitvec -> bitvec

val rshift : nat -> bitvec -> bool list

val f231 : ('a1 -> 'a2 -> 'a3 -> 'a4) -> 'a2 -> 'a3 -> 'a1 -> 'a4

val gf_mul : nat -> bitvec -> bitvec -> bitvec -> bitvec

val ascii_to_byte : char -> byte

val str_to_bitvec : char list -> bool list

val byte_to_ascii : bool list -> char

val bitvec_to_str : bool list -> char list

val s_box : byte list

val rC : byte list

val list_get : byte list -> nat -> byte

val sub_byte : byte -> byte

val get_byte : bitvec -> nat -> bool list

val set_byte : bitvec -> nat -> bool list -> bool list

val lcshift_byte : bool list -> bool list

val g : nat -> key_t -> bool list

val gen_round_key : key_t -> nat -> key_t

val key_schedule : key_t -> key_schedule_t

type 'a matrix = 'a list list

val trans_mx : 'a1 -> 'a1 matrix -> nat -> nat -> 'a1 matrix

val to_row_major_mx : nat -> nat -> 'a1 list -> 'a1 matrix

val to_col_major_mx : 'a1 -> nat -> nat -> 'a1 list -> 'a1 matrix

val of_row_major_mx : 'a1 matrix -> nat -> nat -> 'a1 list

val of_col_major_mx : 'a1 -> 'a1 matrix -> nat -> nat -> 'a1 list

val mx_mul :
  'a1 -> ('a1 -> 'a1 -> 'a1) -> ('a1 -> 'a1 -> 'a1) -> 'a1 matrix -> nat ->
  nat -> 'a1 matrix -> nat -> 'a1 matrix

val shift_rows : byte matrix -> byte list list

val mix_matrix : byte matrix

val gf8_byte_mul : byte -> byte -> byte

val mix_rows : byte matrix -> byte matrix

val add_round_key : b128 -> b128 -> bitvec

val round : bool -> b128 -> b128 -> bool list

val encrypt : key_t -> b128 -> bool list

val stateful_map :
  ('a1 -> 'a1) -> 'a1 -> ('a2 -> 'a1 -> 'a2) -> 'a2 list -> 'a2 list * 'a1

val fold_left_i : (nat -> 'a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> nat -> 'a1

val len : 'a1 list -> bitvec

val gf128_mul : bitvec -> bitvec -> bitvec

val gHASH : b128 -> bitvec -> bitvec -> b128

type iV_t = bitvec

type a_t = bitvec

val h : (key_t -> b128 -> b128) -> key_t -> b128

val msb_unsign_plus : bitvec -> bitvec -> bitvec

val incr : bool list -> bool list

val y0 : (key_t -> b128 -> b128) -> key_t -> iV_t -> b128

val encrypt0 : (key_t -> b128 -> b128) -> key_t -> iV_t -> bitvec -> bitvec

val hash :
  (key_t -> b128 -> b128) -> key_t -> iV_t -> a_t -> nat -> bitvec -> bool
  list

val encrypt1 :
  (key_t -> b128 -> b128) -> key_t -> iV_t -> bitvec -> a_t -> nat ->
  bitvec * bool list

val decrypt :
  (key_t -> b128 -> b128) -> key_t -> iV_t -> bitvec -> a_t -> bitvec ->
  bitvec option

module type EncryptionDataTypes = 
 sig 
  type rawDataT 
  
  type masterKeyT 
  
  type encryptedDataT 
  
  type systemRandomnessT 
  
  type systemRandomnessHintT 
 end

module EncryptionStringDataTypes : 
 sig 
  type rawDataT = char list
  
  type masterKeyT = char list
  
  type encryptedDataT = char list
  
  type systemRandomnessT = char list
  
  type systemRandomnessHintT = nat
 end

type ('systemRandomnessHintT, 'systemRandomnessT) encryptionError =
| NotEnoughRandomness of 'systemRandomnessHintT * 'systemRandomnessT

module AESGCM : 
 sig 
  val isValidMasterKey : EncryptionStringDataTypes.masterKeyT -> bool
  
  val randomnessHint :
    EncryptionStringDataTypes.rawDataT ->
    EncryptionStringDataTypes.systemRandomnessHintT
  
  val encrypt :
    EncryptionStringDataTypes.systemRandomnessT ->
    EncryptionStringDataTypes.masterKeyT ->
    EncryptionStringDataTypes.rawDataT ->
    (EncryptionStringDataTypes.encryptedDataT,
    (EncryptionStringDataTypes.systemRandomnessHintT,
    EncryptionStringDataTypes.systemRandomnessT) encryptionError) sum
  
  val decrypt :
    EncryptionStringDataTypes.masterKeyT ->
    EncryptionStringDataTypes.encryptedDataT ->
    (EncryptionStringDataTypes.rawDataT, __) sum
  
  val doit :
    (EncryptionStringDataTypes.encryptedDataT,
    (EncryptionStringDataTypes.systemRandomnessHintT,
    EncryptionStringDataTypes.systemRandomnessT) encryptionError) sum ->
    EncryptionStringDataTypes.encryptedDataT
  
  val check :
    (EncryptionStringDataTypes.rawDataT, __) sum ->
    EncryptionStringDataTypes.rawDataT option
  
  module Coq_test1 : 
   sig 
    val coq_K : char list
    
    val coq_R : char list
    
    val coq_P : char list
    
    val coq_C : EncryptionStringDataTypes.encryptedDataT
    
    val bad1 : char list
    
    val bad2 : char list
    
    val replace3 : char list
    
    val bad3 : char list
   end
  
  module Coq_test2 : 
   sig 
    val coq_K : char list
    
    val coq_R : char list
    
    val coq_P : char list
    
    val coq_C : EncryptionStringDataTypes.encryptedDataT
    
    val bad1 : char list
    
    val bad2 : char list
    
    val replace3 : char list
    
    val bad3 : char list
   end
 end

type 'a serializable =
  'a -> char list
  (* singleton inductive, whose constructor was Build_Serializable *)

val to_string : 'a1 serializable -> 'a1 -> char list

type 'a deserializable =
  char list -> 'a option * char list
  (* singleton inductive, whose constructor was Build_Deserializable *)

val from_string : 'a1 deserializable -> char list -> 'a1 option * char list

type 'a prefixSerializable = { serialize : 'a serializable;
                               deserialize : 'a deserializable }

val serialize : 'a1 prefixSerializable -> 'a1 serializable

val deserialize : 'a1 prefixSerializable -> 'a1 deserializable

module type SerializableOrderedType = 
 sig 
  type t 
  
  val compare : t -> t -> t compare
  
  val eq_dec : t -> t -> bool
  
  val coq_PrefixSerializable_ord : t prefixSerializable
 end

val string_of_Npositive : Big.big_int -> char list

val string_of_N : Big.big_int -> char list

val n_of_string_helper :
  char list -> Big.big_int -> char list -> Big.big_int option * char list

val n_of_string : char list -> Big.big_int option * char list

val serializable_N : Big.big_int serializable

val deserializable_N : Big.big_int deserializable

val prod_map : ('a1 -> 'a2) -> ('a3 -> 'a4) -> ('a1 * 'a3) -> 'a2 * 'a4

val serializable_nat : nat serializable

val deserializable_nat : nat deserializable

val string_drop : nat -> char list -> char list

val serializable_string : char list serializable

val deserializable_string : char list deserializable

val prefixSerializable_string : __ -> char list prefixSerializable

val serializable_unit : unit serializable

val deserializable_unit : unit deserializable

val serializable_sum :
  'a1 serializable -> 'a2 serializable -> ('a1, 'a2) sum serializable

val deserializable_sum :
  'a1 deserializable -> 'a2 deserializable -> ('a1, 'a2) sum deserializable

val serializable_option : 'a1 serializable -> 'a1 option serializable

val deserializable_option : 'a1 deserializable -> 'a1 option deserializable

val serializable_prod :
  'a1 serializable -> 'a2 serializable -> ('a1 * 'a2) serializable

val deserializable_prod :
  'a1 deserializable -> 'a2 deserializable -> ('a1 * 'a2) deserializable

val list_to_string_helper : 'a1 serializable -> 'a1 list -> char list

val list_to_string : 'a1 serializable -> 'a1 list -> char list

val list_from_string_helper :
  'a1 deserializable -> nat -> char list -> 'a1 list option * char list

val list_from_string :
  'a1 deserializable -> char list -> 'a1 list option * char list

val serializable_list : 'a1 serializable -> 'a1 list serializable

val deserializable_list : 'a1 deserializable -> 'a1 list deserializable

module MakeSerializableMergableMap : 
 functor (E:SerializableOrderedType) ->
 functor (M:sig 
  type key = E.t
  
  type 'x t 
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val find : key -> 'a1 t -> 'a1 option
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end) ->
 sig 
  type key = M.key
  
  type 'elt t = (nat * 'elt option) M.t
  
  val empty : (nat * 'a1 option) M.t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val find : key -> 'a1 t -> 'a1 option
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val garbage_collect : 'a1 t -> 'a1 t
  
  val filter_some : ('a1 * 'a2 option) list -> ('a1 * 'a2) list
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
  
  val merge : 'a1 t -> 'a1 t -> 'a1 t
  
  val from_internal_elements : (M.key * (nat * 'a1 option)) list -> 'a1 t
  
  val is_sorted : (M.key * (nat * 'a1 option)) list -> bool
  
  val sorted_from_internal_elements :
    (M.key * (nat * 'a1 option)) list option -> 'a1 t option
  
  val coq_Serializable_map : 'a1 serializable -> 'a1 t serializable
  
  val coq_Deserializable_map : 'a1 deserializable -> 'a1 t deserializable
  
  val coq_PrefixSerializable_map :
    'a1 prefixSerializable -> 'a1 t prefixSerializable
 end

val string_lt : char list -> char list -> bool

module String_as_SOT : 
 sig 
  type t = char list
  
  val compare' : t -> t -> comparison
  
  val compare : t -> t -> t compare
  
  val eq_dec : t -> t -> bool
  
  val coq_PrefixSerializable_ord : t prefixSerializable
 end

module PwMgrUI : 
 functor (KVStore:sig 
  type key = char list
  
  type 'x t 
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val find : key -> 'a1 t -> 'a1 option
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
  
  val coq_Serializable_map : 'a1 serializable -> 'a1 t serializable
  
  val coq_Deserializable_map : 'a1 deserializable -> 'a1 t deserializable
  
  val coq_PrefixSerializable_map :
    'a1 prefixSerializable -> 'a1 t prefixSerializable
  
  val merge : 'a1 t -> 'a1 t -> 'a1 t
 end) ->
 sig 
  type uiInput =
  | Coq_uiConsoleIn of char list
  | Coq_uiGotUpdate of char list
  
  val uiInput_rect :
    (char list -> 'a1) -> (char list -> 'a1) -> uiInput -> 'a1
  
  val uiInput_rec :
    (char list -> 'a1) -> (char list -> 'a1) -> uiInput -> 'a1
  
  type uiOutput =
  | Coq_uiGetUpdate
  | Coq_uiSetData of char list
  | Coq_uiConsoleOut of char list
  
  val uiOutput_rect :
    'a1 -> (char list -> 'a1) -> (char list -> 'a1) -> uiOutput -> 'a1
  
  val uiOutput_rec :
    'a1 -> (char list -> 'a1) -> (char list -> 'a1) -> uiOutput -> 'a1
  
  val split :
    char
    ->
    char list
    ->
    char list
    list
  
  val newline :
    char
  
  val dump :
    (char list * char list)
    list
    ->
    char list
  
  val load :
    char list
    ->
    (char list * char list)
    list
  
  val list_dec :
    'a1
    list
    ->
    ('a1 * 'a1
    list)
    option
  
  val uiLoopBody :
    (uiOutput
    ->
    'a1
    action)
    ->
    (char list
    KVStore.t
    ->
    (uiInput,
    'a1)
    process)
    ->
    char list
    KVStore.t
    ->
    uiInput
    ->
    'a1
    action * (uiInput,
    'a1)
    process
  
  val uiLoop :
    (uiOutput
    ->
    'a1
    action)
    ->
    char list
    KVStore.t
    ->
    (uiInput,
    'a1)
    process
  
  val ui :
    (uiOutput
    ->
    'a1
    action)
    ->
    (uiInput,
    'a1)
    process
 end

type publishDurationT =
| DurationOf of Big.big_int
| Inf

val duration_leb :
  Big.big_int
  ->
  publishDurationT
  ->
  bool

type 'dataT tickBoxPreState =
| NoData of Big.big_int
| InitiallyWaitingOnData of Big.big_int
| HaveData of Big.big_int
   * 'dataT
   * Big.big_int
     option
| WaitingOnData of Big.big_int
   * Big.big_int
     option
| WaitingOnTicks of Big.big_int
   * Big.big_int
     option

type 'dataT tickBoxState = { curData : 'dataT
                                       tickBoxPreState;
                             publishInterval : Big.big_int;
                             publishDuration : publishDurationT;
                             waitBeforeUpdateInterval : Big.big_int;
                             publishPrecision : Big.big_int }

val curData :
  'a1
  tickBoxState
  ->
  'a1
  tickBoxPreState

val publishInterval :
  'a1
  tickBoxState
  ->
  Big.big_int

val publishDuration :
  'a1
  tickBoxState
  ->
  publishDurationT

val waitBeforeUpdateInterval :
  'a1
  tickBoxState
  ->
  Big.big_int

val publishPrecision :
  'a1
  tickBoxState
  ->
  Big.big_int

val set_curData :
  'a1
  tickBoxState
  ->
  'a1
  tickBoxPreState
  ->
  'a1
  tickBoxState

val set_publishInterval :
  'a1
  tickBoxState
  ->
  Big.big_int
  ->
  'a1
  tickBoxState

val set_publishDuration :
  'a1
  tickBoxState
  ->
  publishDurationT
  ->
  'a1
  tickBoxState

val set_waitBeforeUpdateInterval :
  'a1
  tickBoxState
  ->
  Big.big_int
  ->
  'a1
  tickBoxState

val set_publishPrecision :
  'a1
  tickBoxState
  ->
  Big.big_int
  ->
  'a1
  tickBoxState

type tbConfigInput =
| TbSetPublishInterval of Big.big_int
| TbSetPublishDuration of publishDurationT
| TbSetWaitBeforeUpdateInterval of Big.big_int
| TbSetPublishPrecision of Big.big_int

type 'dataT tbEventInput =
| TbNotifyChange
| TbTick of Big.big_int
| TbValueReady of 'dataT

type 'dataT tbInput
  =
  (tbConfigInput,
  'dataT
  tbEventInput)
  sum

type 'dataT tbWarningOutput =
| TbWarnNoDataReady
| TbWarnTicksTooInfrequent of Big.big_int
| TbWarnInvalidWaitBeforeUpdateInterval of Big.big_int
| TbWarnInvalidEvent of 'dataT
                        tickBoxPreState
   * 'dataT
     tbEventInput
| TbDebugStateTransition of 'dataT
                            tickBoxPreState
   * 'dataT
     tickBoxPreState
   * 'dataT
     tbInput

type 'dataT tbEventOutput =
| TbRequestDataUpdate
| TbPublishUpdate of 'dataT
| TbSleepFor of Big.big_int

type 'dataT tbOutput
  =
  ('dataT
  tbWarningOutput,
  'dataT
  tbEventOutput)
  sum

val initState :
  'a1
  tickBoxState

val ticksToTransmit :
  Big.big_int
  ->
  'a1
  tickBoxState
  ->
  Big.big_int

val ticksToGetUpdate :
  Big.big_int
  ->
  'a1
  tickBoxState
  ->
  Big.big_int

val invalidWaitBeforeUpdateInterval :
  Big.big_int
  ->
  'a1
  tickBoxState
  ->
  bool

val ticksTooCoarse :
  Big.big_int
  ->
  'a1
  tickBoxState
  ->
  bool

val ticksTooCoarseWaitingOnTicks :
  Big.big_int
  ->
  'a1
  tickBoxState
  ->
  bool

val enoughTransmissions :
  Big.big_int
  ->
  'a1
  tickBoxState
  ->
  bool

val ticksMod :
  Big.big_int
  ->
  'a1
  tickBoxState
  ->
  Big.big_int

val tickBoxLoopPreBody' :
  'a1
  tickBoxState
  ->
  'a1
  tbInput
  ->
  'a1
  tbOutput
  list * 'a1
  tickBoxState

val tickBoxLoopPreBody :
  'a1
  tickBoxState
  ->
  'a1
  tbInput
  ->
  'a1
  tbOutput
  list * 'a1
  tickBoxState

module TrustedEncryptBox : 
 functor (DataTypes:EncryptionDataTypes) ->
 functor (Algorithm:sig 
  val isValidMasterKey :
    DataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    DataTypes.rawDataT
    ->
    DataTypes.systemRandomnessHintT
  
  val encrypt :
    DataTypes.systemRandomnessT
    ->
    DataTypes.masterKeyT
    ->
    DataTypes.rawDataT
    ->
    (DataTypes.encryptedDataT,
    (DataTypes.systemRandomnessHintT,
    DataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    DataTypes.masterKeyT
    ->
    DataTypes.encryptedDataT
    ->
    (DataTypes.rawDataT,
    __)
    sum
 end) ->
 sig 
  type coq_EncryptBoxState =
    DataTypes.masterKeyT
    option
    (* singleton inductive, whose constructor was Build_EncryptBoxState *)
  
  val coq_EncryptBoxState_rect :
    (DataTypes.masterKeyT
    option
    ->
    'a1)
    ->
    coq_EncryptBoxState
    ->
    'a1
  
  val coq_EncryptBoxState_rec :
    (DataTypes.masterKeyT
    option
    ->
    'a1)
    ->
    coq_EncryptBoxState
    ->
    'a1
  
  val masterKey :
    coq_EncryptBoxState
    ->
    DataTypes.masterKeyT
    option
  
  type 'dataTagT ebInput =
  | Coq_ebSetMasterKey of DataTypes.masterKeyT
  | Coq_ebSystemRandomness of DataTypes.systemRandomnessT
     * (DataTypes.rawDataT * 'dataTagT)
  | Coq_ebEncrypt of DataTypes.rawDataT
     * 'dataTagT
  
  val ebInput_rect :
    (DataTypes.masterKeyT
    ->
    'a2)
    ->
    (DataTypes.systemRandomnessT
    ->
    (DataTypes.rawDataT * 'a1)
    ->
    'a2)
    ->
    (DataTypes.rawDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    ebInput
    ->
    'a2
  
  val ebInput_rec :
    (DataTypes.masterKeyT
    ->
    'a2)
    ->
    (DataTypes.systemRandomnessT
    ->
    (DataTypes.rawDataT * 'a1)
    ->
    'a2)
    ->
    (DataTypes.rawDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    ebInput
    ->
    'a2
  
  type ebErrorOutput =
  | Coq_ebErrorNotEnoughRandomness of DataTypes.systemRandomnessHintT
     * DataTypes.systemRandomnessT
  | Coq_ebErrorInvalidMasterKey of DataTypes.masterKeyT
  | Coq_ebErrorNoMasterKey
  
  val ebErrorOutput_rect :
    (DataTypes.systemRandomnessHintT
    ->
    DataTypes.systemRandomnessT
    ->
    'a1)
    ->
    (DataTypes.masterKeyT
    ->
    __
    ->
    'a1)
    ->
    'a1
    ->
    ebErrorOutput
    ->
    'a1
  
  val ebErrorOutput_rec :
    (DataTypes.systemRandomnessHintT
    ->
    DataTypes.systemRandomnessT
    ->
    'a1)
    ->
    (DataTypes.masterKeyT
    ->
    __
    ->
    'a1)
    ->
    'a1
    ->
    ebErrorOutput
    ->
    'a1
  
  type 'dataTagT ebEventOutput =
  | Coq_ebRequestSystemRandomness of DataTypes.systemRandomnessHintT
     * (DataTypes.rawDataT * 'dataTagT)
  | Coq_ebEncrypted of DataTypes.encryptedDataT
     * 'dataTagT
  
  val ebEventOutput_rect :
    (DataTypes.systemRandomnessHintT
    ->
    (DataTypes.rawDataT * 'a1)
    ->
    'a2)
    ->
    (DataTypes.encryptedDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    ebEventOutput
    ->
    'a2
  
  val ebEventOutput_rec :
    (DataTypes.systemRandomnessHintT
    ->
    (DataTypes.rawDataT * 'a1)
    ->
    'a2)
    ->
    (DataTypes.encryptedDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    ebEventOutput
    ->
    'a2
  
  type 'dataTagT ebOutput
    =
    (ebErrorOutput,
    'dataTagT
    ebEventOutput)
    sum
  
  val initState :
    coq_EncryptBoxState
  
  val encryptBoxLoopPreBody :
    coq_EncryptBoxState
    ->
    'a1
    ebInput
    ->
    'a1
    ebOutput
    option * coq_EncryptBoxState
  
  val encryptBoxLoopBody :
    ('a1
    ebOutput
    ->
    'a2
    action)
    ->
    (coq_EncryptBoxState
    ->
    'a3)
    ->
    coq_EncryptBoxState
    ->
    'a1
    ebInput
    ->
    'a2
    action * 'a3
  
  val encryptBoxLoop :
    ('a1
    ebOutput
    ->
    'a2
    action)
    ->
    coq_EncryptBoxState
    ->
    ('a1
    ebInput,
    'a2)
    process
  
  val encryptBox :
    ('a1
    ebOutput
    ->
    'a2
    action)
    ->
    ('a1
    ebInput,
    'a2)
    process
 end

module TrustedDecryptBox : 
 functor (DataTypes:EncryptionDataTypes) ->
 functor (Algorithm:sig 
  val isValidMasterKey :
    DataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    DataTypes.rawDataT
    ->
    DataTypes.systemRandomnessHintT
  
  val encrypt :
    DataTypes.systemRandomnessT
    ->
    DataTypes.masterKeyT
    ->
    DataTypes.rawDataT
    ->
    (DataTypes.encryptedDataT,
    (DataTypes.systemRandomnessHintT,
    DataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    DataTypes.masterKeyT
    ->
    DataTypes.encryptedDataT
    ->
    (DataTypes.rawDataT,
    __)
    sum
 end) ->
 sig 
  type coq_DecryptBoxState =
    DataTypes.masterKeyT
    option
    (* singleton inductive, whose constructor was Build_DecryptBoxState *)
  
  val coq_DecryptBoxState_rect :
    (DataTypes.masterKeyT
    option
    ->
    'a1)
    ->
    coq_DecryptBoxState
    ->
    'a1
  
  val coq_DecryptBoxState_rec :
    (DataTypes.masterKeyT
    option
    ->
    'a1)
    ->
    coq_DecryptBoxState
    ->
    'a1
  
  val masterKey :
    coq_DecryptBoxState
    ->
    DataTypes.masterKeyT
    option
  
  type 'dataTagT dbInput =
  | Coq_dbSetMasterKey of DataTypes.masterKeyT
  | Coq_dbDecrypt of DataTypes.encryptedDataT
     * 'dataTagT
  
  val dbInput_rect :
    (DataTypes.masterKeyT
    ->
    'a2)
    ->
    (DataTypes.encryptedDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    dbInput
    ->
    'a2
  
  val dbInput_rec :
    (DataTypes.masterKeyT
    ->
    'a2)
    ->
    (DataTypes.encryptedDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    dbInput
    ->
    'a2
  
  type 'dataTagT dbErrorOutput =
  | Coq_dbErrorInvalidData of DataTypes.encryptedDataT
     * 'dataTagT
  | Coq_dbErrorInvalidMasterKey of DataTypes.masterKeyT
  | Coq_dbErrorNoMasterKey
  
  val dbErrorOutput_rect :
    (DataTypes.encryptedDataT
    ->
    'a1
    ->
    'a2)
    ->
    (DataTypes.masterKeyT
    ->
    __
    ->
    'a2)
    ->
    'a2
    ->
    'a1
    dbErrorOutput
    ->
    'a2
  
  val dbErrorOutput_rec :
    (DataTypes.encryptedDataT
    ->
    'a1
    ->
    'a2)
    ->
    (DataTypes.masterKeyT
    ->
    __
    ->
    'a2)
    ->
    'a2
    ->
    'a1
    dbErrorOutput
    ->
    'a2
  
  type 'dataTagT dbEventOutput =
  | Coq_dbDecrypted of DataTypes.rawDataT
     * 'dataTagT
  
  val dbEventOutput_rect :
    (DataTypes.rawDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    dbEventOutput
    ->
    'a2
  
  val dbEventOutput_rec :
    (DataTypes.rawDataT
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    dbEventOutput
    ->
    'a2
  
  type 'dataTagT dbOutput
    =
    ('dataTagT
    dbErrorOutput,
    'dataTagT
    dbEventOutput)
    sum
  
  val initState :
    coq_DecryptBoxState
  
  val decryptBoxLoopPreBody :
    coq_DecryptBoxState
    ->
    'a1
    dbInput
    ->
    'a1
    dbOutput
    option * coq_DecryptBoxState
  
  val decryptBoxLoopBody :
    ('a1
    dbOutput
    ->
    'a2
    action)
    ->
    (coq_DecryptBoxState
    ->
    'a3)
    ->
    coq_DecryptBoxState
    ->
    'a1
    dbInput
    ->
    'a2
    action * 'a3
  
  val decryptBoxLoop :
    ('a1
    dbOutput
    ->
    'a2
    action)
    ->
    coq_DecryptBoxState
    ->
    ('a1
    dbInput,
    'a2)
    process
  
  val decryptBox :
    ('a1
    dbOutput
    ->
    'a2
    action)
    ->
    ('a1
    dbInput,
    'a2)
    process
 end

module TrustedServerSyncBox : 
 functor (DataTypes:EncryptionDataTypes) ->
 functor (Algorithm:sig 
  val isValidMasterKey :
    DataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    DataTypes.rawDataT
    ->
    DataTypes.systemRandomnessHintT
  
  val encrypt :
    DataTypes.systemRandomnessT
    ->
    DataTypes.masterKeyT
    ->
    DataTypes.rawDataT
    ->
    (DataTypes.encryptedDataT,
    (DataTypes.systemRandomnessHintT,
    DataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    DataTypes.masterKeyT
    ->
    DataTypes.encryptedDataT
    ->
    (DataTypes.rawDataT,
    __)
    sum
 end) ->
 sig 
  module TEB : 
   sig 
    type coq_EncryptBoxState =
      DataTypes.masterKeyT
      option
      (* singleton inductive, whose constructor was Build_EncryptBoxState *)
    
    val coq_EncryptBoxState_rect :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_EncryptBoxState
      ->
      'a1
    
    val coq_EncryptBoxState_rec :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_EncryptBoxState
      ->
      'a1
    
    val masterKey :
      coq_EncryptBoxState
      ->
      DataTypes.masterKeyT
      option
    
    type 'dataTagT ebInput =
    | Coq_ebSetMasterKey of DataTypes.masterKeyT
    | Coq_ebSystemRandomness of DataTypes.systemRandomnessT
       * (DataTypes.rawDataT * 'dataTagT)
    | Coq_ebEncrypt of DataTypes.rawDataT
       * 'dataTagT
    
    val ebInput_rect :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.systemRandomnessT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebInput
      ->
      'a2
    
    val ebInput_rec :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.systemRandomnessT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebInput
      ->
      'a2
    
    type ebErrorOutput =
    | Coq_ebErrorNotEnoughRandomness of DataTypes.systemRandomnessHintT
       * DataTypes.systemRandomnessT
    | Coq_ebErrorInvalidMasterKey of DataTypes.masterKeyT
    | Coq_ebErrorNoMasterKey
    
    val ebErrorOutput_rect :
      (DataTypes.systemRandomnessHintT
      ->
      DataTypes.systemRandomnessT
      ->
      'a1)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a1)
      ->
      'a1
      ->
      ebErrorOutput
      ->
      'a1
    
    val ebErrorOutput_rec :
      (DataTypes.systemRandomnessHintT
      ->
      DataTypes.systemRandomnessT
      ->
      'a1)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a1)
      ->
      'a1
      ->
      ebErrorOutput
      ->
      'a1
    
    type 'dataTagT ebEventOutput =
    | Coq_ebRequestSystemRandomness of DataTypes.systemRandomnessHintT
       * (DataTypes.rawDataT * 'dataTagT)
    | Coq_ebEncrypted of DataTypes.encryptedDataT
       * 'dataTagT
    
    val ebEventOutput_rect :
      (DataTypes.systemRandomnessHintT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebEventOutput
      ->
      'a2
    
    val ebEventOutput_rec :
      (DataTypes.systemRandomnessHintT
      ->
      (DataTypes.rawDataT * 'a1)
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      ebEventOutput
      ->
      'a2
    
    type 'dataTagT ebOutput
      =
      (ebErrorOutput,
      'dataTagT
      ebEventOutput)
      sum
    
    val initState :
      coq_EncryptBoxState
    
    val encryptBoxLoopPreBody :
      coq_EncryptBoxState
      ->
      'a1
      ebInput
      ->
      'a1
      ebOutput
      option * coq_EncryptBoxState
    
    val encryptBoxLoopBody :
      ('a1
      ebOutput
      ->
      'a2
      action)
      ->
      (coq_EncryptBoxState
      ->
      'a3)
      ->
      coq_EncryptBoxState
      ->
      'a1
      ebInput
      ->
      'a2
      action * 'a3
    
    val encryptBoxLoop :
      ('a1
      ebOutput
      ->
      'a2
      action)
      ->
      coq_EncryptBoxState
      ->
      ('a1
      ebInput,
      'a2)
      process
    
    val encryptBox :
      ('a1
      ebOutput
      ->
      'a2
      action)
      ->
      ('a1
      ebInput,
      'a2)
      process
   end
  
  module TDB : 
   sig 
    type coq_DecryptBoxState =
      DataTypes.masterKeyT
      option
      (* singleton inductive, whose constructor was Build_DecryptBoxState *)
    
    val coq_DecryptBoxState_rect :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_DecryptBoxState
      ->
      'a1
    
    val coq_DecryptBoxState_rec :
      (DataTypes.masterKeyT
      option
      ->
      'a1)
      ->
      coq_DecryptBoxState
      ->
      'a1
    
    val masterKey :
      coq_DecryptBoxState
      ->
      DataTypes.masterKeyT
      option
    
    type 'dataTagT dbInput =
    | Coq_dbSetMasterKey of DataTypes.masterKeyT
    | Coq_dbDecrypt of DataTypes.encryptedDataT
       * 'dataTagT
    
    val dbInput_rect :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbInput
      ->
      'a2
    
    val dbInput_rec :
      (DataTypes.masterKeyT
      ->
      'a2)
      ->
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbInput
      ->
      'a2
    
    type 'dataTagT dbErrorOutput =
    | Coq_dbErrorInvalidData of DataTypes.encryptedDataT
       * 'dataTagT
    | Coq_dbErrorInvalidMasterKey of DataTypes.masterKeyT
    | Coq_dbErrorNoMasterKey
    
    val dbErrorOutput_rect :
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a2)
      ->
      'a2
      ->
      'a1
      dbErrorOutput
      ->
      'a2
    
    val dbErrorOutput_rec :
      (DataTypes.encryptedDataT
      ->
      'a1
      ->
      'a2)
      ->
      (DataTypes.masterKeyT
      ->
      __
      ->
      'a2)
      ->
      'a2
      ->
      'a1
      dbErrorOutput
      ->
      'a2
    
    type 'dataTagT dbEventOutput =
    | Coq_dbDecrypted of DataTypes.rawDataT
       * 'dataTagT
    
    val dbEventOutput_rect :
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbEventOutput
      ->
      'a2
    
    val dbEventOutput_rec :
      (DataTypes.rawDataT
      ->
      'a1
      ->
      'a2)
      ->
      'a1
      dbEventOutput
      ->
      'a2
    
    type 'dataTagT dbOutput
      =
      ('dataTagT
      dbErrorOutput,
      'dataTagT
      dbEventOutput)
      sum
    
    val initState :
      coq_DecryptBoxState
    
    val decryptBoxLoopPreBody :
      coq_DecryptBoxState
      ->
      'a1
      dbInput
      ->
      'a1
      dbOutput
      option * coq_DecryptBoxState
    
    val decryptBoxLoopBody :
      ('a1
      dbOutput
      ->
      'a2
      action)
      ->
      (coq_DecryptBoxState
      ->
      'a3)
      ->
      coq_DecryptBoxState
      ->
      'a1
      dbInput
      ->
      'a2
      action * 'a3
    
    val decryptBoxLoop :
      ('a1
      dbOutput
      ->
      'a2
      action)
      ->
      coq_DecryptBoxState
      ->
      ('a1
      dbInput,
      'a2)
      process
    
    val decryptBox :
      ('a1
      dbOutput
      ->
      'a2
      action)
      ->
      ('a1
      dbInput,
      'a2)
      process
   end
  
  type coq_ServerSyncBoxPreState = { localStateD : DataTypes.rawDataT;
                                     remoteStateE : DataTypes.encryptedDataT
                                                    option }
  
  val coq_ServerSyncBoxPreState_rect :
    (DataTypes.rawDataT
    ->
    DataTypes.encryptedDataT
    option
    ->
    'a1)
    ->
    coq_ServerSyncBoxPreState
    ->
    'a1
  
  val coq_ServerSyncBoxPreState_rec :
    (DataTypes.rawDataT
    ->
    DataTypes.encryptedDataT
    option
    ->
    'a1)
    ->
    coq_ServerSyncBoxPreState
    ->
    'a1
  
  val localStateD :
    coq_ServerSyncBoxPreState
    ->
    DataTypes.rawDataT
  
  val remoteStateE :
    coq_ServerSyncBoxPreState
    ->
    DataTypes.encryptedDataT
    option
  
  type coq_ServerSyncBoxState = { ssbState : coq_ServerSyncBoxPreState;
                                  ssbGetUpdateState : unit
                                                      tickBoxState;
                                  ssbCASState : DataTypes.encryptedDataT
                                                tickBoxState;
                                  ssbEncryptState : TEB.coq_EncryptBoxState;
                                  ssbDecryptState : TDB.coq_DecryptBoxState }
  
  val coq_ServerSyncBoxState_rect :
    (coq_ServerSyncBoxPreState
    ->
    unit
    tickBoxState
    ->
    DataTypes.encryptedDataT
    tickBoxState
    ->
    TEB.coq_EncryptBoxState
    ->
    TDB.coq_DecryptBoxState
    ->
    'a1)
    ->
    coq_ServerSyncBoxState
    ->
    'a1
  
  val coq_ServerSyncBoxState_rec :
    (coq_ServerSyncBoxPreState
    ->
    unit
    tickBoxState
    ->
    DataTypes.encryptedDataT
    tickBoxState
    ->
    TEB.coq_EncryptBoxState
    ->
    TDB.coq_DecryptBoxState
    ->
    'a1)
    ->
    coq_ServerSyncBoxState
    ->
    'a1
  
  val ssbState :
    coq_ServerSyncBoxState
    ->
    coq_ServerSyncBoxPreState
  
  val ssbGetUpdateState :
    coq_ServerSyncBoxState
    ->
    unit
    tickBoxState
  
  val ssbCASState :
    coq_ServerSyncBoxState
    ->
    DataTypes.encryptedDataT
    tickBoxState
  
  val ssbEncryptState :
    coq_ServerSyncBoxState
    ->
    TEB.coq_EncryptBoxState
  
  val ssbDecryptState :
    coq_ServerSyncBoxState
    ->
    TDB.coq_DecryptBoxState
  
  val set_ssbState :
    coq_ServerSyncBoxState
    ->
    coq_ServerSyncBoxPreState
    ->
    coq_ServerSyncBoxState
  
  val set_ssbGetUpdateState :
    coq_ServerSyncBoxState
    ->
    unit
    tickBoxState
    ->
    coq_ServerSyncBoxState
  
  val set_ssbCASState :
    coq_ServerSyncBoxState
    ->
    DataTypes.encryptedDataT
    tickBoxState
    ->
    coq_ServerSyncBoxState
  
  val set_ssbEncryptState :
    coq_ServerSyncBoxState
    ->
    TEB.coq_EncryptBoxState
    ->
    coq_ServerSyncBoxState
  
  val set_ssbDecryptState :
    coq_ServerSyncBoxState
    ->
    TDB.coq_DecryptBoxState
    ->
    coq_ServerSyncBoxState
  
  type ssbConfigInput =
  | Coq_ssbGetUpdateConfig of tbConfigInput
  | Coq_ssbCASConfig of tbConfigInput
  | Coq_ssbSetMasterKey of DataTypes.masterKeyT
  
  val ssbConfigInput_rect :
    (tbConfigInput
    ->
    'a1)
    ->
    (tbConfigInput
    ->
    'a1)
    ->
    (DataTypes.masterKeyT
    ->
    'a1)
    ->
    ssbConfigInput
    ->
    'a1
  
  val ssbConfigInput_rec :
    (tbConfigInput
    ->
    'a1)
    ->
    (tbConfigInput
    ->
    'a1)
    ->
    (DataTypes.masterKeyT
    ->
    'a1)
    ->
    ssbConfigInput
    ->
    'a1
  
  type ssbEventInput =
  | Coq_ssbClientGetUpdate
  | Coq_ssbClientSet of DataTypes.rawDataT
  | Coq_ssbServerGotUpdate of DataTypes.encryptedDataT
  | Coq_ssbSystemRandomness of DataTypes.systemRandomnessT
     * DataTypes.rawDataT
  | Coq_ssbTick of Big.big_int
  
  val ssbEventInput_rect :
    'a1
    ->
    (DataTypes.rawDataT
    ->
    'a1)
    ->
    (DataTypes.encryptedDataT
    ->
    'a1)
    ->
    (DataTypes.systemRandomnessT
    ->
    DataTypes.rawDataT
    ->
    'a1)
    ->
    (Big.big_int
    ->
    'a1)
    ->
    ssbEventInput
    ->
    'a1
  
  val ssbEventInput_rec :
    'a1
    ->
    (DataTypes.rawDataT
    ->
    'a1)
    ->
    (DataTypes.encryptedDataT
    ->
    'a1)
    ->
    (DataTypes.systemRandomnessT
    ->
    DataTypes.rawDataT
    ->
    'a1)
    ->
    (Big.big_int
    ->
    'a1)
    ->
    ssbEventInput
    ->
    'a1
  
  type ssbInput
    =
    (ssbConfigInput,
    ssbEventInput)
    sum
  
  type ssbWarningOutput =
  | Coq_ssbGetUpdateWarning of unit
                               tbWarningOutput
  | Coq_ssbCASWarning of DataTypes.encryptedDataT
                         tbWarningOutput
  | Coq_ssbEncryptError of TEB.ebErrorOutput
  | Coq_ssbDecryptError of unit
                           TDB.dbErrorOutput
  | Coq_ssbWarningInvalidTransition of ssbInput
     * coq_ServerSyncBoxState
  | Coq_ssbWarningPushBeforePull
  
  val ssbWarningOutput_rect :
    (unit
    tbWarningOutput
    ->
    'a1)
    ->
    (DataTypes.encryptedDataT
    tbWarningOutput
    ->
    'a1)
    ->
    (TEB.ebErrorOutput
    ->
    'a1)
    ->
    (unit
    TDB.dbErrorOutput
    ->
    'a1)
    ->
    (ssbInput
    ->
    coq_ServerSyncBoxState
    ->
    'a1)
    ->
    'a1
    ->
    ssbWarningOutput
    ->
    'a1
  
  val ssbWarningOutput_rec :
    (unit
    tbWarningOutput
    ->
    'a1)
    ->
    (DataTypes.encryptedDataT
    tbWarningOutput
    ->
    'a1)
    ->
    (TEB.ebErrorOutput
    ->
    'a1)
    ->
    (unit
    TDB.dbErrorOutput
    ->
    'a1)
    ->
    (ssbInput
    ->
    coq_ServerSyncBoxState
    ->
    'a1)
    ->
    'a1
    ->
    ssbWarningOutput
    ->
    'a1
  
  type ssbEventOutput =
  | Coq_ssbClientGotUpdate of DataTypes.rawDataT
  | Coq_ssbServerGetUpdate
  | Coq_ssbServerCAS of DataTypes.encryptedDataT
     * DataTypes.encryptedDataT
  | Coq_ssbRequestSystemRandomness of DataTypes.systemRandomnessHintT
     * DataTypes.rawDataT
  | Coq_ssbSleepFor of Big.big_int
  
  val ssbEventOutput_rect :
    (DataTypes.rawDataT
    ->
    'a1)
    ->
    'a1
    ->
    (DataTypes.encryptedDataT
    ->
    DataTypes.encryptedDataT
    ->
    'a1)
    ->
    (DataTypes.systemRandomnessHintT
    ->
    DataTypes.rawDataT
    ->
    'a1)
    ->
    (Big.big_int
    ->
    'a1)
    ->
    ssbEventOutput
    ->
    'a1
  
  val ssbEventOutput_rec :
    (DataTypes.rawDataT
    ->
    'a1)
    ->
    'a1
    ->
    (DataTypes.encryptedDataT
    ->
    DataTypes.encryptedDataT
    ->
    'a1)
    ->
    (DataTypes.systemRandomnessHintT
    ->
    DataTypes.rawDataT
    ->
    'a1)
    ->
    (Big.big_int
    ->
    'a1)
    ->
    ssbEventOutput
    ->
    'a1
  
  type ssbOutput
    =
    (ssbWarningOutput,
    ssbEventOutput)
    sum
  
  val initState :
    DataTypes.rawDataT
    ->
    coq_ServerSyncBoxState
  
  val isTickBoxSimpleResult :
    'a1
    tbOutput
    list
    ->
    bool
  
  val handle_simpleTickBox :
    ('a1
    tbWarningOutput
    ->
    ssbWarningOutput)
    ->
    'a1
    tbOutput
    list
    ->
    ssbOutput
    list
  
  val handle_ssbGetUpdate' :
    coq_ServerSyncBoxState
    ->
    (unit
    tbOutput * unit
    tickBoxState)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val fold_handler :
    (coq_ServerSyncBoxState
    ->
    'a2)
    ->
    (coq_ServerSyncBoxState
    ->
    'a2
    ->
    coq_ServerSyncBoxState)
    ->
    (coq_ServerSyncBoxState
    ->
    ('a1 * 'a2)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState)
    ->
    coq_ServerSyncBoxState
    ->
    ('a1
    list * 'a2)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val handle_ssbGetUpdate :
    coq_ServerSyncBoxState
    ->
    (unit
    tbOutput
    list * unit
    tickBoxState)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val handle_ssbEncrypt :
    coq_ServerSyncBoxState
    ->
    (unit
    TEB.ebOutput
    option * TEB.coq_EncryptBoxState)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val handle_ssbCAS' :
    coq_ServerSyncBoxState
    ->
    (DataTypes.encryptedDataT
    tbOutput * DataTypes.encryptedDataT
    tickBoxState)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val handle_ssbCAS :
    coq_ServerSyncBoxState
    ->
    (DataTypes.encryptedDataT
    tbOutput
    list * DataTypes.encryptedDataT
    tickBoxState)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val handle_ssbDecrypt :
    (DataTypes.rawDataT
    ->
    DataTypes.rawDataT
    ->
    bool)
    ->
    coq_ServerSyncBoxState
    ->
    (unit
    TDB.dbOutput
    option * TDB.coq_DecryptBoxState)
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val serverSyncBoxLoopPreBody :
    (DataTypes.rawDataT
    ->
    DataTypes.rawDataT
    ->
    bool)
    ->
    coq_ServerSyncBoxState
    ->
    ssbInput
    ->
    ssbOutput
    list * coq_ServerSyncBoxState
  
  val serverSyncBoxLoopBody :
    (DataTypes.rawDataT
    ->
    DataTypes.rawDataT
    ->
    bool)
    ->
    (ssbOutput
    ->
    'a1
    action)
    ->
    (coq_ServerSyncBoxState
    ->
    'a2)
    ->
    coq_ServerSyncBoxState
    ->
    ssbInput
    ->
    'a1
    action * 'a2
  
  val serverSyncBoxLoop :
    (DataTypes.rawDataT
    ->
    DataTypes.rawDataT
    ->
    bool)
    ->
    (ssbOutput
    ->
    'a1
    action)
    ->
    coq_ServerSyncBoxState
    ->
    (ssbInput,
    'a1)
    process
  
  val serverSyncBox :
    (DataTypes.rawDataT
    ->
    DataTypes.rawDataT
    ->
    bool)
    ->
    DataTypes.rawDataT
    ->
    (ssbOutput
    ->
    'a1
    action)
    ->
    (ssbInput,
    'a1)
    process
 end

type tickGInput =
| TGWakeUp
| TGClocksGot of Big.big_int
| TGWantWakeupIn of Big.big_int

val nanos_per_tick :
  Big.big_int

type gatewayPreState =
| Init
| WaitingToWake
| WaitingToSleep

type gatewayState = { systemTime : Big.big_int
                                   option;
                      nextWakeUpTime : Big.big_int
                                       option;
                      waitingOn : gatewayPreState }

val systemTime :
  gatewayState
  ->
  Big.big_int
  option

val nextWakeUpTime :
  gatewayState
  ->
  Big.big_int
  option

val waitingOn :
  gatewayState
  ->
  gatewayPreState

val set_waitingOn :
  gatewayState
  ->
  gatewayPreState
  ->
  gatewayState

type tickGWarningOutput =
| TGDebugStateTransition of gatewayState
   * gatewayState
   * tickGInput

type tickGEventOutput =
| TGGetNanosecs
| TGTick of Big.big_int
| TGSystemSleep of Big.big_int

type tickGOutput
  =
  (tickGWarningOutput,
  tickGEventOutput)
  sum

val tickStarvationBoundary :
  Big.big_int

val tickGLoopPreBody' :
  gatewayState
  ->
  tickGInput
  ->
  tickGOutput
  list * gatewayState

val tickGLoopPreBody :
  gatewayState
  ->
  tickGInput
  ->
  tickGOutput
  list * gatewayState

val tickGLoopBody :
  (tickGOutput
  ->
  'a1
  action)
  ->
  (gatewayState
  ->
  'a2)
  ->
  gatewayState
  ->
  tickGInput
  ->
  'a1
  action * 'a2

val tickGLoop :
  (tickGOutput
  ->
  'a1
  action)
  ->
  gatewayState
  ->
  (tickGInput,
  'a1)
  process

val tickGInitState :
  gatewayState

val tickG :
  (tickGOutput
  ->
  'a1
  action)
  ->
  (tickGInput,
  'a1)
  process

val tickBoxState_Serializable :
  'a1
  serializable
  ->
  'a1
  tickBoxPreState
  serializable

val publishDurationT_Serializable :
  publishDurationT
  serializable

val tbConfigInput_Serializable :
  tbConfigInput
  serializable

val tbEventInput_Serializable :
  'a1
  serializable
  ->
  'a1
  tbEventInput
  serializable

val gatewayPreState_Serializable :
  gatewayPreState
  serializable

val gatewayState_Serializable :
  gatewayState
  serializable

val tickGInput_Serializable :
  tickGInput
  serializable

module PwMgrWarningBox : 
 functor (Algorithm:sig 
  val isValidMasterKey :
    EncryptionStringDataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    EncryptionStringDataTypes.rawDataT
    ->
    EncryptionStringDataTypes.systemRandomnessHintT
  
  val encrypt :
    EncryptionStringDataTypes.systemRandomnessT
    ->
    EncryptionStringDataTypes.masterKeyT
    ->
    EncryptionStringDataTypes.rawDataT
    ->
    (EncryptionStringDataTypes.encryptedDataT,
    (EncryptionStringDataTypes.systemRandomnessHintT,
    EncryptionStringDataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    EncryptionStringDataTypes.masterKeyT
    ->
    EncryptionStringDataTypes.encryptedDataT
    ->
    (EncryptionStringDataTypes.rawDataT,
    __)
    sum
 end) ->
 sig 
  module SSB : 
   sig 
    module TEB : 
     sig 
      type coq_EncryptBoxState =
        EncryptionStringDataTypes.masterKeyT
        option
        (* singleton inductive, whose constructor was Build_EncryptBoxState *)
      
      val coq_EncryptBoxState_rect :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_EncryptBoxState
        ->
        'a1
      
      val coq_EncryptBoxState_rec :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_EncryptBoxState
        ->
        'a1
      
      val masterKey :
        coq_EncryptBoxState
        ->
        EncryptionStringDataTypes.masterKeyT
        option
      
      type 'dataTagT ebInput =
      | Coq_ebSetMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_ebSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
         * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
      | Coq_ebEncrypt of EncryptionStringDataTypes.rawDataT
         * 'dataTagT
      
      val ebInput_rect :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.systemRandomnessT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebInput
        ->
        'a2
      
      val ebInput_rec :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.systemRandomnessT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebInput
        ->
        'a2
      
      type ebErrorOutput =
      | Coq_ebErrorNotEnoughRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * EncryptionStringDataTypes.systemRandomnessT
      | Coq_ebErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_ebErrorNoMasterKey
      
      val ebErrorOutput_rect :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        EncryptionStringDataTypes.systemRandomnessT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a1)
        ->
        'a1
        ->
        ebErrorOutput
        ->
        'a1
      
      val ebErrorOutput_rec :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        EncryptionStringDataTypes.systemRandomnessT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a1)
        ->
        'a1
        ->
        ebErrorOutput
        ->
        'a1
      
      type 'dataTagT ebEventOutput =
      | Coq_ebRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
      | Coq_ebEncrypted of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      
      val ebEventOutput_rect :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebEventOutput
        ->
        'a2
      
      val ebEventOutput_rec :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebEventOutput
        ->
        'a2
      
      type 'dataTagT ebOutput
        =
        (ebErrorOutput,
        'dataTagT
        ebEventOutput)
        sum
      
      val initState :
        coq_EncryptBoxState
      
      val encryptBoxLoopPreBody :
        coq_EncryptBoxState
        ->
        'a1
        ebInput
        ->
        'a1
        ebOutput
        option * coq_EncryptBoxState
      
      val encryptBoxLoopBody :
        ('a1
        ebOutput
        ->
        'a2
        action)
        ->
        (coq_EncryptBoxState
        ->
        'a3)
        ->
        coq_EncryptBoxState
        ->
        'a1
        ebInput
        ->
        'a2
        action * 'a3
      
      val encryptBoxLoop :
        ('a1
        ebOutput
        ->
        'a2
        action)
        ->
        coq_EncryptBoxState
        ->
        ('a1
        ebInput,
        'a2)
        process
      
      val encryptBox :
        ('a1
        ebOutput
        ->
        'a2
        action)
        ->
        ('a1
        ebInput,
        'a2)
        process
     end
    
    module TDB : 
     sig 
      type coq_DecryptBoxState =
        EncryptionStringDataTypes.masterKeyT
        option
        (* singleton inductive, whose constructor was Build_DecryptBoxState *)
      
      val coq_DecryptBoxState_rect :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_DecryptBoxState
        ->
        'a1
      
      val coq_DecryptBoxState_rec :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_DecryptBoxState
        ->
        'a1
      
      val masterKey :
        coq_DecryptBoxState
        ->
        EncryptionStringDataTypes.masterKeyT
        option
      
      type 'dataTagT dbInput =
      | Coq_dbSetMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_dbDecrypt of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      
      val dbInput_rect :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbInput
        ->
        'a2
      
      val dbInput_rec :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbInput
        ->
        'a2
      
      type 'dataTagT dbErrorOutput =
      | Coq_dbErrorInvalidData of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      | Coq_dbErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_dbErrorNoMasterKey
      
      val dbErrorOutput_rect :
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a2)
        ->
        'a2
        ->
        'a1
        dbErrorOutput
        ->
        'a2
      
      val dbErrorOutput_rec :
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a2)
        ->
        'a2
        ->
        'a1
        dbErrorOutput
        ->
        'a2
      
      type 'dataTagT dbEventOutput =
      | Coq_dbDecrypted of EncryptionStringDataTypes.rawDataT
         * 'dataTagT
      
      val dbEventOutput_rect :
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbEventOutput
        ->
        'a2
      
      val dbEventOutput_rec :
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbEventOutput
        ->
        'a2
      
      type 'dataTagT dbOutput
        =
        ('dataTagT
        dbErrorOutput,
        'dataTagT
        dbEventOutput)
        sum
      
      val initState :
        coq_DecryptBoxState
      
      val decryptBoxLoopPreBody :
        coq_DecryptBoxState
        ->
        'a1
        dbInput
        ->
        'a1
        dbOutput
        option * coq_DecryptBoxState
      
      val decryptBoxLoopBody :
        ('a1
        dbOutput
        ->
        'a2
        action)
        ->
        (coq_DecryptBoxState
        ->
        'a3)
        ->
        coq_DecryptBoxState
        ->
        'a1
        dbInput
        ->
        'a2
        action * 'a3
      
      val decryptBoxLoop :
        ('a1
        dbOutput
        ->
        'a2
        action)
        ->
        coq_DecryptBoxState
        ->
        ('a1
        dbInput,
        'a2)
        process
      
      val decryptBox :
        ('a1
        dbOutput
        ->
        'a2
        action)
        ->
        ('a1
        dbInput,
        'a2)
        process
     end
    
    type coq_ServerSyncBoxPreState = { localStateD : EncryptionStringDataTypes.rawDataT;
                                       remoteStateE : EncryptionStringDataTypes.encryptedDataT
                                                      option }
    
    val coq_ServerSyncBoxPreState_rect :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      option
      ->
      'a1)
      ->
      coq_ServerSyncBoxPreState
      ->
      'a1
    
    val coq_ServerSyncBoxPreState_rec :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      option
      ->
      'a1)
      ->
      coq_ServerSyncBoxPreState
      ->
      'a1
    
    val localStateD :
      coq_ServerSyncBoxPreState
      ->
      EncryptionStringDataTypes.rawDataT
    
    val remoteStateE :
      coq_ServerSyncBoxPreState
      ->
      EncryptionStringDataTypes.encryptedDataT
      option
    
    type coq_ServerSyncBoxState = { ssbState : coq_ServerSyncBoxPreState;
                                    ssbGetUpdateState : unit
                                                        tickBoxState;
                                    ssbCASState : EncryptionStringDataTypes.encryptedDataT
                                                  tickBoxState;
                                    ssbEncryptState : TEB.coq_EncryptBoxState;
                                    ssbDecryptState : TDB.coq_DecryptBoxState }
    
    val coq_ServerSyncBoxState_rect :
      (coq_ServerSyncBoxPreState
      ->
      unit
      tickBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      'a1)
      ->
      coq_ServerSyncBoxState
      ->
      'a1
    
    val coq_ServerSyncBoxState_rec :
      (coq_ServerSyncBoxPreState
      ->
      unit
      tickBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      'a1)
      ->
      coq_ServerSyncBoxState
      ->
      'a1
    
    val ssbState :
      coq_ServerSyncBoxState
      ->
      coq_ServerSyncBoxPreState
    
    val ssbGetUpdateState :
      coq_ServerSyncBoxState
      ->
      unit
      tickBoxState
    
    val ssbCASState :
      coq_ServerSyncBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
    
    val ssbEncryptState :
      coq_ServerSyncBoxState
      ->
      TEB.coq_EncryptBoxState
    
    val ssbDecryptState :
      coq_ServerSyncBoxState
      ->
      TDB.coq_DecryptBoxState
    
    val set_ssbState :
      coq_ServerSyncBoxState
      ->
      coq_ServerSyncBoxPreState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbGetUpdateState :
      coq_ServerSyncBoxState
      ->
      unit
      tickBoxState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbCASState :
      coq_ServerSyncBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbEncryptState :
      coq_ServerSyncBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbDecryptState :
      coq_ServerSyncBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      coq_ServerSyncBoxState
    
    type ssbConfigInput =
    | Coq_ssbGetUpdateConfig of tbConfigInput
    | Coq_ssbCASConfig of tbConfigInput
    | Coq_ssbSetMasterKey of EncryptionStringDataTypes.masterKeyT
    
    val ssbConfigInput_rect :
      (tbConfigInput
      ->
      'a1)
      ->
      (tbConfigInput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.masterKeyT
      ->
      'a1)
      ->
      ssbConfigInput
      ->
      'a1
    
    val ssbConfigInput_rec :
      (tbConfigInput
      ->
      'a1)
      ->
      (tbConfigInput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.masterKeyT
      ->
      'a1)
      ->
      ssbConfigInput
      ->
      'a1
    
    type ssbEventInput =
    | Coq_ssbClientGetUpdate
    | Coq_ssbClientSet of EncryptionStringDataTypes.rawDataT
    | Coq_ssbServerGotUpdate of EncryptionStringDataTypes.encryptedDataT
    | Coq_ssbSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
       * EncryptionStringDataTypes.rawDataT
    | Coq_ssbTick of Big.big_int
    
    val ssbEventInput_rect :
      'a1
      ->
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventInput
      ->
      'a1
    
    val ssbEventInput_rec :
      'a1
      ->
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventInput
      ->
      'a1
    
    type ssbInput
      =
      (ssbConfigInput,
      ssbEventInput)
      sum
    
    type ssbWarningOutput =
    | Coq_ssbGetUpdateWarning of unit
                                 tbWarningOutput
    | Coq_ssbCASWarning of EncryptionStringDataTypes.encryptedDataT
                           tbWarningOutput
    | Coq_ssbEncryptError of TEB.ebErrorOutput
    | Coq_ssbDecryptError of unit
                             TDB.dbErrorOutput
    | Coq_ssbWarningInvalidTransition of ssbInput
       * coq_ServerSyncBoxState
    | Coq_ssbWarningPushBeforePull
    
    val ssbWarningOutput_rect :
      (unit
      tbWarningOutput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbWarningOutput
      ->
      'a1)
      ->
      (TEB.ebErrorOutput
      ->
      'a1)
      ->
      (unit
      TDB.dbErrorOutput
      ->
      'a1)
      ->
      (ssbInput
      ->
      coq_ServerSyncBoxState
      ->
      'a1)
      ->
      'a1
      ->
      ssbWarningOutput
      ->
      'a1
    
    val ssbWarningOutput_rec :
      (unit
      tbWarningOutput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbWarningOutput
      ->
      'a1)
      ->
      (TEB.ebErrorOutput
      ->
      'a1)
      ->
      (unit
      TDB.dbErrorOutput
      ->
      'a1)
      ->
      (ssbInput
      ->
      coq_ServerSyncBoxState
      ->
      'a1)
      ->
      'a1
      ->
      ssbWarningOutput
      ->
      'a1
    
    type ssbEventOutput =
    | Coq_ssbClientGotUpdate of EncryptionStringDataTypes.rawDataT
    | Coq_ssbServerGetUpdate
    | Coq_ssbServerCAS of EncryptionStringDataTypes.encryptedDataT
       * EncryptionStringDataTypes.encryptedDataT
    | Coq_ssbRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
       * EncryptionStringDataTypes.rawDataT
    | Coq_ssbSleepFor of Big.big_int
    
    val ssbEventOutput_rect :
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessHintT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1
    
    val ssbEventOutput_rec :
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessHintT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1
    
    type ssbOutput
      =
      (ssbWarningOutput,
      ssbEventOutput)
      sum
    
    val initState :
      EncryptionStringDataTypes.rawDataT
      ->
      coq_ServerSyncBoxState
    
    val isTickBoxSimpleResult :
      'a1
      tbOutput
      list
      ->
      bool
    
    val handle_simpleTickBox :
      ('a1
      tbWarningOutput
      ->
      ssbWarningOutput)
      ->
      'a1
      tbOutput
      list
      ->
      ssbOutput
      list
    
    val handle_ssbGetUpdate' :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val fold_handler :
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2
      ->
      coq_ServerSyncBoxState)
      ->
      (coq_ServerSyncBoxState
      ->
      ('a1 * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState)
      ->
      coq_ServerSyncBoxState
      ->
      ('a1
      list * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbGetUpdate :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput
      list * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbEncrypt :
      coq_ServerSyncBoxState
      ->
      (unit
      TEB.ebOutput
      option * TEB.coq_EncryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbCAS' :
      coq_ServerSyncBoxState
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbOutput * EncryptionStringDataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbCAS :
      coq_ServerSyncBoxState
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbOutput
      list * EncryptionStringDataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbDecrypt :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      (unit
      TDB.dbOutput
      option * TDB.coq_DecryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val serverSyncBoxLoopPreBody :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val serverSyncBoxLoopBody :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      'a1
      action * 'a2
    
    val serverSyncBoxLoop :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      coq_ServerSyncBoxState
      ->
      (ssbInput,
      'a1)
      process
    
    val serverSyncBox :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (ssbInput,
      'a1)
      process
   end
  
  type wInput
    =
    (SSB.ssbWarningOutput,
    tickGWarningOutput)
    sum
  
  module Coercions : 
   sig 
    val wInput_of_ssb :
      SSB.ssbWarningOutput
      ->
      wInput
    
    val wInput_of_tg :
      tickGWarningOutput
      ->
      wInput
   end
  
  type wOutput =
  | Coq_wConsoleErr of char list
  | Coq_wFatalError of char list
  | Coq_wBad of char list
  
  val wOutput_rect :
    (char list
    ->
    'a1)
    ->
    (char list
    ->
    'a1)
    ->
    (char list
    ->
    'a1)
    ->
    wOutput
    ->
    'a1
  
  val wOutput_rec :
    (char list
    ->
    'a1)
    ->
    (char list
    ->
    'a1)
    ->
    (char list
    ->
    'a1)
    ->
    wOutput
    ->
    'a1
  
  val newline :
    char
  
  val newlineS :
    char list
  
  val emit :
    (wOutput
    ->
    'a1
    action)
    ->
    char list
    ->
    'a1
    action
  
  val debugMsg :
    (wOutput
    ->
    'a1
    action)
    ->
    Big.big_int
    ->
    char list
    ->
    char list
    ->
    Big.big_int
    ->
    'a1
    action
  
  val labelTBStateTransition :
    'a1
    serializable
    ->
    'a1
    tickBoxPreState
    ->
    'a1
    tickBoxPreState
    ->
    'a1
    tbInput
    ->
    char list
  
  val labelTGBStateTransition :
    gatewayState
    ->
    gatewayState
    ->
    tickGInput
    ->
    char list
  
  val emitTB :
    (wOutput
    ->
    'a1
    action)
    ->
    'a2
    serializable
    ->
    Big.big_int
    ->
    'a2
    tbWarningOutput
    ->
    char list
    ->
    'a1
    action
  
  val wLoopBody :
    (wOutput
    ->
    'a1
    action)
    ->
    (Big.big_int
    ->
    (wInput,
    'a1)
    process)
    ->
    Big.big_int
    ->
    wInput
    ->
    'a1
    action * (wInput,
    'a1)
    process
  
  val warningBox :
    (wOutput
    ->
    'a1
    action)
    ->
    Big.big_int
    ->
    (wInput,
    'a1)
    process
 end

val storageURI :
  char list

val storageGet :
  (char list
  ->
  (char list * char list)
  list
  ->
  (('a1,
  httpResponse)
  abortable
  ->
  'a3)
  ->
  'a2
  action)
  ->
  char list
  ->
  (('a1,
  (char list,
  httpResponse)
  sum)
  abortable
  ->
  'a3)
  ->
  'a2
  action

val storageSet :
  (char list
  ->
  (char list * char list)
  list
  ->
  (('a1,
  httpResponse)
  abortable
  ->
  'a3)
  ->
  'a2
  action)
  ->
  char list
  ->
  char list
  ->
  char list
  ->
  (('a1,
  (char list
  option,
  httpResponse)
  sum)
  abortable
  ->
  'a3)
  ->
  'a2
  action

val storagePoll :
  (char list
  ->
  (char list * char list)
  list
  ->
  (('a1,
  httpResponse)
  abortable
  ->
  'a3)
  ->
  'a2
  action)
  ->
  char list
  ->
  char list
  ->
  (('a1,
  (char list,
  httpResponse)
  sum)
  abortable
  ->
  'a3)
  ->
  'a2
  action

type 'world0 netInput =
| NetStarted of 'world0
                action
| NetGetUpdate
| NetCAS of char list
   * char list
| NetSendGotUpdate of char list
| NetHttpError of httpResponse

type 'world0 netOutput =
| NetLift of 'world0
             action
| NetGotUpdate of char list
| NetHttpPOST of char list
   * (char list * char list)
     list
   * (('world0,
     httpResponse)
     abortable
     ->
     'world0
     netInput)

val sendHttpPOST :
  ('a1
  netOutput
  ->
  'a2
  action)
  ->
  char list
  ->
  (char list * char list)
  list
  ->
  (('a1,
  httpResponse)
  abortable
  ->
  'a1
  netInput)
  ->
  'a2
  action

val netGetUpdateCallback :
  ('a1,
  (char list,
  httpResponse)
  sum)
  abortable
  ->
  'a1
  netInput

val netCASCallback :
  char list
  ->
  ('a1,
  (char list
  option,
  httpResponse)
  sum)
  abortable
  ->
  'a1
  netInput

val netLoop :
  ('a1
  netOutput
  ->
  'a2
  action)
  ->
  char list
  ->
  'a1
  action
  ->
  ('a1
  netInput,
  'a2)
  process

val net :
  ('a1
  netOutput
  ->
  'a2
  action)
  ->
  char list
  ->
  ('a1
  netInput,
  'a2)
  process

val getStep :
  ('a1,
  'a2)
  process
  ->
  'a1
  ->
  'a2
  action * ('a1,
  'a2)
  process

module MakePwMgr : 
 functor (KVStore:sig 
  type key
    =
    char list
  
  type 'x t 
  
  val empty :
    'a1
    t
  
  val is_empty :
    'a1
    t
    ->
    bool
  
  val add :
    key
    ->
    'a1
    ->
    'a1
    t
    ->
    'a1
    t
  
  val find :
    key
    ->
    'a1
    t
    ->
    'a1
    option
  
  val remove :
    key
    ->
    'a1
    t
    ->
    'a1
    t
  
  val mem :
    key
    ->
    'a1
    t
    ->
    bool
  
  val map :
    ('a1
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    t
  
  val mapi :
    (key
    ->
    'a1
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    t
  
  val map2 :
    ('a1
    option
    ->
    'a2
    option
    ->
    'a3
    option)
    ->
    'a1
    t
    ->
    'a2
    t
    ->
    'a3
    t
  
  val elements :
    'a1
    t
    ->
    (key * 'a1)
    list
  
  val cardinal :
    'a1
    t
    ->
    nat
  
  val fold :
    (key
    ->
    'a1
    ->
    'a2
    ->
    'a2)
    ->
    'a1
    t
    ->
    'a2
    ->
    'a2
  
  val equal :
    ('a1
    ->
    'a1
    ->
    bool)
    ->
    'a1
    t
    ->
    'a1
    t
    ->
    bool
  
  val coq_Serializable_map :
    'a1
    serializable
    ->
    'a1
    t
    serializable
  
  val coq_Deserializable_map :
    'a1
    deserializable
    ->
    'a1
    t
    deserializable
  
  val coq_PrefixSerializable_map :
    'a1
    prefixSerializable
    ->
    'a1
    t
    prefixSerializable
  
  val merge :
    'a1
    t
    ->
    'a1
    t
    ->
    'a1
    t
 end) ->
 functor (Algorithm:sig 
  val isValidMasterKey :
    EncryptionStringDataTypes.masterKeyT
    ->
    bool
  
  val randomnessHint :
    EncryptionStringDataTypes.rawDataT
    ->
    EncryptionStringDataTypes.systemRandomnessHintT
  
  val encrypt :
    EncryptionStringDataTypes.systemRandomnessT
    ->
    EncryptionStringDataTypes.masterKeyT
    ->
    EncryptionStringDataTypes.rawDataT
    ->
    (EncryptionStringDataTypes.encryptedDataT,
    (EncryptionStringDataTypes.systemRandomnessHintT,
    EncryptionStringDataTypes.systemRandomnessT)
    encryptionError)
    sum
  
  val decrypt :
    EncryptionStringDataTypes.masterKeyT
    ->
    EncryptionStringDataTypes.encryptedDataT
    ->
    (EncryptionStringDataTypes.rawDataT,
    __)
    sum
 end) ->
 sig 
  module SSB : 
   sig 
    module TEB : 
     sig 
      type coq_EncryptBoxState =
        EncryptionStringDataTypes.masterKeyT
        option
        (* singleton inductive, whose constructor was Build_EncryptBoxState *)
      
      val coq_EncryptBoxState_rect :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_EncryptBoxState
        ->
        'a1
      
      val coq_EncryptBoxState_rec :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_EncryptBoxState
        ->
        'a1
      
      val masterKey :
        coq_EncryptBoxState
        ->
        EncryptionStringDataTypes.masterKeyT
        option
      
      type 'dataTagT ebInput =
      | Coq_ebSetMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_ebSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
         * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
      | Coq_ebEncrypt of EncryptionStringDataTypes.rawDataT
         * 'dataTagT
      
      val ebInput_rect :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.systemRandomnessT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebInput
        ->
        'a2
      
      val ebInput_rec :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.systemRandomnessT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebInput
        ->
        'a2
      
      type ebErrorOutput =
      | Coq_ebErrorNotEnoughRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * EncryptionStringDataTypes.systemRandomnessT
      | Coq_ebErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_ebErrorNoMasterKey
      
      val ebErrorOutput_rect :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        EncryptionStringDataTypes.systemRandomnessT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a1)
        ->
        'a1
        ->
        ebErrorOutput
        ->
        'a1
      
      val ebErrorOutput_rec :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        EncryptionStringDataTypes.systemRandomnessT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a1)
        ->
        'a1
        ->
        ebErrorOutput
        ->
        'a1
      
      type 'dataTagT ebEventOutput =
      | Coq_ebRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
      | Coq_ebEncrypted of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      
      val ebEventOutput_rect :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebEventOutput
        ->
        'a2
      
      val ebEventOutput_rec :
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        (EncryptionStringDataTypes.rawDataT * 'a1)
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        ebEventOutput
        ->
        'a2
      
      type 'dataTagT ebOutput
        =
        (ebErrorOutput,
        'dataTagT
        ebEventOutput)
        sum
      
      val initState :
        coq_EncryptBoxState
      
      val encryptBoxLoopPreBody :
        coq_EncryptBoxState
        ->
        'a1
        ebInput
        ->
        'a1
        ebOutput
        option * coq_EncryptBoxState
      
      val encryptBoxLoopBody :
        ('a1
        ebOutput
        ->
        'a2
        action)
        ->
        (coq_EncryptBoxState
        ->
        'a3)
        ->
        coq_EncryptBoxState
        ->
        'a1
        ebInput
        ->
        'a2
        action * 'a3
      
      val encryptBoxLoop :
        ('a1
        ebOutput
        ->
        'a2
        action)
        ->
        coq_EncryptBoxState
        ->
        ('a1
        ebInput,
        'a2)
        process
      
      val encryptBox :
        ('a1
        ebOutput
        ->
        'a2
        action)
        ->
        ('a1
        ebInput,
        'a2)
        process
     end
    
    module TDB : 
     sig 
      type coq_DecryptBoxState =
        EncryptionStringDataTypes.masterKeyT
        option
        (* singleton inductive, whose constructor was Build_DecryptBoxState *)
      
      val coq_DecryptBoxState_rect :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_DecryptBoxState
        ->
        'a1
      
      val coq_DecryptBoxState_rec :
        (EncryptionStringDataTypes.masterKeyT
        option
        ->
        'a1)
        ->
        coq_DecryptBoxState
        ->
        'a1
      
      val masterKey :
        coq_DecryptBoxState
        ->
        EncryptionStringDataTypes.masterKeyT
        option
      
      type 'dataTagT dbInput =
      | Coq_dbSetMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_dbDecrypt of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      
      val dbInput_rect :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbInput
        ->
        'a2
      
      val dbInput_rec :
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbInput
        ->
        'a2
      
      type 'dataTagT dbErrorOutput =
      | Coq_dbErrorInvalidData of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      | Coq_dbErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_dbErrorNoMasterKey
      
      val dbErrorOutput_rect :
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a2)
        ->
        'a2
        ->
        'a1
        dbErrorOutput
        ->
        'a2
      
      val dbErrorOutput_rec :
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1
        ->
        'a2)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        __
        ->
        'a2)
        ->
        'a2
        ->
        'a1
        dbErrorOutput
        ->
        'a2
      
      type 'dataTagT dbEventOutput =
      | Coq_dbDecrypted of EncryptionStringDataTypes.rawDataT
         * 'dataTagT
      
      val dbEventOutput_rect :
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbEventOutput
        ->
        'a2
      
      val dbEventOutput_rec :
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1
        ->
        'a2)
        ->
        'a1
        dbEventOutput
        ->
        'a2
      
      type 'dataTagT dbOutput
        =
        ('dataTagT
        dbErrorOutput,
        'dataTagT
        dbEventOutput)
        sum
      
      val initState :
        coq_DecryptBoxState
      
      val decryptBoxLoopPreBody :
        coq_DecryptBoxState
        ->
        'a1
        dbInput
        ->
        'a1
        dbOutput
        option * coq_DecryptBoxState
      
      val decryptBoxLoopBody :
        ('a1
        dbOutput
        ->
        'a2
        action)
        ->
        (coq_DecryptBoxState
        ->
        'a3)
        ->
        coq_DecryptBoxState
        ->
        'a1
        dbInput
        ->
        'a2
        action * 'a3
      
      val decryptBoxLoop :
        ('a1
        dbOutput
        ->
        'a2
        action)
        ->
        coq_DecryptBoxState
        ->
        ('a1
        dbInput,
        'a2)
        process
      
      val decryptBox :
        ('a1
        dbOutput
        ->
        'a2
        action)
        ->
        ('a1
        dbInput,
        'a2)
        process
     end
    
    type coq_ServerSyncBoxPreState = { localStateD : EncryptionStringDataTypes.rawDataT;
                                       remoteStateE : EncryptionStringDataTypes.encryptedDataT
                                                      option }
    
    val coq_ServerSyncBoxPreState_rect :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      option
      ->
      'a1)
      ->
      coq_ServerSyncBoxPreState
      ->
      'a1
    
    val coq_ServerSyncBoxPreState_rec :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      option
      ->
      'a1)
      ->
      coq_ServerSyncBoxPreState
      ->
      'a1
    
    val localStateD :
      coq_ServerSyncBoxPreState
      ->
      EncryptionStringDataTypes.rawDataT
    
    val remoteStateE :
      coq_ServerSyncBoxPreState
      ->
      EncryptionStringDataTypes.encryptedDataT
      option
    
    type coq_ServerSyncBoxState = { ssbState : coq_ServerSyncBoxPreState;
                                    ssbGetUpdateState : unit
                                                        tickBoxState;
                                    ssbCASState : EncryptionStringDataTypes.encryptedDataT
                                                  tickBoxState;
                                    ssbEncryptState : TEB.coq_EncryptBoxState;
                                    ssbDecryptState : TDB.coq_DecryptBoxState }
    
    val coq_ServerSyncBoxState_rect :
      (coq_ServerSyncBoxPreState
      ->
      unit
      tickBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      'a1)
      ->
      coq_ServerSyncBoxState
      ->
      'a1
    
    val coq_ServerSyncBoxState_rec :
      (coq_ServerSyncBoxPreState
      ->
      unit
      tickBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      'a1)
      ->
      coq_ServerSyncBoxState
      ->
      'a1
    
    val ssbState :
      coq_ServerSyncBoxState
      ->
      coq_ServerSyncBoxPreState
    
    val ssbGetUpdateState :
      coq_ServerSyncBoxState
      ->
      unit
      tickBoxState
    
    val ssbCASState :
      coq_ServerSyncBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
    
    val ssbEncryptState :
      coq_ServerSyncBoxState
      ->
      TEB.coq_EncryptBoxState
    
    val ssbDecryptState :
      coq_ServerSyncBoxState
      ->
      TDB.coq_DecryptBoxState
    
    val set_ssbState :
      coq_ServerSyncBoxState
      ->
      coq_ServerSyncBoxPreState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbGetUpdateState :
      coq_ServerSyncBoxState
      ->
      unit
      tickBoxState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbCASState :
      coq_ServerSyncBoxState
      ->
      EncryptionStringDataTypes.encryptedDataT
      tickBoxState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbEncryptState :
      coq_ServerSyncBoxState
      ->
      TEB.coq_EncryptBoxState
      ->
      coq_ServerSyncBoxState
    
    val set_ssbDecryptState :
      coq_ServerSyncBoxState
      ->
      TDB.coq_DecryptBoxState
      ->
      coq_ServerSyncBoxState
    
    type ssbConfigInput =
    | Coq_ssbGetUpdateConfig of tbConfigInput
    | Coq_ssbCASConfig of tbConfigInput
    | Coq_ssbSetMasterKey of EncryptionStringDataTypes.masterKeyT
    
    val ssbConfigInput_rect :
      (tbConfigInput
      ->
      'a1)
      ->
      (tbConfigInput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.masterKeyT
      ->
      'a1)
      ->
      ssbConfigInput
      ->
      'a1
    
    val ssbConfigInput_rec :
      (tbConfigInput
      ->
      'a1)
      ->
      (tbConfigInput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.masterKeyT
      ->
      'a1)
      ->
      ssbConfigInput
      ->
      'a1
    
    type ssbEventInput =
    | Coq_ssbClientGetUpdate
    | Coq_ssbClientSet of EncryptionStringDataTypes.rawDataT
    | Coq_ssbServerGotUpdate of EncryptionStringDataTypes.encryptedDataT
    | Coq_ssbSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
       * EncryptionStringDataTypes.rawDataT
    | Coq_ssbTick of Big.big_int
    
    val ssbEventInput_rect :
      'a1
      ->
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventInput
      ->
      'a1
    
    val ssbEventInput_rec :
      'a1
      ->
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventInput
      ->
      'a1
    
    type ssbInput
      =
      (ssbConfigInput,
      ssbEventInput)
      sum
    
    type ssbWarningOutput =
    | Coq_ssbGetUpdateWarning of unit
                                 tbWarningOutput
    | Coq_ssbCASWarning of EncryptionStringDataTypes.encryptedDataT
                           tbWarningOutput
    | Coq_ssbEncryptError of TEB.ebErrorOutput
    | Coq_ssbDecryptError of unit
                             TDB.dbErrorOutput
    | Coq_ssbWarningInvalidTransition of ssbInput
       * coq_ServerSyncBoxState
    | Coq_ssbWarningPushBeforePull
    
    val ssbWarningOutput_rect :
      (unit
      tbWarningOutput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbWarningOutput
      ->
      'a1)
      ->
      (TEB.ebErrorOutput
      ->
      'a1)
      ->
      (unit
      TDB.dbErrorOutput
      ->
      'a1)
      ->
      (ssbInput
      ->
      coq_ServerSyncBoxState
      ->
      'a1)
      ->
      'a1
      ->
      ssbWarningOutput
      ->
      'a1
    
    val ssbWarningOutput_rec :
      (unit
      tbWarningOutput
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbWarningOutput
      ->
      'a1)
      ->
      (TEB.ebErrorOutput
      ->
      'a1)
      ->
      (unit
      TDB.dbErrorOutput
      ->
      'a1)
      ->
      (ssbInput
      ->
      coq_ServerSyncBoxState
      ->
      'a1)
      ->
      'a1
      ->
      ssbWarningOutput
      ->
      'a1
    
    type ssbEventOutput =
    | Coq_ssbClientGotUpdate of EncryptionStringDataTypes.rawDataT
    | Coq_ssbServerGetUpdate
    | Coq_ssbServerCAS of EncryptionStringDataTypes.encryptedDataT
       * EncryptionStringDataTypes.encryptedDataT
    | Coq_ssbRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
       * EncryptionStringDataTypes.rawDataT
    | Coq_ssbSleepFor of Big.big_int
    
    val ssbEventOutput_rect :
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessHintT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1
    
    val ssbEventOutput_rec :
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessHintT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1
    
    type ssbOutput
      =
      (ssbWarningOutput,
      ssbEventOutput)
      sum
    
    val initState :
      EncryptionStringDataTypes.rawDataT
      ->
      coq_ServerSyncBoxState
    
    val isTickBoxSimpleResult :
      'a1
      tbOutput
      list
      ->
      bool
    
    val handle_simpleTickBox :
      ('a1
      tbWarningOutput
      ->
      ssbWarningOutput)
      ->
      'a1
      tbOutput
      list
      ->
      ssbOutput
      list
    
    val handle_ssbGetUpdate' :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val fold_handler :
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2
      ->
      coq_ServerSyncBoxState)
      ->
      (coq_ServerSyncBoxState
      ->
      ('a1 * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState)
      ->
      coq_ServerSyncBoxState
      ->
      ('a1
      list * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbGetUpdate :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput
      list * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbEncrypt :
      coq_ServerSyncBoxState
      ->
      (unit
      TEB.ebOutput
      option * TEB.coq_EncryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbCAS' :
      coq_ServerSyncBoxState
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbOutput * EncryptionStringDataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbCAS :
      coq_ServerSyncBoxState
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbOutput
      list * EncryptionStringDataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbDecrypt :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      (unit
      TDB.dbOutput
      option * TDB.coq_DecryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val serverSyncBoxLoopPreBody :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val serverSyncBoxLoopBody :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      'a1
      action * 'a2
    
    val serverSyncBoxLoop :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      coq_ServerSyncBoxState
      ->
      (ssbInput,
      'a1)
      process
    
    val serverSyncBox :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (ssbInput,
      'a1)
      process
   end
  
  module WB : 
   sig 
    module SSB : 
     sig 
      module TEB : 
       sig 
        type coq_EncryptBoxState =
          EncryptionStringDataTypes.masterKeyT
          option
          (* singleton inductive, whose constructor was Build_EncryptBoxState *)
        
        val coq_EncryptBoxState_rect :
          (EncryptionStringDataTypes.masterKeyT
          option
          ->
          'a1)
          ->
          coq_EncryptBoxState
          ->
          'a1
        
        val coq_EncryptBoxState_rec :
          (EncryptionStringDataTypes.masterKeyT
          option
          ->
          'a1)
          ->
          coq_EncryptBoxState
          ->
          'a1
        
        val masterKey :
          coq_EncryptBoxState
          ->
          EncryptionStringDataTypes.masterKeyT
          option
        
        type 'dataTagT ebInput =
        | Coq_ebSetMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_ebSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
           * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
        | Coq_ebEncrypt of EncryptionStringDataTypes.rawDataT
           * 'dataTagT
        
        val ebInput_rect :
          (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
          (EncryptionStringDataTypes.systemRandomnessT ->
          (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
          (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1 ebInput
          -> 'a2
        
        val ebInput_rec :
          (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
          (EncryptionStringDataTypes.systemRandomnessT ->
          (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
          (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1 ebInput
          -> 'a2
        
        type ebErrorOutput =
        | Coq_ebErrorNotEnoughRandomness of EncryptionStringDataTypes.systemRandomnessHintT
           * EncryptionStringDataTypes.systemRandomnessT
        | Coq_ebErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_ebErrorNoMasterKey
        
        val ebErrorOutput_rect :
          (EncryptionStringDataTypes.systemRandomnessHintT ->
          EncryptionStringDataTypes.systemRandomnessT -> 'a1) ->
          (EncryptionStringDataTypes.masterKeyT -> __ -> 'a1) -> 'a1 ->
          ebErrorOutput -> 'a1
        
        val ebErrorOutput_rec :
          (EncryptionStringDataTypes.systemRandomnessHintT ->
          EncryptionStringDataTypes.systemRandomnessT -> 'a1) ->
          (EncryptionStringDataTypes.masterKeyT -> __ -> 'a1) -> 'a1 ->
          ebErrorOutput -> 'a1
        
        type 'dataTagT ebEventOutput =
        | Coq_ebRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
           * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
        | Coq_ebEncrypted of EncryptionStringDataTypes.encryptedDataT
           * 'dataTagT
        
        val ebEventOutput_rect :
          (EncryptionStringDataTypes.systemRandomnessHintT ->
          (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
          (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
          ebEventOutput -> 'a2
        
        val ebEventOutput_rec :
          (EncryptionStringDataTypes.systemRandomnessHintT ->
          (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
          (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
          ebEventOutput -> 'a2
        
        type 'dataTagT ebOutput =
          (ebErrorOutput, 'dataTagT ebEventOutput) sum
        
        val initState : coq_EncryptBoxState
        
        val encryptBoxLoopPreBody :
          coq_EncryptBoxState -> 'a1 ebInput -> 'a1 ebOutput
          option * coq_EncryptBoxState
        
        val encryptBoxLoopBody :
          ('a1 ebOutput -> 'a2 action) -> (coq_EncryptBoxState -> 'a3) ->
          coq_EncryptBoxState -> 'a1 ebInput -> 'a2 action * 'a3
        
        val encryptBoxLoop :
          ('a1 ebOutput -> 'a2 action) -> coq_EncryptBoxState -> ('a1
          ebInput, 'a2) process
        
        val encryptBox :
          ('a1 ebOutput -> 'a2 action) -> ('a1 ebInput, 'a2) process
       end
      
      module TDB : 
       sig 
        type coq_DecryptBoxState =
          EncryptionStringDataTypes.masterKeyT option
          (* singleton inductive, whose constructor was Build_DecryptBoxState *)
        
        val coq_DecryptBoxState_rect :
          (EncryptionStringDataTypes.masterKeyT option -> 'a1) ->
          coq_DecryptBoxState -> 'a1
        
        val coq_DecryptBoxState_rec :
          (EncryptionStringDataTypes.masterKeyT option -> 'a1) ->
          coq_DecryptBoxState -> 'a1
        
        val masterKey :
          coq_DecryptBoxState -> EncryptionStringDataTypes.masterKeyT option
        
        type 'dataTagT dbInput =
        | Coq_dbSetMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_dbDecrypt of EncryptionStringDataTypes.encryptedDataT
           * 'dataTagT
        
        val dbInput_rect :
          (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
          (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
          dbInput -> 'a2
        
        val dbInput_rec :
          (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
          (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
          dbInput -> 'a2
        
        type 'dataTagT dbErrorOutput =
        | Coq_dbErrorInvalidData of EncryptionStringDataTypes.encryptedDataT
           * 'dataTagT
        | Coq_dbErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_dbErrorNoMasterKey
        
        val dbErrorOutput_rect :
          (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) ->
          (EncryptionStringDataTypes.masterKeyT -> __ -> 'a2) -> 'a2 -> 'a1
          dbErrorOutput -> 'a2
        
        val dbErrorOutput_rec :
          (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) ->
          (EncryptionStringDataTypes.masterKeyT -> __ -> 'a2) -> 'a2 -> 'a1
          dbErrorOutput -> 'a2
        
        type 'dataTagT dbEventOutput =
        | Coq_dbDecrypted of EncryptionStringDataTypes.rawDataT * 'dataTagT
        
        val dbEventOutput_rect :
          (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1
          dbEventOutput -> 'a2
        
        val dbEventOutput_rec :
          (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1
          dbEventOutput -> 'a2
        
        type 'dataTagT dbOutput =
          ('dataTagT dbErrorOutput, 'dataTagT dbEventOutput) sum
        
        val initState : coq_DecryptBoxState
        
        val decryptBoxLoopPreBody :
          coq_DecryptBoxState -> 'a1 dbInput -> 'a1 dbOutput
          option * coq_DecryptBoxState
        
        val decryptBoxLoopBody :
          ('a1 dbOutput -> 'a2 action) -> (coq_DecryptBoxState -> 'a3) ->
          coq_DecryptBoxState -> 'a1 dbInput -> 'a2 action * 'a3
        
        val decryptBoxLoop :
          ('a1 dbOutput -> 'a2 action) -> coq_DecryptBoxState -> ('a1
          dbInput, 'a2) process
        
        val decryptBox :
          ('a1 dbOutput -> 'a2 action) -> ('a1 dbInput, 'a2) process
       end
      
      type coq_ServerSyncBoxPreState = { localStateD : EncryptionStringDataTypes.rawDataT;
                                         remoteStateE : EncryptionStringDataTypes.encryptedDataT
                                                        option }
      
      val coq_ServerSyncBoxPreState_rect :
        (EncryptionStringDataTypes.rawDataT ->
        EncryptionStringDataTypes.encryptedDataT option -> 'a1) ->
        coq_ServerSyncBoxPreState -> 'a1
      
      val coq_ServerSyncBoxPreState_rec :
        (EncryptionStringDataTypes.rawDataT ->
        EncryptionStringDataTypes.encryptedDataT option -> 'a1) ->
        coq_ServerSyncBoxPreState -> 'a1
      
      val localStateD :
        coq_ServerSyncBoxPreState -> EncryptionStringDataTypes.rawDataT
      
      val remoteStateE :
        coq_ServerSyncBoxPreState -> EncryptionStringDataTypes.encryptedDataT
        option
      
      type coq_ServerSyncBoxState = { ssbState : coq_ServerSyncBoxPreState;
                                      ssbGetUpdateState : unit tickBoxState;
                                      ssbCASState : EncryptionStringDataTypes.encryptedDataT
                                                    tickBoxState;
                                      ssbEncryptState : TEB.coq_EncryptBoxState;
                                      ssbDecryptState : TDB.coq_DecryptBoxState }
      
      val coq_ServerSyncBoxState_rect :
        (coq_ServerSyncBoxPreState -> unit tickBoxState ->
        EncryptionStringDataTypes.encryptedDataT tickBoxState ->
        TEB.coq_EncryptBoxState -> TDB.coq_DecryptBoxState -> 'a1) ->
        coq_ServerSyncBoxState -> 'a1
      
      val coq_ServerSyncBoxState_rec :
        (coq_ServerSyncBoxPreState -> unit tickBoxState ->
        EncryptionStringDataTypes.encryptedDataT tickBoxState ->
        TEB.coq_EncryptBoxState -> TDB.coq_DecryptBoxState -> 'a1) ->
        coq_ServerSyncBoxState -> 'a1
      
      val ssbState : coq_ServerSyncBoxState -> coq_ServerSyncBoxPreState
      
      val ssbGetUpdateState : coq_ServerSyncBoxState -> unit tickBoxState
      
      val ssbCASState :
        coq_ServerSyncBoxState -> EncryptionStringDataTypes.encryptedDataT
        tickBoxState
      
      val ssbEncryptState : coq_ServerSyncBoxState -> TEB.coq_EncryptBoxState
      
      val ssbDecryptState : coq_ServerSyncBoxState -> TDB.coq_DecryptBoxState
      
      val set_ssbState :
        coq_ServerSyncBoxState -> coq_ServerSyncBoxPreState ->
        coq_ServerSyncBoxState
      
      val set_ssbGetUpdateState :
        coq_ServerSyncBoxState -> unit tickBoxState -> coq_ServerSyncBoxState
      
      val set_ssbCASState :
        coq_ServerSyncBoxState -> EncryptionStringDataTypes.encryptedDataT
        tickBoxState -> coq_ServerSyncBoxState
      
      val set_ssbEncryptState :
        coq_ServerSyncBoxState -> TEB.coq_EncryptBoxState ->
        coq_ServerSyncBoxState
      
      val set_ssbDecryptState :
        coq_ServerSyncBoxState -> TDB.coq_DecryptBoxState ->
        coq_ServerSyncBoxState
      
      type ssbConfigInput =
      | Coq_ssbGetUpdateConfig of tbConfigInput
      | Coq_ssbCASConfig of tbConfigInput
      | Coq_ssbSetMasterKey of EncryptionStringDataTypes.masterKeyT
      
      val ssbConfigInput_rect :
        (tbConfigInput -> 'a1) -> (tbConfigInput -> 'a1) ->
        (EncryptionStringDataTypes.masterKeyT -> 'a1) -> ssbConfigInput ->
        'a1
      
      val ssbConfigInput_rec :
        (tbConfigInput -> 'a1) -> (tbConfigInput -> 'a1) ->
        (EncryptionStringDataTypes.masterKeyT -> 'a1) -> ssbConfigInput ->
        'a1
      
      type ssbEventInput =
      | Coq_ssbClientGetUpdate
      | Coq_ssbClientSet of EncryptionStringDataTypes.rawDataT
      | Coq_ssbServerGotUpdate of EncryptionStringDataTypes.encryptedDataT
      | Coq_ssbSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
         * EncryptionStringDataTypes.rawDataT
      | Coq_ssbTick of Big.big_int
      
      val ssbEventInput_rect :
        'a1 -> (EncryptionStringDataTypes.rawDataT -> 'a1) ->
        (EncryptionStringDataTypes.encryptedDataT -> 'a1) ->
        (EncryptionStringDataTypes.systemRandomnessT ->
        EncryptionStringDataTypes.rawDataT -> 'a1) -> (Big.big_int -> 'a1) ->
        ssbEventInput -> 'a1
      
      val ssbEventInput_rec :
        'a1 -> (EncryptionStringDataTypes.rawDataT -> 'a1) ->
        (EncryptionStringDataTypes.encryptedDataT -> 'a1) ->
        (EncryptionStringDataTypes.systemRandomnessT ->
        EncryptionStringDataTypes.rawDataT -> 'a1) -> (Big.big_int -> 'a1) ->
        ssbEventInput -> 'a1
      
      type ssbInput = (ssbConfigInput, ssbEventInput) sum
      
      type ssbWarningOutput =
      | Coq_ssbGetUpdateWarning of unit tbWarningOutput
      | Coq_ssbCASWarning of EncryptionStringDataTypes.encryptedDataT
                             tbWarningOutput
      | Coq_ssbEncryptError of TEB.ebErrorOutput
      | Coq_ssbDecryptError of unit TDB.dbErrorOutput
      | Coq_ssbWarningInvalidTransition of ssbInput * coq_ServerSyncBoxState
      | Coq_ssbWarningPushBeforePull
      
      val ssbWarningOutput_rect :
        (unit tbWarningOutput -> 'a1) ->
        (EncryptionStringDataTypes.encryptedDataT tbWarningOutput -> 'a1) ->
        (TEB.ebErrorOutput -> 'a1) -> (unit TDB.dbErrorOutput -> 'a1) ->
        (ssbInput -> coq_ServerSyncBoxState -> 'a1) -> 'a1 ->
        ssbWarningOutput -> 'a1
      
      val ssbWarningOutput_rec :
        (unit tbWarningOutput -> 'a1) ->
        (EncryptionStringDataTypes.encryptedDataT tbWarningOutput -> 'a1) ->
        (TEB.ebErrorOutput -> 'a1) -> (unit TDB.dbErrorOutput -> 'a1) ->
        (ssbInput -> coq_ServerSyncBoxState -> 'a1) -> 'a1 ->
        ssbWarningOutput -> 'a1
      
      type ssbEventOutput =
      | Coq_ssbClientGotUpdate of EncryptionStringDataTypes.rawDataT
      | Coq_ssbServerGetUpdate
      | Coq_ssbServerCAS of EncryptionStringDataTypes.encryptedDataT
         * EncryptionStringDataTypes.encryptedDataT
      | Coq_ssbRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * EncryptionStringDataTypes.rawDataT
      | Coq_ssbSleepFor of Big.big_int
      
      val ssbEventOutput_rect :
        (EncryptionStringDataTypes.rawDataT -> 'a1) -> 'a1 ->
        (EncryptionStringDataTypes.encryptedDataT ->
        EncryptionStringDataTypes.encryptedDataT -> 'a1) ->
        (EncryptionStringDataTypes.systemRandomnessHintT ->
        EncryptionStringDataTypes.rawDataT -> 'a1) -> (Big.big_int -> 'a1) ->
        ssbEventOutput -> 'a1
      
      val ssbEventOutput_rec :
        (EncryptionStringDataTypes.rawDataT -> 'a1) -> 'a1 ->
        (EncryptionStringDataTypes.encryptedDataT ->
        EncryptionStringDataTypes.encryptedDataT -> 'a1) ->
        (EncryptionStringDataTypes.systemRandomnessHintT ->
        EncryptionStringDataTypes.rawDataT -> 'a1) -> (Big.big_int -> 'a1) ->
        ssbEventOutput -> 'a1
      
      type ssbOutput = (ssbWarningOutput, ssbEventOutput) sum
      
      val initState :
        EncryptionStringDataTypes.rawDataT -> coq_ServerSyncBoxState
      
      val isTickBoxSimpleResult : 'a1 tbOutput list -> bool
      
      val handle_simpleTickBox :
        ('a1 tbWarningOutput -> ssbWarningOutput) -> 'a1 tbOutput list ->
        ssbOutput list
      
      val handle_ssbGetUpdate' :
        coq_ServerSyncBoxState -> (unit tbOutput * unit tickBoxState) ->
        ssbOutput list * coq_ServerSyncBoxState
      
      val fold_handler :
        (coq_ServerSyncBoxState -> 'a2) -> (coq_ServerSyncBoxState -> 'a2 ->
        coq_ServerSyncBoxState) -> (coq_ServerSyncBoxState -> ('a1 * 'a2) ->
        ssbOutput list * coq_ServerSyncBoxState) -> coq_ServerSyncBoxState ->
        ('a1 list * 'a2) -> ssbOutput list * coq_ServerSyncBoxState
      
      val handle_ssbGetUpdate :
        coq_ServerSyncBoxState -> (unit tbOutput list * unit tickBoxState) ->
        ssbOutput list * coq_ServerSyncBoxState
      
      val handle_ssbEncrypt :
        coq_ServerSyncBoxState -> (unit TEB.ebOutput
        option * TEB.coq_EncryptBoxState) -> ssbOutput
        list * coq_ServerSyncBoxState
      
      val handle_ssbCAS' :
        coq_ServerSyncBoxState -> (EncryptionStringDataTypes.encryptedDataT
        tbOutput * EncryptionStringDataTypes.encryptedDataT tickBoxState) ->
        ssbOutput list * coq_ServerSyncBoxState
      
      val handle_ssbCAS :
        coq_ServerSyncBoxState -> (EncryptionStringDataTypes.encryptedDataT
        tbOutput list * EncryptionStringDataTypes.encryptedDataT
        tickBoxState) -> ssbOutput list * coq_ServerSyncBoxState
      
      val handle_ssbDecrypt :
        (EncryptionStringDataTypes.rawDataT ->
        EncryptionStringDataTypes.rawDataT -> bool) -> coq_ServerSyncBoxState
        -> (unit TDB.dbOutput option * TDB.coq_DecryptBoxState) -> ssbOutput
        list * coq_ServerSyncBoxState
      
      val serverSyncBoxLoopPreBody :
        (EncryptionStringDataTypes.rawDataT ->
        EncryptionStringDataTypes.rawDataT -> bool) -> coq_ServerSyncBoxState
        -> ssbInput -> ssbOutput list * coq_ServerSyncBoxState
      
      val serverSyncBoxLoopBody :
        (EncryptionStringDataTypes.rawDataT ->
        EncryptionStringDataTypes.rawDataT -> bool) -> (ssbOutput -> 'a1
        action) -> (coq_ServerSyncBoxState -> 'a2) -> coq_ServerSyncBoxState
        -> ssbInput -> 'a1 action * 'a2
      
      val serverSyncBoxLoop :
        (EncryptionStringDataTypes.rawDataT ->
        EncryptionStringDataTypes.rawDataT -> bool) -> (ssbOutput -> 'a1
        action) -> coq_ServerSyncBoxState -> (ssbInput, 'a1) process
      
      val serverSyncBox :
        (EncryptionStringDataTypes.rawDataT ->
        EncryptionStringDataTypes.rawDataT -> bool) ->
        EncryptionStringDataTypes.rawDataT -> (ssbOutput -> 'a1 action) ->
        (ssbInput, 'a1) process
     end
    
    type wInput = (SSB.ssbWarningOutput, tickGWarningOutput) sum
    
    module Coercions : 
     sig 
      val wInput_of_ssb : SSB.ssbWarningOutput -> wInput
      
      val wInput_of_tg : tickGWarningOutput -> wInput
     end
    
    type wOutput =
    | Coq_wConsoleErr of char list
    | Coq_wFatalError of char list
    | Coq_wBad of char list
    
    val wOutput_rect :
      (char list -> 'a1) -> (char list -> 'a1) -> (char list -> 'a1) ->
      wOutput -> 'a1
    
    val wOutput_rec :
      (char list -> 'a1) -> (char list -> 'a1) -> (char list -> 'a1) ->
      wOutput -> 'a1
    
    val newline : char
    
    val newlineS : char list
    
    val emit : (wOutput -> 'a1 action) -> char list -> 'a1 action
    
    val debugMsg :
      (wOutput -> 'a1 action) -> Big.big_int -> char list -> char list ->
      Big.big_int -> 'a1 action
    
    val labelTBStateTransition :
      'a1 serializable -> 'a1 tickBoxPreState -> 'a1 tickBoxPreState -> 'a1
      tbInput -> char list
    
    val labelTGBStateTransition :
      gatewayState -> gatewayState -> tickGInput -> char list
    
    val emitTB :
      (wOutput -> 'a1 action) -> 'a2 serializable -> Big.big_int -> 'a2
      tbWarningOutput -> char list -> 'a1 action
    
    val wLoopBody :
      (wOutput -> 'a1 action) -> (Big.big_int -> (wInput, 'a1) process) ->
      Big.big_int -> wInput -> 'a1 action * (wInput, 'a1) process
    
    val warningBox :
      (wOutput -> 'a1 action) -> Big.big_int -> (wInput, 'a1) process
   end
  
  module UI : 
   sig 
    type uiInput =
    | Coq_uiConsoleIn of char list
    | Coq_uiGotUpdate of char list
    
    val uiInput_rect :
      (char list -> 'a1) -> (char list -> 'a1) -> uiInput -> 'a1
    
    val uiInput_rec :
      (char list -> 'a1) -> (char list -> 'a1) -> uiInput -> 'a1
    
    type uiOutput =
    | Coq_uiGetUpdate
    | Coq_uiSetData of char list
    | Coq_uiConsoleOut of char list
    
    val uiOutput_rect :
      'a1 -> (char list -> 'a1) -> (char list -> 'a1) -> uiOutput -> 'a1
    
    val uiOutput_rec :
      'a1 -> (char list -> 'a1) -> (char list -> 'a1) -> uiOutput -> 'a1
    
    val split : char -> char list -> char list list
    
    val newline : char
    
    val dump : (char list * char list) list -> char list
    
    val load : char list -> (char list * char list) list
    
    val list_dec : 'a1 list -> ('a1 * 'a1 list) option
    
    val uiLoopBody :
      (uiOutput -> 'a1 action) -> (char list KVStore.t -> (uiInput, 'a1)
      process) -> char list KVStore.t -> uiInput -> 'a1 action * (uiInput,
      'a1) process
    
    val uiLoop :
      (uiOutput -> 'a1 action) -> char list KVStore.t -> (uiInput, 'a1)
      process
    
    val ui : (uiOutput -> 'a1 action) -> (uiInput, 'a1) process
   end
  
  val eta_ebError : SSB.TEB.ebErrorOutput -> WB.SSB.TEB.ebErrorOutput
  
  val eta_dbError : 'a1 SSB.TDB.dbErrorOutput -> 'a1 WB.SSB.TDB.dbErrorOutput
  
  val eta_ssbConfigInput : SSB.ssbConfigInput -> WB.SSB.ssbConfigInput
  
  val eta_ssbEventInput : SSB.ssbEventInput -> WB.SSB.ssbEventInput
  
  val eta_ssbInput : SSB.ssbInput -> WB.SSB.ssbInput
  
  val eta_EncryptBoxState :
    SSB.TEB.coq_EncryptBoxState -> WB.SSB.TEB.coq_EncryptBoxState
  
  val eta_DecryptBoxState :
    SSB.TDB.coq_DecryptBoxState -> WB.SSB.TDB.coq_DecryptBoxState
  
  val eta_ServerSyncBoxPreState :
    SSB.coq_ServerSyncBoxPreState -> WB.SSB.coq_ServerSyncBoxPreState
  
  val eta_ServerSyncBoxState :
    SSB.coq_ServerSyncBoxState -> WB.SSB.coq_ServerSyncBoxState
  
  val eta_ssbWarning : SSB.ssbWarningOutput -> WB.SSB.ssbWarningOutput
  
  type 'world input =
  | Coq_pwMgrFatal of char list
  | Coq_pwMgrConfigure of Big.big_int
  | Coq_pwMgrInit of char list
  | Coq_pwMgrConsoleIn of char list
  | Coq_pwUI of UI.uiInput
  | Coq_pwW of WB.wInput
  | Coq_pwSSB of SSB.ssbInput
  | Coq_pwNET of 'world netInput
  | Coq_pwTG of tickGInput
  
  val input_rect :
    (char list -> 'a2) -> (Big.big_int -> 'a2) -> (char list -> 'a2) ->
    (char list -> 'a2) -> (UI.uiInput -> 'a2) -> (WB.wInput -> 'a2) ->
    (SSB.ssbInput -> 'a2) -> ('a1 netInput -> 'a2) -> (tickGInput -> 'a2) ->
    'a1 input -> 'a2
  
  val input_rec :
    (char list -> 'a2) -> (Big.big_int -> 'a2) -> (char list -> 'a2) ->
    (char list -> 'a2) -> (UI.uiInput -> 'a2) -> (WB.wInput -> 'a2) ->
    (SSB.ssbInput -> 'a2) -> ('a1 netInput -> 'a2) -> (tickGInput -> 'a2) ->
    'a1 input -> 'a2
  
  val one_second : Big.big_int
  
  val abort : ('a1 input, 'a1) systemActions -> char list -> 'a1 -> 'a1
  
  val hang : ('a1, 'a2) process
  
  val pwMgrLoopBody :
    ('a1 input, 'a1) systemActions -> ((SSB.ssbInput, ('a1 input, 'a1)
    stackWorld) process -> (WB.wInput, ('a1 input, 'a1) stackWorld) process
    -> (UI.uiInput, ('a1 input, 'a1) stackWorld) process -> ('a1 netInput,
    ('a1 input, 'a1) stackWorld) process -> (tickGInput, ('a1 input, 'a1)
    stackWorld) process -> ('a1 input, 'a1) stackProcess) -> (SSB.ssbInput,
    ('a1 input, 'a1) stackWorld) process -> (WB.wInput, ('a1 input, 'a1)
    stackWorld) process -> (UI.uiInput, ('a1 input, 'a1) stackWorld) process
    -> ('a1 netInput, ('a1 input, 'a1) stackWorld) process -> (tickGInput,
    ('a1 input, 'a1) stackWorld) process -> 'a1 input -> ('a1 input, 'a1)
    stackWorld action * ('a1 input, 'a1) stackProcess
  
  val pwMgrLoop :
    ('a1 input, 'a1) systemActions -> (SSB.ssbInput, ('a1 input, 'a1)
    stackWorld) process -> (WB.wInput, ('a1 input, 'a1) stackWorld) process
    -> (UI.uiInput, ('a1 input, 'a1) stackWorld) process -> ('a1 netInput,
    ('a1 input, 'a1) stackWorld) process -> (tickGInput, ('a1 input, 'a1)
    stackWorld) process -> ('a1 input, 'a1) stackProcess
  
  val wrap_ui :
    ('a1 input, 'a1) systemActions -> (__ -> (UI.uiOutput -> __ action) ->
    (UI.uiInput, __) process) -> (UI.uiInput, ('a1 input, 'a1) stackWorld)
    process
  
  val wrap_wb :
    ('a1 input, 'a1) systemActions -> (__ -> (WB.wOutput -> __ action) ->
    (WB.wInput, __) process) -> (WB.wInput, ('a1 input, 'a1) stackWorld)
    process
  
  val wrap_ssb :
    ('a1 input, 'a1) systemActions -> (__ -> (SSB.ssbOutput -> __ action) ->
    (SSB.ssbInput, __) process) -> (SSB.ssbInput, ('a1 input, 'a1)
    stackWorld) process
  
  val wrap_net :
    ('a1 input, 'a1) systemActions -> (__ -> __ -> (__ netOutput -> __
    action) -> (__ netInput, __) process) -> ('a1 netInput, ('a1 input, 'a1)
    stackWorld) process
  
  val wrap_tickG :
    ('a1 input, 'a1) systemActions -> (__ -> (tickGOutput -> __ action) ->
    (tickGInput, __) process) -> (tickGInput, ('a1 input, 'a1) stackWorld)
    process
  
  val mkPwMgrStack :
    ('a1 input, 'a1) systemActions -> (__ -> (SSB.ssbOutput -> __ action) ->
    (SSB.ssbInput, __) process) -> (__ -> (WB.wOutput -> __ action) ->
    (WB.wInput, __) process) -> (__ -> (UI.uiOutput -> __ action) ->
    (UI.uiInput, __) process) -> (__ -> __ -> (__ netOutput -> __ action) ->
    (__ netInput, __) process) -> (__ -> (tickGOutput -> __ action) ->
    (tickGInput, __) process) -> ('a1 input, 'a1) stackProcess
  
  val pwMgrStack :
    ('a1 input, 'a1) systemActions -> EncryptionStringDataTypes.rawDataT ->
    char list -> Big.big_int -> (__ -> (tickGOutput -> __ action) ->
    (tickGInput, __) process) -> ('a1 input, 'a1) stackProcess
  
  val initStore : char list
  
  val storageId : char list
  
  val getMasterKeyLoop :
    ('a1 input, 'a1) systemActions -> Big.big_int -> ('a1 input, 'a1) process
  
  val getMasterKey :
    ('a1 input, 'a1) systemActions -> Big.big_int -> ('a1 -> 'a1) * ('a1
    input, 'a1) process
  
  val parseFlag :
    char list -> Big.big_int -> char list -> (Big.big_int -> 'a1 input) ->
    'a1 input
  
  val parseArgv' : char list -> char list list -> Big.big_int -> 'a1 input
  
  val parseArgv : Big.big_int -> char list list -> 'a1 input
  
  val proc :
    ('a1 input, 'a1) systemActions -> 'a1 action * ('a1 input, 'a1) process
 end

module PreKVStore : 
 sig 
  module E : 
   sig 
    type t = char list
    
    val compare : char list -> char list -> char list compare
    
    val eq_dec : char list -> char list -> bool
   end
  
  module Raw : 
   sig 
    type key = char list
    
    type 'elt tree =
    | Leaf
    | Node of 'elt tree * key * 'elt * 'elt tree * Z_as_Int.t
    
    val tree_rect :
      'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> Z_as_Int.t
      -> 'a2) -> 'a1 tree -> 'a2
    
    val tree_rec :
      'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> Z_as_Int.t
      -> 'a2) -> 'a1 tree -> 'a2
    
    val height : 'a1 tree -> Z_as_Int.t
    
    val cardinal : 'a1 tree -> nat
    
    val empty : 'a1 tree
    
    val is_empty : 'a1 tree -> bool
    
    val mem : char list -> 'a1 tree -> bool
    
    val find : char list -> 'a1 tree -> 'a1 option
    
    val create : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    val assert_false : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    val add : key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    val remove_min :
      'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1)
    
    val merge : 'a1 tree -> 'a1 tree -> 'a1 tree
    
    val remove : char list -> 'a1 tree -> 'a1 tree
    
    val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree
    
    type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                         t_right : 'elt tree }
    
    val triple_rect :
      ('a1 tree -> 'a1 option -> 'a1 tree -> 'a2) -> 'a1 triple -> 'a2
    
    val triple_rec :
      ('a1 tree -> 'a1 option -> 'a1 tree -> 'a2) -> 'a1 triple -> 'a2
    
    val t_left : 'a1 triple -> 'a1 tree
    
    val t_opt : 'a1 triple -> 'a1 option
    
    val t_right : 'a1 triple -> 'a1 tree
    
    val split : char list -> 'a1 tree -> 'a1 triple
    
    val concat : 'a1 tree -> 'a1 tree -> 'a1 tree
    
    val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list
    
    val elements : 'a1 tree -> (key * 'a1) list
    
    val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
    
    type 'elt enumeration =
    | End
    | More of key * 'elt * 'elt tree * 'elt enumeration
    
    val enumeration_rect :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2
    
    val enumeration_rec :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2
    
    val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration
    
    val equal_more :
      ('a1 -> 'a1 -> bool) -> char list -> 'a1 -> ('a1 enumeration -> bool)
      -> 'a1 enumeration -> bool
    
    val equal_cont :
      ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
      enumeration -> bool
    
    val equal_end : 'a1 enumeration -> bool
    
    val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool
    
    val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree
    
    val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree
    
    val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree
    
    val map2_opt :
      (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
      ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree
    
    val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree -> 'a3
      tree
    
    module Proofs : 
     sig 
      module MX : 
       sig 
        module TO : 
         sig 
          type t = char list
         end
        
        module IsTO : 
         sig 
          
         end
        
        module OrderTac : 
         sig 
          
         end
        
        val eq_dec : char list -> char list -> bool
        
        val lt_dec : char list -> char list -> bool
        
        val eqb : char list -> char list -> bool
       end
      
      module PX : 
       sig 
        module MO : 
         sig 
          module TO : 
           sig 
            type t = char list
           end
          
          module IsTO : 
           sig 
            
           end
          
          module OrderTac : 
           sig 
            
           end
          
          val eq_dec : char list -> char list -> bool
          
          val lt_dec : char list -> char list -> bool
          
          val eqb : char list -> char list -> bool
         end
       end
      
      module L : 
       sig 
        module MX : 
         sig 
          module TO : 
           sig 
            type t = char list
           end
          
          module IsTO : 
           sig 
            
           end
          
          module OrderTac : 
           sig 
            
           end
          
          val eq_dec : char list -> char list -> bool
          
          val lt_dec : char list -> char list -> bool
          
          val eqb : char list -> char list -> bool
         end
        
        module PX : 
         sig 
          module MO : 
           sig 
            module TO : 
             sig 
              type t = char list
             end
            
            module IsTO : 
             sig 
              
             end
            
            module OrderTac : 
             sig 
              
             end
            
            val eq_dec : char list -> char list -> bool
            
            val lt_dec : char list -> char list -> bool
            
            val eqb : char list -> char list -> bool
           end
         end
        
        type key = char list
        
        type 'elt t = (char list * 'elt) list
        
        val empty : 'a1 t
        
        val is_empty : 'a1 t -> bool
        
        val mem : key -> 'a1 t -> bool
        
        type 'elt coq_R_mem =
        | R_mem_0 of 'elt t
        | R_mem_1 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_mem_2 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_mem_3 of 'elt t * char list * 'elt * (char list * 'elt) list
           * bool * 'elt coq_R_mem
        
        val coq_R_mem_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 t ->
          bool -> 'a1 coq_R_mem -> 'a2
        
        val coq_R_mem_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 t ->
          bool -> 'a1 coq_R_mem -> 'a2
        
        val mem_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val mem_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val coq_R_mem_correct : key -> 'a1 t -> bool -> 'a1 coq_R_mem
        
        val find : key -> 'a1 t -> 'a1 option
        
        type 'elt coq_R_find =
        | R_find_0 of 'elt t
        | R_find_1 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_find_2 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_find_3 of 'elt t * char list * 'elt * (char list * 'elt) list
           * 'elt option * 'elt coq_R_find
        
        val coq_R_find_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 t
          -> 'a1 option -> 'a1 coq_R_find -> 'a2
        
        val coq_R_find_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 t
          -> 'a1 option -> 'a1 coq_R_find -> 'a2
        
        val find_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val find_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val coq_R_find_correct : key -> 'a1 t -> 'a1 option -> 'a1 coq_R_find
        
        val add : key -> 'a1 -> 'a1 t -> 'a1 t
        
        type 'elt coq_R_add =
        | R_add_0 of 'elt t
        | R_add_1 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_add_2 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_add_3 of 'elt t * char list * 'elt * (char list * 'elt) list
           * 'elt t * 'elt coq_R_add
        
        val coq_R_add_rect :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a1 t -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 t ->
          'a1 t -> 'a1 coq_R_add -> 'a2
        
        val coq_R_add_rec :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a1 t -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 t ->
          'a1 t -> 'a1 coq_R_add -> 'a2
        
        val add_rect :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val add_rec :
          key -> 'a1 -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val coq_R_add_correct : key -> 'a1 -> 'a1 t -> 'a1 t -> 'a1 coq_R_add
        
        val remove : key -> 'a1 t -> 'a1 t
        
        type 'elt coq_R_remove =
        | R_remove_0 of 'elt t
        | R_remove_1 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_remove_2 of 'elt t * char list * 'elt * (char list * 'elt) list
        | R_remove_3 of 'elt t * char list * 'elt * (char list * 'elt) list
           * 'elt t * 'elt coq_R_remove
        
        val coq_R_remove_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 t ->
          'a1 t -> 'a1 coq_R_remove -> 'a2
        
        val coq_R_remove_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a1 t -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 t ->
          'a1 t -> 'a1 coq_R_remove -> 'a2
        
        val remove_rect :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val remove_rec :
          key -> ('a1 t -> __ -> 'a2) -> ('a1 t -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> __ -> 'a2) -> ('a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          'a2) -> ('a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __
          -> __ -> __ -> 'a2 -> 'a2) -> 'a1 t -> 'a2
        
        val coq_R_remove_correct : key -> 'a1 t -> 'a1 t -> 'a1 coq_R_remove
        
        val elements : 'a1 t -> 'a1 t
        
        val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
        
        type ('elt, 'a) coq_R_fold =
        | R_fold_0 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a
        | R_fold_1 of (key -> 'elt -> 'a -> 'a) * 'elt t * 'a * char list
           * 'elt * (char list * 'elt) list * 'a * ('elt, 'a) coq_R_fold
        
        val coq_R_fold_rect :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2
          -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a3 ->
          ('a1, 'a3) coq_R_fold -> 'a2
        
        val coq_R_fold_rec :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> __ -> ('a1, __) coq_R_fold -> 'a2
          -> 'a2) -> (key -> 'a1 -> 'a3 -> 'a3) -> 'a1 t -> 'a3 -> 'a3 ->
          ('a1, 'a3) coq_R_fold -> 'a2
        
        val fold_rect :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3
          -> 'a3) -> 'a1 t -> 'a3 -> 'a2
        
        val fold_rec :
          (__ -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> __ -> 'a2) -> (__
          -> (key -> 'a1 -> __ -> __) -> 'a1 t -> __ -> char list -> 'a1 ->
          (char list * 'a1) list -> __ -> 'a2 -> 'a2) -> (key -> 'a1 -> 'a3
          -> 'a3) -> 'a1 t -> 'a3 -> 'a2
        
        val coq_R_fold_correct :
          (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 -> ('a1, 'a2)
          coq_R_fold
        
        val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
        
        type 'elt coq_R_equal =
        | R_equal_0 of 'elt t * 'elt t
        | R_equal_1 of 'elt t * 'elt t * char list * 'elt
           * (char list * 'elt) list * char list * 'elt
           * (char list * 'elt) list * bool * 'elt coq_R_equal
        | R_equal_2 of 'elt t * 'elt t * char list * 'elt
           * (char list * 'elt) list * char list * 'elt
           * (char list * 'elt) list * char list compare
        | R_equal_3 of 'elt t * 'elt t * 'elt t * 'elt t
        
        val coq_R_equal_rect :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __ ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          bool -> 'a1 coq_R_equal -> 'a2 -> 'a2) -> ('a1 t -> 'a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> char list ->
          'a1 -> (char list * 'a1) list -> __ -> char list compare -> __ ->
          __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __
          -> 'a2) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal -> 'a2
        
        val coq_R_equal_rec :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __ ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ ->
          bool -> 'a1 coq_R_equal -> 'a2 -> 'a2) -> ('a1 t -> 'a1 t ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> char list ->
          'a1 -> (char list * 'a1) list -> __ -> char list compare -> __ ->
          __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t -> __ -> 'a1 t -> __ -> __
          -> 'a2) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal -> 'a2
        
        val equal_rect :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __ ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ -> 'a2
          -> 'a2) -> ('a1 t -> 'a1 t -> char list -> 'a1 -> (char list * 'a1)
          list -> __ -> char list -> 'a1 -> (char list * 'a1) list -> __ ->
          char list compare -> __ -> __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t
          -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t -> 'a2
        
        val equal_rec :
          ('a1 -> 'a1 -> bool) -> ('a1 t -> 'a1 t -> __ -> __ -> 'a2) -> ('a1
          t -> 'a1 t -> char list -> 'a1 -> (char list * 'a1) list -> __ ->
          char list -> 'a1 -> (char list * 'a1) list -> __ -> __ -> __ -> 'a2
          -> 'a2) -> ('a1 t -> 'a1 t -> char list -> 'a1 -> (char list * 'a1)
          list -> __ -> char list -> 'a1 -> (char list * 'a1) list -> __ ->
          char list compare -> __ -> __ -> 'a2) -> ('a1 t -> 'a1 t -> 'a1 t
          -> __ -> 'a1 t -> __ -> __ -> 'a2) -> 'a1 t -> 'a1 t -> 'a2
        
        val coq_R_equal_correct :
          ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool -> 'a1 coq_R_equal
        
        val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
        
        val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
        
        val option_cons :
          key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list
        
        val map2_l :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t
        
        val map2_r :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t
        
        val map2 :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
        
        val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t
        
        val fold_right_pair :
          ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3
        
        val map2_alt :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
          (key * 'a3) list
        
        val at_least_one :
          'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option
        
        val at_least_one_then_f :
          ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2
          option -> 'a3 option
       end
      
      type 'elt coq_R_mem =
      | R_mem_0 of 'elt tree
      | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * bool * 'elt coq_R_mem
      | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * bool * 'elt coq_R_mem
      
      val coq_R_mem_rect :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1
        coq_R_mem -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
        bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
        coq_R_mem -> 'a2
      
      val coq_R_mem_rec :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> bool -> 'a1
        coq_R_mem -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
        bool -> 'a1 coq_R_mem -> 'a2 -> 'a2) -> 'a1 tree -> bool -> 'a1
        coq_R_mem -> 'a2
      
      type 'elt coq_R_find =
      | R_find_0 of 'elt tree
      | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt option * 'elt coq_R_find
      | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt option * 'elt coq_R_find
      
      val coq_R_find_rect :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 option ->
        'a1 coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
        'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option
        -> 'a1 coq_R_find -> 'a2
      
      val coq_R_find_rec :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 option ->
        'a1 coq_R_find -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ ->
        'a1 option -> 'a1 coq_R_find -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option
        -> 'a1 coq_R_find -> 'a2
      
      type 'elt coq_R_bal =
      | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
      | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
      | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t
      | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key
         * 'elt * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_bal_8 of 'elt tree * key * 'elt * 'elt tree
      
      val coq_R_bal_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1
        -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree
        -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
      
      val coq_R_bal_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree ->
        key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1
        -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree
        -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2
      
      type 'elt coq_R_add =
      | R_add_0 of 'elt tree
      | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_add
      | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_add
      
      val coq_R_add_rect :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_add -> 'a2
      
      val coq_R_add_rec :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_add -> 'a2
      
      type 'elt coq_R_remove_min =
      | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
      | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree
         * key * 'elt * 'elt tree * Z_as_Int.t * ('elt tree * (key * 'elt))
         * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)
      
      val coq_R_remove_min_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2
      
      val coq_R_remove_min_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2 -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min
        -> 'a2
      
      type 'elt coq_R_merge =
      | R_merge_0 of 'elt tree * 'elt tree
      | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t
      | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * (key * 'elt) * key * 'elt
      
      val coq_R_merge_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) ->
        'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
      
      val coq_R_merge_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) ->
        'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_merge -> 'a2
      
      type 'elt coq_R_remove =
      | R_remove_0 of 'elt tree
      | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_remove
      | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * 'elt coq_R_remove
      
      val coq_R_remove_rect :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
        'a1 coq_R_remove -> 'a2
      
      val coq_R_remove_rec :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_remove -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1
        tree -> 'a1 coq_R_remove -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree ->
        'a1 coq_R_remove -> 'a2
      
      type 'elt coq_R_concat =
      | R_concat_0 of 'elt tree * 'elt tree
      | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t
      | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt tree * (key * 'elt)
      
      val coq_R_concat_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1
        tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
      
      val coq_R_concat_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2) ->
        ('a1 tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        Z_as_Int.t -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a1 tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1
        tree -> 'a1 tree -> 'a1 coq_R_concat -> 'a2
      
      type 'elt coq_R_split =
      | R_split_0 of 'elt tree
      | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
         * 'elt option * 'elt tree
      | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t
      | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt triple * 'elt coq_R_split * 'elt tree
         * 'elt option * 'elt tree
      
      val coq_R_split_rect :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple ->
        'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
      
      val coq_R_split_rec :
        char list -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple ->
        'a1 coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> Z_as_Int.t -> __ -> __ -> __ -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ ->
        'a2) -> 'a1 tree -> 'a1 triple -> 'a1 coq_R_split -> 'a2
      
      type ('elt, 'elt') coq_R_map_option =
      | R_map_option_0 of 'elt tree
      | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt' * 'elt' tree * ('elt, 'elt') coq_R_map_option
         * 'elt' tree * ('elt, 'elt') coq_R_map_option
      | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree
         * Z_as_Int.t * 'elt' tree * ('elt, 'elt') coq_R_map_option
         * 'elt' tree * ('elt, 'elt') coq_R_map_option
      
      val coq_R_map_option_rect :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 -> __
        -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
        -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3
      
      val coq_R_map_option_rec :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 -> __
        -> 'a2 tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree
        -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> __ -> 'a2 tree ->
        ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3
      
      type ('elt, 'elt', 'elt'') coq_R_map2_opt =
      | R_map2_opt_0 of 'elt tree * 'elt' tree
      | R_map2_opt_1 of 'elt tree * 'elt' tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t
      | R_map2_opt_2 of 'elt tree * 'elt' tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt' tree * key * 'elt' * 'elt' tree
         * Z_as_Int.t * 'elt' tree * 'elt' option * 'elt' tree * 'elt''
         * 'elt'' tree * ('elt, 'elt', 'elt'') coq_R_map2_opt * 'elt'' tree
         * ('elt, 'elt', 'elt'') coq_R_map2_opt
      | R_map2_opt_3 of 'elt tree * 'elt' tree * 'elt tree * key * 'elt
         * 'elt tree * Z_as_Int.t * 'elt' tree * key * 'elt' * 'elt' tree
         * Z_as_Int.t * 'elt' tree * 'elt' option * 'elt' tree * 'elt'' tree
         * ('elt, 'elt', 'elt'') coq_R_map2_opt * 'elt'' tree
         * ('elt, 'elt', 'elt'') coq_R_map2_opt
      
      val coq_R_map2_opt_rect :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
        tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __
        -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
        'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> Z_as_Int.t -> __ ->
        'a2 tree -> 'a2 option -> 'a2 tree -> __ -> __ -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3)
        coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3 tree ->
        ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4
      
      val coq_R_map2_opt_rec :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> Z_as_Int.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2
        tree -> Z_as_Int.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __
        -> 'a3 -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 ->
        'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> Z_as_Int.t
        -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> Z_as_Int.t -> __ ->
        'a2 tree -> 'a2 option -> 'a2 tree -> __ -> __ -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1, 'a2, 'a3)
        coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree -> 'a2 tree -> 'a3 tree ->
        ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4
      
      val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2
      
      val flatten_e : 'a1 enumeration -> (key * 'a1) list
     end
   end
  
  type 'elt bst =
    'elt Raw.tree
    (* singleton inductive, whose constructor was Bst *)
  
  val bst_rect : ('a1 Raw.tree -> __ -> 'a2) -> 'a1 bst -> 'a2
  
  val bst_rec : ('a1 Raw.tree -> __ -> 'a2) -> 'a1 bst -> 'a2
  
  val this : 'a1 bst -> 'a1 Raw.tree
  
  type 'elt t = 'elt bst
  
  type key = char list
  
  val empty : 'a1 t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val find : key -> 'a1 t -> 'a1 option
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
 end

module KVStore : 
 sig 
  type key = PreKVStore.key
  
  type 'elt t = (nat * 'elt option) PreKVStore.t
  
  val empty : (nat * 'a1 option) PreKVStore.t
  
  val is_empty : 'a1 t -> bool
  
  val add : key -> 'a1 -> 'a1 t -> 'a1 t
  
  val find : key -> 'a1 t -> 'a1 option
  
  val remove : key -> 'a1 t -> 'a1 t
  
  val mem : key -> 'a1 t -> bool
  
  val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t
  
  val map2 :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
  
  val garbage_collect : 'a1 t -> 'a1 t
  
  val filter_some : ('a1 * 'a2 option) list -> ('a1 * 'a2) list
  
  val elements : 'a1 t -> (key * 'a1) list
  
  val cardinal : 'a1 t -> nat
  
  val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2
  
  val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool
  
  val merge : 'a1 t -> 'a1 t -> 'a1 t
  
  val from_internal_elements :
    (PreKVStore.key * (nat * 'a1 option)) list -> 'a1 t
  
  val is_sorted : (PreKVStore.key * (nat * 'a1 option)) list -> bool
  
  val sorted_from_internal_elements :
    (PreKVStore.key * (nat * 'a1 option)) list option -> 'a1 t option
  
  val coq_Serializable_map : 'a1 serializable -> 'a1 t serializable
  
  val coq_Deserializable_map : 'a1 deserializable -> 'a1 t deserializable
  
  val coq_PrefixSerializable_map :
    'a1 prefixSerializable -> 'a1 t prefixSerializable
 end

module PwMgr : 
 sig 
  module SSB : 
   sig 
    module TEB : 
     sig 
      type coq_EncryptBoxState =
        EncryptionStringDataTypes.masterKeyT option
        (* singleton inductive, whose constructor was Build_EncryptBoxState *)
      
      val coq_EncryptBoxState_rect :
        (EncryptionStringDataTypes.masterKeyT option -> 'a1) ->
        coq_EncryptBoxState -> 'a1
      
      val coq_EncryptBoxState_rec :
        (EncryptionStringDataTypes.masterKeyT option -> 'a1) ->
        coq_EncryptBoxState -> 'a1
      
      val masterKey :
        coq_EncryptBoxState -> EncryptionStringDataTypes.masterKeyT option
      
      type 'dataTagT ebInput =
      | Coq_ebSetMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_ebSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
         * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
      | Coq_ebEncrypt of EncryptionStringDataTypes.rawDataT * 'dataTagT
      
      val ebInput_rect :
        (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
        (EncryptionStringDataTypes.systemRandomnessT ->
        (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
        (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1 ebInput ->
        'a2
      
      val ebInput_rec :
        (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
        (EncryptionStringDataTypes.systemRandomnessT ->
        (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
        (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1 ebInput ->
        'a2
      
      type ebErrorOutput =
      | Coq_ebErrorNotEnoughRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * EncryptionStringDataTypes.systemRandomnessT
      | Coq_ebErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_ebErrorNoMasterKey
      
      val ebErrorOutput_rect :
        (EncryptionStringDataTypes.systemRandomnessHintT ->
        EncryptionStringDataTypes.systemRandomnessT -> 'a1) ->
        (EncryptionStringDataTypes.masterKeyT -> __ -> 'a1) -> 'a1 ->
        ebErrorOutput -> 'a1
      
      val ebErrorOutput_rec :
        (EncryptionStringDataTypes.systemRandomnessHintT ->
        EncryptionStringDataTypes.systemRandomnessT -> 'a1) ->
        (EncryptionStringDataTypes.masterKeyT -> __ -> 'a1) -> 'a1 ->
        ebErrorOutput -> 'a1
      
      type 'dataTagT ebEventOutput =
      | Coq_ebRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
      | Coq_ebEncrypted of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      
      val ebEventOutput_rect :
        (EncryptionStringDataTypes.systemRandomnessHintT ->
        (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
        (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
        ebEventOutput -> 'a2
      
      val ebEventOutput_rec :
        (EncryptionStringDataTypes.systemRandomnessHintT ->
        (EncryptionStringDataTypes.rawDataT * 'a1) -> 'a2) ->
        (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
        ebEventOutput -> 'a2
      
      type 'dataTagT ebOutput = (ebErrorOutput, 'dataTagT ebEventOutput) sum
      
      val initState : coq_EncryptBoxState
      
      val encryptBoxLoopPreBody :
        coq_EncryptBoxState -> 'a1 ebInput -> 'a1 ebOutput
        option * coq_EncryptBoxState
      
      val encryptBoxLoopBody :
        ('a1 ebOutput -> 'a2 action) -> (coq_EncryptBoxState -> 'a3) ->
        coq_EncryptBoxState -> 'a1 ebInput -> 'a2 action * 'a3
      
      val encryptBoxLoop :
        ('a1 ebOutput -> 'a2 action) -> coq_EncryptBoxState -> ('a1 ebInput,
        'a2) process
      
      val encryptBox :
        ('a1 ebOutput -> 'a2 action) -> ('a1 ebInput, 'a2) process
     end
    
    module TDB : 
     sig 
      type coq_DecryptBoxState =
        EncryptionStringDataTypes.masterKeyT option
        (* singleton inductive, whose constructor was Build_DecryptBoxState *)
      
      val coq_DecryptBoxState_rect :
        (EncryptionStringDataTypes.masterKeyT option -> 'a1) ->
        coq_DecryptBoxState -> 'a1
      
      val coq_DecryptBoxState_rec :
        (EncryptionStringDataTypes.masterKeyT option -> 'a1) ->
        coq_DecryptBoxState -> 'a1
      
      val masterKey :
        coq_DecryptBoxState -> EncryptionStringDataTypes.masterKeyT option
      
      type 'dataTagT dbInput =
      | Coq_dbSetMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_dbDecrypt of EncryptionStringDataTypes.encryptedDataT * 'dataTagT
      
      val dbInput_rect :
        (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
        (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
        dbInput -> 'a2
      
      val dbInput_rec :
        (EncryptionStringDataTypes.masterKeyT -> 'a2) ->
        (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) -> 'a1
        dbInput -> 'a2
      
      type 'dataTagT dbErrorOutput =
      | Coq_dbErrorInvalidData of EncryptionStringDataTypes.encryptedDataT
         * 'dataTagT
      | Coq_dbErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
      | Coq_dbErrorNoMasterKey
      
      val dbErrorOutput_rect :
        (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) ->
        (EncryptionStringDataTypes.masterKeyT -> __ -> 'a2) -> 'a2 -> 'a1
        dbErrorOutput -> 'a2
      
      val dbErrorOutput_rec :
        (EncryptionStringDataTypes.encryptedDataT -> 'a1 -> 'a2) ->
        (EncryptionStringDataTypes.masterKeyT -> __ -> 'a2) -> 'a2 -> 'a1
        dbErrorOutput -> 'a2
      
      type 'dataTagT dbEventOutput =
      | Coq_dbDecrypted of EncryptionStringDataTypes.rawDataT * 'dataTagT
      
      val dbEventOutput_rect :
        (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1
        dbEventOutput -> 'a2
      
      val dbEventOutput_rec :
        (EncryptionStringDataTypes.rawDataT -> 'a1 -> 'a2) -> 'a1
        dbEventOutput -> 'a2
      
      type 'dataTagT dbOutput =
        ('dataTagT dbErrorOutput, 'dataTagT dbEventOutput) sum
      
      val initState : coq_DecryptBoxState
      
      val decryptBoxLoopPreBody :
        coq_DecryptBoxState -> 'a1 dbInput -> 'a1 dbOutput
        option * coq_DecryptBoxState
      
      val decryptBoxLoopBody :
        ('a1 dbOutput -> 'a2 action) -> (coq_DecryptBoxState -> 'a3) ->
        coq_DecryptBoxState -> 'a1 dbInput -> 'a2 action * 'a3
      
      val decryptBoxLoop :
        ('a1 dbOutput -> 'a2 action) -> coq_DecryptBoxState -> ('a1 dbInput,
        'a2) process
      
      val decryptBox :
        ('a1 dbOutput -> 'a2 action) -> ('a1 dbInput, 'a2) process
     end
    
    type coq_ServerSyncBoxPreState = { localStateD : EncryptionStringDataTypes.rawDataT;
                                       remoteStateE : EncryptionStringDataTypes.encryptedDataT
                                                      option }
    
    val coq_ServerSyncBoxPreState_rect :
      (EncryptionStringDataTypes.rawDataT ->
      EncryptionStringDataTypes.encryptedDataT option -> 'a1) ->
      coq_ServerSyncBoxPreState -> 'a1
    
    val coq_ServerSyncBoxPreState_rec :
      (EncryptionStringDataTypes.rawDataT ->
      EncryptionStringDataTypes.encryptedDataT option -> 'a1) ->
      coq_ServerSyncBoxPreState -> 'a1
    
    val localStateD :
      coq_ServerSyncBoxPreState -> EncryptionStringDataTypes.rawDataT
    
    val remoteStateE :
      coq_ServerSyncBoxPreState -> EncryptionStringDataTypes.encryptedDataT
      option
    
    type coq_ServerSyncBoxState = { ssbState : coq_ServerSyncBoxPreState;
                                    ssbGetUpdateState : unit tickBoxState;
                                    ssbCASState : EncryptionStringDataTypes.encryptedDataT
                                                  tickBoxState;
                                    ssbEncryptState : TEB.coq_EncryptBoxState;
                                    ssbDecryptState : TDB.coq_DecryptBoxState }
    
    val coq_ServerSyncBoxState_rect :
      (coq_ServerSyncBoxPreState -> unit tickBoxState ->
      EncryptionStringDataTypes.encryptedDataT tickBoxState ->
      TEB.coq_EncryptBoxState -> TDB.coq_DecryptBoxState -> 'a1) ->
      coq_ServerSyncBoxState -> 'a1
    
    val coq_ServerSyncBoxState_rec :
      (coq_ServerSyncBoxPreState -> unit tickBoxState ->
      EncryptionStringDataTypes.encryptedDataT tickBoxState ->
      TEB.coq_EncryptBoxState -> TDB.coq_DecryptBoxState -> 'a1) ->
      coq_ServerSyncBoxState -> 'a1
    
    val ssbState : coq_ServerSyncBoxState -> coq_ServerSyncBoxPreState
    
    val ssbGetUpdateState : coq_ServerSyncBoxState -> unit tickBoxState
    
    val ssbCASState :
      coq_ServerSyncBoxState -> EncryptionStringDataTypes.encryptedDataT
      tickBoxState
    
    val ssbEncryptState : coq_ServerSyncBoxState -> TEB.coq_EncryptBoxState
    
    val ssbDecryptState : coq_ServerSyncBoxState -> TDB.coq_DecryptBoxState
    
    val set_ssbState :
      coq_ServerSyncBoxState -> coq_ServerSyncBoxPreState ->
      coq_ServerSyncBoxState
    
    val set_ssbGetUpdateState :
      coq_ServerSyncBoxState -> unit tickBoxState -> coq_ServerSyncBoxState
    
    val set_ssbCASState :
      coq_ServerSyncBoxState -> EncryptionStringDataTypes.encryptedDataT
      tickBoxState -> coq_ServerSyncBoxState
    
    val set_ssbEncryptState :
      coq_ServerSyncBoxState -> TEB.coq_EncryptBoxState ->
      coq_ServerSyncBoxState
    
    val set_ssbDecryptState :
      coq_ServerSyncBoxState -> TDB.coq_DecryptBoxState ->
      coq_ServerSyncBoxState
    
    type ssbConfigInput =
    | Coq_ssbGetUpdateConfig of tbConfigInput
    | Coq_ssbCASConfig of tbConfigInput
    | Coq_ssbSetMasterKey of EncryptionStringDataTypes.masterKeyT
    
    val ssbConfigInput_rect :
      (tbConfigInput -> 'a1) -> (tbConfigInput -> 'a1) ->
      (EncryptionStringDataTypes.masterKeyT -> 'a1) -> ssbConfigInput -> 'a1
    
    val ssbConfigInput_rec :
      (tbConfigInput -> 'a1) -> (tbConfigInput -> 'a1) ->
      (EncryptionStringDataTypes.masterKeyT -> 'a1) -> ssbConfigInput -> 'a1
    
    type ssbEventInput =
    | Coq_ssbClientGetUpdate
    | Coq_ssbClientSet of EncryptionStringDataTypes.rawDataT
    | Coq_ssbServerGotUpdate of EncryptionStringDataTypes.encryptedDataT
    | Coq_ssbSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
       * EncryptionStringDataTypes.rawDataT
    | Coq_ssbTick of Big.big_int
    
    val ssbEventInput_rect :
      'a1 -> (EncryptionStringDataTypes.rawDataT -> 'a1) ->
      (EncryptionStringDataTypes.encryptedDataT -> 'a1) ->
      (EncryptionStringDataTypes.systemRandomnessT ->
      EncryptionStringDataTypes.rawDataT -> 'a1) -> (Big.big_int -> 'a1) ->
      ssbEventInput -> 'a1
    
    val ssbEventInput_rec :
      'a1 -> (EncryptionStringDataTypes.rawDataT -> 'a1) ->
      (EncryptionStringDataTypes.encryptedDataT -> 'a1) ->
      (EncryptionStringDataTypes.systemRandomnessT ->
      EncryptionStringDataTypes.rawDataT -> 'a1) -> (Big.big_int -> 'a1) ->
      ssbEventInput -> 'a1
    
    type ssbInput = (ssbConfigInput, ssbEventInput) sum
    
    type ssbWarningOutput =
    | Coq_ssbGetUpdateWarning of unit tbWarningOutput
    | Coq_ssbCASWarning of EncryptionStringDataTypes.encryptedDataT
                           tbWarningOutput
    | Coq_ssbEncryptError of TEB.ebErrorOutput
    | Coq_ssbDecryptError of unit TDB.dbErrorOutput
    | Coq_ssbWarningInvalidTransition of ssbInput * coq_ServerSyncBoxState
    | Coq_ssbWarningPushBeforePull
    
    val ssbWarningOutput_rect :
      (unit tbWarningOutput -> 'a1) ->
      (EncryptionStringDataTypes.encryptedDataT tbWarningOutput -> 'a1) ->
      (TEB.ebErrorOutput -> 'a1) -> (unit TDB.dbErrorOutput -> 'a1) ->
      (ssbInput -> coq_ServerSyncBoxState -> 'a1) -> 'a1 -> ssbWarningOutput
      -> 'a1
    
    val ssbWarningOutput_rec :
      (unit tbWarningOutput -> 'a1) ->
      (EncryptionStringDataTypes.encryptedDataT tbWarningOutput -> 'a1) ->
      (TEB.ebErrorOutput -> 'a1) -> (unit TDB.dbErrorOutput -> 'a1) ->
      (ssbInput -> coq_ServerSyncBoxState -> 'a1) -> 'a1 -> ssbWarningOutput
      -> 'a1
    
    type ssbEventOutput =
    | Coq_ssbClientGotUpdate of EncryptionStringDataTypes.rawDataT
    | Coq_ssbServerGetUpdate
    | Coq_ssbServerCAS of EncryptionStringDataTypes.encryptedDataT
       * EncryptionStringDataTypes.encryptedDataT
    | Coq_ssbRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
       * EncryptionStringDataTypes.rawDataT
    | Coq_ssbSleepFor of Big.big_int
    
    val ssbEventOutput_rect :
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessHintT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1
    
    val ssbEventOutput_rec :
      (EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      'a1
      ->
      (EncryptionStringDataTypes.encryptedDataT
      ->
      EncryptionStringDataTypes.encryptedDataT
      ->
      'a1)
      ->
      (EncryptionStringDataTypes.systemRandomnessHintT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      'a1)
      ->
      (Big.big_int
      ->
      'a1)
      ->
      ssbEventOutput
      ->
      'a1
    
    type ssbOutput
      =
      (ssbWarningOutput,
      ssbEventOutput)
      sum
    
    val initState :
      EncryptionStringDataTypes.rawDataT
      ->
      coq_ServerSyncBoxState
    
    val isTickBoxSimpleResult :
      'a1
      tbOutput
      list
      ->
      bool
    
    val handle_simpleTickBox :
      ('a1
      tbWarningOutput
      ->
      ssbWarningOutput)
      ->
      'a1
      tbOutput
      list
      ->
      ssbOutput
      list
    
    val handle_ssbGetUpdate' :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val fold_handler :
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2
      ->
      coq_ServerSyncBoxState)
      ->
      (coq_ServerSyncBoxState
      ->
      ('a1 * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState)
      ->
      coq_ServerSyncBoxState
      ->
      ('a1
      list * 'a2)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbGetUpdate :
      coq_ServerSyncBoxState
      ->
      (unit
      tbOutput
      list * unit
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbEncrypt :
      coq_ServerSyncBoxState
      ->
      (unit
      TEB.ebOutput
      option * TEB.coq_EncryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbCAS' :
      coq_ServerSyncBoxState
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbOutput * EncryptionStringDataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbCAS :
      coq_ServerSyncBoxState
      ->
      (EncryptionStringDataTypes.encryptedDataT
      tbOutput
      list * EncryptionStringDataTypes.encryptedDataT
      tickBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val handle_ssbDecrypt :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      (unit
      TDB.dbOutput
      option * TDB.coq_DecryptBoxState)
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val serverSyncBoxLoopPreBody :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      ssbOutput
      list * coq_ServerSyncBoxState
    
    val serverSyncBoxLoopBody :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (coq_ServerSyncBoxState
      ->
      'a2)
      ->
      coq_ServerSyncBoxState
      ->
      ssbInput
      ->
      'a1
      action * 'a2
    
    val serverSyncBoxLoop :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      coq_ServerSyncBoxState
      ->
      (ssbInput,
      'a1)
      process
    
    val serverSyncBox :
      (EncryptionStringDataTypes.rawDataT
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      bool)
      ->
      EncryptionStringDataTypes.rawDataT
      ->
      (ssbOutput
      ->
      'a1
      action)
      ->
      (ssbInput,
      'a1)
      process
   end
  
  module WB : 
   sig 
    module SSB : 
     sig 
      module TEB : 
       sig 
        type coq_EncryptBoxState =
          EncryptionStringDataTypes.masterKeyT
          option
          (* singleton inductive, whose constructor was Build_EncryptBoxState *)
        
        val coq_EncryptBoxState_rect :
          (EncryptionStringDataTypes.masterKeyT
          option
          ->
          'a1)
          ->
          coq_EncryptBoxState
          ->
          'a1
        
        val coq_EncryptBoxState_rec :
          (EncryptionStringDataTypes.masterKeyT
          option
          ->
          'a1)
          ->
          coq_EncryptBoxState
          ->
          'a1
        
        val masterKey :
          coq_EncryptBoxState
          ->
          EncryptionStringDataTypes.masterKeyT
          option
        
        type 'dataTagT ebInput =
        | Coq_ebSetMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_ebSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
           * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
        | Coq_ebEncrypt of EncryptionStringDataTypes.rawDataT
           * 'dataTagT
        
        val ebInput_rect :
          (EncryptionStringDataTypes.masterKeyT
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.systemRandomnessT
          ->
          (EncryptionStringDataTypes.rawDataT * 'a1)
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.rawDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          ebInput
          ->
          'a2
        
        val ebInput_rec :
          (EncryptionStringDataTypes.masterKeyT
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.systemRandomnessT
          ->
          (EncryptionStringDataTypes.rawDataT * 'a1)
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.rawDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          ebInput
          ->
          'a2
        
        type ebErrorOutput =
        | Coq_ebErrorNotEnoughRandomness of EncryptionStringDataTypes.systemRandomnessHintT
           * EncryptionStringDataTypes.systemRandomnessT
        | Coq_ebErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_ebErrorNoMasterKey
        
        val ebErrorOutput_rect :
          (EncryptionStringDataTypes.systemRandomnessHintT
          ->
          EncryptionStringDataTypes.systemRandomnessT
          ->
          'a1)
          ->
          (EncryptionStringDataTypes.masterKeyT
          ->
          __
          ->
          'a1)
          ->
          'a1
          ->
          ebErrorOutput
          ->
          'a1
        
        val ebErrorOutput_rec :
          (EncryptionStringDataTypes.systemRandomnessHintT
          ->
          EncryptionStringDataTypes.systemRandomnessT
          ->
          'a1)
          ->
          (EncryptionStringDataTypes.masterKeyT
          ->
          __
          ->
          'a1)
          ->
          'a1
          ->
          ebErrorOutput
          ->
          'a1
        
        type 'dataTagT ebEventOutput =
        | Coq_ebRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
           * (EncryptionStringDataTypes.rawDataT * 'dataTagT)
        | Coq_ebEncrypted of EncryptionStringDataTypes.encryptedDataT
           * 'dataTagT
        
        val ebEventOutput_rect :
          (EncryptionStringDataTypes.systemRandomnessHintT
          ->
          (EncryptionStringDataTypes.rawDataT * 'a1)
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.encryptedDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          ebEventOutput
          ->
          'a2
        
        val ebEventOutput_rec :
          (EncryptionStringDataTypes.systemRandomnessHintT
          ->
          (EncryptionStringDataTypes.rawDataT * 'a1)
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.encryptedDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          ebEventOutput
          ->
          'a2
        
        type 'dataTagT ebOutput
          =
          (ebErrorOutput,
          'dataTagT
          ebEventOutput)
          sum
        
        val initState :
          coq_EncryptBoxState
        
        val encryptBoxLoopPreBody :
          coq_EncryptBoxState
          ->
          'a1
          ebInput
          ->
          'a1
          ebOutput
          option * coq_EncryptBoxState
        
        val encryptBoxLoopBody :
          ('a1
          ebOutput
          ->
          'a2
          action)
          ->
          (coq_EncryptBoxState
          ->
          'a3)
          ->
          coq_EncryptBoxState
          ->
          'a1
          ebInput
          ->
          'a2
          action * 'a3
        
        val encryptBoxLoop :
          ('a1
          ebOutput
          ->
          'a2
          action)
          ->
          coq_EncryptBoxState
          ->
          ('a1
          ebInput,
          'a2)
          process
        
        val encryptBox :
          ('a1
          ebOutput
          ->
          'a2
          action)
          ->
          ('a1
          ebInput,
          'a2)
          process
       end
      
      module TDB : 
       sig 
        type coq_DecryptBoxState =
          EncryptionStringDataTypes.masterKeyT
          option
          (* singleton inductive, whose constructor was Build_DecryptBoxState *)
        
        val coq_DecryptBoxState_rect :
          (EncryptionStringDataTypes.masterKeyT
          option
          ->
          'a1)
          ->
          coq_DecryptBoxState
          ->
          'a1
        
        val coq_DecryptBoxState_rec :
          (EncryptionStringDataTypes.masterKeyT
          option
          ->
          'a1)
          ->
          coq_DecryptBoxState
          ->
          'a1
        
        val masterKey :
          coq_DecryptBoxState
          ->
          EncryptionStringDataTypes.masterKeyT
          option
        
        type 'dataTagT dbInput =
        | Coq_dbSetMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_dbDecrypt of EncryptionStringDataTypes.encryptedDataT
           * 'dataTagT
        
        val dbInput_rect :
          (EncryptionStringDataTypes.masterKeyT
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.encryptedDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          dbInput
          ->
          'a2
        
        val dbInput_rec :
          (EncryptionStringDataTypes.masterKeyT
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.encryptedDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          dbInput
          ->
          'a2
        
        type 'dataTagT dbErrorOutput =
        | Coq_dbErrorInvalidData of EncryptionStringDataTypes.encryptedDataT
           * 'dataTagT
        | Coq_dbErrorInvalidMasterKey of EncryptionStringDataTypes.masterKeyT
        | Coq_dbErrorNoMasterKey
        
        val dbErrorOutput_rect :
          (EncryptionStringDataTypes.encryptedDataT
          ->
          'a1
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.masterKeyT
          ->
          __
          ->
          'a2)
          ->
          'a2
          ->
          'a1
          dbErrorOutput
          ->
          'a2
        
        val dbErrorOutput_rec :
          (EncryptionStringDataTypes.encryptedDataT
          ->
          'a1
          ->
          'a2)
          ->
          (EncryptionStringDataTypes.masterKeyT
          ->
          __
          ->
          'a2)
          ->
          'a2
          ->
          'a1
          dbErrorOutput
          ->
          'a2
        
        type 'dataTagT dbEventOutput =
        | Coq_dbDecrypted of EncryptionStringDataTypes.rawDataT
           * 'dataTagT
        
        val dbEventOutput_rect :
          (EncryptionStringDataTypes.rawDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          dbEventOutput
          ->
          'a2
        
        val dbEventOutput_rec :
          (EncryptionStringDataTypes.rawDataT
          ->
          'a1
          ->
          'a2)
          ->
          'a1
          dbEventOutput
          ->
          'a2
        
        type 'dataTagT dbOutput
          =
          ('dataTagT
          dbErrorOutput,
          'dataTagT
          dbEventOutput)
          sum
        
        val initState :
          coq_DecryptBoxState
        
        val decryptBoxLoopPreBody :
          coq_DecryptBoxState
          ->
          'a1
          dbInput
          ->
          'a1
          dbOutput
          option * coq_DecryptBoxState
        
        val decryptBoxLoopBody :
          ('a1
          dbOutput
          ->
          'a2
          action)
          ->
          (coq_DecryptBoxState
          ->
          'a3)
          ->
          coq_DecryptBoxState
          ->
          'a1
          dbInput
          ->
          'a2
          action * 'a3
        
        val decryptBoxLoop :
          ('a1
          dbOutput
          ->
          'a2
          action)
          ->
          coq_DecryptBoxState
          ->
          ('a1
          dbInput,
          'a2)
          process
        
        val decryptBox :
          ('a1
          dbOutput
          ->
          'a2
          action)
          ->
          ('a1
          dbInput,
          'a2)
          process
       end
      
      type coq_ServerSyncBoxPreState = { localStateD : EncryptionStringDataTypes.rawDataT;
                                         remoteStateE : EncryptionStringDataTypes.encryptedDataT
                                                        option }
      
      val coq_ServerSyncBoxPreState_rect :
        (EncryptionStringDataTypes.rawDataT
        ->
        EncryptionStringDataTypes.encryptedDataT
        option
        ->
        'a1)
        ->
        coq_ServerSyncBoxPreState
        ->
        'a1
      
      val coq_ServerSyncBoxPreState_rec :
        (EncryptionStringDataTypes.rawDataT
        ->
        EncryptionStringDataTypes.encryptedDataT
        option
        ->
        'a1)
        ->
        coq_ServerSyncBoxPreState
        ->
        'a1
      
      val localStateD :
        coq_ServerSyncBoxPreState
        ->
        EncryptionStringDataTypes.rawDataT
      
      val remoteStateE :
        coq_ServerSyncBoxPreState
        ->
        EncryptionStringDataTypes.encryptedDataT
        option
      
      type coq_ServerSyncBoxState = { ssbState : coq_ServerSyncBoxPreState;
                                      ssbGetUpdateState : unit
                                                          tickBoxState;
                                      ssbCASState : EncryptionStringDataTypes.encryptedDataT
                                                    tickBoxState;
                                      ssbEncryptState : TEB.coq_EncryptBoxState;
                                      ssbDecryptState : TDB.coq_DecryptBoxState }
      
      val coq_ServerSyncBoxState_rect :
        (coq_ServerSyncBoxPreState
        ->
        unit
        tickBoxState
        ->
        EncryptionStringDataTypes.encryptedDataT
        tickBoxState
        ->
        TEB.coq_EncryptBoxState
        ->
        TDB.coq_DecryptBoxState
        ->
        'a1)
        ->
        coq_ServerSyncBoxState
        ->
        'a1
      
      val coq_ServerSyncBoxState_rec :
        (coq_ServerSyncBoxPreState
        ->
        unit
        tickBoxState
        ->
        EncryptionStringDataTypes.encryptedDataT
        tickBoxState
        ->
        TEB.coq_EncryptBoxState
        ->
        TDB.coq_DecryptBoxState
        ->
        'a1)
        ->
        coq_ServerSyncBoxState
        ->
        'a1
      
      val ssbState :
        coq_ServerSyncBoxState
        ->
        coq_ServerSyncBoxPreState
      
      val ssbGetUpdateState :
        coq_ServerSyncBoxState
        ->
        unit
        tickBoxState
      
      val ssbCASState :
        coq_ServerSyncBoxState
        ->
        EncryptionStringDataTypes.encryptedDataT
        tickBoxState
      
      val ssbEncryptState :
        coq_ServerSyncBoxState
        ->
        TEB.coq_EncryptBoxState
      
      val ssbDecryptState :
        coq_ServerSyncBoxState
        ->
        TDB.coq_DecryptBoxState
      
      val set_ssbState :
        coq_ServerSyncBoxState
        ->
        coq_ServerSyncBoxPreState
        ->
        coq_ServerSyncBoxState
      
      val set_ssbGetUpdateState :
        coq_ServerSyncBoxState
        ->
        unit
        tickBoxState
        ->
        coq_ServerSyncBoxState
      
      val set_ssbCASState :
        coq_ServerSyncBoxState
        ->
        EncryptionStringDataTypes.encryptedDataT
        tickBoxState
        ->
        coq_ServerSyncBoxState
      
      val set_ssbEncryptState :
        coq_ServerSyncBoxState
        ->
        TEB.coq_EncryptBoxState
        ->
        coq_ServerSyncBoxState
      
      val set_ssbDecryptState :
        coq_ServerSyncBoxState
        ->
        TDB.coq_DecryptBoxState
        ->
        coq_ServerSyncBoxState
      
      type ssbConfigInput =
      | Coq_ssbGetUpdateConfig of tbConfigInput
      | Coq_ssbCASConfig of tbConfigInput
      | Coq_ssbSetMasterKey of EncryptionStringDataTypes.masterKeyT
      
      val ssbConfigInput_rect :
        (tbConfigInput
        ->
        'a1)
        ->
        (tbConfigInput
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a1)
        ->
        ssbConfigInput
        ->
        'a1
      
      val ssbConfigInput_rec :
        (tbConfigInput
        ->
        'a1)
        ->
        (tbConfigInput
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.masterKeyT
        ->
        'a1)
        ->
        ssbConfigInput
        ->
        'a1
      
      type ssbEventInput =
      | Coq_ssbClientGetUpdate
      | Coq_ssbClientSet of EncryptionStringDataTypes.rawDataT
      | Coq_ssbServerGotUpdate of EncryptionStringDataTypes.encryptedDataT
      | Coq_ssbSystemRandomness of EncryptionStringDataTypes.systemRandomnessT
         * EncryptionStringDataTypes.rawDataT
      | Coq_ssbTick of Big.big_int
      
      val ssbEventInput_rect :
        'a1
        ->
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.systemRandomnessT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        (Big.big_int
        ->
        'a1)
        ->
        ssbEventInput
        ->
        'a1
      
      val ssbEventInput_rec :
        'a1
        ->
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.systemRandomnessT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        (Big.big_int
        ->
        'a1)
        ->
        ssbEventInput
        ->
        'a1
      
      type ssbInput
        =
        (ssbConfigInput,
        ssbEventInput)
        sum
      
      type ssbWarningOutput =
      | Coq_ssbGetUpdateWarning of unit
                                   tbWarningOutput
      | Coq_ssbCASWarning of EncryptionStringDataTypes.encryptedDataT
                             tbWarningOutput
      | Coq_ssbEncryptError of TEB.ebErrorOutput
      | Coq_ssbDecryptError of unit
                               TDB.dbErrorOutput
      | Coq_ssbWarningInvalidTransition of ssbInput
         * coq_ServerSyncBoxState
      | Coq_ssbWarningPushBeforePull
      
      val ssbWarningOutput_rect :
        (unit
        tbWarningOutput
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        tbWarningOutput
        ->
        'a1)
        ->
        (TEB.ebErrorOutput
        ->
        'a1)
        ->
        (unit
        TDB.dbErrorOutput
        ->
        'a1)
        ->
        (ssbInput
        ->
        coq_ServerSyncBoxState
        ->
        'a1)
        ->
        'a1
        ->
        ssbWarningOutput
        ->
        'a1
      
      val ssbWarningOutput_rec :
        (unit
        tbWarningOutput
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.encryptedDataT
        tbWarningOutput
        ->
        'a1)
        ->
        (TEB.ebErrorOutput
        ->
        'a1)
        ->
        (unit
        TDB.dbErrorOutput
        ->
        'a1)
        ->
        (ssbInput
        ->
        coq_ServerSyncBoxState
        ->
        'a1)
        ->
        'a1
        ->
        ssbWarningOutput
        ->
        'a1
      
      type ssbEventOutput =
      | Coq_ssbClientGotUpdate of EncryptionStringDataTypes.rawDataT
      | Coq_ssbServerGetUpdate
      | Coq_ssbServerCAS of EncryptionStringDataTypes.encryptedDataT
         * EncryptionStringDataTypes.encryptedDataT
      | Coq_ssbRequestSystemRandomness of EncryptionStringDataTypes.systemRandomnessHintT
         * EncryptionStringDataTypes.rawDataT
      | Coq_ssbSleepFor of Big.big_int
      
      val ssbEventOutput_rect :
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        'a1
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        EncryptionStringDataTypes.encryptedDataT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        (Big.big_int
        ->
        'a1)
        ->
        ssbEventOutput
        ->
        'a1
      
      val ssbEventOutput_rec :
        (EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        'a1
        ->
        (EncryptionStringDataTypes.encryptedDataT
        ->
        EncryptionStringDataTypes.encryptedDataT
        ->
        'a1)
        ->
        (EncryptionStringDataTypes.systemRandomnessHintT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        'a1)
        ->
        (Big.big_int
        ->
        'a1)
        ->
        ssbEventOutput
        ->
        'a1
      
      type ssbOutput
        =
        (ssbWarningOutput,
        ssbEventOutput)
        sum
      
      val initState :
        EncryptionStringDataTypes.rawDataT
        ->
        coq_ServerSyncBoxState
      
      val isTickBoxSimpleResult :
        'a1
        tbOutput
        list
        ->
        bool
      
      val handle_simpleTickBox :
        ('a1
        tbWarningOutput
        ->
        ssbWarningOutput)
        ->
        'a1
        tbOutput
        list
        ->
        ssbOutput
        list
      
      val handle_ssbGetUpdate' :
        coq_ServerSyncBoxState
        ->
        (unit
        tbOutput * unit
        tickBoxState)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val fold_handler :
        (coq_ServerSyncBoxState
        ->
        'a2)
        ->
        (coq_ServerSyncBoxState
        ->
        'a2
        ->
        coq_ServerSyncBoxState)
        ->
        (coq_ServerSyncBoxState
        ->
        ('a1 * 'a2)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState)
        ->
        coq_ServerSyncBoxState
        ->
        ('a1
        list * 'a2)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val handle_ssbGetUpdate :
        coq_ServerSyncBoxState
        ->
        (unit
        tbOutput
        list * unit
        tickBoxState)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val handle_ssbEncrypt :
        coq_ServerSyncBoxState
        ->
        (unit
        TEB.ebOutput
        option * TEB.coq_EncryptBoxState)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val handle_ssbCAS' :
        coq_ServerSyncBoxState
        ->
        (EncryptionStringDataTypes.encryptedDataT
        tbOutput * EncryptionStringDataTypes.encryptedDataT
        tickBoxState)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val handle_ssbCAS :
        coq_ServerSyncBoxState
        ->
        (EncryptionStringDataTypes.encryptedDataT
        tbOutput
        list * EncryptionStringDataTypes.encryptedDataT
        tickBoxState)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val handle_ssbDecrypt :
        (EncryptionStringDataTypes.rawDataT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        bool)
        ->
        coq_ServerSyncBoxState
        ->
        (unit
        TDB.dbOutput
        option * TDB.coq_DecryptBoxState)
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val serverSyncBoxLoopPreBody :
        (EncryptionStringDataTypes.rawDataT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        bool)
        ->
        coq_ServerSyncBoxState
        ->
        ssbInput
        ->
        ssbOutput
        list * coq_ServerSyncBoxState
      
      val serverSyncBoxLoopBody :
        (EncryptionStringDataTypes.rawDataT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        bool)
        ->
        (ssbOutput
        ->
        'a1
        action)
        ->
        (coq_ServerSyncBoxState
        ->
        'a2)
        ->
        coq_ServerSyncBoxState
        ->
        ssbInput
        ->
        'a1
        action * 'a2
      
      val serverSyncBoxLoop :
        (EncryptionStringDataTypes.rawDataT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        bool)
        ->
        (ssbOutput
        ->
        'a1
        action)
        ->
        coq_ServerSyncBoxState
        ->
        (ssbInput,
        'a1)
        process
      
      val serverSyncBox :
        (EncryptionStringDataTypes.rawDataT
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        bool)
        ->
        EncryptionStringDataTypes.rawDataT
        ->
        (ssbOutput
        ->
        'a1
        action)
        ->
        (ssbInput,
        'a1)
        process
     end
    
    type wInput
      =
      (SSB.ssbWarningOutput,
      tickGWarningOutput)
      sum
    
    module Coercions : 
     sig 
      val wInput_of_ssb :
        SSB.ssbWarningOutput
        ->
        wInput
      
      val wInput_of_tg :
        tickGWarningOutput
        ->
        wInput
     end
    
    type wOutput =
    | Coq_wConsoleErr of char list
    | Coq_wFatalError of char list
    | Coq_wBad of char list
    
    val wOutput_rect :
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      wOutput
      ->
      'a1
    
    val wOutput_rec :
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      wOutput
      ->
      'a1
    
    val newline :
      char
    
    val newlineS :
      char list
    
    val emit :
      (wOutput
      ->
      'a1
      action)
      ->
      char list
      ->
      'a1
      action
    
    val debugMsg :
      (wOutput
      ->
      'a1
      action)
      ->
      Big.big_int
      ->
      char list
      ->
      char list
      ->
      Big.big_int
      ->
      'a1
      action
    
    val labelTBStateTransition :
      'a1
      serializable
      ->
      'a1
      tickBoxPreState
      ->
      'a1
      tickBoxPreState
      ->
      'a1
      tbInput
      ->
      char list
    
    val labelTGBStateTransition :
      gatewayState
      ->
      gatewayState
      ->
      tickGInput
      ->
      char list
    
    val emitTB :
      (wOutput
      ->
      'a1
      action)
      ->
      'a2
      serializable
      ->
      Big.big_int
      ->
      'a2
      tbWarningOutput
      ->
      char list
      ->
      'a1
      action
    
    val wLoopBody :
      (wOutput
      ->
      'a1
      action)
      ->
      (Big.big_int
      ->
      (wInput,
      'a1)
      process)
      ->
      Big.big_int
      ->
      wInput
      ->
      'a1
      action * (wInput,
      'a1)
      process
    
    val warningBox :
      (wOutput
      ->
      'a1
      action)
      ->
      Big.big_int
      ->
      (wInput,
      'a1)
      process
   end
  
  module UI : 
   sig 
    type uiInput =
    | Coq_uiConsoleIn of char list
    | Coq_uiGotUpdate of char list
    
    val uiInput_rect :
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiInput
      ->
      'a1
    
    val uiInput_rec :
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiInput
      ->
      'a1
    
    type uiOutput =
    | Coq_uiGetUpdate
    | Coq_uiSetData of char list
    | Coq_uiConsoleOut of char list
    
    val uiOutput_rect :
      'a1
      ->
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiOutput
      ->
      'a1
    
    val uiOutput_rec :
      'a1
      ->
      (char list
      ->
      'a1)
      ->
      (char list
      ->
      'a1)
      ->
      uiOutput
      ->
      'a1
    
    val split :
      char
      ->
      char list
      ->
      char list
      list
    
    val newline :
      char
    
    val dump :
      (char list * char list)
      list
      ->
      char list
    
    val load :
      char list
      ->
      (char list * char list)
      list
    
    val list_dec :
      'a1
      list
      ->
      ('a1 * 'a1
      list)
      option
    
    val uiLoopBody :
      (uiOutput
      ->
      'a1
      action)
      ->
      (char list
      KVStore.t
      ->
      (uiInput,
      'a1)
      process)
      ->
      char list
      KVStore.t
      ->
      uiInput
      ->
      'a1
      action * (uiInput,
      'a1)
      process
    
    val uiLoop :
      (uiOutput
      ->
      'a1
      action)
      ->
      char list
      KVStore.t
      ->
      (uiInput,
      'a1)
      process
    
    val ui :
      (uiOutput
      ->
      'a1
      action)
      ->
      (uiInput,
      'a1)
      process
   end
  
  val eta_ebError :
    SSB.TEB.ebErrorOutput
    ->
    WB.SSB.TEB.ebErrorOutput
  
  val eta_dbError :
    'a1
    SSB.TDB.dbErrorOutput
    ->
    'a1
    WB.SSB.TDB.dbErrorOutput
  
  val eta_ssbConfigInput :
    SSB.ssbConfigInput
    ->
    WB.SSB.ssbConfigInput
  
  val eta_ssbEventInput :
    SSB.ssbEventInput
    ->
    WB.SSB.ssbEventInput
  
  val eta_ssbInput :
    SSB.ssbInput
    ->
    WB.SSB.ssbInput
  
  val eta_EncryptBoxState :
    SSB.TEB.coq_EncryptBoxState
    ->
    WB.SSB.TEB.coq_EncryptBoxState
  
  val eta_DecryptBoxState :
    SSB.TDB.coq_DecryptBoxState
    ->
    WB.SSB.TDB.coq_DecryptBoxState
  
  val eta_ServerSyncBoxPreState :
    SSB.coq_ServerSyncBoxPreState
    ->
    WB.SSB.coq_ServerSyncBoxPreState
  
  val eta_ServerSyncBoxState :
    SSB.coq_ServerSyncBoxState
    ->
    WB.SSB.coq_ServerSyncBoxState
  
  val eta_ssbWarning :
    SSB.ssbWarningOutput
    ->
    WB.SSB.ssbWarningOutput
  
  type 'world input =
  | Coq_pwMgrFatal of char list
  | Coq_pwMgrConfigure of Big.big_int
  | Coq_pwMgrInit of char list
  | Coq_pwMgrConsoleIn of char list
  | Coq_pwUI of UI.uiInput
  | Coq_pwW of WB.wInput
  | Coq_pwSSB of SSB.ssbInput
  | Coq_pwNET of 'world
                 netInput
  | Coq_pwTG of tickGInput
  
  val input_rect :
    (char list
    ->
    'a2)
    ->
    (Big.big_int
    ->
    'a2)
    ->
    (char list
    ->
    'a2)
    ->
    (char list
    ->
    'a2)
    ->
    (UI.uiInput
    ->
    'a2)
    ->
    (WB.wInput
    ->
    'a2)
    ->
    (SSB.ssbInput
    ->
    'a2)
    ->
    ('a1
    netInput
    ->
    'a2)
    ->
    (tickGInput
    ->
    'a2)
    ->
    'a1
    input
    ->
    'a2
  
  val input_rec :
    (char list
    ->
    'a2)
    ->
    (Big.big_int
    ->
    'a2)
    ->
    (char list
    ->
    'a2)
    ->
    (char list
    ->
    'a2)
    ->
    (UI.uiInput
    ->
    'a2)
    ->
    (WB.wInput
    ->
    'a2)
    ->
    (SSB.ssbInput
    ->
    'a2)
    ->
    ('a1
    netInput
    ->
    'a2)
    ->
    (tickGInput
    ->
    'a2)
    ->
    'a1
    input
    ->
    'a2
  
  val one_second :
    Big.big_int
  
  val abort :
    ('a1
    input,
    'a1)
    systemActions
    ->
    char list
    ->
    'a1
    ->
    'a1
  
  val hang :
    ('a1,
    'a2)
    process
  
  val pwMgrLoopBody :
    ('a1
    input,
    'a1)
    systemActions
    ->
    ((SSB.ssbInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (WB.wInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (UI.uiInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    ('a1
    netInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (tickGInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    ('a1
    input,
    'a1)
    stackProcess)
    ->
    (SSB.ssbInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (WB.wInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (UI.uiInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    ('a1
    netInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (tickGInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    'a1
    input
    ->
    ('a1
    input,
    'a1)
    stackWorld
    action * ('a1
    input,
    'a1)
    stackProcess
  
  val pwMgrLoop :
    ('a1
    input,
    'a1)
    systemActions
    ->
    (SSB.ssbInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (WB.wInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (UI.uiInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    ('a1
    netInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    (tickGInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
    ->
    ('a1
    input,
    'a1)
    stackProcess
  
  val wrap_ui :
    ('a1
    input,
    'a1)
    systemActions
    ->
    (__
    ->
    (UI.uiOutput
    ->
    __
    action)
    ->
    (UI.uiInput,
    __)
    process)
    ->
    (UI.uiInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
  
  val wrap_wb :
    ('a1
    input,
    'a1)
    systemActions
    ->
    (__
    ->
    (WB.wOutput
    ->
    __
    action)
    ->
    (WB.wInput,
    __)
    process)
    ->
    (WB.wInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
  
  val wrap_ssb :
    ('a1
    input,
    'a1)
    systemActions
    ->
    (__
    ->
    (SSB.ssbOutput
    ->
    __
    action)
    ->
    (SSB.ssbInput,
    __)
    process)
    ->
    (SSB.ssbInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
  
  val wrap_net :
    ('a1
    input,
    'a1)
    systemActions
    ->
    (__
    ->
    __
    ->
    (__
    netOutput
    ->
    __
    action)
    ->
    (__
    netInput,
    __)
    process)
    ->
    ('a1
    netInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
  
  val wrap_tickG :
    ('a1
    input,
    'a1)
    systemActions
    ->
    (__
    ->
    (tickGOutput
    ->
    __
    action)
    ->
    (tickGInput,
    __)
    process)
    ->
    (tickGInput,
    ('a1
    input,
    'a1)
    stackWorld)
    process
  
  val mkPwMgrStack :
    ('a1
    input,
    'a1)
    systemActions
    ->
    (__
    ->
    (SSB.ssbOutput
    ->
    __
    action)
    ->
    (SSB.ssbInput,
    __)
    process)
    ->
    (__
    ->
    (WB.wOutput
    ->
    __
    action)
    ->
    (WB.wInput,
    __)
    process)
    ->
    (__
    ->
    (UI.uiOutput
    ->
    __
    action)
    ->
    (UI.uiInput,
    __)
    process)
    ->
    (__
    ->
    __
    ->
    (__
    netOutput
    ->
    __
    action)
    ->
    (__
    netInput,
    __)
    process)
    ->
    (__
    ->
    (tickGOutput
    ->
    __
    action)
    ->
    (tickGInput,
    __)
    process)
    ->
    ('a1
    input,
    'a1)
    stackProcess
  
  val pwMgrStack :
    ('a1
    input,
    'a1)
    systemActions
    ->
    EncryptionStringDataTypes.rawDataT
    ->
    char list
    ->
    Big.big_int
    ->
    (__
    ->
    (tickGOutput
    ->
    __
    action)
    ->
    (tickGInput,
    __)
    process)
    ->
    ('a1
    input,
    'a1)
    stackProcess
  
  val initStore :
    char list
  
  val storageId :
    char list
  
  val getMasterKeyLoop :
    ('a1
    input,
    'a1)
    systemActions
    ->
    Big.big_int
    ->
    ('a1
    input,
    'a1)
    process
  
  val getMasterKey :
    ('a1
    input,
    'a1)
    systemActions
    ->
    Big.big_int
    ->
    ('a1
    ->
    'a1) * ('a1
    input,
    'a1)
    process
  
  val parseFlag :
    char list
    ->
    Big.big_int
    ->
    char list
    ->
    (Big.big_int
    ->
    'a1
    input)
    ->
    'a1
    input
  
  val parseArgv' :
    char list
    ->
    char list
    list
    ->
    Big.big_int
    ->
    'a1
    input
  
  val parseArgv :
    Big.big_int
    ->
    char list
    list
    ->
    'a1
    input
  
  val proc :
    ('a1
    input,
    'a1)
    systemActions
    ->
    'a1
    action * ('a1
    input,
    'a1)
    process
 end

